﻿<%
'May need to rem out this statement for debugging!
'on error resume next
dim cor_SoopCoreVersion
'<!--#include file="classes/class_mgmt_menutree.asp" -->
'<!--#include file="classes/class_menu.asp" -->
%>
<!--#include file="classes/class_string.asp" -->
<!--#include file="classes/class_sha256.asp" -->
<!--#include file="classes/class_baseUtils.asp" -->
<!--#include file="classes/class_filters.asp" -->
<!--#include file="classes/class_dal.asp" -->
<!--#include file="classes/class_objectsPool.asp" -->
<!--#include file="classes/class_errorTrap.asp" -->
<!--#include file="classes/class_sqlBuilder.asp" -->
<!--#include file="classes/class_media.asp" -->
<!--#include file="classes/class_languageParser.asp" -->
<!--#include file="classes/class_rtebuilder.asp" -->
<!--#include file="classes/class_modbox.asp" -->
<!--#include file="classes/class_dyninc.asp" -->
<!--#include file="classes/class_modules.asp" -->

<!--#include file="classes/class_audit.asp" -->
<!--#include file="classes/class_io.asp" -->
<!--#include file="classes/class_boxing.asp" -->
<!--#include file="classes/class_configHandler.asp" -->
<!--#include file="classes/class_stats.asp" -->
<!--#include file="classes/class_pm.asp" -->
<!--#include file="classes/class_comboBuilder.asp" -->
<!--#include file="classes/class_checkboxBuilder.asp" -->
<!--#include file="classes/class_permissions.asp" -->
<!--#include file="classes/class_menu_phh.asp" -->
<!--#include file="classes/class_utils.asp" -->
<!--#include file="classes/class_template.asp" -->
<!--#include file="classes/class_login.asp" -->
<!--#include file="classes/class_boot.asp" -->
<!--#include file="classes/class_pageNo.asp" -->
<!--#include file="classes/class_purr.asp" -->

<%
'---------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'---------------------------------------------------------------------------------------------
'

' Start page processing timers
'
cor_dStartTime			= timer()
cor_dModStart			= timer()
cor_iQueriesTotal		= 0
cor_iQueriesMod			= 0
'
' Default security settings
'
cor_sLoggedInUserEmail	= ""
cor_sLoggedInUsername	= "Guest"
cor_iGroupID			= 2
cor_lUserID				= 2
cor_bAdmin				= false
cor_bModerator			= false
cor_bGuest				= true
cor_bMember				= false
'
' Init DB Layer
'
select case lcase(cor_sDatabaseType)
case "access"
	cor_dbNow			= "now()"
	cor_dbDelim			= "#"
	cor_dbLQ			= "`"
	cor_dbRQ			= "`"
	cor_dbUC			= " UCASE"
	cor_dbLC			= " LCASE"
	'
	if cor_sCustomProvider = "" Then cor_sCustomProvider = "Provider=Microsoft.Jet.OLEDB.4.0;"
	cor_sCon			= cor_sCustomProvider & "Data Source=" & cor_sDbPathAndName 'This one is for Access 2000/2002
	'
case "mssql" 
	cor_dbNow			= "getDate()"
	cor_dbDelim			= "'"
	cor_dbLQ			= "["
	cor_dbRQ			= "]"
	cor_dbUC			= " UPPER"
	cor_dbLC			= " LOWER"
	'
	if cor_sCustomProvider = "" Then cor_sCustomProvider = "Provider=SQLOLEDB.1;"
	cor_sCon			= cor_sCustomProvider & "Server=" & cor_sSQLServerName & ";User ID=" & cor_sSqlDbUserName & ";Password=" & cor_sSqlDbPassword & ";Database=" & cor_sSqlDbName
	'
case "mysql" 
	cor_dbNow			= "now()"
	cor_dbDelim			= "'"
	cor_dbLQ			= "`"
	cor_dbRQ			= "`"
	cor_dbUC			= " UPPER"
	cor_dbLC			= " LOWER"
	'
	if cor_sCustomProvider = "" Then cor_sCustomProvider = "Driver={MySQL ODBC 3.51 Driver};Port=" & cor_iMySqlPort & ";Option=16419;charset=utf8;"
	cor_sCon			= cor_sCustomProvider & "Server=" & cor_sSQLServerName & ";Database=" & cor_sSqlDbName & ";Uid=" & cor_sSqlDbUserName & ";Pwd=" & cor_sSqlDbPassword
	'
end Select
'
' Set Configuration defaults
'
if NOT (request.serverVariables("SERVER_PORT") = 80) _
OR NOT (request.serverVariables("SERVER_PORT") <> 443) Then
	cor_iServerPort		= ":" & request.serverVariables("SERVER_PORT")
end if
cor_sServerName			= request.serverVariables("SERVER_NAME")
cor_bPostback			= iif(ucase(request.serverVariables("REQUEST_METHOD")) = "POST", true, false)
'

'
' Document Type validation level
'
cor_cPageDocType		= "<!DOCTYPE html PUBLIC ""-//W3C//DTD XHTML 1.0 Transitional//EN"" " _
					& """http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"">"

cor_sScriptName = request.serverVariables("SCRIPT_NAME")
cor_sReferer = request.serverVariables("HTTP_REFERER")
'------------------------
' BOOT
'------------------------
set cor = new class_boot

cor.connString			= cor_sCon
cor.enablePooling		= cor_cEnableConnectionPooling
cor.boot()
'
' Check size allowance of postback events
'
cor.util.checkPostSizeAllowance()
'
' normalize URL (i.e. add www. prefix)
'
cor.util.normalizeUrl(cor_bUseW3)
'
' Read section configuration from DB
'
cor.cfg.loadAllSystem() ' same as cor.cfg.includeSection("core,paging,mail,member,captcha")
cor_sDefaultLang		= cor.filter.checkStr(cor.cfg.item("DefaultLang"))
cor_sEditor				= cor.filter.checkStr(cor.cfg.item("Editor"))
cor_sReplyMail			= cor.filter.checkStr(cor.cfg.item("ReplyAddress"))
cor_sDefaultLocationID	= cor.filter.checkInt(cor.cfg.item("DefaultLocationID"))
cor_iServerTimezone		= cor.filter.checkInt(cor.cfg.item("ServerTimezone"))
cor_dTimeZone			= cor.filter.checkInt(cor.cfg.item("DefaultTimeZone"))
cor_bBanners			= cor.filter.checkBol(cor.cfg.item("EnableBanners"))
cor_bDebug				= cor.filter.checkBol(cor.cfg.item("EnableDebug"))
' (needed as a hack because debug class is messing up the banner system...)
if cor_bDebug Then cor_bBanners = false
cor_bPM					= cor.filter.checkBol(cor.cfg.item("EnablePM"))
cor_bPolls				= cor.filter.checkBol(cor.cfg.item("EnablePolls"))
cor_bFsoEnable			= cor.filter.checkBol(cor.cfg.item("FSOenabled"))
cor_bEnableStats		= cor.filter.checkBol(cor.cfg.item("EnableStats"))
cor_bEnableHorizMenu	= cor.filter.checkBol(cor.cfg.item("EnableHorizMenu"))
cor_bEnableVertMenu		= cor.filter.checkBol(cor.cfg.item("EnableVertMenu"))
'
' normalize current base domain path
'
cor_sPortalDomainPath	= cor.butil.normPath(cor_sServerProtocol & lcase(request.serverVariables("SERVER_NAME")) & cor_iServerPort & cor_sWebroot)

'
' set last time visited
'
cor_dLastVisit			= cor.butil.cvUxTime(now())
'
' populate forums permissions array
'
cor_aForumsPerm			= cor.util.buildForumsPermArray(false)


if cor.util.checkBannedIP() Then
	cor.msg("IP address not authorized to access this resource")
end if
'
'------------------------
' LOGIN & POST-LOGIN
'------------------------
cor.login.init_io(cor.io.r("lg"))
cor.login.controller()
'
' Activate some basic protection against form-post tampering attempts coming from alien domains
'
cor.filter.validatePostEvent(cor_bEnableRefer)
'
'--- (a) populate horizontal/vertical menus vars if any already enabled from cfg
cor_sMenuH = cor.login.util.buildMenuH(cor_bEnableHorizMenu)
'cor_sMenuV = cor.login.util.buildMenuV(cor_bEnableVertMenu)
'
'--- (b) populate activeuser list var (if a new user it would also insert to DB cor_sMenuH/cor_sMenuV data)
cor_sListMembersOnline = cor.login.util.buildActiveMembersList()
'
'--- perform stats calculations, if such feature is enabled
cor.util.calculateStats(cor_bEnableStats)
'
'--- set marker if page has been opened via popup or embedded into an iframe
cor_bEmbedded = cor.butil.setEmbedState()
'
'--- Check browser version if suitable
'cor.butil.checkBrowser()
%>
<!--#include file="_version.asp" -->