﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - 26/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_audit ':: global, class_dal, class_utils, class_objectsPool
	'
	public sub write( strID, strMessage )
		'On error resume next
		dim ts, sMsg, sFn, sFolder
		dim bWriteHeader, sHeader
		dim userwrk
		if NOT cor_bEnableAudit then exit sub
		call cor.obj.init("fso")
		bWriteHeader = true
		userwrk = cor_lUserID
		sHeader = _
			"date"   & vbTab & _
			"user"   & vbTab & _
			"id"	 & vbTab & _
			"audit"
'		sMsg = Now() & vbTab & _
'			userwrk  & vbTab & _
'			strID	& vbTab & _
'			strMessage
		'ML
		sMsg = cor.butil.datetime(Now(),cor_iDateFormat) & " " & time() & vbTab & _
			userwrk  & vbTab & _
			strID	& vbTab & _
			strMessage
		'---------------------------------------------------------------------------------------
		sFolder = cor_sWebroot & "audit/"
		sFn = cor_sAuditFile & "_" & cor.butil.zeroPad(Year(Date), 4) & cor.butil.zeroPad(Month(Date), 2) & cor.butil.zeroPad(Day(Date), 2) & ".txt"
		bWriteHeader = cor.obj.fso.FileExists(server.mappath(sFolder & sFn))
		set ts = cor.obj.fso.openTextFile(server.mappath(sFolder & sFn), 8, True)
		'ML
		if not bWriteHeader Then ts.writeline(sHeader)
		'-----------------------------------------------------------------------------------------------
		ts.writeline(sMsg)
		ts.close
		set ts  = nothing
		'On error goto 0
	end sub

	'* sqlShield log activity
	public sub sqlShieldLog(origline, shieldLine)
		if NOT cor_bEnableAudit then exit sub
		str.clear
		str.add vbcrlf
		str.add "QUERY:	[" & origline & "]"
		str.add "FILTERED: [" & shieldLine & "]"
		str.add "TIMESTAMP:[" & now() & "]"
		str.add "ORIGIN:   [" & "http://" & cor_sServerName & cor_sScriptName & "]"
		str.add "REFERRED: [" & cor_sReferer & "]"
		str.add "GET DATA: [" & request.querystring & "]" 
		str.add "POST DATA:[" & request.form & "]"
		str.add "USER:	 [" & cor_sLoggedInUsername & "]" 
		str.add "************************************************************"
		str.add vbcrlf
		call writeLogFile(str.build, "sqlShieldLog.txt")
	end sub

	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------

	public sub writeLogFile(line, filename)
		dim myFile, sMsg
		'
		if NOT cor_bEnableAudit then exit sub
		call cor.obj.init("fso")
		sMsg = cor.util.createFoldersP(cor_sLogsPath)
		if sMsg <> "" then cor.msg(sMsg)
		set myFile = cor.obj.fso.openTextFile(cor_sLogsPath & filename, cor_cForappending, true) 
		myFile.writeLine(line) 
		myFile.close
		set myFile = nothing
	end sub

	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub writeLogDb(eventid, message)
		if NOT cor_bEnableAudit then exit sub
		'response.write eventID & "-" & message & "<br />"
		cor.dal.exec "INSERT INTO " & cor_dbpre & "logs (lmemberid, leventid, lmessage, lip, ldate) VALUES ({0},{1},{2},{3},{4})", array(cor_lUserID, eventid, message, request.serverVariables("REMOTE_ADDR"), cor.butil.cvUxTime(now))
	end sub
	'
	private sub class_initialize
		set str = new class_string
	end sub
	'
	private sub class_terminate
		set str = nothing
	end sub
	'
	private str
	'
end class

'<#late-binding hook
function boot_class_audit : boot_class_audit = true : end function
'/>

%>
