﻿<%
'------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - 26/02/2008
'	Revised 29 Apr 2009 
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'-------------------------------------------------------------------------------------------------------------------------------------

class class_baseUtils ':: globals
private SCount

	public oRegExp
	'--------------------------------------------------------------------------------------------------------------------------------
	' system and error message transport
	'----------------------------------------------------------------------------------------------------------------------------
	public Property get msg
		msg = session(cor_pre&"msg_")
	end property
	'
	public property let msg(sVal)
		'--- skip empty msgs
		if isEmpty(sVal) OR isNull(sVal) Then exit property
		'--- skip repeated msgs
		if session(cor_pre&"msg_") <> "" AND instr(session(cor_pre&"msg_"), sVal)>0 Then exit property
		'---stack msg
		session(cor_pre&"msg_") = session(cor_pre&"msg_") & "<br />" & sVal
	end property
	'
	public property get emsg
		emsg = session(cor_pre&"emsg_")
	end property
	'
	public property let emsg(sVal)
		'--- skip empty msgs
		if isEmpty(sVal) OR isNull(sVal)  Then exit property
		'--- skip repeated msgs
		if session(cor_pre&"emsg_") <> "" AND instr(session(cor_pre&"emsg_"), sVal)>0 Then exit property
		'---stack msg
		session(cor_pre&"emsg_") = session(cor_pre&"emsg_") & "<br />" & sVal
	end property
	'
	public sub clear_msg()
		session.contents.remove(cor_pre&"msg_")
	end sub
	'
	public sub clear_emsg()
		session.contents.remove(cor_pre&"emsg_")
	end sub
	'
	public function msgBuffer()
		msgBuffer = iif(msg<>"" OR emsg<>"", true, false)
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------
	' displays system-level messages (via msg.asp or thickbox)
	'------------------------------------------------------------------------------------------------------------------------------
	public sub winWrite(txt)
		'--- skip thickbox messaging if to display instead in msg.asp via msgWrite()
		if NOT cbool(session(cor_pre&"inpage_")) then
			call winBuild(txt, "id=""cor_msg"" style=""display:none;""")
		end if
	end sub
	'
	public sub msgWrite()
		if cbool(session(cor_pre&"inpage_")) then
			call winBuild("","")
			session.contents.remove(cor_pre&"inpage_")
		end if
	end sub
'
	public sub winBuild(txt, div_id)
		if txt = "" AND msg = "" AND emsg = "" Then exit sub
			dim purr
			if txt <> "" then
				set purr = new class_Purr
				purr.screenPosition = "center-center"
				purr.Image = "Info"
				purr.HeaderTxt = lngSystemMessage
				purr.MessageTxt	=  txt
				purr.removeTimer = 15000
				purr.doPurr
				set purr = nothing
			end if
			if msg <> "" then
				set purr = new class_Purr
				purr.screenPosition = "center-center"
				purr.Image = "Info"
				purr.HeaderTxt = lngSystemMessage
				purr.MessageTxt	=  msg
				purr.removeTimer = 15000
				purr.doPurr
				set purr = nothing
				clear_msg()
			end if
			if emsg <> "" then
				set purr = new class_Purr
				purr.screenPosition = "center-center"
				purr.CssClasstop = "purr-top-failure"
				purr.CssClassBody = "purr-body-failure"
				purr.CssClassBottom = "purr-bottom-failure"
				purr.Image = "False"
				purr.HeaderTxt = lngSystemMessage
				purr.MessageTxt	=  emsg
				purr.removeTimer = 15000
				purr.doPurr
				set purr = nothing
				clear_emsg()
			end if
	end sub
	'---------------------------------------------------------------------------------------------------------------------------------
	' Browser compatibility checker
	'--------------------------------------------------------------------------------------------------------------------------------
'	public sub checkBrowser()
'		if NOT cor_bBrowserChecker then exit sub
'		if request.cookies(cor_sCookieName&"navchk") = "" Then
'			if getBrowser() Then
'				saveCookieAr "", "navchk", 1
'			else
'				call oldBrowser()
'			end if
'		end if
'	end sub
	'
'	public function getBrowser()
'		Dim i, UserAgent, browserType, browserVersion
'		Dim CheckUpToVersion
'		CheckUpToVersion = cor_iUpToBrowserVersion
'		UserAgent = lcase(request.serverVariables("HTTP_USER_AGENT"))
'		for i = CheckUpToVersion to 4 step -1
'			'* Determine IE compatible (Opera mimics IE, however)
'			if		instr(1, UserAgent, "opera/"	&i, 1) > 0 Then
'				browserType	= "opera"
'				browserVersion	= i
'				exit for
'			elseif	instr(1, UserAgent, "msie "		&i & ".5", 1) > 0 Then '* IE 5.5
'				browserType	= "msie"
'				browserVersion	= i + .5
'				exit for
'			elseif	instr(1, UserAgent, "msie "		&i, 1) > 0 Then
'				browserType	= "msie"
'				browserVersion	= i
'				exit for
'			elseif	instr(1, UserAgent, "firefox/"	&i, 1) > 0 Then
'				browserType	= "firefox"
'				browserVersion	= i
'				exit for
'			elseif	instr(1, UserAgent, "netscape/"	&i, 1) > 0 Then
'				browserType	= "netscape"
'				browserVersion	= i
'				exit for
'			elseif	instr(1, UserAgent, "mozilla/"	&i, 1) > 0 Then
'				browserType	= "mozilla"
'				browserVersion	= i
'				exit for
'			end if
'		next
'		if (browserType =  "msie" AND browserVersion >  5) OR _
'			(browserType <> "msie" AND browserType <> "netscape" AND browserVersion >= 5) OR _
'			 browserType =  "firefox" Then getBrowser = true else getBrowser = false
'	End function
'	'
'	public sub oldBrowser()
'		dim oldpage
'		oldpage = oldpage & "<!DOCTYPE html PUBLIC ""-//W3C//DTD XHTML 1.0 Strict//EN"" ""http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"">" & vbcrlf
'		oldpage = oldpage & "<html xmlns=""http://www.w3.org/1999/xhtml"" xml:lang=""en"" lang=""en"">"   & vbcrlf
'		oldpage = oldpage & "<head>"  & vbcrlf
'		oldpage = oldpage & "<meta http-equiv=""Content-Type"" content=""text/html;charset=utf-8"" />"	& vbcrlf
'		oldpage = oldpage & "<link type=""text/css"" rel=""stylesheet"" href=""" & cor_sSkinCss & """ />" & vbcrlf
'		oldpage = oldpage & "<title>Incompatible Browser Found</title>" & vbcrlf
'		oldpage = oldpage & "</head>" & vbcrlf
'		oldpage = oldpage & "<body>"  & vbcrlf
'		oldpage = oldpage & "<table width=""100%"" style=""heigh:100%"" border=""0""><tr><td align=""center"">" & vbcrlf
'		oldpage = oldpage & request.serverVariables("HTTP_USER_AGENT")  & "<br /><br />" & vbcrlf
'		oldpage = oldpage & "The browser you're using is rather old or unsupported.<br />"
'		oldpage = oldpage & "SOOP is known to work well with:<br /> IE 5.5+ or compatible, Mozilla 1.6+, Firefox, Opera 6+, Safari.<br /><br />" & vbcrlf
'		oldpage = oldpage & "Please visit us back with any of them."	& vbcrlf
'		oldpage = oldpage & "</td></tr></table>" & vbcrlf
'		oldpage = oldpage & "</body>" & vbcrlf
'		oldpage = oldpage & "</html>" & vbcrlf
'		cor.stopper(oldpage)
'	end sub

	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	function eof(arr)
		if NOT isarray(arr) then eof = true : exit function
		if ubound(arr,2) = -1 Then eof = true else eof = false
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	function zeroPad(m, t)
		zeroPad = string(t - len(m), "0") & m
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public function properCase(ByVal sString)
		dim wordCounter, colWords, outPut
		'
		if len("" & sString) = 0 Then
			properCase = ""
			exit function
		end if
		if instr(sString, "-") Then
			colWords = split(sString, "-")
			for wordCounter = 0 TO ubound(colWords)
				colWords(wordCounter) = ucase(left(colWords(wordCounter),1)) & lcase(right(colWords(wordCounter), len(colWords(wordCounter)) - 1))
			next
			outPut = Join(colWords," ")
		elseif instr(sString, "_") Then
			colWords = split(sString, "_")
			for wordCounter = 0 TO ubound(colWords)
				colWords(wordCounter) = ucase(left(colWords(wordCounter),1)) & lcase(right(colWords(wordCounter), len(colWords(wordCounter)) - 1))
			next
			outPut = Join(colWords," ")
		else
			outPut = ucase(left(sString,1)) & lcase(right(sString, len(sString) - 1))
		end if
		properCase = outPut
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public function isEmptyStr(str)
		'dim typ : typ = varType(str)
		'if typ = vbEmpty OR typ = vbNull Then
		if isnull(str) or isempty(str) then
			isEmptyStr = true
			exit function
		end if
		if trim(str) = "" Then 
			isEmptyStr = true
			exit function
		end if
		isEmptyStr = false
	end function
	
	public function isEmptyNumber(val)
		'dim typ	:	typ = vartype(val)
		'if typ = vbEmpty OR typ = vbNull Then
		if isnull(val) or isempty(val) then
			isEmptyNumber = true
			exit function
		end if
		if NOT isNumeric(val) then
			isEmptyNumber = True
			exit function
		end if
		isEmptyNumber = false
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public function inArray(wrd, arr)
		dim sw
		dim i
		sw = lcase(wrd)
		if NOT eof(arr) Then
			for i = 0 To ubound(arr)
				if lcase(arr(i,0)) = sw Then
					inArray = i
					exit function
				end if
			Next
			inArray = -1
		else
			inArray = -1
		end if
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public sub preventCaching()
		response.addHeader "pragma","no-cache"
		response.addHeader "cache-control","private"
		response.expires = 0
		response.expiresAbsolute = Now() - 1000
		response.cacheControl = "no-cache"
	end sub
	'-----------------------------------------------------------------------------------------------------------------------------
	' function used for debugging or performance issues. Output is only shown when debugging is active
'---------------------------------------------------------------------------------------------------------------------------------
	public function breakpoint(sBlockName)
		if cor_bDebug Then
			'
			'--- total queries happened until the last breakpoint
			cor_iQueriesMod = cor_iQueriesTotal - cor_iQueriesMod
			'
			breakpoint		= "<div class=""pageCurrent"">[" & sBlockName & "] DB calls: " & cor_iQueriesMod & "&nbsp;-&nbsp;" & formatNumber((timer() - cor_dModStart),4) & "&nbsp;sec.</div>"
			'
			'--- reset timer and query counter, so we may call breakpoint() again down the page and get both dbcalls and time for different parts of the same mod/block
			cor_dModStart	= timer()
			cor_iQueriesMod = cor_iQueriesTotal
		end if
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public function IP()
		dim aIP, raddr, xfaddr, arrIP
		raddr	= trim(request.serverVariables("REMOTE_ADDR"))
		xfaddr	= trim(Lcase(request.serverVariables("HTTP_X_FORWARDED_FOR")))
		aIP	= raddr
		arrIP	= split(xfaddr,",")
		if NOT isArray(arrIP) Then
			arrIP = split(xfaddr,";")
			if isArray(arrIP) Then aIP = arrIP(0)
		end if
		IP = aIP
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------

	public function getWebRoot()
		getWebRoot = server.mappath(cor_sWebroot)
		if right(getWebRoot,1) <> "\" then
			getWebRoot = getWebroot & "\"
		end if
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public function normPath(path)
		dim delim
		' process physical and virtual paths
		if inStr(path, "\") > 0 Then delim = "\" else delim = "/"
		if right(path,1) <> delim then normPath = path & delim else normPath = path
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	public function strMatch(objText, objPattern, objreplace, replaceOrMatch)
		dim objMatch
		if isEmptyStr(objText) Then exit function
		if NOT isObject(oRegExp) Then
			set oRegExp		= new RegExp
			oRegExp.global		= true
			oRegExp.ignoreCase	= true
		end if
		oRegExp.pattern		= objpattern
		set objMatch = oRegExp.execute(objText)
		select case replaceOrMatch
			case true
				if objMatch.count > 0 Then
					strMatch = oRegExp.replace(objText,objreplace)
				else
					strMatch = objText
				end if
			case else
				if objMatch.count > 0 Then
					strMatch = true
				else
					strMatch = false
				end if
			end select
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------

	public function createGuid()
		dim TypeLib, tg
		set TypeLib = server.createObject("Scriptlet.TypeLib")
		tg = TypeLib.Guid
		createGuid  = left(tg, len(tg)-2)
		set TypeLib = nothing
	end function
	'---------------------------------------------------------------------------------------------------------------------------
	' Converts dates to UNIX timestamps to be stored in the database as integer value.
	'----------------------------------------------------------------------------------------------------------------------------
	public function cvUxTime(byVal dDate) '  Convert to UNIX timestamp to store in database
		if NOT isDate(dDate) then cvUxTime = clng(0) : exit function
		cvUxTime = clng(dateDiff("s", "1970-01-01 00:00:00",dDate))
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	' Converts UNIX timestamps back to dates, into the LCID format the webserver uses
	'--------------------------------------------------------------------------------------------------------------------------------
	public function cvLcidTime(byVal dDate)
		On error resume next
		dim cvTime, timezone, timezoneSrv, timezonehour, timezonemin, strTmp
		'
		'--- ensure valid entries
		dDate		= iif(isNumeric(dDate), dDate, cvUxTime(now))
		timezone	= iif(isNumeric(cor_dTimeZone), cor_dTimeZone, 0)
		timezoneSrv = iif(isNumeric(cor_iServerTimezone), cor_iServerTimezone, 0)
		cvTime		= dateAdd("s", dDate, "01/01/1970 00:00:00")
		'
		if timezone > 12 OR timezone < -12 then
			timezonehour = mid  (timezone,1, len(timezone)-1)
			timezonemin  = right(timezone,1)
		else
			timezonehour = timezone
		end if
		timezonehour	 = cint(timezonehour) - timezoneSrv
		cvTime		 = dateAdd("H", timezonehour, cvTime)
		'
		'--- check if we need to add/remove minutes
		if instr(timezone, ".") OR instr(timezone, ",") OR timezonemin > 0 then
			if left(timezonehour,1) = "-" then strTmp = "-"
			strTmp		= strTmp & 30
			cvTime		= dateAdd("N", strTmp , cvTime)
		end if
		'
		cvLcidTime		= datetime(cvTime,2) & " " & datetime(cvTime,4)
		'
		if err.number<>0 then cvLcidTime = cvLcidTime(cvUxTime(now))
		'On error goto 0
	end function
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	' public function for date format
	' intFormat = 0-8, where 0-4 same as VBScript!
	'	vbGeneralDate  	0  	Display a date in format mm/dd/yy. If the date parameter is Now(), it will also return the time, after the date
	'	vbLongDate 		1 	Display a date using the long date format: weekday, month day, year
	'	vbShortDate 	2 	Display a date using the short date format: like the default (mm/dd/yy)
	'	vbLongTime 		3 	Display a time using the time format: hh:mm:ss PM/AM
	'	vbShortTime 	4 	Display a time using the 24-hour format: hh:mm
	' 5 = "yyyy/mm/dd"
	' 6 = "mm/dd/yyyy"
	' 7 = "dd/mm/yyyy"
	' 8 = Short American Date & " " & Short Time
	'
	'---------------------------------------------------------------------------------------------------------------------------------
	public function datetime(dDate, intFormat)
		dim sep : sep = "/"
		if NOT isDate(dDate) Then datetime = dDate : exit function
		if intFormat >= 0 AND intFormat <= 4 Then
			datetime = formatDateTime(dDate, intFormat)
		elseif intFormat = 5 Then
			datetime = Year(dDate)  & sep & cor.butil.zeropad(Month(dDate),2) & sep & cor.butil.zeropad(Day(dDate),2)
		elseif intFormat = 6 Then
			datetime = cor.butil.zeropad(Month(dDate),2) & sep & cor.butil.zeropad(Day(dDate),2)   & sep & Year(dDate)
		elseif intFormat = 7 Then
			datetime = cor.butil.zeropad(Day(dDate),2)   & sep & cor.butil.zeropad(Month(dDate),2) & sep & Year(dDate)
		elseif intFormat = 8 Then
			datetime = formatDateTime(dDate, 2)
			if hour(dDate) <> 0 OR minute(dDate) <> 0 OR second(dDate) <> 0 Then
				datetime = datetime & " " & formatDateTime(dDate, 4) & ":" & zeroPad(second(dDate), 2)
			end if
		else
			datetime = dDate
		end if

	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	' generate a random code, e.g. for activation codes or new passwords when "I forgot my password" mails
	'---------------------------------------------------------------------------------------------------------------------------------
	public function genRandomCode(intLen)
	'	dim i, strTemp, strPass
		Randomize
	' The original code below has two problems.
	' One, it resets the random code's length to 10, regardless of what the calling code requested.
	' Two, there's a more efficient way to randomize this than adding some letters, then numbers, then letters, then mixing it up.
	'	intLen = 10
	'	for i = 1 To intLen / 3 ' Some lowecase
	'		strTemp = strTemp & Chr(Int((123 - 97) * Rnd() + 97))
	'	Next
	'	for i = 1 To intLen / 3 ' Some digits
	'		strTemp = strTemp & Chr(Int((57 - 48) * Rnd() + 48))
	'	Next
	'	for i = 1 To intLen / 3 ' Some uppercase
	'		strTemp = strTemp & Chr(Int((90 - 65) * Rnd() + 65))
	'	Next
	'	' Randomize the string
	'	for i = 1 To len(strTemp)
	'		if Int((3 - 1) * Rnd() + 1) = 1 Then
	'			strPass = strPass & mid(strTemp, i, 1)
	'		else
	'			strPass = mid(strTemp, i, 1) & strPass
	'		end if
	'	Next
		dim xChar, xPass, strPass
		if isEmptyNumber(intLen) then intLen = 10
		if intLen < 4 then intLen = 4
		if intLen > 25 then intLen = 25
		for xPass = 1 to intLen
			xChar = random(1,3)
			select case xChar
			case 1		' 	lowercase
				strPass = strPass & chr(random(97,122))
			case 2		'	numbers
				strPass = strPass & chr(random(48,57))
			case 3		'	uppercase
				strPass = strPass & chr(random(65,90))
			end select 
		next
		genRandomCode = strPass
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------

	public function checkPerm(pattern, group)
		dim arrPerm, i
		checkPerm = false
		if isNull(pattern) OR pattern="" Then
			exit function
		elseif inStr(pattern,",") = 0 then
			arrPerm = array(pattern) : if NOT isNumeric(arrPerm(0)) then exit function
		else
			arrPerm = split(pattern,",")
		end if
		for i = 0 to ubound(arrPerm)
			if cint(arrPerm(i)) = cint(group) AND cint(group) > 0 Then
				checkPerm = true
				exit function
			end if
		next
	end Function
	'--------------------------------------------------------------------------------------------------------------------------------
	'		Function added to decrypt the captcha id string
	'--------------------------------------------------------------------------------------------------------------------------------
	public Function decryptcaptcha(ByVal encryptedstring)
		dim x, i, tmp
		encryptedstring = StrReverse( encryptedstring )
		for i = 1 To len( encryptedstring )
			x = mid( encryptedstring, i, 1 )
			tmp = tmp & chr( asc( x ) - 1 )
		Next
		decryptcaptcha = tmp
	end function
	'
	'this code is no longer used.  Use class_filters (encrypt) function instead.
	'public Function encryptcaptcha(ByVal str)
	'	dim x, i, tmp
	'	for i = 1 To len( str )
	'		x = mid( str, i, 1 )
	'		tmp = tmp & chr( asc( x ) + 1 )
	'	Next
	'	tmp = StrReverse( tmp )
	'	encryptcaptcha = tmp
	'end Function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	Public Function checkSecurityCode(valSecurityCode, valSessionName)
		dim SessionSecurityCode
		'session prefix not used here, because counterpart securecode.asp cannot handle it
		valSessionName = decryptcaptcha(ValSessionName)
		SessionSecurityCode = trim(session(valSessionname))
		session(valSessionname) = vbNullString
		if len(SessionSecurityCode) < 1 then
			checkSecurityCode = False
			Exit function
		End If
		if cstr(SessionSecurityCode) = Ucase(cstr(valSecurityCode)) then
			checkSecurityCode = true
		else
			checkSecurityCode = false
		end if
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------

	function modExist(sModuleName)
		if eval("varType(boot_"&sModuleName&")")>0 Then modExist = true else modExist = false
	end function
	'
	function varExist(sVarName)
		varExist = false
		dim t
		t = trim(sVarName)
		if isEmpty(t) or len(t) < 1 then 	exit function
		if NOT isempty(eval(t)) Then		varExist = true
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	' simpler server.htmlEncode with null handling. Built-in HTMLencode damages HTML entities: &euro; -> &amp;euro;
	'---------------------------------------------------------------------------------------------------------------------------------
	public function htmlEncode(byVal str)
		str = replace(str&"","&"	,"&amp;",	1, -1, 1)
		str = replace(str	,""""	,"&quot;",	1, -1, 1)
		str = replace(str	,"<"	,"&lt;",	1, -1, 1)
		str = replace(str	,">"	,"&gt;",	1, -1, 1)
		htmlEncode = str
	end Function
	'
	'---------------------------------------------------------------------------------------------------------------------------------
	' Inverse of server.URLencode
	' However, it would also decode 4 hex digit Unicode characters,
	' which aren't part of the URL encoding scheme
	' http://flangy.com/dev/asp/urldecode.html
	'--------------------------------------------------------------------------------------------------------------------------------
	public function urlDecode(byVal str)
		str	  = replace(str, "+", " ")
		urlDecode = unescape(str)
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	' Generate unique ID for holder DIV's of user-generated/related content
	'---------------------------------------------------------------------------------------------------------------------------------
	public function genUniqueId()
		const idSize = 5000
		Randomize
		genUniqueId = "UID_" & int(rnd * (idSize-1))+1
	end function
	'------------------------------------------------------------------------------------------------------------------------------
	' Serializes a two-dimentional getrows returned array to a string
	'-------------------------------------------------------------------------------------------------------------------------------
	public function serialRows(arrPassed)
		dim x_i
		dim y_i
		dim tmpStr
		dim tmpStr1
		dim tmpCarr
		dim tmpCarr1
		dim tmpArr
		tmpStr  = ""
		for x_i = 0 to ubound(arrPassed,2)
			for y_i = 0 to ubound(arrPassed,1)
				tmpStr = tmpStr & arrPassed(y_i,x_i) & chr(8)
			next
			tmpStr = tmpStr & chr(9)
		next
		serialRows  = tmpStr
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' takes a serialRows string and reconstitute it back as a two dimentional array, same as if you get it from a getrows dbcall
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function regetRows(strPassed)
		dim x_i
		dim y_i
		dim tmpStr
		dim tmpStr1
		dim tmpCarr
		dim tmpCarr1
		dim tmpArr
		'
		if instr(strPassed,chr(9)) = 0 Then exit function
		tmpCarr = split(strPassed,chr(9))
		'
		if NOT isarray(tmpCarr) Then exit function
		if ubound(tmpCarr) < 0  Then exit function
		'
		tmpStr1  = tmpCarr(0)
		tmpCarr1 = split( tmpStr1,chr(8) )
		'
		redim tmpArr(ubound(tmpCarr1),ubound(tmpCarr))
		for x_i = 0 to ubound(tmpCarr) -1
			tmpStr1  = tmpCarr(x_i)
			tmpCarr1 = split( tmpStr1,chr(8) )
			for y_i  = 0 to ubound(tmpCarr1)
				tmpArr(y_i,x_i) = tmpCarr1(y_i)
			next
		next
		regetRows = tmpArr
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' check array of (usually IO) parameters that shouldn't be zero or empty
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public sub checkNotVoid(strParams)
		dim arrParams, oName, i, msg, sparam
		'
		if instr(strParams, ",") = 0 _
		OR instr(strParams, ":") = 0 _
		Then cor.msg "[ERR:checkNotVoid] " & lngSysInvalidParams
		strParams = replace(strParams, " ", "")	' trim any space
		arrParams = split(strParams, ",")		' get array of params to check
		'
		'--- extract object name where params belong
		oName	= split(arrParams(0),":")(0)
		oName	= mid(oName,2,len(oName)) & "."
		On error resume next
		for i=1 to ubound(arrParams)
			sparam = oName&arrParams(i)
			if eval("isNumeric("&sparam&")") Then
				if eval(sparam&"=0") Then
					msg = msg & "Invalid " & arrParams(i) & "<br />"
				end if
			elseif eval("isEmpty("&sparam&")") Then
				msg = msg & "Invalid " & arrParams(i) & "<br />"
			end if
		next
		if err.number <>0 then cor.stopper("[ERR:class_baseUtils] " & err.description & ": '" & sparam & "'" )
		On error goto 0
		if msg <> "" Then cor.msg(arrParams(0) & msg)
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' get (ASP) values from variants delimited as {} in a query string
	' if variant is undefined in code, the string is kept. Example:
	' a=5, b is undefined
	' execParam (a={a}&b={b}) -> a=5&b=b
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function execParam(byVal querystr)
		dim matches, match, param
		const ldelm = "{"
		const rdelm = "}"
		if isemptystr(querystr) then
			querystr= " "
		end if
		if NOT isObject(oRegExp) Then
			set oRegExp = new RegExp
			oRegExp.global = true
			oRegExp.ignoreCase = true
		end if
		oRegExp.pattern = "\" & ldelm & "([\W\w]*?)" & "\" & rdelm
		set matches = oRegExp.execute(querystr)
		for each match in matches
			param = mid(match.value, 2, len(match.value)-2)
			if isEmpty(eval(param)) Then
				querystr = replace(querystr, match.value, param)
			else
				querystr = replace(querystr, match.value, eval(param))
			end if
		next
		execParam = querystr
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' cookie mgmt
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	public sub saveCookie(name, value)
		 value = iif(isNull(value), "", cstr(value))
		 if value = "" Then delCookie(name) : exit sub
		 response.cookies(name)				= value
		 response.cookies(name).path		= cor_sWebroot
		 response.cookies(name).expires		= now()+365
	end sub
	'
	public sub saveCookieAr(arname, name, value)
		value = iif(isNull(value), "", cstr(value))
		response.cookies(cor_sCookieName&arname)(cstr(name))	= value
		response.cookies(cor_sCookieName&arname).path			= cor_sWebroot
		if cstr(value) <> "" Then
			response.cookies(cor_sCookieName&arname).expires	= now()+365
		end if
	end sub
	'
	public sub delCookie (name)
		 response.cookies(name)		= ""
		 response.cookies(name).path	= cor_sWebroot
		 response.cookies(name).expires	= now()-365
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' cache mgmt (sys/lang/menu types)
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function getCache(name)
		if NOT isEmpty(application(cor_pre&name)) Then cor_bCached = true
		getCache = application(cor_pre&name)
	end function
	'
	public sub updCache(name, value, byVal typ)
		typ = lcase(typ)
		if (cor_cUseSysCache  AND typ="sys")  _
		OR (cor_cUseLangCache AND typ="lang") _
		OR (cor_cUseMenuCache AND typ="menu") Then
			application.lock
			application(cor_pre&name) = value
			application.unlock
			cor_bCached = false
		end if
	end sub
	'
'-------------------------------------------------------------------------------------------------------------------------------------
	'
	' Strip parameter from querystring
	'
	'-------------------------------------------------------------------------------------------------------------------------------------
	public function stripq(query, param)
		dim qs
		if query = "" Then exit function
		qs = replace(lcase(query), lcase(param), "")
		qs = replace(qs, "&&", "&")
		qs = replace(qs, "?&", "?")
		stripq = qs
	end Function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Embed Manager (ASP part)
	' (js counterpart in core.js->EmbedMan())
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function setEmbedState()
		dim ioEmbed, ckEmbed
		'
		ioEmbed = cor.io.q("emb")
		ckEmbed = request.cookies("emb")
		'
		select case ioEmbed
			case "0"
				'--- disable embedding
				if ckEmbed <> "0" Then saveCookie "emb", "0"
				setEmbedState = false
				'
			case "1"
				'--- enable embedding
				if ckEmbed <> "1" Then saveCookie "emb", "1"
				setEmbedState = true
			case else
				'--- embedding according persistance
				setEmbedState = iif(ckEmbed="1", true, false)
		end select
	end Function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' convert a delimited string to an array. Mind to trim trailing spaces!
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function deserialize(byval str, delim)
		if isEmpty(str) OR isNull(str) then deserialize = array() : exit function
		str = trim(str)
		' get rid of first/last redundant delimiters, if any
		if left (str, len(delim)) = delim then str = mid (str, len(delim)+1)
		if right(str, len(delim)) = delim then str = left(str, len(str)-len(delim))
		if str = "" then deserialize = array() : exit Function
		deserialize = split(str, delim)
	End Function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Randomizer function (takes lowval and highval input and outputs a random value between the two)
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	Public Function random(lowval,highval)
		Randomize
		if lowval > highval then
			random=cint(lowval * Rnd + highval)
		elseif lowval = highval then
			random = lowval
		else
			random=cint(highval * Rnd + Lowval)
		end if
		'random = cInt((highval - lowval + 1) * Rnd + lowval)
		
	End Function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Simple functions to display Error, Info and Success purr message, extended to allow for redirection and page animation.
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	Public Function errorMsg(msgText,headerText,fade,fadetimeout,redirect,url,urltimeout,scroll)
		Dim purr
		Set purr = new class_Purr
		purr.isNewPm		= "false"
		purr.screenPosition = "center-center"
		purr.CssClasstop 	= "purr-top-warnL3"
		purr.CssClassBody 	= "purr-body-warnL3"
		purr.CssClassBottom = "purr-bottom-warnL3"
		purr.Image			= "True"
		purr.HeaderTxt		= headerText
		purr.MessageTxt		= msgText
		If not fade Then purr.isSticky		= "true"
		If fade Then purr.removeTimer	= fadetimeout
		purr.doPurr
		Set purr = Nothing
		If redirect OR scroll Then cor.str.wri "<script type=""text/javascript""><!-- <[CDATA["
		If redirect Then cor.str.wri "setTimeout('parent.window.location = """ & url & """', " & urltimeout & ");"
		If scroll Then cor.str.wri "$('html,body#" & cor_sBodyId & "').animate({scrollTop:0}, 2000);"
		If redirect OR scroll Then cor.str.wri "// ]]> --></script>"
		if redirect then call cor.off()

	End Function
	'
	'
	Public Function successMsg(msgText,headerText,fade,fadetimeout,redirect,url,urltimeout,scroll)
		Dim purr
		Set purr = new class_Purr
		purr.isNewPm		= "false"
		purr.CssClasstop 	= "purr-top-succes"
		purr.CssClassBody 	= "purr-body-succes"
		purr.CssClassBottom = "purr-bottom-succes"
		purr.screenPosition = "center-center"
		purr.Image			= "True"
		purr.HeaderTxt		= headerText
		purr.MessageTxt		= msgText
		If Not fade Then purr.isSticky		= "true"
		If fade Then purr.removeTimer	= fadetimeout
		purr.doPurr
		Set purr = Nothing
		If redirect OR scroll Then cor.str.wri "<script type=""text/javascript""><!-- <[CDATA["
		If redirect Then cor.str.wri "setTimeout('parent.window.location = """ & url & """', " & urltimeout & ");"
		If scroll Then cor.str.wri "$('html, body').animate({scrollTop:0}, 2000);"
		If redirect OR scroll Then cor.str.wri "// ]]> --></script>"
		if redirect then call cor.off()
	End Function
	'
	'
	Public Function infoMsg(msgText,headerText,fade,fadetimeout,redirect,url,urltimeout,scroll)
		Dim purr
		Set purr = new class_Purr
		purr.isNewPm		= "false"
		purr.CssClasstop 	= "purr-top-info"
		purr.CssClassBody 	= "purr-body-info"
		purr.CssClassBottom = "purr-bottom-info"
		purr.screenPosition = "center-center"
		purr.Image			= "True"
		purr.HeaderTxt		= headerText
		purr.MessageTxt		= msgText
		If Not fade Then purr.isSticky		= "true"
		If fade Then purr.removeTimer	= fadetimeout
		purr.doPurr
		Set purr = Nothing
		If redirect Then cor.str.wri "<script type=""text/javascript"">setTimeout('parent.window.location = """ & url & """', " & urltimeout & ");</script>"
		If scroll Then cor.str.wri "<script type=""text/javascript"">$('html, body').animate({scrollBottom:0}, 2000);</script>"
		if redirect then call cor.off()
	End Function
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	' Function to display banner add's from a given zone
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	Function printBanner(intZoneID)
		If cor_bBanners Then '<cor_bBanners>
			'define variables
			Dim intZone_ID, arrBanners, rndMax, rndNumber
			Dim intBannerID, strBannerTitle, strBannerPicURL, strBannerURL, Banners, intBannerImpression, strBannerText
			dim imageBanner, FlashLink, intBannerWidth, intBannerHeight, strLinkTarget, intInterest, strBannerHtml
			Dim FlashBanner, strBorderColor, strBackground, strBannerLine1, strBannerLine2, strBannerLine3
			Dim strBannerTitleColor, strBannerLineColor, strBannerBottomColor, strBannerBorder, strBannerBackground
			Dim htmlBanner, intBanner, intBannerType, b_sql
			intZone_ID = cor.filter.checkInt(intZoneID)
			
			'test to make sure we have an enabled zone.  Otherwise, show nothing.
			dim pbCheck
			pbCheck = cor.dal.getvalue("SELECT BannerZoneEnabled FROM " & cor_dbpre & "bannerzones WHERE BannerZone_ID={0}",array(intZoneID))
			If isEmpty(pbCheck) Or IsNull (pbCheck) Or len(cstr(pbcheck)) < 1 Then pbCheck = 0
			if pbcheck < 1 then		'we have no eabled banner zone here.
				printBanner = ""
				exit function
			end if
			'Get Data
			'-----------------0------------1---------------2-
			'------------------3-------------4---------------------5--------------6----------------7----------------8-
			'------------------9-------------------10----------------11-
			'------------------12---------------13-------------14-
			b_sql = "SELECT b.Banner_ID, b.Banner_Title, b.Banner_Pic_URL, " & _
							"b.Banner_URL, b.Banner_Impressions, b.Banner_Hits, b.BannerZone_ID, b.BannerType_ID, b.BannerEnabled, " & _
							"b.Banner_StartDate, b.Banner_EndDate, b.Banner_Client_ID, " & _
							"b.Banner_Target, b.Banner_Html, t.bannerType_ID  " & _
					"FROM " & cor_dbpre & "banners AS b " & _
					"INNER JOIN " & cor_dbpre & "bannertypes AS t ON b.BannerType_ID=t.BannerType_ID " & _
					"WHERE " & "b.BannerEnabled = {0} AND b.BannerZone_ID = {1} AND {2} BETWEEN b.banner_startdate and b.banner_enddate"
			'
			'set the to retrieve records per page to be sure to be above the maximum banner existing active records!
			cor.dal.open arrBanners, b_sql, array(1,intZone_ID,cor.butil.cvUxTime(now()))
			b_sql = ""
			If Not cor.butil.eof(arrBanners) Then '</EOF>
				' Get the total number of records returned for the randomizer
				rndMax = Ubound(arrBanners,2)
				rndNumber = -1
				do until rndNumber >= 0 and rndNumber =< rndMax
					' check to see there are more than one record to randimize
					If rndMax > 0 Then
						rndNumber = random(0,rndMax)
					Else
						rndNumber=rndMax
					End If
				loop
				'set vars
				intBannerImpression = cor.filter.checkDbl(arrBanners(4,rndNumber)) + 1
				intBannerID			= arrBanners(0,rndNumber)
				strBannerTitle		= arrBanners(1,rndNumber)
				strBannerPicURL		= arrBanners(2,rndNumber)
				strBannerURL		= arrBanners(3,rndNumber)
				strLinkTarget		= arrBanners(12,rndNumber)
				strBannerHtml		= arrBanners(13,rndNumber)
				intBannerType		= arrBanners(14,rndNumber)
				b_sql = "UPDATE " & cor_dbpre & "banners SET Banner_Impressions=" & intBannerImpression _
					& " WHERE Banner_ID=" & intBannerID
				cor.dal.exec b_sql, array()
				'Main HTML For banner display
				select case intBannerType
				case 3
'					cor.str.add cor.filter.escEditor(strBannerHtml)
					cor.str.add strBannerHtml
				case 2
					FlashLink = strBannerPicURL & "?ClickTAG=" & Server.URLEncode(cor_sWebroot & _
								"banner_id.asp?banner_id=" & intBannerID)
					cor.str.add "<a href=""banner_id.asp?banner_id=" & intBannerID & """ style=""cursor:pointer; height:240px; z-index:1010;"">"
					cor.str.adn "<object classid=""clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"" "
					cor.str.adn "codebase=""http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,19,0"" "
					cor.str.adn "width=""468"" height=""60"" align=""top""><param name=""movie"" value=""" & FlashLink & """ />"
					cor.str.adn "<param name=""quality"" value=""high"" /><param name=""menu"" value=""false"" />" & _
								"<param name=""wmode"" value=""transparent"" />"
					'cor.str.adn "<embed src=""" & FlashLink & """ quality=""high"" pluginspage=" & _
					'			"""http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash""" & _
					'			" type=""application/x-shockwave-flash"" width=""468"" height=""60"" " & _
					'			"menu=""false"" wmode=""transparent"" align=""top""></embed>"
					cor.str.add "</object></a>"
				case 4
					cor.str.add strBannerHtml
				case 1
					cor.str.adn "<a href=""" & cor_sWebroot & "banner_id.asp?banner_id=" & intBannerID & """ target=""" & Trim(strLinkTarget) & """>" & _
								"<img alt=""" & strBannerTitle & """ src=""" & strBannerPicURL & """ /></a>"
				End Select 
			End If '</EOF>
		End If '</cor_bBanners>
		printBanner = cor.str.build
	End Function
	'* http://www.psacake.com/web/func/htmldecode_function.htm
	public function HTMLdecode(byVal encodedstring)
		dim tmp, i
		tmp = encodedstring
		tmp = replace( tmp, "&quot;", chr(34) )
		tmp = replace( tmp, "&lt;" , chr(60) )
		tmp = replace( tmp, "&gt;" , chr(62) )
		tmp = replace( tmp, "&amp;" , chr(38) )
		tmp = replace( tmp, "&nbsp;", chr(32) )
		for i = 1 to 255
			tmp = replace( tmp, "&#" & i & ";", chr( i ) )
		Next
		HTMLdecode = tmp
	end Function
	
	public Function ParseSearchKeywords(strSearchWords)
		'FROM http://bytes.com/groups/asp/52614-keyword-parsing-asp, Chris Hohmann, 19 Jul 2005
		'	1. Don't mix delimiters for a phrase. This will work correctly:
		'		Jack, Jill Jim, "Timothy Brown", 'Mary'
		'	but this will not:
		'		Jack, Jill Jim, "Timothy Brown', 'Mary'
		'	2 If literal delimiter characters are used, all delimiters in the entire list must be the same. This will work:
		'		Jim, "Tom Brown", "Pat O'Malley"
		'		This won't:
		'		Jim, 'Tom Brown', "Pat O'Malley"
		'The value list can contain a mixture of quote-qualified phrases and apostrophe qualified phrases.
		'Also, a qualifier can be embedded into a phrase by doubling-it-up (escaping).
		'Finally, regular expression, by default are greedy algorithms (although you can override this behavior).
		'As such the expression will match as much of the string as possible. 
		' Having said all that, the following should be a valid value list:
		'Bob, Barrows, "Bob 'The Man' Barrows", 'Bob "The Man" Barrows', "Bob ""The Man"" Barrows", 'Bob ''The Man'' Barrows'
		' Or:
		'Jack, Jill Jim, 'Timothy Brown', Mary
		'Expression needs tweaking; this search fails to split:
		'	"MS Access", them, "Soop Phoenix" 
		Dim oRE,oMatches,oMatch, arrWords()
		dim xi : xi = 0
		Set oRE = New RegExp
		oRE.Global=True
		oRE.Pattern = "\w+|('|"")([^\1]|\1{2})+\1"
		'\w+ = a series of one(1) or more word characters, i.e. 	[a-zA-Z0-9_]
		'| = OR
		'('|") = a quote (") OR an apostrophe ('), let call this submatch QUALIFIER
		'([^\1]|\1{2})+ = one(1) or more characters that are either not the QUALIFIER
		'	OR a double occurrence of the QUALIFIER (escaping quotes)
		'\1 = a closing instance of the QUALIFIER
		Set oMatches = oRE.Execute(strSearchWords)
		For Each oMatch In oMatches
			redim preserve arrWords(xi + 1)
			arrWords(xi) = trim(oMatch.Value)
			if left(arrWords(xi),1) = """" or left(arrWords(xi),1) = "'" then
				arrWords(xi) = mid(arrWords(xi), 2,(len(arrWords(xi)) - 1))
			end if
			if right(arrWords(xi),1) = """" or right(arrWords(xi),1) = "'" then
				arrWords(xi) = mid(arrWords(xi), 1, (len(arrWords(xi)) - 1))
			end if
			arrWords(xi) = cor.dal.escapeParam(trim(arrWords(xi)))  'Clean code for DB testing.
			'response.write arrWords(xi) & "<br />"  'Debug print
			xi = xi + 1
		Next
		redim preserve arrWords(xi - 1)
		ParseSearchKeywords = arrWords
	end function

	public function GetLCIDDateformat()
		dim Dateformat
		'build datepicker date format from LCID
		'added 29 Apr 2009
		select case cor_cCalendarLCID
		case 1052,3084,1045,1053
			dateFormat = "yy-mm-dd"
		case 1078,7177,1077,1069,1132,1074,1076
			dateFormat = "yy/mm/dd"
		case 1038
			dateFormat = "yy. mm. dd. "
		case 1062,1063
			dateFormat = "yy.mm.dd"
		case 1104
			dateFormat = "y.mm.dd"
'
		case 1033,13321,12297,1124,1089
			dateFormat = "m/d/yy"
		case 9225,6154
			dateformat = "mm/dd/yy"
'
		case 2092,1068,1059,4108,1071,1031,3079,5127,4103,2055,2064,1087,1044,2068,1048,1049,1083,1092,1055,1058,2115
			dateformat = "dd.mm.yy"
		case 1027,2057,3081,10249,4105,6153,8201,5129,5132,6156,2108,1057,1040,1131,2155,3179,1047,1036,2060
			dateFormat = "dd/mm/yy"
		case 1050,4122,1029,1061,1035,1039,5146,1026,2074,3098,1060,2077
			dateFormat = "d.m.yy"
		case 1030,2067,1080,2070,13322
			dateFormat = "dd-mm-yy"
		case 1043,1122
			dateFormat = "d-m-yy"
		case 1057, 1086, 2110, 1082,1153,11273,3082,1034,11274,16394,9226,5130,7178,12298,17418,4106,18442,2058,19466,15370,10250,20490,14346,8202,11273,1106
			dateFormat = "dd/mm/yy"
		case 1110
			dateFormat = "dd/mm/y"
		case 1032, 1046
			dateFormat = "d/m/yy"
		case 1088
			dateFormat = "dd.mm.y"
		case 1051
			dateFormat = "d. m. yy"
		case 1091
			dateFormat = "dd/mm yy"
		case else
			dateFormat = "dd/mm/yy"
		end select		
		'dateFormat: 'yy-mm-dd'
		'	d or dd for day 1 or 01
		'	m or mm for month 1 or 01
		'	y or yy for year (2 or 4 digit)

		GetLCIDDateformat = " dateFormat: '" & dateFormat & "' "
	end function
end class
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
'  core functions outside a class for compactness
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' VB iif emulator
'
function iif(condition, value1, value2)
	if condition then iif = value1 else iif = value2
end function
'
' VB max emulator
'
function max(a, b)
	if a > b Then max = a else max = b
end function

'
'<#late-binding hook
function boot_class_baseUtils : boot_class_baseUtils = true : end function
'/>
%>
