﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

'--- dependencies between core classes:
'--- 0
' class_string 				:: none
' class_sha256 				:: none
' class_debug 				:: none
'--- 1
' class_baseUtils			:: global
' class_filters				:: global
' class_objectsPool			:: global
' class_dal 				:: global
'--- 2
' class_sqlBuilder 			:: ':: global, class_filters, (class_string)
' class_media 				:: global, class_objectsPool
'--- 3
' class_languageParser		:: global, class_baseUtils, class_objectsPool
' class_RTEbuilder 			:: global, class_string, class_baseUtils	//_init_plugins.asp: class_tinyMCE, class_FCK
' class_modbox 				:: global, class_string, class_baseUtils
' class_dyninc 				:: global, class_string, class_objectsPool
' class_modules 			:: global, class_baseUtils, class_dal
' class_mgmt_menutree		:: global, class_baseUtils, class_dal
' class_menu				:: class_string, class_baseUtils, class_objectsPool
'--- 4
' class_io 					:: global, class_filters, class_objectsPool, class_audit
' class_boxing 				:: global, class_string, class_filters, class_modbox
' class_configHandler		:: global, class_baseUtils, class_dal, class_objectsPool 
' class_stats 				:: global, class_baseUtils, class_dal, class_io
' class_audit 				:: global, class_dal, class_utils, class_objectsPool
' class_sendmail 			:: global, class_baseUtils, class_filters, class_config
'--- 5
' class_comboBuilder		:: class_string, class_baseUtils, class_filters, class_dal, class_objectsPool
' class_checkboxBuilder		:: class_string, class_baseUtils, class_filters, class_dal, class_objectsPool
' class_permissions			:: global, class_baseUtils, class_filters, class_dal, class_debug  
' class_assetman			:: global, class_string, class_fso, class_languageParser, class_utils
'--- 6
' class_pm					:: global, class_baseUtils, class_filters, class_dal, class_io, class_sendmail
'--- 8
' class_menu_acc			:: global, class_string, class_baseUtils, class_filters, class_dal, class_languageParser, class_permissions, cor_xmlSoopMenu
' class_menu_phh			:: global, class_string, class_baseUtils, class_filters, class_dal, class_languageParser, class_permissions, cor_xmlSoopMenu
'--- max
' class_utils				:: global, class_string, class_baseUtils, class_filters, class_dal, class_dyninc, class_languageParser, class_io, class_configHandler, class_permissions, cor_xmlSoopMenu
' class_template			:: global, class_string, class_filters, class_dal, class_utils
' class_members				:: global, class_baseUtils, class_dal, class_io, class_filters, class_configHandler, class_sha256, class_utils, class_sendmail
' class_login				:: global, class_baseUtils, class_dal, class_io, class_filters, class_menu_acc, class_menu_phh, class_stats, class_utils
' class_boot				:: <all>
'
'--- page level (after class_boot/core_init.asp)
' class_secureCode			:: none // page init: securecode.asp
' class_pageNo				:: class_string // _init_core.asp, page init
' class_imageSizer			:: class_objectsPool // inc_ndutil.asp
' class_forum				:: global, class_string, class_baseUtils, class_filters, class_dal, class_io, class_languageParser // _init_forum.asp
' class_guestbook			:: global, class_baseUtils, class_filters, class_dal, class_io, class_template
'---
'
class class_boot
	'--- 0
	public str
	public sha
	public debug
	' class_secureCode
	'--- 1
	public butil
	public filter
	public obj
	public dal
	'--- 2
	public sql
	public media
	'--- 3
	public lng
	public rte
	public modbox
	public dyninc
	public module
'	public mgtree 
	public audit
	public menu
	'--- 4
	public io
	public boxing
	public cfg
	public stats
	public asset
	public mail
	'--- 5
	public combo
	public checkbox
	public perm
	'--- 6
	public pm
	'--- 7
'	public menuacc
	public menuphh
	'--- max
	public util	
	public tpl
	public member
	public login
	public errTrap
	'--- page level
	' class_secureCode
	' class_pageNo
	' class_imageSizer
	public forum
	public guestbook
	'
	public connString
	public enablePooling
	'
	public sub boot()
		'--------------------------------------------------------------------------------------------
		' core classes init
		' Instantiate objects with the LESS dependencies FIRST, to ensure more dependent classes
		' would instantiate in later steps
		'--------------------------------------------------------------------------------------------
		'--- 0
		
		set cor.str			= new class_string
		set cor.sha			= new class_sha256
		if eval("varType(boot_class_debug)")>0 Then _
			set cor.debug 		= new class_debug
		'--- 1
		set cor.butil		= new class_baseUtils
		set cor.filter		= new class_filters
		set cor.obj			= new class_objectsPool
		set cor.dal			= new class_dal
		set cor.errTrap		= new class_errorTrap
		'--- 2
		set cor.sql			= new class_sqlBuilder
		if eval("varType(boot_class_media)")>0 Then _
			set cor.media		= new class_media
		'--- 3
		set cor.lng			= new class_languageParser
		set cor.rte			= new class_RTEbuilder
		set cor.modBox		= new class_modbox
		if eval("varType(boot_class_dyninc)")>0 Then _
			set cor.dyninc		= new class_dyninc
		set cor.module		= new class_modules
'		if eval("varType(boot_class_mgmt_menutree)")>0 Then _
'			set cor.mgtree 		= new class_mgmt_menutree
'		if eval("varType(boot_class_menu)")>0 Then _
'			set cor.menu		= new class_menu
		'--- 4
		if eval("varType(boot_class_sendmail)")>0 Then _
			set cor.mail		= new class_sendmail
		set cor.io 			= new class_io
		set cor.boxing		= new class_boxing
		set cor.cfg 		= new class_configHandler
		if eval("varType(boot_class_stats)")>0 Then _
		set cor.stats 		= new class_stats 
		if eval("varType(boot_class_audit)")>0 Then _
		set cor.audit		= new class_audit
		'--- 5
		set cor.combo		= new class_comboBuilder
		if eval("boot_class_CheckBoxBuilder")>0 Then _
			set cor.checkbox	= new class_checkboxBuilder
		set cor.perm		= new class_permissions
		if eval("varType(boot_class_assetman)")>0 Then _
			set cor.asset		= new class_assetman
		'--- 6
		if eval("varType(boot_class_pm)")>0 Then _
			set cor.pm			= new class_pm
		'--- 7
'		if eval("varType(boot_class_menu_acc)")>0 Then _
'			set cor.menuacc		= new class_menu_acc
		if eval("varType(boot_class_menu_phh)")>0 Then _
			set cor.menuphh		= new class_menu_phh
		'--- max
		set cor.util 		= new class_utils
		set cor.tpl			= new class_template
		if eval("varType(boot_class_members)")>0 Then _
			set cor.member		= new class_members
		set cor.login		= new class_login 

		'--- page level	
		' class_secureCode
		' class_pageNo
		' class_imageSizer
		if eval("varType(boot_class_forum)")>0	Then _
			set cor.forum		= new class_forum
		if eval("varType(boot_class_guestbook)")>0 Then _
			set cor.guestbook = new class_guestbook
	end sub
	'
	public sub shutdown()
		'
		' de-reference (dependant) objects in INVERSE order (or these with the MOST dependencies FIRST),
		' to ensure that ALL other references to the same object, pointing to it from other class-objects,
		' get also de-referenced and so the object *really* disposed
		'
		'--- page-level
		if isObject(guestbook)	Then set guestbook	= nothing : guestbook	= empty
		if isObject(forum)		Then set forum		= nothing : forum		= empty
		' class_imageSizer
		' class_pageNo
		' class_secureCode
		'--- max
		if isObject(login)		Then set login		= nothing : login		= empty
		if isObject(member)		Then set member		= nothing : member		= empty
		if isObject(tpl)		Then set tpl		= nothing : tpl			= empty
		if isObject(util)		Then set util		= nothing : util		= empty
		'--- 7
		if isObject(menuphh)	Then set menuphh	= nothing : menuphh		= empty
'		if isObject(menuacc)	Then set menuacc	= nothing : menuacc		= empty
		'--- 6
		if isObject(pm)			Then set pm			= nothing : pm			= empty
		'--- 5
		if isObject(asset)		Then set asset		= nothing : asset		= empty
		if isObject(perm)		Then set perm		= nothing : perm		= empty
		if isObject(checkbox)		Then set checkbox	= nothing : checkbox	= empty
		if isObject(combo)		Then set combo		= nothing : combo		= empty
		'--- 4
		if isObject(mail)		Then set mail		= nothing : mail		= empty
		if isObject(audit)		Then set audit		= nothing : audit		= empty
		if isObject(stats)		Then set stats		= nothing : stats		= empty
		if isObject(cfg)		Then set cfg		= nothing : cfg			= empty
		if isObject(boxing)		Then set boxing		= nothing : boxing		= empty
		if isObject(io)			Then set io 		= nothing : io			= empty
		'--- 3
		if isObject(menu)		Then set menu		= nothing : menu		= empty
'		if isObject(mgtree)		Then set mgtree		= nothing : mgtree		= empty
		if isObject(module)		Then set module		= nothing : module		= empty
		if isObject(dyninc)		Then set dyninc		= nothing : dyninc		= empty
		if isObject(modBox)		Then set modBox		= nothing : modBox		= empty
		if isObject(rte)		Then set rte		= nothing : rte			= empty
		if isObject(lng)		Then set lng		= nothing : lng			= empty
		'--- 2
		if isObject(media)		Then set media		= nothing : media		= empty
		if isObject(sql)		Then set sql		= nothing : sql			= empty
		'--- 1
		if isObject(errTrap)	Then set errTrap	= nothing : errTrap			= empty
		if isObject(dal)		Then set dal		= nothing : dal			= empty
		if isObject(obj)		Then set obj		= nothing : obj			= empty
		if isObject(filter)		Then set filter		= nothing : filter		= empty
		if isObject(butil)		Then set butil		= nothing : butil		= empty
		'--- 0
		if isObject(debug)		Then set debug		= nothing : debug		= empty
		if isObject(sha)		Then set sha		= nothing : sha			= empty
		if isObject(str)		Then set str		= nothing : str			= empty
	end sub
	'
	'--------------------------------------------------------------------------------------------
	'
	' shutdown routines
	'
	'--------------------------------------------------------------------------------------------
	'
	' response.redirect substitute that ensures all page resources are consistently disposed
	public sub redir(surl)
		checkStack(surl)
		' http://support.microsoft.com/kb/159402
		' clear response obj of any remaining html to allow redirection
		call off()
		response.clear
		response.redirect surl
		' avoids any static html after redirect() to be sent to the browser
		response.end
	end sub
	'
	public sub redirm(smsg, surl)
		checkStack(surl)
		'--- ensure thickbox enabled instead of inplace
		session.contents.remove(cor_pre&"inpage_")
		'--- ensure already existing messages are also displayed (but not repeated ones)
		if  session(cor_pre&"msg_") <> "" AND smsg <> "" AND instr(session(cor_pre&"msg_"), smsg)>0 Then
		elseif smsg <> "" Then
			session(cor_pre&"msg_") = session(cor_pre&"msg_") & "<br />" & smsg
		end if
		call off()
		response.clear
		response.redirect surl
		response.end
	end sub
	'
	public sub msg(smsg)
		'--- disable thickbox to show inplace instead
		session(cor_pre&"inpage_")  = true
		'--- ensure already existing messages are also displayed (but not repeated ones)
		if  session(cor_pre&"msg_") <> "" AND smsg <> "" AND instr(session(cor_pre&"msg_"), smsg)>0 Then
			checkStack(request.serverVariables("URL"))
		elseif smsg <> "" Then
			session(cor_pre&"msg_") = session(cor_pre&"msg_") & "<br />" & smsg
		else '--- no message to display, redir instead
			redir(cor_sWebroot)
		end if
		call off()
		response.clear
		server.transfer "msg.asp"
		response.end
	end sub
	'
	' when an error may loop in an endless redirection, use this method instead
	public sub stopper(smsg)
		call off()
		response.clear
		response.write smsg
		response.end
	end sub
	'
	public sub off()
		if eval("varType(mods_dispose)")>0 Then call mods_dispose()
		call shutdown()
	end sub
	'
	'--------------------------------------------------------------------------------------------
	'
	' Helpers
	'
	'--------------------------------------------------------------------------------------------
	'
	' prevent stack overflow that may crash the server, from redirects that become endless because were called from an unsuitable place 
	private sub checkStack(surl)
		dim u, c, d
		' url ** counter of same url event ** time of last event
		'--------------------------------------------------------------0--------1-------------2----
		if instr(session(cor_pre&"stack_"),"**") = 0 then session(cor_pre&"stack_") = surl & "**1**" & udate(now) : exit sub
		'
		u = cstr(split(session(cor_pre&"stack_"),"**")(0))
		c = cint(split(session(cor_pre&"stack_"),"**")(1))
		d = clng(split(session(cor_pre&"stack_"),"**")(2))
		'
		'--- same url changed too fast! (less than 3 sec time-frame)
		if  lcase(u)=lcase(surl) AND (d+3) > udate(now) then
			session(cor_pre&"stack_") = surl & "**" & (c+1) & "**" & udate(now)
			if c+1 > 10 then session.contents.remove(cor_pre&"stack_") : stopper("[ERR:class_boot] " & lngSysStackOverflowMsg & " [" & c & "]")
		else
			session.contents.remove(cor_pre&"stack_")
		end if
	end sub
	'
	private function udate(dDate)
		udate = cdbl(dateDiff("s", "01/01/1970 00:00:00", dDate))
	end function
	'
	private sub class_terminate()
		call off()
	end sub
	'
end class

%>
