﻿<%
'---------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - initial 22/07/2007
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'-----------------------------------------------------------------------------------------------------------------------------------

class class_boxing ':: global, class_string, class_filters, class_modbox
	'-----------------------------------------------------------------------------------------------------------------------------
	'
	'------------------------------------------------------------------------------------------------------------------------------
	public sub print2ColumnTop( strHeader, strTT)
		 PrintBoxTopMerged strHeader, strTT, 2
	end sub
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'-------------------------------------------------------------------------------------------------------------------------------
	public sub print2ColumnBottom()
		PrintBottomMerged(2)
	end sub
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'-----------------------------------------------------------------------------------------------------------------------------
	public sub print3ColumnTop( strHeader, strTT)
		PrintBoxTopMerged strHeader, strTT, 3
	end sub
	'----------------------------------------------------------------------------------------------------------------------------------
	'
	'---------------------------------------------------------------------------------------------------------------------------------
	public sub print3ColumnBottom()
		PrintBottomMerged(3)
	end sub
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'-------------------------------------------------------------------------------------------------------------------------------
	public sub printBoxTop(strHeader, strTT)
		PrintBoxTopMerged strHeader, strTT, 1
	end Sub
	'
'	Public sub printBoxTabTop()
'		If cor_bEmbedded Then exit Sub
'		'If strHeader <> "" Then bShowBoxing = True
'		If NOT bShowBoxing Then exit Sub
'		Dim module_box
'		Set module_box = New class_modbox
'			module_box.printBoxTabTop
'		set module_box = nothing
'	end Sub
	
	public sub printBoxBottom()
		PrintBottomMerged(1)
	end sub

	'----------------------------------------------------------------------------------------------------------------------------------
	'Code below combines duplicate code from above into single modules rather than multiples.  Fewer lines, fewer bugs!
	'charles 6 Feb 2009
	'---------------------------------------------------------------------------------------------------------------------------------
	private sub PrintBoxTopMerged(strHeader, strTT, Cols)
		'code merged from print2columntop, printBoxTop and print3columntop modules.
		if cor_bEmbedded Then exit sub
		dim topArray
		dim z_i
		if strHeader = "" Then bShowBoxing = false
		select case cols	'this line is different from different source code (just the comment changes, but still....
		case 2, 3
			str.wri "<div id=""innerWrapper""><!-- <innerWrapper#" & cstr(cols) & "> -->"
		case else	'one col, note that we don't have as much code for this box. NOTE Yes WE DO!
			if NOT bShowBoxing then exit sub
			str.wri "<div id=""innerWrapper""><!-- <innerWrapper#1> -->"
			str.wri "<div id=""content""><!-- <content#1> -->"
'			PrintModBoxMerged strHeader, strTT
			exit sub
		end select
		'two and three cols use this layout.
		str.wri "<div id=""left-col""><!-- <left-col#1> -->"
		if NOT cor_bUseFreeLayout Then
			cor.module.arrangeColumn(1)
		else
			if NOT cor.butil.isEmptyStr(cor_sLeft) Then
				topArray = split( cor_sLeft, "," )
				for z_i = 0 To ubound(topArray)
					Call cor.module.arrangeOne(toparray(z_i),false)
				next
			end if
		end if
		str.wri "</div><!-- </left-col#1> -->"
		str.wri "<div id=""content""><!-- <content#2> -->"
		if NOT bShowBoxing Then exit sub
'		PrintModBoxMerged strHeader, strTT
	end sub
	'
	'
	private sub PrintModBoxMerged(strHeader, strTT)
		'merged from Print2ColumnTop, PrintBoxTop, and Print3ColumnTop above.
		dim module_box
		set module_box = New class_modbox
			module_box.box_toggle		= false
			module_box.box_hide			= false
			module_box.box_name			= cor.butil.genUniqueId()
			module_box.box_title_text	= server.htmlEncode(strHeader)
		if strTT <> "" Then
			module_box.box_tool_tip		= true
			module_box.box_tool_tip_text = strTT
			module_box.printBoxTop
			module_box.printBoxTT
		else
			module_box.box_tool_tip		= false
			module_box.box_tool_tip_text = ""
			module_box.printBoxTop
		end if
		set module_box = nothing
	end sub
	'
	'
	private sub PrintBottomMerged(cols)
		'combines print3CoumnBottom, print2ColumnBottom, and printBoxBottom
		if cor_bEmbedded  Then exit sub
'		if bShowBoxing Then
'			dim module_box
'			set module_box  = New class_modbox
'				module_box.printBoxBottom
'			set module_box  = nothing
'			bShowBoxing = false
'		end if
		str.wri "</div><!-- </content#" & cstr(cols) & "> -->"
		if cols < 3 then
			str.wri "</div><!-- </innerWrapper#" & cstr(cols) & "> -->"	
			exit sub			'end 2col and innerWrapper
		end if
		'	only needed for 3col layout:
		dim topArray
		dim z_i
		str.wri "<div id=""right-col""><!-- <right-col#3> -->"
		if NOT cor_bUseFreeLayout Then
			cor.module.arrangeColumn(3)
		else
			if NOT cor.butil.isEmptyStr(cor_sRight) Then
				topArray = split( cor_sRight, "," )
				for z_i = 0 To ubound(topArray)
					Call cor.module.arrangeOne(toparray(z_i),false)
				next
			end if
		end if
		str.wri "</div><!-- </right-col#3> -->"
		str.wri "</div><!-- </innerWrapper#3> -->"
	end sub

'

	private sub class_initialize()
		if cor_bEmbedded Then bShowBoxing=false else bShowBoxing=true
		set str = new class_string
	end sub
	'
	private sub class_terminate
		set str = nothing
	end sub
	'
	private str
	private bShowBoxing
end class

'<#late-binding hook
function boot_class_boxing : boot_class_boxing = true : end function
'/>

%>
