﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
class class_configHandler ':: global, class_baseUtils, class_DAL, class_objectsPool 

	public default function item(cname)
		dim tmpcvalue
		if  cor.obj.dict.exists(pre&cname) Then
			item = cor.obj.dict.item(pre&cname)
		else
			tmpcvalue = cor.dal.getValue("SELECT c.cvalue FROM " & cor_dbpre & "config AS c WHERE " & cor_dbLC & "(c.cname)={0}", array(lcase(cname)))
			if len(tmpcvalue) = 0 Then
				err.raise vbObjectError+1, "[ERR:class_configHandler]", "Missing Config cvalue: "& cname
				tmpcvalue = ""
			else
				' handle nulls as empty strings
				if isNull(tmpcvalue) then tmpcvalue=""
				cor.obj.dict.add pre&cname, tmpcvalue
			end if
			item = tmpcvalue
		end if
	end function

	public function exists(cname)
		if cor.obj.dict.exists(pre&cname) Then exists = true else exists = false
	end function

	public sub setValue(cname, cvalue) 
		if cor.obj.dict.exists(pre&cname) Then
			cor.obj.dict.item(pre&cname) = cvalue
		else
			cor.obj.dict.add pre&cname, cvalue
		end if
	end sub

	public sub insertDbKey(cname, cvalue, csection, ctype) 
		dim ssql, arrConfigKey
		'
		'--- first check key/csection doesn't exist
		ssql = "SELECT c.cname, c.csection FROM " & cor_dbpre & "config AS c WHERE " _
			 & cor_dbLC & "(c.cname)={0} AND "    & cor_dbLC  & "(c.csection)={1}"
		cor.dal.open arrConfigKey, ssql, array(lcase(cname), lcase(csection))
		'
		'--- if cvalue doesn't exist - insert, else - update
		if  cor.butil.eof(arrConfigKey) Then
			ssql = "INSERT INTO " & cor_dbpre & "config (cname, cvalue, csection, ctype) VALUES ({0},{1},{2},{3})"
			cor.dal.exec ssql, array(cname, cvalue, csection, ctype)
			'--- add cvalue in dictionary
			call setValue(cname, cvalue)
		else
			call updateDbKeyValue(cname, cvalue, csection, ctype)			
		end if
	end sub

	public sub updateDbKeyValue(cname, cvalue, csection, ctype) 
		dim ssql
		ssql = "UPDATE " & cor_dbpre & "config SET cvalue={1}, ctype={3} WHERE " & cor_dbLC & "(cname)={0} AND " & cor_dbLC & "(csection)={2}"
		cor.dal.exec ssql, array(lcase(cname), cvalue, lcase(csection), ctype)
		'--- update cvalue in dictionary
		call setValue(cname, cvalue)
	end sub
	'
	' load one or more sections
	'
'This  sub is no longer used
'	public sub includeSection(byval csection)
'		dim arrConfigKeys, configCount, ssql
'		dim asection, ssection, i
'		'
'		if cor.butil.isEmptyStr(csection) Then exit sub
'		'--- normalize
'		csection = replace(csection, " ", "")
'		if right(csection,1) = "," then csection = left(csection, len(csection)-1)
'		'--- build where-clause
'		asection = split(csection, ",")	
'		for i=0 to ubound(asection)
'			ssection = ssection & "c.csection='" & asection(i) & "'"
'			if i < ubound(asection) then ssection = ssection & " OR "
'		next
'		'
'		ssql = "SELECT c.cname, c.cvalue FROM " & cor_dbpre & "config AS c WHERE " & cor_dbLC & "(" & ssection & ")"
'		cor.dal.open arrConfigKeys, ssql, empty
'		'
'		if  NOT cor.butil.eof(arrConfigKeys) Then
'			for configCount = 0 to ubound(arrConfigKeys, 2)
'				if NOT cor.obj.dict.exists(pre&arrConfigKeys(1, configCount)) Then
'					cor.obj.dict.add pre&arrConfigKeys(1, configCount), arrConfigKeys(0, configCount)
'				end if
'			next
'		end if
'	end sub
'Above Sub is No Longer Used 

	'
	' load all csystem type params
	'
	public sub loadAllSystem()
		dim arrConfigKeys, configCount, ssql
		'
		ssql = "SELECT c.cvalue, c.cname FROM " & cor_dbpre & "config AS c WHERE csystem=1"
		cor.dal.open arrConfigKeys, ssql, empty
		'
		if NOT cor.butil.eof(arrConfigKeys) Then
			for configCount = 0 to ubound(arrConfigKeys, 2)
				if NOT cor.obj.dict.exists(pre&arrConfigKeys(1, configCount)) Then
					cor.obj.dict.add pre&arrConfigKeys(1, configCount), arrConfigKeys(0, configCount)
				end if
			next
		end if
	end sub

	private sub class_initialize
		' init reusable dict
		call cor.obj.init("dict")
		' used to distinguish elems of this class when in a same dict obj with others
		pre = "cfg___"
	end sub

	private pre
	
end class

'<#late-binding hook
function boot_class_configHandler : boot_class_configHandler = true : end function
'/>

%>
