﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - initial 22/07/2007
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

' 
' Based on free code by Simon Svensson, tant102@tant102.mine.nu
' class-ified and optimized for SooP by alx359@gmail.com
'
class class_dyninc ':: global, class_string, class_objectsPool

	public function exists(byVal strFilename)	
		strFilename = server.mappath(strFilename)
		if cor.obj.fso.fileExists(strFilename) Then exists = true else exists = false	
	end function
	
	public function include(strFilename)
		'On error resume next
		if NOT exists(strFilename) Then cor.stopper("[ERR:class_dyninc] file '"&strFilename&"' does not exist")
		set oTextStream  = cor.obj.fso.openTextFile(server.mappath(strFilename), cor_cForReading, false)
		'Response.Write oTextStream.ReadAll
		executeGlobal parseCode(oTextStream.ReadAll)
		if err.number<>0 Then
			cor.stopper("[ERR:class_dyninc] exec error in file: '"&strFilename&"', description: '" &err.description& "'")
		end if
		oTextStream.close
		set oTextStream = nothing
		'On error goto 0
	end function

	public sub read(byVal strFilename)
		if NOT exists(strFilename) Then exit sub
		set oTextStream  = cor.obj.fso.openTextFile(server.mappath(strFilename), cor_cForReading, false)
		read parseCode(oTextStream.ReadAll)
		oTextStream.close
		set oTextStream  = nothing
	end sub

	private function parseCode(byRef strCode)
		dim strResult, intStartPos, intEndPos, strCodeBlock
		dim intIterations

		do  until len(strCode)=0
			intIterations = intIterations+1
			'if intIterations > 10 Then exit do

			' Grab everything to first asp block
			intStartPos = instr(strCode, "<%")
			if (intStartPos = 0) Then
				' No ASP block
				strResult = strResult & parseHtmlBlock(strCode)
				exit do
			elseif (intStartPos > 1) Then
				' Html block
				strResult = strResult & parseHtmlBlock(mid(strCode, 1, intStartPos-1))
				strCode = mid(strCode, intStartPos)
			end if

			' Should now be at <%
			intEndPos = instr(strCode, "%\>")
			if  intEndPos = 0 Then
				err.raise vbObjectError+1, "[class_dyninc]", "Malformed ASP block detected."
			end if
			
			strCodeBlock = mid(strCode, 3, intEndPos-3)
			if mid(strCodeBlock, 1, 1)= "=" Then
				strCodeBlock = "response.write " & mid(strCodeBlock, 2)
			end if
			strResult = strResult & strCodeBlock & vbCrLf
			strCode   = mid(strCode, intEndPos+2)
		loop
			
		parseCode = strResult
	end function

	private function parseHtmlBlock(ByVal strHtml)
		strHtml = replace (strHtml, """", """""")
		strHtml = replace (strHtml, vbCrLf, """ & vbCrLf 	& """)
		strHtml = replace (strHtml, vbCr, """   & vbCr 		& """)
		strHtml = replace (strHtml, vbLf, """   & vbLf 		& """)
		parseHtmlBlock = "response.write """	& strHtml 	& """" & vbCrLf
	end function

	private sub class_initialize
		call cor.obj.init("fso")
	end sub

	private oTextStream, arrCode, lineCode
end class

'<#late-binding hook
function boot_class_dyninc : boot_class_dyninc = true : end function
'/>

%>
