﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_modules ':: global, class_baseUtils, class_DAL
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' shows all MOD Boxes in the concerned column
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function arrangeColumn(intColumnToArrange)
		'
		dim rsArrange
		dim Module_Name
		dim showToggle
		dim blnBox_Hide
		dim modPerm
		dim arrMods
		dim countMods
		dim ssql
		dim atleastone
		'
		' ensure mods are shown for adequate page template
		if cor_sBodyId = "oneCol" AND (intColumnToArrange = 1 OR intColumnToArrange = 3) Then exit function
		if cor_sBodyId = "twoCol" AND intColumnToArrange  = 3 Then exit function
		'
		atleastone = false
		'
		'-----------------0-------------1---------------------2---------------3--------------4---------------------5----------------------6-------------
		ssql  = "SELECT T1.Module_id, T1.Module_Permission, T1.Module_name, T1.showToggle, T1.Module_Parameters, T1.Module_TTtext, T1.Module_Class FROM " & cor_dbpre & "modules AS T1 "_
			  & "WHERE T1.ColumnToAppearIn= {0} AND T1.Module_Type=1 AND T1.mShow <> 0 ORDER BY T1.OrderToShow ASC"
		cor.dal.open arrMods, ssql, array(intColumnToArrange)
		If  NOT cor.butil.eof(arrMods) Then
			for countMods = 0 to ubound(arrMods,2)
				if  cor.butil.checkPerm(arrMods(1,countMods),cor_iGroupID) Then
					'ML 
					if not IsNull(arrMods(6,countMods)) and arrMods(6,countMods) <> "" then 
						cor_sClass = arrMods(6,countMods)
					else
						cor_sClass = "module"
					end if
					if not ucase(arrMods(2,countMods)) = "MODULE_PMALERT" then atleastone = true
					'-----------------------------------------------------------------------------------------------------------------------
					cor_sModTT = arrMods(5,countMods)
					showToggle = arrMods(3,countMods)
					modPerm = iif(cor.butil.checkPerm(arrMods(1,countMods),cor_iGroupID),1,0)
					Module_Name = arrMods(2,countMods) & "(" & (showToggle) & "," & (modPerm) & "," & arrMods(0,countMods) & ",""" & cor.filter.validASPList(arrMods(4,countMods)) & """,False)"
					if  cor.butil.modExist(arrMods(2,countMods)) Then
						'On error resume next
						'response.write cor.butil.breakpoint(arrMods(2,countMods))
						response.write vbcrlf & "<!-- <"  & arrMods(2,countMods) & "> -->" & vbcrlf & vbcrlf
						eval(Module_Name)
						response.write vbcrlf & "<!-- </" & arrMods(2,countMods) & "> -->" & vbcrlf
						'if err.number <> 0 then cor.butil.winWrite("[ERR:class_modules] error in mod " & Module_Name & " " & err.description) 
						'On error goto 0
						'
						'--- performance counter: mod loaded
						response.write cor.butil.breakpoint(arrMods(2,countMods))
					end if
				end if
			next
			if not atleastone then 		Response.Write "&nbsp;"
		Else
		Response.Write "&nbsp;"
		End If
	end function
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' display the MOD BOX which ID has been given as parameter - this can be handy to show individual MOD Boxes or for a tabbed interface
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function arrangeOne(intToArrange,blnTabs)
		dim rsArrange
		dim Module_Name
		dim showToggle
		dim blnBox_Hide
		dim modPerm
		dim arrMods
		dim countMods
		dim ssql

		ssql = "SELECT T1.Module_id, T1.Module_Permission, T1.Module_name, T1.showToggle, T1.Module_Parameters, T1.Module_TTtext, T1.Module_Class " _
			  & "FROM " & cor_dbpre & "modules AS T1 WHERE T1.Module_id={0} AND T1.Module_Type=1 ORDER BY T1.OrderToShow ASC"
		cor.dal.open arrMods, ssql, array(intToArrange)

		if  NOT cor.butil.eof(arrMods) Then
			if cor.butil.checkPerm(arrMods(1,countMods),cor_iGroupID) Then
				'ML 
				if not IsNull(arrMods(6,countMods)) and arrMods(6,countMods) <> "" then 
					cor_sClass = arrMods(6,countMods)
				else
					cor_sClass = "module"
				end if
				'-----------------------------------------------------------------------------------------------------------------------
				cor_sModTT = arrMods(5,countMods)
				showToggle = arrMods(3,countMods)
				modPerm = iif(cor.butil.checkPerm(arrMods(1,countMods),cor_iGroupID),1,0)
				Module_Name = arrMods(2,countMods) & "(" & (showToggle) & "," & (modPerm) & "," & arrMods(0,countMods) & ",""" & cor.filter.validASPList(arrMods(4,countMods)) & """, blnTabs)"
				if  cor.butil.modExist(arrMods(2,countMods)) Then

					On error resume next
					response.write vbcrlf & "<!--  <"  & arrMods(2,countMods) & "> -->" & vbcrlf & vbcrlf
					eval(Module_Name)
					response.write vbcrlf & "<!--  </" & arrMods(2,countMods) & "> -->" & vbcrlf 
					if err.number <> 0 then cor.butil.winWrite("[ERR:class_modules] error in mod " & Module_Name & " " & err.description) 
					On error goto 0

					'--- performance counter: mod loaded
					response.write cor.butil.breakpoint(arrMods(2,countMods))
				end if
			end if
		end if
	end function
end class

'<#late-binding hook
function boot_class_modules : boot_class_modules = true : end function
'/>

%>
