﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - initial 26/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
'
' Avoid ASP objects proliferation because of classes and mods 
' keeping a certain pool or resources centralized in this class
'
class class_objectsPool ':: global
	public fso, dict, xml, lngxml

	public sub init(sObjName)
		On error resume next

		select case lcase(sObjName)
		case "fso"	
			if NOT isObject(fso) Then set fso = server.createObject("scripting.fileSystemObject")
		case "dict"
			if NOT isObject(dict) Then set dict = server.createObject("scripting.dictionary")
		case "xml"
			if NOT isObject(xml)  Then set xml  = server.createObject("Microsoft.freeThreadedXMLDOM")
			if NOT isObject(xml)  Then set xml  = server.createObject("Microsoft.XMLDOM")
		case "lngxml"
			if NOT isObject(lngxml)  Then set lngxml  = server.createObject("Microsoft.freeThreadedXMLDOM")
			if NOT isObject(lngxml)  Then set lngxml  = server.createObject("Microsoft.XMLDOM")
		case else
			cor.stopper("[ERR:class_objectsPool] object '" &sObjName& "' not found")
		end select
		if  err.number<>0 Then
			cor.stopper("[ERR:class_objectsPool] '" &sObjName& "' object unavailable. Cannot continue<br /><br />[" & err.description &"]")
		end if	
		'On error goto 0
	end sub

	private sub class_terminate() 
		if  isObject(fso)  Then set fso  = nothing : fso  = empty
		if  isObject(dict) Then 
			dict.removeAll :    set dict = nothing : dict = empty
		end if
		if  isObject(xml)  Then set xml  = nothing : xml  = empty	
		if  isObject(lngxml)  Then set lngxml  = nothing : xml  = empty
	end sub
	
end class

'<#late-binding hook
function boot_class_objectsPool : boot_class_objectsPool = true : end function
'/>

%>
