﻿<%
' Purr Message System class for SOOP Phoenix
' Created by Kokopelli
' Created October 25th 2008
' Version 1.0

class class_Purr ':: class_string
	public isNewPm				' "true", "false"  NOTE: Case Sensitive, must be lowercase!
	public screenPosition		' "top-left", "top-center", "top-right", "center-center", "bottom-right", "bottom-center", "bottom-left"
	public CssClassTop			' "purr-body-failure", "purr-body-info", "purr-body-succes", "purr-body-warnL1", "purr-body-warnL2", "purr-body-warnL3"
	public CssClassBody			' "purr-body-failure", "purr-body-info", "purr-body-succes", "purr-body-warnL1", "purr-body-warnL2", "purr-body-warnL3"
	public CssClassBottom		' "purr-body-failure", "purr-body-info", "purr-body-succes", "purr-body-warnL1", "purr-body-warnL2", "purr-body-warnL3"
	public Image				' "False", "Help", "Info", "NewPM", "True", "Warning"
	public HeaderTxt
	public MessageTxt
	public fadeInSpeed			' Milliseconds e.g. 500
	public fadeOutSpeed			' Milliseconds e.g. 500
	public removeTimer			' Milliseconds e.g. 3000
	public isSticky				' "true", "false"  NOTE: Case Sensitive, must be lowercase!
	public usingTransparentPNG	' "true", "false"  NOTE: Case Sensitive, must be lowercase!

	private sub class_initialize()
		isNewPm				= "false"
		screenPosition		= "top-right"
		CssClassTop			= "purr-top-info"
		CssClassBody		= "purr-body-info"
		CssClassBottom		= "purr-bottom-info"
		Image				= "Info"
		HeaderTxt			= lngSystemMessage
		MessageTxt			= "This is a system message"
		fadeInSpeed 		= 500
		fadeOutSpeed 		= 500
		removeTimer			= 3000
		isSticky			= "false"
		usingTransparentPNG	= "true"
		set str				= new class_string
	end sub
	
	public sub doPurr()
		str.add "<script type=""text/javascript"" language=""JavaScript""><!-- <![CDATA["
		str.add "$(document).ready(function(){"
		str.add "	var isNewPm = " & isNewPm & ";"
		str.add "	if(isNewPm && self!=top){"
		str.add "	} else {"
		str.add "		var notice = '<div class=""purr"">'"
		str.add "			+ '<div class=""" & CssClassTop & """></div>'"
		str.add "			+ '<div class=""" & CssClassBody & """>'"
		str.add "			+ 	'<span class=""purricon "& Image &"""></span>'"
' src=""" & cor_sSkinPath & "purrImg/purrIcon" & Image & ".png"" alt="""" />'"
'		str.add "			+ 	'<img src=""" & cor_sSkinPath & "purrImg/purrIcon" & Image & ".png"" alt="""" />'"
		str.add "			+ 	'<h3>" & HeaderTxt & "</h3>'"
		str.add "			+ 	'<p>'"
		str.adn "			+ 	'" & cor.filter.escEditor(Replace(MessageTxt,vbcrlf,"",1,-1,1)) & "'"
		str.adn "			+'</p>'"
		str.add "			+ '</div>'"
		str.add "			+ '<div class=""" & CssClassBottom & """></div>'"
		str.add "		+ '</div>';"
		str.add "		$(notice).purr({" 
		str.add "			isNewPm: " & isNewPm & ","
		str.add "			usingTransparentPNG: " & usingTransparentPNG & ","
		str.add "			fadeInSpeed: " & fadeInSpeed & ","
		str.add "			fadeOutSpeed: " & fadeOutSpeed & ","
		str.add "			screenPosition: """ & screenPosition & ""","
		if isSticky then
			str.add "			isSticky: " & isSticky
		else
			str.add "			removeTimer: " & removeTimer
		end if
		str.add "		});"
		str.add "	}"
		str.add "});"
		str.add "// ]]> --></script>"
		response.write str.build
	end sub

	private sub class_terminate()
		set str = nothing
	end sub
	
	private str
end class 
'
'<#late-binding hook
function boot_class_Purr : boot_class_Purr = true : end function
%>