﻿<!--#include file="template.asp" -->
<%
'------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------
'we do have a simple templating system witch uses all defaults everywhere, and only gives some liberty on one, two or three
'columns display - the complete template system will use a special table which builds the complete layout except header / footer and
'where every layout detail contains the to display content or MOD boxes (this most probably will be introduced in SOOPPortal Rattler)
'------------------------------------------------------------------------------------------------------------------------------------

class class_template ':: global, class_string, class_filters, class_DAL, class_utils
	'
	'---------------------------------------------------------------------------------------------------------------------------------
	' gather info needed for layout, meta tags, title, scripts, js, CSS files etc... for concerned script / section
	'---------------------------------------------------------------------------------------------------------------------------------
	public sub init(strParameter)
		dim x_i,sScriptName
		dim arrToLoad
		'
		'
		x_i = instrRev(cor_sScriptName,"/")
		sScriptName = mid(cor_sScriptName,x_i + 1)
		'
		if cor.filter.checkStr(strParameter) <> "" Then 
			sScriptName = strParameter
		end if
		'
		'response.write cor_sScriptName & "<br />"
		'
		'---7--------------8-------------17-------------------21-------------
		's.seccssfiles, s.secjsfiles, s.secconfigsections, s.seccssskinfiles " _
		'-----------------0--------1----------2-----------3----------4------------5------------6----------------7--------------8-----------------9----------------------10------------------11---------------12--------------13-------------14--------------15----------16----------17-------
		p_sql = "SELECT s.secid, s.secname, s.secadmin, s.secperm, s.secbodyid, s.seclayout, s.seclngsections,s.secaspfiles, s.secmodsdefault, s.secmeta_description, s.secmeta_keywords, s.secmeta_title, s.sechorizmenu, s.secmodsleft, s.secmodsright, s.secfmenu, s.secclass, s.secfgraphical "_
			& "FROM " & cor_dbpre & "sections AS s WHERE s.secname = {0}"
		cor.dal.open arrSections, p_sql, array(sScriptName)
		'
		if cor.butil.eof(arrSections) Then cor.stopper "[ERR:class_template] Empty section configuration"
		'
		' check if admin rights are needed
		' TO DO - multiple admin groups will be possible 
		'
		if cor.filter.checkInt(arrSections(2,0)) > 0 Then
			if NOT cor_bAdmin Then cor.msg(lngNoAccessPermission)
		end if
		'
		'--- may be already set from cor_bHeaderFooterInclude mode
		if cor_sBodyId = "" then cor_sBodyId = arrSections(4,0)
		'
		cor_sLeft				= arrSections(13,0)
		cor_sRight				= arrSections(14,0)
		cor_bFooterMenu 		= cor.filter.checkInt(arrSections(15,0))
		cor_bGraphicalFooter 	= cor.filter.checkInt(arrSections(17,0))
		cor_sSectionTitle 		= arrSections(11,0)		
		cor_bHorizMenu 			= iif(cor.filter.checkInt(arrSections(12,0)) = 1,true,false)
'---		cor_bInlineTools		=
		
		' default mods? if no we do have a special layout and specific mods etc...
		cor_bUseFreeLayout = iif(cor.filter.checkInt(arrSections(8,0)) = 0, false, true)
		cor_sContentClass = arrSections(16,0)
		if IsNull(cor_sContentClass) or cor_sContentClass="" then cor_sContentClass = "modular"
		
		'
		' read in associated language and configuration sections
		' ML also read in default ones defined in config variable defaultXML - need to be loaded before header
		' can contain multiple XML sections 
		cor.lng.includeSection(arrSections(6,0))
		cor.lng.includeSection(cor.cfg.item("defaultXML"))
		'
		'cor.cfg.includeSection(arrSections(17,0))
	end sub
	'---------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------
	public function header( strHeader, strSearch)
		dim arrToLoad
		dim x_i,x_j
		dim strCSSconfig
		dim strCSSdb
		dim strCSSskin
		dim strJSconfig
		dim strJSdb
		dim blnTitle	: blnTitle = false
		dim fullTitle	: fullTitle = ""
		Dim currentpage : currentpage = replace(lcase(Replace(cor_sScriptName,cor_sWebroot,"",1,-1,1)),".asp","",1,-1,1)

		if NOT cor_bHeaderFooterInclude Then
			str.wri cor_cPageDocType
			str.wri "<html dir=""" & cor_sHtmlDir & """ xmlns=""http://www.w3.org/1999/xhtml"">"
			str.wri "<head>"
		end if
		str.wri "<meta http-equiv=""content-type"" content=""text/html; charset=" & cor_sCharset & """ />"

		cor_sPageTitle = cor.util.pageTitle(strHeader,strSearch)

		if NOT cor_bHeaderFooterInclude Then
			str.wri "<title>" & cor.filter.ReverseHTMLCode(cor_sPageTitle & lngWebSiteTitle) & "</title>"
			blnTitle = true
		end if
		
		'Pull the meta title tag, as it's not used anywhere in major search engines.
		if NOT cor.butil.isEmptyStr(arrSections(11,0)) Then
			if blnTitle = false then 
				'str.wrn "<meta name=""title"" content=""" & arrSections(11,0)
				str.wrn "<title>" 
				fullTitle = arrSections(11,0)
				if cor_sPageTitle <> "" then fullTitle = fullTitle & " | " & replace(cor_sPageTitle,cor_sTitleDelim,"",1,1,1)
				'str.wri """ />"
				str.wri cor.filter.ReverseHTMLCode(fullTitle) & "</title>"
			end if
		end if

		if  NOT cor.butil.isEmptyStr(arrSections(9,0)) Then
			str.wri "<meta name=""description"" content=""" & cor.filter.ReverseHTMLCode(replace(cor_sPageTitle,cor_sTitleDelim,",",1,-1,1)) & arrSections(9,0) & """ />"
		end if

		if NOT cor.butil.isEmptyStr(arrSections(10,0)) Then
			str.wri "<meta name=""keywords"" content=""" & cor.filter.ReverseHTMLCode(replace(replace(cor_sPageTitle,cor_sTitleDelim,",",1,-1,1)," ",",",1,-1,1)) & arrSections(10,0) & """ />"
		end if

		if InStr(currentpage,"mgmt") > 0 then
			str.wri "<meta name=""robots"" content=""noindex,nofollow"" />"
		else
			str.wri "<meta name=""robots"" content=""index,follow"" />"
		end if

		str.wri "<link type=""image/x-icon"" rel=""icon"" href=""" & cor_sPortalDomainPath & "favicon.ico"" />"
		str.wri "<link type=""image/x-icon"" rel=""shortcut icon"" href=""" & cor_sPortalDomainPath & "favicon.ico"" />"
		
		' Load main stylesheet
		str.wri "<link charset=""" & ucase(cor_sCharset) & """ type=""text/css"" rel=""stylesheet"" href=""" & cor_sSkinCss & """ />"

		'Hood --- Load default scripts used site wide.
		'Use Google API copy of J-Query to get the bennfits of off loading server resources, world  wide cache, Improves you chance of the end user already having the file in they're cache
		'Calling google.load ""1"" ensures that the most current version of jquery/jqueryui will be loaded
		'If the server protocol is sercure then use the local jquery file to prevent the unwanted, allow insecure items message, on your secure page.
		if cor_sServerProtocol<>"https://" then
			cor.str.wri "<script type=""text/javascript"" src=""http://www.google.com/jsapi""></script>"
			cor.str.wri "<script type=""text/javascript"">"
			cor.str.wri "google.load(""jquery"", ""1"");"
			cor.str.wri "google.load(""jqueryui"", ""1"");"
			cor.str.wri "</script>"
		else
			'str.wri "<script src=""" & cor_sWebroot & "core/jscss/jquery-1.3.2.min.js"" type=""text/javascript"" charset=""" & ucase(cor_sCharset) & """></script>"
			str.wri "<script src=""" & cor_sWebroot & "core/jscss/jquery-1.4.2.min.js"" type=""text/javascript"" charset=""" & ucase(cor_sCharset) & """></script>"
			str.wri "<script src=""" & cor_sWebroot & "core/jscss/jquery-ui-1.7.2.min.js"" type=""text/javascript"" charset=""" & ucase(cor_sCharset) & """></script>"
		end if
		str.wri "<script src=""" & cor_sWebroot & "core/jscss/jquery.plugins.js"" type=""text/javascript"" charset=""" & ucase(cor_sCharset) & """></script>"
		str.wri "<script src=""" & cor_sWebroot & "core/jscss/core.js"" type=""text/javascript"" charset=""" & ucase(cor_sCharset) & """></script>"
		'str.wri "<script src=""" & cor_sWebroot & "core/jscss/jquery.form.js"" type=""text/javascript"" charset=""" & ucase(cor_sCharset) & """></script>"
		
		dim strAnalyticsCode
		strAnalyticsCode = cor.filter.checkStr(cor.dal.getValue("SELECT c.cvalue FROM " & cor_dbpre & "config AS c WHERE " & cor_dbLC & "(c.cname)={0}", array("googleanalytics")))
		if len(strAnalyticsCode) > 3 then
			str.wri "<script type=""text/javascript"">window.google_analytics_uacct = """ & strAnalyticsCode & """;</script>"
		end if
		
		'Hood --- Load js and css files on a per page basis.
		dim scriptsChecker,arrPageScripts
		cor_sql = "SELECT c.cname FROM " & cor_dbpre & "config AS c WHERE c.cname = '" & currentpage & "S' OR c.cname = '" & currentpage & "C' OR c.cname = '" & currentpage & "M' OR c.cname = '" & currentpage & "B';"
		'str.wri cor_sql
		' Returns the existing variable names so not to call non existing records from DB
		cor.dal.open arrPageScripts, cor_sql, array() 
		if NOT cor.butil.eof(arrPageScripts) Then
			for x_j = 0 to ubound(arrPageScripts,2)
				scriptsChecker = Right(arrPageScripts(0,x_j),1)
				Select Case scriptsChecker
					case "B"
						' Load CSS files from somewhere (not necessarily the skins folder)
						if not IsNull(cor.cfg.item(currentpage & "B")) and cor.cfg.item(currentpage & "B") <> "" then
							arrToLoad = Split(cor.cfg.item(currentpage & "B"),",")
							for x_i = 0 To ubound(arrToLoad)
								str.wri "<link charset=""" & ucase(cor_sCharset) & """ type=""text/css"" rel=""stylesheet"" href=""" & cor_sWebroot & trim(arrToLoad(x_i)) & """ />"
							next
						end if
					case "S"
						' Load CSS files from Skins folder
						if not IsNull(cor.cfg.item(currentpage & "S")) and cor.cfg.item(currentpage & "S") <> "" then
							arrToLoad = Split(cor.cfg.item(currentpage & "S"),",")
							for x_i = 0 To ubound(arrToLoad)
								str.wri "<link charset=""" & ucase(cor_sCharset) & """ type=""text/css"" rel=""stylesheet"" href=""" & cor_sSkinPath & trim(arrToLoad(x_i)) & """ />"
							next
						end if
					case "C"
						' Load JS files from core/jscss folder
						if not IsNull(cor.cfg.item(currentpage & "C")) and cor.cfg.item(currentpage & "C") <> "" then
							arrToLoad = Split(cor.cfg.item(currentpage & "C"),",")
							for x_i = 0 To ubound(arrToLoad)
								str.wri "<script src=""" & cor_sWebroot & "core/jscss/" & trim(arrToLoad(x_i)) & """ type=""text/javascript"" charset=""" & ucase(cor_sCharset) & """></script>"
							next
						end if
					case "M"
						' Load JS files from mods/jscss folder
						if not IsNull(cor.cfg.item(currentpage & "M")) and cor.cfg.item(currentpage & "M") <> "" then
							arrToLoad = Split(cor.cfg.item(currentpage & "M"),",")
							for x_i = 0 To ubound(arrToLoad)
								str.wri "<script src=""" & cor_sWebroot & "mods/jscss/" & trim(arrToLoad(x_i)) & """ type=""text/javascript"" charset=""" & ucase(cor_sCharset) & """></script>"
							next
						end if
				End Select
			next
		End If

		'--- js localization Loads the language JS files
		'str.wri cor.util.getJSlocale(true,true)

		''ML --- System ASP files according CONFIG configuration
		'if not IsNull(cor.cfg.item("defaultASP")) and cor.cfg.item("defaultASP") <> "" then
		'	arrToLoad = Split(cor.cfg.item("defaultASP"),",")
		'	for x_i = 0 To ubound(arrToLoad)
		'		call cor.util.loadFile( arrToLoad(x_i), "core/")
		'	next
		'end if

		str.wri "</head>"

		str.wri "<body id=""" & cor_sBodyId & """>"
		'This div is used by the jquery.form plugin for both ajaxForm and ajaxSubmit to display success or failure errors
		str.wri"<div id=""form_results""></div>"
		' Passive JS-enabled checker
		str.wri "<noscript><h3>" & lngNoJS &"</h3></noscript>"

		' embedding support Must remain just inside the body tag, before div#wrapper
		str.wri "<script type=""text/javascript"" charset=""" & ucase(cor_sCharset) & """><!-- <![CDATA["
		str.wri "EmbedMan()"
		str.wri "// ]]> --></script>"

		str.wri "<div id=""wrapper""><!-- <wrapper> -->"

		If NOT cor_bEmbedded Then '<cor_bEmbedded>
		
			str.wri tpl_header( cor_bBanners, cor_bInlineTools, cor_bShowHeaderLines )
			
			'--- performance counter: header breakpoint
			str.wri cor.butil.breakpoint("header breakpoint")

			if cor_bHorizMenu Then

				str.wri tpl_hmenu()

			end if
			'
			'--- performance counter: menu loading breakpoint
			if cor_bCached Then
				str.wri "<br /><br />" & cor.butil.breakpoint("Init SooP Menu done - Cached")
			else
				str.wri "<br /><br />" & cor.butil.breakpoint("Init SooP Menu done - Queried")
			end if

		end if '</cor_bEmbedded>

		' display (via purr msg system) any session-carried messages
		cor.butil.winWrite("")
		'
		' cache editor images for faster ulterior display
		' cache was disabled by hooded as it's just a wasted http call.
		' Call cacheImages()
		'
		if  NOT (cor_bEmbedded OR cor_bHeaderFooterInclude) Then '<cor_bEmbedded>
			select case lcase(cor_sBodyId)
				case "onecol"
					cor.boxing.printBoxTop Replace(cor_sPageTitle,cor_sTitleDelim," ",1,-1,1),""
				case "twocol"
					cor.boxing.print2ColumnTop Replace(cor_sPageTitle,cor_sTitleDelim," ",1,-1,1),""
				case "threecol"
					cor.boxing.print3ColumnTop Replace(cor_sPageTitle,cor_sTitleDelim," ",1,-1,1),""
			end select
		end if '</cor_bEmbedded>
	end function
	'--------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------
	public sub footer()
		if  NOT (cor_bEmbedded OR cor_bHeaderFooterInclude) Then '<cor_bEmbedded>
			select case lcase(cor_sBodyId)
				case "onecol"
					cor.boxing.printBoxBottom
				case "twocol"
					cor.boxing.print2ColumnBottom
				case "threecol"
					cor.boxing.print3ColumnBottom
			end select'

			'if cor_bGraphicalFooter <> 0 AND (NOT isEmpty(cor_bGraphicalFooter) OR NOT isNull(cor_bGraphicalFooter)) then
			'	response.write tpl_graphfooter(cor_bFooterMenu,cor_cShowSoopIcons,cor_cShowProcessInfo,True)
			'else
				response.write tpl_footer(cor_bFooterMenu,cor_cShowSoopIcons,cor_cShowProcessInfo,True)
			'end if

		end if '</cor_bEmbedded>
		'
		' page wrapper end
		str.wri "</div><!-- </wrapper> -->"
		str.wri footerScripts()

		'
'		Call soopbar()
		'Final Script tags & SoopBar MUST remain inside the closing body tag to properly validate as XHTML.
		
		str.wri GoogleAnalytics
		str.wri "</body>"
		str.wri "</html>"
	
		call cor.off()
		
	end sub
	
	function GoogleAnalytics
		'pulls google analytics code from config table and writes the js 
		'added 9/25/2009 by charles
		dim strAnalyticsCode
		strAnalyticsCode = cor.filter.checkStr(cor.dal.getValue("SELECT c.cvalue FROM " & cor_dbpre & "config AS c WHERE " & cor_dbLC & "(c.cname)={0}", array("googleanalytics")))
		if len(strAnalyticsCode) < 3 then
			GoogleAnalytics = ""
		else
			GoogleAnalytics = "<script type=""text/javascript"">" & vbcrlf & _
				"var gaJsHost = ((""https:"" == document.location.protocol) ? ""https://ssl."" : ""http://www."");" & vbcrlf & _
			 	"document.write(unescape(""%3Cscript src='"" + gaJsHost + ""google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E""));" & vbcrlf & _
			 	"</script>" & vbcrlf & _
			 	"<script type=""text/javascript"">" & vbcrlf & _
			 	"try {"  & vbcrlf & _
			 	"var pageTracker = _gat._getTracker(""" & strAnalyticsCode & """);" & vbcrlf & _
			 	"pageTracker._trackPageview();" & vbcrlf & _
			 	"} catch(err) {}</script>" 
		end if
	end function
	'---------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'---------------------------------------------------------------------------------------------------------------------------
	Sub soopbar()
		If cor.cfg.item("useSoopBar") = "1" And cor.io.q("modal")<>"1" And Not cor_iGroupID = 2 Then
			response.write cor.str.build
			cor.lng.includeSection("mod_xmlSoopBar")
			cor.util.loadFile "chatterConfig.asp", "mods/SoopBar/chat/"
			cor.util.loadFile "SoopBar-js.asp", "mods/soopbar/"
			cor.util.loadFile "SoopBar.asp", "mods/soopbar/"
		End If
	End Sub
	'---------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'---------------------------------------------------------------------------------------------------------------------------
	public function footerScripts()
		cor.str.add "<script type=""text/javascript"" charset=""UTF-8""><!-- <![CDATA["
		' port ASP variables to Javascript

		'if NOT cor_bHeaderFooterInclude Then
		cor.str.add cor.util.loadFile("inc_ASPvars2JS.asp","core/includes/")
		'end if
		cor.str.add cor.util.loadFile("core-footer-js.asp","core/jscss/")
		
		'Get Users Language files
		cor.str.add cor.util.getLocale(true,true)
		
		'Setup superfish menu defaults
		'if cor_bHorizMenu Then						---> as even actual vertical menu (if not treeview mode) uses superfish leave this js in
			cor.str.adn	"$(function(){"
			cor.str.adn	"$('ul.sf-menu').supersubs({minWidth: 15,maxWidth: 50,extraWidth: 1});"
			cor.str.adn	"$('ul.sf-vertical').supersubs({minWidth: 15,maxWidth: 50,extraWidth: 1});"
			cor.str.adn	"if ($.browser.mozilla && parseFloat($.browser.version) < 1.9 && navigator.appVersion.indexOf('Mac') !== -1) $('body').css('-moz-opacity',.999);"
			cor.str.adn	"$.fn.superfish.defaults.autoArrows = true;"
			cor.str.adn	"$.fn.superfish.defaults.dropShadows = false;"
			cor.str.adn	"$.fn.superfish.defaults.speed = 'fast';"
			cor.str.adn	"$.fn.superfish.defaults.delay = 1;"
			cor.str.adn	"$('#soopmenuh').superfish().find(""ul"").bgIframe({opacity:false});"
			cor.str.adn	"$('#soopmenuv').superfish().find(""ul"").bgIframe({opacity:false});"
			cor.str.adn	"$('#navmenuGH').superfish().find(""ul"").bgIframe({opacity:false});"
			cor.str.add	"});"
		'end if
		
		cor.str.adn "// ]]> --></script>"
		
		footerScripts = cor.str.build
		
	end function

	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	'The call to this was disabled by Hooded because it is a waste to cache an image not used on every page of the portal.
	'ML does this speed up the tinyMCE editor ? - specific CSS class has to be added to the core CSS file
	'public sub cacheimages()
	'	cor.str.wri "<div class=""imgCache"">"
	'	cor.str.wri "<img src=""" & cor_sWebRoot & "core/plugins/tiny_MCE3/themes/advanced/img/icons.gif"" alt="""" />"
	'	cor.str.wri "<img src=""" & cor_sSkinPath & "img/sprite.png"" alt="""" />"
	'	cor.str.wri "</div>"
	'end sub
	'--------------------------------------------------------------------------------------------------------------------------------
	private Sub class_initialize
		set str = new class_string
	end Sub
	'
	'--------------------------------------------------------------------------------------------------------------------------------
	private sub class_terminate
		set str = nothing
	end sub
	'
	private str
	private p_sql
	private arrSections
	'
end class
'
'<#late-binding hook
function boot_class_template : boot_class_template = true : end function
'/>
%>
