﻿<%
'-------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - 26/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'----------------------------------------------------------------------------------------------------------------------------

class class_utils ':: global, class_string, class_baseUtils, class_filters, class_DAL, class_dyninc, 
	'			  '   class_languageParser, class_io, class_configHandler, class_permissions, cor_xmlSoopTitle
	'
	private str
	private p_sql
	'
	private sub class_initialize
		set str = new class_string
	end sub
	'
	private sub class_terminate
		set str = nothing
	end sub
	'----------------------------------------------------------------------------------------------------------
	'
	'-----------------------------------------------------------------------------------------------------------
	public function loadFile( strFile, strFolder )
		cor.dyninc.include(cor_sWebroot & strFolder & trim(strFile))
	end function
	'----------------------------------------------------------------------------------------------------------
	'
	'-----------------------------------------------------------------------------------------------------------
	public function displayFlash(swfFile,swfHeight,swfWidth,swfTransparent)
		str.add "<div class=""flashobj"">"
		str.add "<object type=""application/x-shockwave-flash"" data=""" & swfFile & """ width=""" & swfWidth & """ height=""" & swfHeight & """>"
		str.add "<param name=""movie"" value=""" & swfFile & """ />"
		if swfTransparent Then
			str.add "<param name=""wmode"" value=""" & "transparent" & """ />"
		end if
		str.add "</object>"
		str.add "</div>"
		displayFlash = str.build
	end function
	'----------------------------------------------------------------------------------------------------------
	'
	'-----------------------------------------------------------------------------------------------------------

	public function checkMod(Mod_Name)
		dim sql
		dim arrModCheck
		checkMod = false
		if cor.filter.checkStr(Mod_Name) = Empty Then
			exit function
		end if
		sql = "SELECT m.show, m.Module_Permission FROM " & cor_dbpre & "modules AS m WHERE m.Module_Name={0}"
		cor.dal.open arrModCheck, sql, array(Mod_Name)
		'
		if NOT cor.butil.eof(arrModCheck) Then
			if cor.filter.checkInt(arrModCheck(0,0)) > 0 AND cor.perm.checkPerm(arrModCheck(1,0),cor_iGroupID) Then
				checkMod = true
			end if
		end if
	end function
	'----------------------------------------------------------------------------------------------------------
	'
	'-----------------------------------------------------------------------------------------------------------

	public function displayModsList()
		dim sql
		dim arrMod
		dim strListMod
		dim idx
		sql = "SELECT m.Module_name, m.show, m.Module_Permission FROM " & cor_dbpre & "modules AS m "
		cor.dal.open arrMod, sql, array()
		if NOT cor.butil.eof(arrMod) Then
			for idx = 0 to ubound(arrMod, 2)
				'changing the below line to reduce DB calls. This may mean checkMod is no longer needed?
				'  changed by charles / Cadius 23 Oct 2009
				'if checkMod(arrMod(0,idx)) Then strListMod = strListMod & "||" & arrMod(0,idx) & "||"
				if cor.filter.checkint(arrMod(1,idx)) > 0 AND cor.perm.checkPerm(arrMod(2,idx),cor_iGroupID) Then
					strListMod = strListMod & "||" & arrMod(0,idx) & "||"
				end if
			next
			displayModsList = lcase(strListMod)
		else
			displayModsList = ""
		end if
	end function
	'
	'-------------------------------------------------------------------------------------------------------------------
	'
	' Display the page title and adds the topic to the html <title>-tag if in forum part of portal
	'
	'-----------------------------------------------------------------------------------------------------------------
	public function pageTitle( strKeyname, strCode )
		dim strTemp
		dim strTempSearch
		dim strTitle
		dim intID
		dim delim : delim = trim(cor_sTitleDelim)
		dim webSiteTitle 
		if len(delim) < 3 then delim = " " & delim & " "
		'webSiteTitle = lngWebSiteTitle
		'
		select case lcase(strCode)
		case "mfid"
			intID = cor.io.q("fid")
			if cor.filter.checkInt(intID) = 0 Then intID = cor.io.q("mfid")
			if cor.filter.checkInt(intID) > 0 Then
				strTitle  = cor.dal.getValue("SELECT f.sname FROM " & cor_dbpre & "forums AS f WHERE f.sid = {0}", array(clng(intID)))
				pageTitle = strTitle & delim
			else
				strTitle  = cor.dal.getValue("SELECT f.sname FROM " & cor_dbpre & "forums AS f WHERE f.sroot = 1", array())
				pageTitle = strTitle & delim
			end If
		case "tid"
			if instr(1,cor.io.q("tid"),"|") <> 0 then
				intID = mid(cor.io.q("tid"), 1, instr(1,cor.io.q("tid"),"|")-1)
				'intID = clng(intTopicID)
			Else
				intID = cor.io.q("tid")
			end if
			'
			dim tidSQL, arrT
			Dim strTitleP2
			if cor.filter.checkInt(intID) > 0 Then
				'strTitle = cor.dal.getValue("SELECT f.sname, t.ttitle FROM (" & cor_dbpre & "topics AS t LEFT JOIN " & cor_dbpre & "forums AS f ON t.tforumid=f.sid) WHERE t.tid = {0}", array(clng(intID)))
				strTitleP2 = cor.dal.getValue("SELECT t.ttitle FROM " & cor_dbpre & "topics AS t WHERE t.tid = {0}", array(clng(intID)))
			'	tidSQL = "SELECT t.ttitle, f.sname, f.sdesc FROM (" & cor_dbpre & "topics AS t INNER JOIN " & cor_dbpre & "forums as f ON f.sid = t.tforumid) WHERE t.tid = {0}"
			'	cor.dal.open arrT, tidSQL, array(clng(intID))
			'	if NOT cor.butil.eof(arrT) then
			'		pageTitle = arrT(0,0) & delim & arrT(1,0) & delim & arrT(2,0) & delim
			'	else
			'		pageTitle = websitetitle
			'	end if
				pageTitle = strTitleP2 & delim
			else
				pageTitle = webSiteTitle
			end If
		case "fcid"
			intID = cor.io.q("cID")
			If cor.filter.checkInt(intID) = 0 Then intID = cor.io.q("cID")
			If cor.filter.checkInt(intID) > 0 Then
				strTitle	= cor.dal.getValue("SELECT f.fcaName FROM " & cor_dbpre & "faqcategory AS f WHERE f.fcaCatcode = {0}", array(clng(intID)))
				pageTitle	= strKeyname & delim & strTitle & delim
			end If
		case "ffid"
			intID = cor.io.q("fid")
			If cor.filter.checkInt(intID) = 0 Then intID = cor.io.q("fid")
			If cor.filter.checkInt(intID) > 0 Then
				strTitle  = cor.dal.getValue("SELECT f.faqQuestion FROM " & cor_dbpre & "faq AS f WHERE f.faqid = {0}", array(clng(intID)))
				Dim intItemLength : intItemLength = cor.filter.checkInt(cor.cfg.item("FAQQuestionTrimLength"))
				If Len(strTitle) > intItemLength Then
				strTitle = Left(strTitle, Clng(intItemLength)) & "..."
				Dim intPosInStr
				intPosInStr = InStrRev(strTitle, " ")
				intPosInStr = intPosInStr
				strTitle = Left(strTitle, CLng(intPosInStr)) & "..."
				End If
				pageTitle = strTitle & delim
			end If
		case "glsec" 'GeckoLinks Directory
			if cor.filter.checkLng(lcase(cor.io.q("sec")))>0 then
				intID = cor.io.q("sec")
			elseif cor.filter.checkLng(lcase(cor.io.q("sectionID")))>0 then
				intID = cor.io.q("sectionID")
			else
				intID = 0
			end if
			If intID > 0 Then
				strTitle	= cor.dal.getValue("SELECT gls.Section_name FROM " & cor_dbpre & "gl_sections AS gls WHERE gls.Section_ID = {0}", array(clng(intID)))
				if strKeyname<>"" Then
					pageTitle = strTitle & delim & strKeyname & delim
				Else
					pageTitle = strTitle & delim
				End If
			end if
		case "gldir" 'GeckoLinks Directory
			if cor.filter.checkLng(lcase(cor.io.q("sec")))>0 then
				intID = cor.filter.checkLng(lcase(cor.io.q("sec")))
			elseif cor.filter.checkLng(lcase(cor.io.q("sectionid")))>0 then
				intID = cor.filter.checkLng(lcase(cor.io.q("sectionid")))
			else
				intID = 0
			end if
			If intID > 0 Then
				strTitle	= cor.dal.getValue("SELECT gls.Section_name FROM " & cor_dbpre & "gl_sections AS gls WHERE gls.Section_ID = {0}", array(clng(intID)))
				if strKeyname<>"" Then
					pageTitle = strTitle & delim & strKeyname & delim
				Else
					pageTitle = strTitle & delim
				End If
			end if
		case "glsubdir" 'GeckoLinks Sub Directory
			if cor.filter.checkLng(lcase(cor.io.q("sec")))>0 then
				intID = cor.filter.checkLng(lcase(cor.io.q("sec")))
			elseif cor.filter.checkLng(lcase(cor.io.q("sectionid")))>0 then
				intID = cor.filter.checkLng(lcase(cor.io.q("sectionid")))
			else
				intID = 0
			end if
			If intID > 0 Then
				strTitle	= cor.dal.getValue("SELECT gls.Section_name FROM " & cor_dbpre & "gl_sections AS gls WHERE gls.Section_ID = {0}", array(clng(intID)))
				if strKeyname<>"" Then
					pageTitle = strTitle & delim & strKeyname & delim
				Else
					pageTitle = strTitle & delim
				End If
			end if
		case else
			'if strKeyname <> "" Then
			'	strTitle  = cor.lng.getKey("cor_xmlCore", strKeyname)
			'end if
			if strTitle <> "" Then 
				strTitle = strTitle & delim
			elseif strKeyname <> "" Then
				strTitle = strKeyname & delim
			end if
			pageTitle = strTitle
		end select
	end function
	'
	'---------------------------------------------------------------------------------------------------------------------
	'
	' Returns true if we have a banned IP connected
	'
	'--------------------------------------------------------------------------------------------------------------------
	public function checkBannedIP()
		dim arrIP, countIP, tempIP, arr1IP, arr2IP
		dim vDate, vDuration, vDateExpires, vDiff, vblnExpired
		p_sql = "SELECT iip, idate, iduration, iid FROM " & cor_dbpre & "banlist  WHERE iip IS NOT NULL"
		cor.dal.open arrIP, p_sql, array(Empty)
		checkBannedIP 	= false
		vblnExpired 	= False
		if cor.butil.EOF(arrIP) Then exit function
		if cor.butil.IP() = "::1" then exit function            'makes no sense when testin on localhost...
		for countIP = 0 to ubound(arrIP, 2)
			arr1IP 	= split(arrIP(0,countIP),".")
			arr2IP 	= split(cor.butil.IP(),".")
			vDate 	= cor.filter.checklng(arrIP(1,countIP))		'get date
			if vDate > 0 then									'do we have a date value in db? (We should!)
				vDate 		= cor.butil.cvLcidTime(vDate)				'convert db value to date type
				vDuration 	= cor.filter.checkInt(arrIP(2, countIP))		'get duration
				if vDuration <> 0 then										'do we have a built-in expiration for this ban?
					if vDuration < 0 then vDuration = vDuration * -1			'make positive
					vDateExpires	= dateadd("d", vDuration, vDate)			'date of expiration (date entered + duration
					vDiff 			= dateDiff("d", Now(), vDateExpires)		'diff between today and expire date
					if vDiff < 1 then											'Expired?
						vblnExpired = True											'flag to ignore ban below
						p_sql = "DELETE FROM " & cor_dbpre & "banlist WHERE iid = {0}" 	
						cor.dal.exec p_sql, array(arrIP(3,countIP))					'delete expired entry
					end if														'/vdiff < 0
				end if														'/duration <> 0?
			end if													'/date > 0?
			if not vblnExpired then				'ignore expired bans!
				select case arr1IP(3)
					case "*"
						if (arr1IP(0) = arr2IP(0)) AND (arr1IP(1) = arr2IP(1)) AND (arr1IP(2) = arr2IP(2)) Then
							checkBannedIP = true
							exit function
						end if
					case else
						if (arr1IP(0) = arr2IP(0)) AND (arr1IP(1) = arr2IP(1)) AND (arr1IP(2) = arr2IP(2)) AND (arr1IP(3) = arr2IP(3)) Then
							checkBannedIP = true
							exit function
						end if
				end select
			end if							'/expired?
		next
	end function
	'
	'----------------------------------------------------------------------------------------------------------
	'
	'-----------------------------------------------------------------------------------------------------------
	public function getUserNamebyID(lngUserID)
		dim arrUsers
		if cor.filter.checkLng(lngUserID) = 0 Then
			getUserNamebyID =  lngNoMatchesFound
			exit function
		end if
		dim adoRec, arruserName
		p_sql = "SELECT T1.mname FROM " & cor_dbpre & "members AS T1 WHERE T1.MemberID={0}"
		cor.dal.open arrUsers, p_sql, array(lngUserID)
		if  cor.butil.eof(arrUsers)  Then
			getUserNamebyID = lngNoMatchesFound
		else
			getUserNamebyID = arrUsers(0,0)
		end if
	end function
	'
	'-----------------------------------------------------------------------------------------------------------------------
	'
	' Check if a UserID member is online parsing param cor_sListMembersOnline
	'
	'----------------------------------------------------------------------------------------------------------------------
	public function checkOnline( UserID )
		dim arrTest
		dim x_i
		if  cor_sListMembersOnline <> "" Then
			arrTest = cor.butil.regetRows(cor_sListMembersOnline)
			if isarray(arrTest) Then
				for x_i = 0 To ubound(arrTest,2)
					if cor.filter.checkLng(arrTest(0,x_i)) = UserID Then
						checkOnline = true
						exit function
					end if
				next
			end if
			checkOnline = false
		else
			checkOnline = false
		end if
	end function
	'----------------------------------------------------------------------------------------------------------
	'
	'-----------------------------------------------------------------------------------------------------------
	public function buildForumsPermArray(blnForced)
		dim arrAccess
		if blnForced OR NOT cor_cUseSysCache OR NOT isArray(cor.butil.getCache("ForumsPermArrayCache")) Then
			'----------------0------1--------2---------------3-------------4---------5--------6----------7----------8--------9---------------10--------------11-------12-------13------14---------15-----------16-----------17-------18-------19------------
			p_sql = "SELECT f.sid, f.sperm, f.smembersonly, f.spermadmin, f.sreply, f.sedit, f.sdelete, f.screate, f.svote, f.sattachments, f.simageupload, f.shide, f.sshow, f.suid, f.snormal, f.smoderate, f.sreadonly, f.spost, f.sname, f.spassword " _
				  & "FROM " & cor_dbpre & "forums AS f "	'" WHERE f.stype = 1"
			cor.dal.open arrAccess, p_sql, array()
			if  NOT cor.butil.eof(arrAccess) Then
				cor.butil.updCache "ForumsPermArrayCache", arrAccess, "sys"
				buildForumsPermArray = arrAccess
			else ' should never happen
				cor.msg "[ERR:class_utils] " & lngSysEmptyForumsTable
			end if
		else
			buildForumsPermArray = cor.butil.getCache("ForumsPermArrayCache")
		end if
	end function
	'
	'--------------------------------------------------------------------------------------------------------------------------
	'
	' retrieves a particular row column value from the forum permissions array 
	'
	'--------------------------------------------------------------------------------------------------------------------------
	public function getForumColVal(forumID, byVal intColToRetrieve, strColType)
		dim x_i
		dim colValue
		intColToRetrieve = cor.filter.checkInt(intColToRetrieve)
		if NOT isarray(cor_aForumsPerm)	Then exit function
		if intColToRetrieve=0 Then exit function
		' column to retrieve must be inside bounds 	
		if intColToRetrieve > ubound(cor_aForumsPerm,1) Then exit function	
		'
		for x_i = 0 to ubound(cor_aForumsPerm,2)
			if  cor.filter.checkInt(cor_aForumsPerm(0,x_i)) = forumID Then
				colValue = cor_aForumsPerm(cor.filter.checkInt(intColToRetrieve),x_i)
				select case strColType
				case cor_cInt
					getForumColVal = cor.filter.checkInt(colValue)
				case cor_cLng
					getForumColVal = cor.filter.checkLng(colValue)
				case cor_cDate
					getForumColVal = cdate(colValue)
				case cor_cBool
					getForumColVal = cor.filter.checkBol(colValue)
				case cor_cTime
					getForumColVal = cor.butil.cvLcidTime(colValue)
				case cor_cStr
					getForumColVal = cor.filter.checkStr(colValue)
				case else
					getForumColVal = colValue
				end select
				exit function
			end if
		next
	end function
	'----------------------------------------------------------------------------------------------------------
	'
	'-----------------------------------------------------------------------------------------------------------

	public function memberAllowedByFid(forumID)
		dim aPerm, x_i
		'
		aPerm = split(getForumColVal( forumID, 1, cor_cStr), ",")
		for x_i = 0 to ubound(aPerm)
			if cor.filter.checkInt(aPerm(x_i)) = cor.filter.checkInt(cor_iGroupID) Then
				memberAllowedByFid = true
				exit function
			end if
		next
	end function
	'----------------------------------------------------------------------------------------------------------

	'-----------------------------------------------------------------------------------------------------------

	public function memberAllowedByPerm(strPerm)
		dim arrsplit, x_i
		if NOT isNull(trim(strPerm)) Then
			arrsplit = split(strPerm&",",",")
			for x_i = 0 to ubound(arrsplit)
				if cor.filter.checkInt(arrsplit(x_i)) = cor.filter.checkInt(cor_iGroupID) Then
					erase arrsplit
					memberAllowedByPerm = true
					exit function
				end if
			next
			erase arrsplit
			memberAllowedByPerm = false
			exit function
		else
			memberAllowedByPerm = true
		end if
	end function
	'----------------------------------------------------------------------------------------------------------

	'-----------------------------------------------------------------------------------------------------------
	public function getTotalUsers(strCond)
		dim arrTotal
		if isEmpty(strCond) Then
			getTotalUsers = 0
			exit function
		end if
		p_sql = "SELECT COUNT(m.MemberID) FROM " & cor_dbpre & "members AS m WHERE m.memberid<>2 AND m.mactive <> 0 " & strCond
		cor.dal.open arrTotal, p_sql, array()
		if cor.butil.EOF(arrTotal) Then
			getTotalUsers = 0
		else
			getTotalUsers = arrTotal(0,0)
		end if
	end function
	'----------------------------------------------------------------------------------------------------------

	'-----------------------------------------------------------------------------------------------------------

	public function checkWrite(strFilePath)
		On error resume next
		dim objFile, strFileName
		call cor.obj.init("fso")
		if NOT cor.obj.fso.FolderExists(strFilePath) Then checkWrite = false : exit function
		strFileName = cor.butil.normPath(strFilepath) & cor.butil.cvUxTime(now) & ".txt"
		set objFile = cor.obj.fso.createTextFile(strFileName, cor_cForWriting, true)
		objFile.writeLine "Hello world!"
		objFile.close()
		set objFile = nothing
		cor.obj.fso.deleteFile(strFileName)
		checkWrite = iif(err.number<>0, false, true)
		On error goto 0
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------
	'
	' Change todays date into "today" and yesterday into ... "yesterday" 
	' TO DO : include the member date format choosen into the display....
	'
	'-----------------------------------------------------------------------------------------------------------------------
	public function postDate(byval dtmDate)

			' PROBLEM... 
			'		the unix numeric value is stored without timezone information, but is corrected for time zone when converted back to cDate.
			'		therefore, the date() value is not valid.  What if we convert the DATE() value through the same process to get the date?
		dim dNow
		dNow = cor.butil.cvUxTime(Date())			'	Convert to numeric unix format
		dNow = cdate(cor.butil.datetime(cor.butil.cvLcidTime(dNow),2))	' convert from numeric to date to shortdate to force data type
		'			convert numeric to date/time to shortdate
		if cdate(cor.butil.datetime(cor.butil.cvLcidTime(dtmDate),2)) = dNow Then
			postDate = lngToday 	& ", " & cor.butil.datetime(cor.butil.cvLcidTime(dtmDate),4) &""
		elseif cdate(cor.butil.datetime(cor.butil.cvLcidTime(dtmDate),2)) = dateadd("d",-1,dNow) then
			postDate = lngYesterday & ", " & cor.butil.datetime(cor.butil.cvLcidTime(dtmDate),4) &""
		else
			postDate = cor.butil.cvLcidTime(dtmDate)
		end if
	end function
	'----------------------------------------------------------------------------------------------------------
	'
	'-----------------------------------------------------------------------------------------------------------
	public function textField(byVal strField)
		strField = trim(strField)
		strField = replaceSmut(strField)
		strField = cor.filter.stripHTMLtags(strField)
		strField = cor.filter.sqlstring(strField)
		textField = strField
	end function
	'----------------------------------------------------------------------------------------------------------
	'
	'-----------------------------------------------------------------------------------------------------------
	public function linkField(byVal strLink)
		strLink = trim(strLink)
		strLink = replaceSmut(strLink)
		strLink = cor.filter.sqlstring(strLink)
		linkField = strLink
	end function
	'----------------------------------------------------------------------------------------------------------
	'
	'-----------------------------------------------------------------------------------------------------------
	public function replaceSmut(byVal strInput)
		dim adoRec
		dim smutWord
		dim smutreplaceWord
		dim arrSmut
		dim counter
		p_sql = "SELECT bw.* FROM " & cor_dbpre & "badwords AS bw "
		cor.dal.open arrSmut, p_sql, array()
		if Not cor.butil.eof(arrSmut) Then
			for counter = 0 to ubound(arrSmut,2)
				smutWord = arrSmut(1,counter)
				smutreplaceWord = arrSmut(2,counter)
				strInput = replace(strInput, smutWord, smutreplaceWord, 1, -1, 1)
			Next
		end if
		replaceSmut = strInput
	end function
	'------------------------------------------------------------------------------------------------------------------------
	'
	' normalize URL (i.e. add www. prefix)
	'
	'-------------------------------------------------------------------------------------------------------------
	public sub normalizeUrl(useWWW)
		dim sUrlTest
		dim sQryStrTest
		dim sSiteTest
		select case useWWW 
			case false
				if (left(lcase(cor_sServerName),4) = "www.") Then
					sUrlTest = request.serverVariables("url")
					if cor.io.qa <> "" Then sQryStrTest = "?" & cor.io.qa
					sSiteTest = replace(lcase(cor_sServerName),"www.","", 1, -1, 1)
					cor.redir(cor_sServerProtocol & sSiteTest & cor_iServerPort & sUrlTest & sQryStrTest)
				end if
			case else
				if  NOT (left(lcase(cor_sServerName),4) = "www.") Then
					sUrlTest = request.serverVariables("url")
					if cor.io.qa <> "" Then sQryStrTest = "?" & cor.io.qa
					sSiteTest = "www." & cor_sServerName
					cor.redir(cor_sServerProtocol & sSiteTest & cor_iServerPort & sUrlTest & sQryStrTest)
				end if
		end select
	end sub
	'
	'---------------------------------------------------------------------------------------------------------------------------
	'
	' Dynamic include ASP to JS localization for cor and/or mods placed between </body> and </html>
	'
	'--------------------------------------------------------------------------------------------------------------------------
	public function getLocale(bcor, bmod)
		'dim scor, smod
		'
		cor.obj.init("fso")
		if bcor then 
			if cor.obj.fso.FileExists(server.mappath(cor_sWebroot & "core/languages/" & cor_sLanguage & ".asp")) Then
				cor.str.adn cor.util.loadFile(cor_sLanguage&".asp","core/languages/")
			else
				cor.str.adn cor.util.loadFile(cor_sDefaultLang&".asp","core/languages/")
			end if
		end if
		if bmod then
			if cor.obj.fso.FileExists(server.mappath(cor_sWebroot & "mods/languages/" & cor_sLanguage & ".asp")) Then
				cor.str.adn cor.util.loadFile(cor_sLanguage&".asp","mods/languages/")
			else
				cor.str.adn cor.util.loadFile(cor_sDefaultLang&".asp","mods/languages/")
			end if 
		end if
		getLocale = cor.str.build
	end function
	'
	'------------------------------------------------------------------------------------------------------------------
	'
	' perform statistics
	'
	'-------------------------------------------------------------------------------------------------------------------
	public sub calculateStats(strEnableStats)
		if not isnumeric(strEnableStats) then strEnableStats = 0
		if cor.butil.modExist("class_stats") AND cint(strEnableStats) > 0 Then
			if cor.butil.isEmptyStr(session(cor_pre&"user_stat")) Then session(cor_pre&"user_stat") = "new"
			if  session(cor_pre&"user_stat") = "new" or session(cor_pre&"user_stat") = "update" Then
					cor.stats.exec = session(cor_pre&"user_stat")
					cor.stats.doStat
					if cor.stats.update Then session(cor_pre&"user_stat") = "update"
			end if
			set cor.stats = nothing
		end if
	end sub
	'
	'------------------------------------------------------------------------------------------------------------------------
	'
	' create a folder path where multiple folders may not exist along the way
	'
	'------------------------------------------------------------------------------------------------------------------------
	'
	' virtual path creator
	'
	public function createFoldersV(byval sFolderPath)
		dim arrFolderSubs, sFolder, i
		'
		'--- physical path found error
		if instr(sFolderPath, "\") > 0 then createFoldersV = "[ERR:createFoldersV] " & lngPathInvalid & sFolderPath : exit function
		'--- if path already exists there's nothing to do
		if cor.obj.fso.folderExists(server.mapPath(sFolderPath)) then exit function
		'--- normalize
		if right(sFolderPath, 1) <> "/" then sFolderPath = sFolderPath & "/"
		arrFolderSubs = split(sFolderPath, "/")
		for i = 0 to ubound(arrFolderSubs)-1
			sFolder = sFolder & arrFolderSubs(i) & "/"
			if  NOT cor.obj.fso.folderExists(server.mapPath(sFolder)) Then
				'--- handle access denied errors
				On error resume next
				cor.obj.fso.createFolder(server.mapPath(sFolder))
				if err.number <> 0 then createFoldersV = err.description : err.clear : On error goto 0 : exit function
				On error goto 0
			end if
		next
	end function
	'
	' physical path creator
	'
	public function createFoldersP(byval sFolderPath)
		dim arrFolderSubs, sFolder, sPathExists, i	
		'
		'--- virtual path found error
		if instr(sFolderPath, "/") > 0 then createFoldersP = "[ERR:createFoldersP] " & lngPathInvalid & sFolderPath : exit function
		'--- if path already exists there's nothing to do
		if cor.obj.fso.folderExists(sFolderPath) then exit function
		'--- normalize
		if right(sFolderPath, 1) = "\" then sFolderPath = mid(sFolderPath, 1, len(sFolderPath)-1)
		'
		' create one level at a time; starting first backwards to find an already existing folder 
		' and then forwards to create the missing ones
		'
		'--- find the subpath that already exists
		sPathExists = sFolderPath
		do  while instr(sPathExists, "\") > 0
			sPathExists  = mid(sPathExists, 1, instrRev(sPathExists, "\")-1)
			if cor.obj.fso.folderExists(sPathExists) then exit do
		loop
		'--- get the subpath folder array that needs creation
		arrFolderSubs = split(mid(sFolderPath, len(sPathExists)+1, len(sFolderPath)), "\")
		'--- create missing folders
		sFolder = sPathExists
		for i = 1 to ubound(arrFolderSubs)
			sFolder = sFolder & "\" & arrFolderSubs(i)
			if  NOT cor.obj.fso.folderExists(sFolder) Then
				'--- handle access denied errors
				On error resume next
				cor.obj.fso.createFolder(sFolder)
				if err.number <> 0 then createFoldersV = err.description : err.clear : On error goto 0 : exit function
				On error goto 0 
			end if
		next
	end function
	'
	' sqlShield activity logger
	'
	public function sqlShieldlog(sorig, sfiltered)
		' log all shielded suspicious attempts if audit is enabled
		if sorig <> sfiltered AND cor_sLogsPath <> "" AND cor_bEnableAudit Then call cor.audit.sqlShieldLog(sorig, sfiltered) 
		sqlShieldlog = sfiltered
	end function
	'
	'-------------------------------------------------------------------------------------------------------------------
	'
	' recreate activeusers menus cache (menu mgmt)
	'
	'--------------------------------------------------------------------------------------------------------------------
	public sub updateMenus()
		dim aid, amid, atype, arrMenu
		'
		amid  = iif(cor_bMember, cor_lUserID, clng(session.sessionID))
		atype = iif(cor_bMember, 1, 0)
		aid  = cor.filter.checkLng(cor.dal.getValue("SELECT au.aid FROM " & cor_dbpre & "activeusers AS au WHERE au.amid={0} AND au.atype={1}", array(amid,atype)))
		if aid=0 then exit sub
		'--- rebuild fresh menus
		'if cor_bEnableHorizMenu Then 
		cor_sMenuH = cor.menuphh.buildMenu()
		''' this menu no longer exists.
		'''if cor_bEnableVertMenu  Then cor_sMenuV = cor.menuacc.buildMenu()
		'--- update activeusers	
		p_sql = "UPDATE " & cor_dbpre & "activeusers SET amenuH={0}"' WHERE aid={1}
		cor.dal.exec p_sql, array(cor_sMenuH, aid)
	end sub
	'
	'-----------------------------------------------------------------------------------------------------------------
	'
	' avatar size html builder
	'
	'--------------------------------------------------------------------------------------------------------------
	public function avatarSz()
		dim intAvatarWidth, intAvatarHeight
		'
		intAvatarWidth  = cor.filter.checkInt(cor.cfg.item("intAvatarWidth")) 
		intAvatarHeight = cor.filter.checkInt(cor.cfg.item("intAvatarHeight"))
		avatarSz 		= iif(intAvatarWidth >0, " width="""  & intAvatarWidth  & """", "") _
						& iif(intAvatarHeight>0, " height=""" & intAvatarHeight & """", "") 
	end function
	'	
	'-----------------------------------------------------------------------------------------------------------
	'
	' If a postback event check if it's inside size allowance
	'
	'-----------------------------------------------------------------------------------------------------------
	public sub checkPostSizeAllowance()
		dim postbackSz, postMaxBytesSz, sVer
		' max size allowed for any non-binary postbacks
		' http://support.microsoft.com/kb/q273482/
		' http://support.microsoft.com/?kbid=260694
		' http://www.microsoft.com/technet/prodtechnol/WindowsServer2003/Library/IIS/a6401b5e-c902-4035-90aa-ee46c270d357.mspx
		sVer = replace(Cstr(cor_iIISver),".",",")
		select case cdbl(sVer)
		case "4"	: postMaxBytesSz = 2097151
		case "5"	: postMaxBytesSz = 15999
		case "5.1"	: postMaxBytesSz = 20000
		case "6"	: postMaxBytesSz = 204799
		case "7"	: postMaxBytesSz = 204799
		case "7.5"	: postMaxBytesSz = 204799
		case else	: postMaxBytesSz = 20000
		end select
		postbackSz = cor.filter.checkDbl(request.serverVariables("CONTENT_LENGTH"))

		'--- if not a postback nothing to do
		if  NOT cor_bPostback OR cor.io.isUpload OR postbackSz=0 Then exit sub
		'--- postback inside bounds
		'if  cor_lPostMaxSymbols > postMaxBytesSz AND cor_bMaxPostSzIIS Then cor.stopper "[ERR:checkPostSizeAllowance] " & lngSysPostMaxSymbolsMsg & cor_iIISver
		if  postbackSz <= cor_lPostMaxSymbols Then exit sub
		'--- mind using msg() instead will create a recursive stack overflow!
		cor.redirm lngSysPostOutOfBounds, cor_sReferer
	end sub
	'
	'-------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------
	public function high( strText, strFind, intclass )
		dim strFinal
		dim strReste
		dim x_i
		dim y_i
		dim blnPrendre
		dim aMorceaux
		dim strMorceau
		dim strNon
		dim strClass
		x_i = len(strText)
		blnPrendre 	= true
		strReste 	= strText
		strFinal 	= ""
		strMorceau 	= ""
		strNon 		= ""
		if (cor.filter.checkInt(intClass) = 0 or cor.filter.checkInt(intClass) > 4) then strclass = "" else strclass = intClass
		if cor.filter.checkLng(x_i) > 0 Then
			if instr(1, strText, "<", 1) > 0 Then
				for y_i = 1 To x_i 
					if mid(strReste,y_i,1) = "<" Then
						blnPrendre 	= false
						strNon 		= strNon & mid(strReste,y_i,1)
						strMorceau 	= highlight(strMorceau, strFind, "<span class=""highlight" & strclass & """>", "</span>")
						'strMorceau = highlight(strMorceau, strFind, "<span class=""highlight"">", "</span>")
						strFinal 	= strFinal & strMorceau
						strMorceau 	= ""
					else
						if  blnPrendre Then
							blnPrendre = true
							strMorceau = strMorceau & mid(strReste,y_i,1)
						else
							if mid(strReste,y_i,1) = ">" Then
								strNon 	 	= strNon & mid(strReste,y_i,1)
								strFinal 	= strFinal & strNon
								strNon 		= ""
								strMorceau 	= ""
								blnPrendre 	= true
							else
								strNon = strNon & mid(strReste,y_i,1)
							end if
						end if
					end if
				Next
				high = strFinal & highlight(strMorceau, strFind, "<span class=""highlight" & strclass & """>", "</span>")
			else
				high = highlight(strText, strFind, "<span class=""highlight" & strclass & """>", "</span>")
			end if
		else	
			high = ""
		end if
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'----------------------------------------------------------------------------------------------------------------------------------
	public function highlight(strText, strFind, strBefore, strAfter)
		dim nPos
		dim nLen
		dim nLenAll
		'	
		nLen = len(strFind)
		nLenAll = nLen + len(strBefore) + len(strAfter) + 1
		'
		highlight = strText
		'
		if nLen > 0 AND len(highlight) > 0 AND strFind <> " " Then
			nPos = instr(1, highlight, strFind, 1)
			do While nPos > 0
				highlight = left(highlight, nPos - 1) & strBefore & mid(highlight, nPos, nLen) & strAfter & mid(highlight, nPos + nLen)
				nPos = instr(nPos + nLenAll, highlight, strFind, 1)
			loop
		end if
	end function
	'---------------------------------------------------------------------------------------------------------------------------------
	'
	'----------------------------------------------------------------------------------------------------------------------------------
	public function highlightArray(strText, arrFind, strBefore, strAfter)
		dim nPos
		dim nLen
		dim nLenAll
		dim xi
		highlightArray = strText
		if len(strText) > 1 then
			for xi = 0 to ubound(arrFind)
			'	nLen = len(arrFind(xi))
			'	nLenAll = nLen + len(strBefore) + len(strAfter) + 1
			'	if nLen > 0 AND len(highlightArray) > 0 AND arrFind(xi) <> " " Then
			'		nPos = instr(1, highlightArray, arrFind(xi), 1)
			'		do While nPos > 0
			'			highlightArray = left(highlightArray, nPos - 1) & strBefore & mid(highlightArray, nPos, nLen) & strAfter & mid(highlightArray, nPos + nLen)
			'			nPos = instr(nPos + nLenAll, highlightArray, arrFind(xi), 1)
			'		loop
			'	end if
			if len(arrFind(xi)) > 0 then
				highlightArray = highlight(highlightArray, arrFind(xi), strBefore, strAfter)
			end if
			next
		end if 		' len of strText > 1
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------
	'
	' Function to rebuild the hierarchical structure of doc/forums/menu (moved from the dal class 2nd feb 2010
	' (Should be noted that this function will make twice the amount of db call as there is items so on a menu
	' that has 150 menu items, this function will make 300 db calls)
	'
	'------------------------------------------------------------------------------------------------------------------------------------
	public function rebuild_tree(iParent, iLeft, iLevel, sTable)
		'reset the left / right values for doc, menu and forums tables.
		dim iRight, sSelect, sUpdate, aTree, x_i
		iRight = iLeft + 1		'the right of a node is the left value +1 unless there are children.
		select case lcase(sTable)
		case "doc"
			sSelect = "SELECT doc_id FROM " & cor_dbpre & "doc WHERE doc_parent_id = {0} ORDER BY doc_order"
			sUpdate = "UPDATE " & cor_dbpre & "doc SET doc_left = {0}, doc_right = {1}, doc_sublevel = {2} WHERE doc_id = {3}"
		case "forums"
			sSelect = "SELECT sid FROM " & cor_dbpre & "forums WHERE suid = {0} ORDER BY sorder"
			sUpdate = "UPDATE " & cor_dbpre & "forums SET sleft = {0}, sright = {1}, ssublevel = {2} WHERE sid = {3}"
		case "menus"
			sSelect = "SELECT submenu_id FROM " & cor_dbpre & "menusub WHERE parent_id = {0} ORDER BY SubMenu_Order"
			sUpdate = "UPDATE " & cor_dbpre & "menusub SET submenu_left = {0}, submenu_right = {1}, SubMenu_SubLevel = {2} WHERE submenu_id = {3}"
		case else
			exit function
		end select
		cor.dal.Open aTree, sSelect, Array(iParent)
		if not cor.butil.eof(aTree) then		'update right for each child node.
			For x_i = 0 To Ubound(aTree,2)
				iRight = rebuild_tree(aTree(0,x_i), iRight, iLevel+1, sTable)
			Next
		end if
		'Update left / right to correct values
		cor.dal.exec sUpdate, array(ileft, iRight, iLevel, iParent)
		rebuild_tree = iRight + 1	'return value of this node + 1
	end function
end class

'<#late-binding hook
function boot_class_utils : boot_class_utils = true : end function
'/>

%>