﻿<!--#include file="db/_soop_pageglobal.asp" -->
<%
'----------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------
%>
<!--#include file="common.asp" -->
<%
' Check for Admin and redirect if not
if not cor_bAdmin then cor.redir("./")
'
dim strPageTitle : strPageTitle = "SooP Patch Installer"
if cor.filter.checkStr(cor.io.q("t")) = "[M]" then strPageTitle = "SooP Mod Installer"
call cor.tpl.init("forums")
call cor.tpl.header(strPageTitle,"")
cor.str.wri cor.modbox.printBoxTop
call js()
cor.str.wri "<div class=""modular"" style=""padding:20px;"">"
select case cor.io.r("step")
	case "1"
		' Enitial Database and Script selection
		call PageContent()
	case "2"
		' Show chosen install detals
		call ShowInstall(cor.io.f("sFile"))
	case "3"
		' Run table installer
		call startInstall(cor.io.f("inst"),false)
	case "4"
		' Run drop table script
		call startInstall(cor.io.f("inst"),true)
	case else
		' Catchall send back to enitial Database and Script selection
		call PageContent()
end select
cor.str.wri "</div>"
cor.str.wri cor.modbox.printBoxBottom
call cor.tpl.footer()
call cor.off()
'
'----------------------------------------------------
'
'	Main installer function
'
'----------------------------------------------------
private function PageContent()
	dim sType
	sType = cor.filter.checkStr(cor.io.q("t"))
	%>
	<script type="text/javascript">
	<!--<![CDATA[
	$(document).ready(function() {
		$('form#dbinstallers1').submit(function() {
			if($('#databasetype').val()==''){
				alert('You must select a database type');
				return false;
			}else{
			}
		});
	});
	// ]]> -->
	</script>
		<form id="dbinstallers1" name="dbinstallers1" class="soop" action="db_update.asp?step=2" method="post">
		<input type="hidden" name="t" id="t" value="<%= sType %>" />
		<input type="hidden" name="step" id="step" value="1" />
		<fieldset>
			<legend>Update/Module Installer</legend>
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label"><label for="">Database Type</label></li>
					<li class="input">
		<%
		dim oCombo
		Set oCombo = New class_comboBuilder
		oCombo.ElementID = "databasetype"
		oCombo.SelectedValue = SetDbType
		oCombo.AddOption "access","Microsoft Access"
		oCombo.AddOption "mssql2000","Microsoft SQL Server 2000 7.0"
		oCombo.AddOption "mssql","Microsoft SQL Server 2005/2008"
		oCombo.AddOption "mysql","MySQL"
		oCombo.CreateCombo()
		Set oCombo = Nothing
		%>
					</li>
				</ul>
				</li>
			</ul>
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label">Install to perform</li>
					<li class="input">
				<%
				cor.str.wri getInstallList(sType)
				%>
					</li>
				</ul>
				</li>
			</ul>
		</fieldset>
		<div class="buttonOuterWrap"><div class="buttonInnerWrap">
			<div class="ui button"><button title="Submit" value="Submit" type="submit"><span>Submit</span></button></div>
		</div></div>
		</form>
		<%
end function
'
'----------------------------------------------------
'
'	Install functions
'
'----------------------------------------------------
'
Private Function OpenIniFile(ByVal FileName)
	call cor.obj.init("fso")
	OpenINIFile = cor.obj.fso.OpenTextFile(FileName,1).ReadAll
End Function
'
Private Function getxmlString(section, nodename, strDefault, filepath)
	call cor.obj.init("xml")
	cor.obj.xml.async = False
	cor.obj.xml.setProperty "ServerHTTPRequest", True
	cor.obj.xml.Load filepath
	'response.write "FilePath: " & filepath & "<br />"
	'response.write "Section:  " & section & "<br />"
	'response.write "nodename: " & Nodename & "<br />"
	'response.flush
	getxmlString = cor.obj.xml.SelectSingleNode("//" & section & "/" & nodename).text
End Function
'
function getInstallList(tType)
	Dim filesystem,folder,subfolders,folderName,objInstallFolder, sTemplateName,sMainFolder
	Dim filecollection,filename, ipos, File
	sMainFolder = Server.MapPath("install\scripts")
	Set filesystem = Server.CreateObject("Scripting.FileSystemObject")
	Set Folder = FileSystem.GetFolder(sMainFolder)
	Set SubFolders = Folder.SubFolders
	ReDim arrayInstalls(4,0)
	For each FolderName in subfolders
	if instr(FolderName,tType)>0 then
		' get files in folder
		Set objInstallFolder = FileSystem.GetFolder(sMainFolder & "\" & foldername.name)
		'return file collection In folder
		Set filecollection = objInstallFolder.Files
		'create the links
		For Each filename In filecollection
			Set file=FileSystem.GetFile(filename.path)
			if Instr(lcase(filename.name),".xml") > 0 Then
				iPos = ubound(arrayInstalls,2)+1
				Redim Preserve arrayInstalls(4,ipos)
				arrayInstalls(0,ipos) = filename.name
				arrayInstalls(1,ipos) = "File"
				arrayInstalls(2,ipos) = File.path
				arrayInstalls(3,ipos) = Foldername.name
				arrayInstalls(4,ipos) = Foldername.path
			end if
		Next
		set filecollection = nothing
		set objInstallFolder = nothing
	end if
	next
	Set fileSystem = Nothing
	Set Folder = Nothing
	Set SubFolders = Nothing
	dim intLoop,strIniFile
		cor.str.add "<select name=""sFile"" id=""sFile"">"
			For intLoop = 1 to ubound(arrayInstalls,2)
			cor.str.add "<option value=""" & arrayInstalls(4,intLoop) & "\" & arrayInstalls(0,intLoop) & """>"
			strIniFile = OpenINIFile(arrayInstalls(4,intLoop) & "\" & arrayInstalls(0,intLoop))
			cor.str.add getxmlString("declare","name","Not Found",arrayInstalls(4,intLoop) & "\" & arrayInstalls(0,intLoop))
			cor.str.add "</option>"
			Next
		cor.str.add "</select>"
	getInstallList = cor.str.build
End function
'
'----------------------------------------------------
'
'	Install sub routines
'
'----------------------------------------------------
'
Sub StartInstall(sInstallFile,blnDrop)
	Dim sSQLFile,sSQLfileName,strSQLCode,sarySQLCode,blnTestOnly,strINIFile,intLoop,strsarySQLCode,insCon
		If blnDrop Then
			sSQLfileName = getxmlString("files","drop", "", sInstallFile)
		Else
			If cor.io.f("databasetype") = "mssql2000" Then
				sSQLfileName = getxmlString("files","mssql", "", sInstallFile)
			ElseIf cor.io.f("databasetype") = "mssql" Then
				sSQLfileName = getxmlString("files","mssql", "", sInstallFile)
			ElseIf cor.io.f("databasetype") = "mysql" Then
				sSQLfileName = getxmlString("files","mysql", "", sInstallFile)
			Else
				sSQLFileName = getxmlString("files","access", "", sInstallFile)
			End If
		End If
		sSQLfileName = Left(sInstallFile,InstrRev(sInstallFile,"\")) & sSQLfileName
		strSQLCode = OpenINIFile(sSQLFilename)
	
		'Insert the Table Reference
		strSQLCode = Replace(strSQLCode,"<DBTABLE>",cor_dbpre, 1, -1, 1)
		strSQLCode = Replace(strSQLCode,"<DBDATE>",cor.butil.cvUxTime(Now), 1, -1, 1)
		If cor.io.f("databasetype") = "mssql2000" Then
			strSQLCode = Replace(strSQLCode,"NVARCHAR(MAX)","NVARCHAR(4000)", 1, -1, 1)
		End If
		
		If blnDrop And cor.io.f("databasetype") = "mysql" Then
			strSQLCode = Replace(strSQLCode,"[","", 1, -1, 1)
			strSQLCode = Replace(strSQLCode,"]","", 1, -1, 1)
		End If
		If cor.io.f("databasetype") = "mssql" Then
			strSQLCode = Replace(strSQLCode,"NTEXT","NVARCHAR(MAX)")
		End If
	sarySQLCode = Split(Trim(strSQLCode), "GO")

	cor.str.wri "<div id=""installinnerwrapper"" class=""modular text"" style=""max-height:500px;overflow:auto;"">"
	For intLoop = LBound(sarySQLCode) to UBound(sarySQLCode) - 1
		strsarySQLCode = sarySQLCode(intLoop)
		strsarySQLCode = Replace(strsarySQLCode, VbCrLf, "")
			Err.Clear
			On Error resume Next
			cor.str.wri "<div style='width:10%;float:left;'><strong>Executing :</strong></div>"
			cor.str.wri "<div style='width:80%;float:left;'>" & strsarySQLCode & "<br /><br /></div>"
			cor.dal.exec sarySQLCode(intLoop), array()
			If Err.Number <> 0 Then
				'Response.Write "$(""#sqlloader"").remove();"
				cor.str.wri "<div align='right' style='width:10%;float:left;'>Failed<br />Error: " & Err.Description & "</div>"
			Else
				'Response.Write "$(""#sqlloader"").remove();"
				cor.str.wri "<div align='right' style='width:10%;float:left;color:#00c000;'>Successful</div>"
			end if
		cor.str.wri "<div style='width:100%;float:left;Border-top:solid 1px #000000;'>&nbsp;</div>"
		'cor.str.wri strsarySQLCode
	Next
		cor.str.wri "<div class=""buttonOuterWrap""><div class=""buttonInnerWrap"">"
		if cor_bEmbedded then
		cor.str.wri "	<div class=""ui button"">"
		cor.str.wri "		<a href=""javascript:void(0)"" class=""ModalRemove"">"
		cor.str.wri "			<span class=""ModalRemove"">Done</span>"
		cor.str.wri "		</a>"
		cor.str.wri "	</div>"
		else
		cor.str.wri "	<div class=""ui button"">"
		if  cor.filter.checkStr(cor.io.q("t")) = "[M]" then	'mod or update?
			cor.str.wri "		<a href=""mgmt_modulesadd.asp"">"
		else
			cor.str.wri "		<a href=""default.asp"">"
		end if
		cor.str.wri "			<span>Done</span>"
		cor.str.wri "		</a>"
		cor.str.wri "	</div>"
		end if
		cor.str.wri "</div></div>"
		cor.str.wri "</div>"
end Sub
'
Sub ShowInstall(sInstallFile)
	Dim sIFile,sIfileName,strIniFile
	strIniFile = OpenINIFile(sInstallFile)
	%>
	<div id="installwrapper2" class="modular text" style="display:none;">
	<div class="tiHeading" style="padding-left:100px;">Installing database tables, Please Wait  <img src="setup/assets/loading.gif" border="0" /></div>
	</div>
	<form i="frmwrapper" class="soop" action="">
	<div id="installwrapper" class="modular text">
	<fieldset id="installdb">
	<legend>Install Database Tables</legend>		
	<ul class="row">
		<li>
			<ul class="col">
				<li class="label">Install:</li>
				<li class="input"><%= getxmlString("declare","name", "", sInstallFile) %></li>
			</ul>
		</li>
	</ul>

	<% If getxmlString("declare","version", "", sInstallFile)<> "" Then %>
	<ul class="row">
		<li>
			<ul class="col">
				<li class="label">Version:</li>
				<li class="input"><%= getxmlString("declare","version", "", sInstallFile) %></li>
			</ul>
		</li>
	</ul>
	<% End If %>
	
	<ul class="row">
		<li>
			<ul class="col">
				<li class="label">Written By:</li>
				<li class="input"><%= getxmlString("declare","written", "", sInstallFile) %></li>
			</ul>
		</li>
	</ul>
	
	<ul class="row">
		<li>
			<ul class="col">
				<li class="label">Script Date:</li>
				<li class="input"><%= getxmlString("declare","date", "", sInstallFile) %></li>
			</ul>
		</li>
	</ul>
	
	<% If getxmlString("declare","updated", "", sInstallFile)<> "" Then %>
	<ul class="row">
		<li>
			<ul class="col">
				<li class="label">Updated:</li>
				<li class="input"><%= getxmlString("declare","updated", "", sInstallFile) %></li>
			</ul>
		</li>
	</ul>
	<% End If %>
	
	<ul class="row">
		<li>
			<ul class="col">
				<li class="label">Comments:</li>
				<li class="input"><%= getxmlString("declare","comments", "", sInstallFile) %></li>
			</ul>
		</li>
	</ul>
	
	<% If (getxmlString("files","mssql", "", sInstallFile) <> "") Or (getxmlString("files","access", "", sInstallFile) <> "") Or (getxmlString("files","mysql", "", sInstallFile) <> "") Then %>
	<ul class="row">
		<li>
			<ul class="col">
				<li class="label">Database Type:</li>
				<li class="input">
				<%
				If cor.io.f("databasetype") = "mssql2000" Then
				cor.str.wri "Microsoft SQL2000"
				ElseIf cor.io.f("databasetype") = "mssql" Then
				cor.str.wri "Microsoft SQL2005/8"
				ElseIf cor.io.f("databasetype") = "mysql" Then
				cor.str.wri "MySql"
				Else
				cor.str.wri "Microsoft Access"
				End If
				%>
				</li>
			</ul>
		</li>
	</ul>
	<% End If %>
	
	<ul class="row">
		<li>
			<ul class="col">
				<li class="label">Database Table Prefix:</li>
				<li class="input"><%= cor_dbpre %></li>
			</ul>
		</li>
	</ul>
	
	<% sIfileName = getxmlString("files","instructions", "", sInstallFile) %>
	<% If sIfileName <> "" then
		sIFile = Left(sInstallFile,InstrRev(sInstallFile,"\")) & sIFilename
		sIFile = OpenIniFile(sIFile) %>
	<ul class="row">
		<li>
			<ul class="col">
				<li class="label">Notes:</li>
				<% If Instr(lcase(sIFilename),".txt") > 0 Then %>
				<li class="input"><textarea rows="8" cols="50"><%= sIFile %></textarea>
				<%End If%>
			</ul>
		</li>
	</ul>
	<%end If%>
	</fieldset>
	<div align="center" class="tiHeading">To install the database, click the Start Install Button.</div>
	<% If (getxmlString("files","drop", "", sInstallFile) <> "") Then %>
	<div align="center" class="tiHeading">To Remove the tables created by a prior install, click Remove Tables.</div>
	<% End If %>
	</form>
	<br />
	<form id="addtbls" name="addtbls" class="soop" action="db_update.asp?step=3" method="post">
	<input type="hidden" name="step" value="2">
	<input type="hidden" name="inst" value="<%= sInstallFile %>" />
	<input type="hidden" name="databasetype" value="<%= cor.io.f("databasetype") %>" />
	<input type="hidden" name="t" id="t" value="<%= cor.filter.checkStr(cor.io.q("t")) %>" />
	<div align="center" class="tiHeading" style="padding:15px;">
		<div class="buttonOuterWrap"><div class="buttonInnerWrap">
			<div class="ui button">
				<button id="dbinsbtn" title="Start Install" value="Start Install" type="submit">
					<span>Start Install</span>
				</button>
			</div>
			<% If (getxmlString("files","drop", "", sInstallFile) <> "") Then %>
			<div class="ui button">
				<button id="dbrmvbtn" title="Remove Tables" value="Remove Tables" type="button">
					<span>Remove Tables</span>
				</button>
			</div>
			<% end if %>
		</div></div>
	</div>
	</form>
	<form id="rmvtbls" name="rmvtbls" class="soop" action="db_update.asp?step=4" method="post">
	<input type="hidden" name="t" id="t" value="<%= cor.filter.checkStr(cor.io.q("t")) %>" />
	<input type="hidden" name="step" value="4" />
	<input type="hidden" name="inst" value="<%= sInstallFile %>" />
	<input type="hidden" name="databasetype" value="<%= cor.io.f("databasetype") %>" />
	</form>
	</div>
<%
end Sub
'
'----------------------------------------------------
'
'	Install JS as a sub routine
'
'----------------------------------------------------
'
private sub js()
%>
<script type="text/javascript">
$(document).ready(function(){
	$('#dbrmvbtn').click(function() {
		var rmvalert = confirm("Are you sure you to remove these tables\n\nThis cannot be undone.");
		if(rmvalert){
			$("#rmvtbls").submit();
		}else{
		}
	});
});
</script>
<%
end sub
private function SetDbType
	dim x	: 	x = lcase(cor_sDatabaseType)
	if x = "mssql" then		'	are we using SQL 2000 or SQL 2005+ ?
		dim cSql, v
		cSql = "SELECT SERVERPROPERTY('productversion')"
		cor.dal.open v, cSql, array()
		if isNumeric(left(v(0,0), 3)) then
			if cdbl(left(v(0,0), 3)) < 9 then	'2000 = 8.00.x, 2005 = 9.00.x
				x = "mssql2000"
			end if
		end if
	end if 
	SetDbType = x
end function

%>

