﻿<!--#include file="db/_soop_pageglobal.asp" -->
<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
' Revision 2.00 - initial 15/02/2008
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<!--#include file="common.asp" -->
<%
call cor.tpl.init("faq")
call cor.tpl.header("Core Filters","")

dim strSkinPath
'we need the path to the skin icons:
strSkinPath = cor_sSkinCss
dim i
for i = len(strSkinPath) to 1 step -1
	if mid(strSkinPath, i, 1) = "/" then
		strSkinPath = left(strSkinPath, i)
		exit for
	end if
next
cor.str.wri cor.modbox.printBoxTop & "<div class=""modular text"">"
%>
<div class="holder1">
<h1 align="center">Core Filters</h1>

<p>The file core/classes/class_filters.asp contains a number of useful subs and functions. This file will list those functions and how to make use of them.</p>
<em>The following information is provided by Cadius (Charles) based on core files as of 23 Oct 2009.</em>

<h4>Access these subs and functions as cor.filter.*</h4>
</p>
<p> <ul>
		<li><strong>clnEditor(strValue)</strong> Returns strValue after trimming and removing carriage return / line feeds (CR/LF).</li>
		<li><strong>escEditor(strValue)</strong> Returns strValue after trimming and replacing " with \", ' with \', _ with \_, (MySQL escape codes) and removing CR/LF.</li>
		<li><strong>stripHTMLTags(htmlString)</strong> Returns htmlString after removing anything between &lt; and &gt;.</li>
		<li><strong>validFilename(str)</strong> Returns str after replacing invalid characters with _.</li>
		<li><strong>validASPList(str)</strong> Returns str after replacing &quot; with `.</li>
		<li><strong>validatePostEvent(bEnableRefer)</strong> If bEnableRefer is True, then this will confirm that posts are coming from the site, not from other (cross-site) locations.</li>
		<li><strong>sqlShield(inputStr, level)</strong> Returns inputStr after filtering out potential SQL Injections.
			<ul><li>If level = cor_cShieldNone, then this filter returns InputStr unchanged.</li>
				<li>If level = cor_cShieldXSS, then this filter uses RegEx to filter out XSS attacks.</li>
				<li>If level = cor_cShieldSql, then this filter will change standard SQL keywords such as select, delete, drop, etc. into non-executable words by replacing one letter with it's HTML code equivilent.</li>
				<li>If level = cor_cShieldSqlXSS, then this filter performs both the XSS check and the Sql check.</li>
			</ul>
		</li>
		<li><strong>checkStrSQL(strString)</strong> This returns strStirng after escaping ' and \ as '' and \\ respectively. (MS-SQL)</li>
		<li><strong>sqlString(strValue)</strong> This returns strValue after replacing ' with ''.</li>
		<li><strong>removeHTML(strText)</strong> This returns strText after replacing BR tags with carriage returns and any other HTML tags are removed.</li>
		<li><strong>CheckZero(num)</strong> This returns 0 if num is not numeric, is null, or is empty.  Otherwise, it returns num without any commas (,).</li>
		<li><strong>checkBol(inputVal)</strong> If inputVal is boolean, it returns inputVal.  If inputVal  = "true" it returns true.  if checkzero(inputVal) <> 0 then it returns true.  Otherwise, it returns False.</li>
		<li><strong>checkNull(inputStr)</strong> If inputStr is null or empty this returns True.  Otherwise it returns False</li>
		<li><strong>CheckNumeric(inputStr)</strong> Returns True if inputStr is numeric, false if it is not.</li>
		<li><strong>CheckInt(inputInt)</strong> This returns 0 if inputInt is not numeric. Otherwise, it converts inputInt to an integer and returns that.</li>
		<li><strong>checkLng(inputLng)</strong> If inputLng is not numeric, this returns 0. Otherwise, it converts inputLng to Long type and returns it.</li>
		<li><strong>checkDbl(inputDbl)</strong> Returns 0 if inputDbl is not numeric.  Otherwise it converts inputDbl to Double and returns that.</li>
		<li><strong>checkStr(inputStr)</strong> Returns "" if inputStr is empty or null.  Otherwise, it returns inputStr.</li>
		<li><strong>decrypt(EncryptedString)</strong> This returns an unencrypted string that was encrypted with the Encrypt function below.</li>
		<li><strong>encrypt(str)</strong> This returns a string that's been encrypted with a fairly basic cypher.</li>
		<li><strong>validhtml(str)</strong> This returns a string that's replaced all &amp; characters with &amp;amp;</li>
		<li><strong>noAnchor(str)</strong> This returns a string that contains anything up to the first occurance of # sign (anchors in URLs).</li>
		<li><strong>iift(val1, val2, ctype)</strong> This functions like iif but uses the variable type to control whether to return val1 or val2. If val1 is ctype data type, then val1 is returned.  Otherwise, val2 is.</li>
		<li><strong>ReverseHTMLCode(inText)</strong> This will return inText after converting words passed through sqlShield back into words by replacing HTML codes with letters.</li>
		<li><strong>BadWordFilter(strText)</strong> This returns strText after replacing any words from BadWords table.</li>
	</ul>
	<br /><br />
</p>

</div><!-- End Holder 1 -->
<%
cor.str.wri "</div>" & cor.modbox.printBoxBottom
call cor.tpl.footer()
call cor.off()
%>
