﻿<!--#include file="db/_soop_pageglobal.asp" -->
<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
' Revision 2.00 - initial 15/02/2008
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<!--#include file="common.asp" -->
<%
call cor.tpl.init("faq")
call cor.tpl.header("Core Utilities","")

dim strSkinPath
'we need the path to the skin icons:
strSkinPath = cor_sSkinCss
dim i
for i = len(strSkinPath) to 1 step -1
	if mid(strSkinPath, i, 1) = "/" then
		strSkinPath = left(strSkinPath, i)
		exit for
	end if
next
cor.str.wri cor.modbox.printBoxTop & "<div class=""modular text"">"
%>
<div class="holder1">
<a name="top"></a>
<h1 align="center">Core Utilities and Core Base Utilities</h1>

<p>The files core/classes/class_utilities.asp and core/classes/class_baseutilities.asp contain a number of useful functions. This file will list those functions and how to make use of them.</p>
<br />
<p><em>The following information is provided by Cadius (Charles) based on core files as of 10 Feb 2010.</em><p>
<br />
<p><ul>
	<li><a href="#util">Core Utilies</a></li>
	<li><a href="#butil">Core Base Utilies</a></li>
	<li><a href="#filter">Core Filters</a></li>
</ul><br /><br /></p>
<p> 
	<h2 align="center"><a name="util">Core Utilities</a></h2>
	<h4>Access these subs and functions as cor.util.*</h4>
	<ul>
		<li><strong>loadFile(strFile, strFolder)</strong> combines cor_sWebroot with strFolder and strFile, then passes this off to cor.dyninc.include.</li>
		<li><strong>displayFlash(swfFile,swfHeight,swfWidth,swfTransparent)</strong> This returns a div containing a Flash file object.</li>
		<li><strong>checkMod(mod_name)</strong> Returns true if the database contains given module and if the user has permission to see it.</li>
		<li><strong>displayModsList</strong> Pulls all modules from DB, checks for user permissions and whether the mod is set to show.  Returns a string of all mod names.</li>
		<li><strong>pageTitle(strKeyname, strCode)</strong> Returns the page's title and adds the forum topic if in forums.</li>
		<li><strong>checkBannedIP</strong> This checks the user's IP against the IP's listed as Banned. Returns True if banned. Also deletes any expired IP bans.</li>
		<li><strong>getUserNamebyID(lngUserID)</strong> Returns a user's name given a user's Member ID value.</li>
		<li><strong>checkOnline(userID)</strong> Returns True if a given Member ID is listed as online in parameters.</li>
		<li><strong>buildForumsPermArray(blnForced)</strong> Returns forum permissions array either from Forums table or cache.</li>
		<li><strong>getForumColVal(forumID, intColToRetrieve, strColType)</strong> Returns a row / column value from the forum permissions array.</li>
		<li><strong>memberAllowedByFid(forumID)</strong> Returns True if the user's group is allowed access to the given forum ID.</li>
		<li><strong>memberAllowedByPerm(strPerm)</strong> Returns true if a user's group has access based on the permissions string passed in.</li>
		<li><strong>getTotalUsers(strCond)</strong> Returns a count of users that are not Guest and are active and/or meet the sql strCond condition.</li>
		<li><strong>checkWrite(strFilePath)</strong> Returns true if the given path exists and if a txt file can be written to the folder.</li>
		<li><strong>postDate(dtmDate)</strong> Returns "Today", "Yesterday", or a formatted date based on the integer dtmDate value. (INTEGER, not date or date/time format). </li>
		<li><strong>textField(strfield)</strong> Returns the strField value after trimming it, replacing any bad words in it, fixing HTMLTags and fixing SQL keywords.</li>
		<li><strong>linkField(strLink)</strong> Returns strLink value after trimming it, replacying any bad words in it, and fixing SQL keywords.</li>
		<li><strong>replaceSmut(strInput)</strong> Returns strInput after any words found the Badwords table are cleaned up.</li>
		<li><strong>normalizeURL(useWWW)</strong> If useWWW is True and the url does not contain www then reload the page with www.*. If url contains www and useWWW is false, reload the page without the www.</li>
		<li><strong>getLocale(bcor, bmod)</strong> Loads dynamic ASP files from core/languages and mods/languages.</li>
		<li><strong>calculateStats(strEnableStats)</strong> If stats are enabled, then this calls out to cor.stats to calculate statistics.</li>
		<li><strong>createFoldersV(sFolderPath)</strong> This creates virtual folder path (i.e. creates all folders in the path as needed).</li>
		<li><strong>createFoldersP(sFolderPath)</strong> Creates a path of folders based on physical file path.</li>
		<li><strong>sqlShieldLog(sorig, sfiltered)</strong> If auditing is on and a suspicious value (anything modified by sql filtering) then log it. Returns sFiltered</li>
		<li><strong>updateMenus</strong> Recreates the menus cache.</li>
		<li><strong>avatarSz</strong> Returns width / height string for avatar image size for use in img tags.</li>
		<li><strong>checkPostSizeAllowance</strong> Checks to see if a form posted back is within IIS size limits. If not, we throw an error msg.</li>
		<li><strong>high(strText, strFind, intclass)</strong> Returns strText after placing occurances of strFind within highlighting spans. (intClass is added to the highlight span class.) This will not alter values inside &lt; &gt; tags.</li>
		<li><strong>highlight(strText, strFind, strBefore, strAfter</strong> Returns strText after placing strBefore and strAfter around strFind. Does NOT test for html tags.</li>
		<li><strong>highlightarray(strText, arrFind, strBefore, strAfter)</strong> Returns strText after replacing all passing it through highlight (see above) for each value in arrFind.</li>
		<li><strong>rebuild_tree(iParent, iLeft, iLevel,sTable)</strong> This function rebuilds heirarchical structures (doc, forums, menus, etc). This can cause huge db loads (# of rows in table  x 2).</li>
	</ul>
	<br />
	<a href="#top">Return to Top</a>
	<br />
</p>
<p> 
	<h2 align="center"><a name="butil">Core Base Utilities</a></h2>		
	<h4>Access these subs and functions as cor.butil.*</h4>
	<ul>
		<li><strong>eof(arr)</strong> This utility will return True if arr is NOT an array or False if arr IS an array.  In database operations, this is useful because the Data Access Layer (cor.dal) returns query results as array, unless no results are returned.<br />
			<em>if cor.butil.eof(arrResults) then exit sub ' no results found</em></li>
		<li><strong>properCase(sString)</strong> This will the first letter of each word as separated by _ or _.</li>
		<li><strong>isEmptyStr(str)</strong> This will return true if the str variable is null, empty, or contains nothing (""). Returns False otherwise.<br />
			<em>if cor.butil.isEmptyStr(strFormVariable) then strFormVariable = "Nothing supplied here." </em></li>
		<li><strong>isEmptyNumber(val)</strong> Like isEmptyStr above, this returns True if val is empty or null.  It also returns True if val is NOT a number.
		<li><strong>inArray(wrd, arr)</strong> Use this to determine if a given item is in an array.  This is kind of like instr for arrays. It returns -1 if not found. Otherwise, it returns the array's counter.  
			NOTE: This function is designed for the arrays coming out of the Data Access Layer, so it assumes a two dimensional array, with the first dimension being the search parameter<br />
			<em>intItem = cor.butil.inArray("Text to Find", arrResults)</em></li>
		<li><strong>IP</strong> This returns the users' IP address</li>
		<li><strong>getWebRoot </strong> This returns the mapped file path to the site's root folder, with the trailing "\" </li>
		<li><strong>normPath(path)</strong> Confirms that a given path ends in either a "/" or a "\", depending on what's used within the supplied path. <em> </em></li>
		<li><strong>strMatch(objText, objPattern, objreplace, replaceOrMatch)</strong> This uses Regular Expressions to search objText for objPattern. If objPattern is found and ReplaceOrMatch is True, then objPattern is replaced with objReplace.  if ReplaceOrMatch is False, then the function returns True if objPattern is found, False if it is NOT found.</li>
		<li><strong>createGuid</strong> This returns a unique GUID (Globally Unique Identifier, this is a long complex string that should always be unique).</li>
		<li><strong>GetLCIDDateformat</strong> This returns the date format as a string, based on the server's LCID value.</li>
		<li><strong>cvUxTime(dDate)</strong> This converts the given date or date/time to a Unix-style integer value. <em>We never store dates as date data types. We only store them as integers to prevent having to handle each DB engine's unique rules for date/time conversions</em></li>
		<li><strong>cvLcidTime(dDate) </strong> This reverses the above function.  It converts an integer into a date/time formatted for the sever's LCID format. If it fails to convert, then it uses current date/time.</li>
		<li><strong>datetime(dDate, intFormat)</strong> This accepts a date or date/time and displays it using the given format. <br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>intFormat for Now():</strong>
			<ol start=0>
				<li>vbGeneralDate: <em><%= cor.butil.datetime(now(), 0) %></em></li>
				<li>vbLongDate: <em><%= cor.butil.datetime(now(), 1) %></em></li>
				<li>vbShortDate: <em><%= cor.butil.datetime(now(), 2) %></em></li>
				<li>vbLongTime:<em> <%= cor.butil.datetime(now(), 3) %></li></em></li>
				<li>vbShortTime: <em><%= cor.butil.datetime(now(), 4) %></em></li>
				<li> yyyy/mm/dd: <em><%= cor.butil.datetime(now(), 5) %></em></li>
				<li> mm/dd/yyyy: <em><%= cor.butil.datetime(now(), 6) %></em></li>
				<li> dd/mm/yyyy: <em><%= cor.butil.datetime(now(), 7) %></em></li>
				<li> mm/dd/yy hh24:mm:ss: <em><%= cor.butil.datetime(now(), 8) %></em></li>
			</ol>
		</li>
		<li><strong>genRAndomCode(intLen)</strong> Generates a random string of intLen length. It is made up of lower and upper case letters and numbers. This is used for password reset emails primarily.</li>
		<li><strong>checkPerm(pattern, group)</strong> Returns True if the integer group is found in pattern (either single integer value, or an string of integers comma separated.)  Otherwise, returns false.  This is used to see if a given group has permissions:
			<em> e.g. if a forum has permissions of "1,2,3,4,5" then cor.butil.checkPerm(pattern, group) would return True for group 3, but False for group 6</em></li>
		<li><strong>decryptCaptcha(encryptedstring)</strong> unencrypts a captcha value.</li>
		<li><strong>checkSecurityCode(valSecurityCode, valSessionName)</strong> Returns True if SessionName = DecryptCaptcha(SecurityCode)</li>
		<li><strong>ModExist(sModuleName)</strong> This tests to see if a given module is being loaded.  Returns true if it is, false if it is not.</li>
		<li><strong>varExist(sVarName)</strong> This returns True if sVarName contains data.  Returns false if the variable does not.</li>
		<li><strong>htmlEncode(str)</strong> A simple HTML replacer. cor.filter is better set to do this task, but this will replace & with &amp;amp;, " with &amp;quot;, &lt; with &amp;lt;, and &gt; with &amp;gt;  Careful, as this will turn valid entries, like &amp;euro; into &amp;amp;euro;</li>
		<li><strong>urlDecode(str)</strong> This is an inverse of server.URLEncode.</li>
		<li><strong>genUniqueID</strong> This generates  "UID_" plus a random number between 1 and 5000. It's used to assign unique ID's to DIV tags</li>
		<li><strong>serialRows(arrPassed)</strong> Converts a two-dimensional array into a string.</li>
		<li><strong>regetRows(strPassed)</strong> This reverses the above, converting a string into a two-dimensional array.</li>
		<li><strong>CheckNotvoid(strParams)</strong> If strParams is empty, or missing values, it throws a core popup message. This is used for required IO values.</li>
		<li><strong>execParam(querystr)</strong> get (ASP) values from variants delimited as {} in a query string.  if variant is undefined in code, the string is kept. <br />
			<em>Example: a=5, b is undefined .. execParam ("a={a}&b={b}") -> a=5&b=b</em></li>
		<li><strong>SaveCookie(name, value)</strong> Saves value to the users' cookie file.</li>
		<li><strong>SaveCookieAr(arname, name, value)</strong> Saves an array value from an array named arname.</li>
		<li><strong>delCookie(name)</strong> Deletes a value from the user's cookie.</li>
		<li><strong>getCache(name)</strong> cache mgmt (sys/lang/menu types)</li>
		<li><strong>updCache(name, value, type)</strong> pushes data out to cache to fix changes.</li>
		<li><strong>Stripq(query, param)</strong> Strips parameter from querystring</li>
		<li><strong>setEmbedState</strong> Determines the Embed Manager (ASP part) (js counterpart in core.js->EmbedMan()) state True = enabled.</li>
		<li><strong>deserialize(str, delim)</strong> This returns an array by splitting str based on delim.</li>
		<li><strong>random(lowval, highval)</strong> This returns a random integer between lowval and highval.</li>
		<li><strong>errorMsg(msgText, headerText, fade, fadetimeout, redirect, url, urltimeout, scroll)</strong> This builds and shows a purr error message.</li>
		<li><strong>successMsg(msgText, headerText, fade, fadetimeout, redirect, url, urltimeout, scroll)</strong> This builds and shows a purr success message.</li>
		<li><strong>infoMsg(msgText, headerText, fade, fadetimeout, redirect, url, urltimeout, scroll)</strong> This builds and shows a purr information message.</li>
		<li><strong>printBanner(intZoneID)</strong> This gets banners for a given banner zone, and returns one random banner from that zone.</li>
		<li><strong>HTMLdecode(encodedstring)</strong> This converts &amp;quote; to &quote; and so on for &lt;, &gt; &amp;, and &amp;nbsp;. A reverse of HTMLencode, above.</li>
		<li><strong>ParseSearchKeywords(strSearchWords)</strong> This uses Regular Expressions to build an array of keywords from a string.  <br />
			It is capable of handling strings like <u>Jack, Jill Jim, "Timothy Brown", 'Mary'</u> or <u>Jim, "Tom Brown", "Pat O'Malley"</u><br />
			<em>Note: there seems to be some problems with the RegEx here, as it does not always split cleanly.</em></li>
		<li><strong>iif(condition, value1, value2)</strong> If Condition is true, then it returns value1.  If it is False, it returns value2.</li>
		<li><strong>max(a,b)</strong> This returns whichever value is greater, a or b. Returns b if a = b.</li>
		<li><strong>zeroPad(m,t)</strong> This function takes value M and adds t zeroes to the beginning of it.<br />
			<em>strPaddedNum = cor.butil.zeroPad(intVal, 8) ' if intVal = 12, then strPaddedNum = "00000012" (added 6 zeroes)</em>	</li>
		<li><strong>properCase(sString)</strong> This takes a string and sets the first letter to upper-case, the rest to lower-case.  It mixes case when words are hyphenated or underscored (- and _) as (dropping the - and _): <br />
			<em>str1 = cor.butil.properCase("this-is-complex") 'str1 now holds "This Is Complex"</em></li>
		<li><strong>preventCaching()</strong> This will add headers to the document that prevent caching of this site.  This MUST be called at the top of the page, prior to any text output such as &lt;HTML&gt;.</li>
		<li><strong>BreakPoint(sBlockName)</strong> if debugging is turned on, this inputs a div class containing the sBlockName to show how far the page has progressed. It also resets the debug timer and shows db query count.</li>
		
	</ul>
	<br /><a href="#top">Return to Top</a><br />
</p><p>
	<h2 align="center"><a name="filter">Core Filter Utilities</a></h2>		
	<h4>Access these subs and functions as cor.filter.*</h4>
	<ul>
		<li><strong>clnEditor(strValue)</strong> this will trim strValue and remove any carriage return/line feeds (vbCrLf, or Enter keystrokes) </li>
		<li><strong>escEditor(strValue)</strong> This will replace characters with their MySQL escape codes: " becomes \", ' becomes \', _ becomes \_. vbCrLf's are removed.</li>
		<li><strong>stripHTMLTags(HTMLString)</strong> Removes any html codes between &lt; and &gt;.</li>
		<li><strong>ReverseHTMLAmpCodes</strong> This takes any &amp;...; type codes (&amp;amp;, &amp;nbsp; etc.) and converts them to ASCII equivalent values.</li>
		<li><strong>validFilename(str)</strong> makes sure str could be a potential filename (no spaces, no null's, and so on).</li>
		<li><strong>validASPList(str)</strong> replaces any " in str with `</li>
		<li><strong>validatePostEvent(bEnableRefer)</strong> Basic protection against form-post tampering coming from alien domains</li>
		<li><strong>sqlShield (inputStr, level)</strong> Provides various levels of protection against SQL Injection attacks, from none, to simple XSS protection to true SQL shielding from sql keywords.</li>
		<li><strong>checkStrSQL(str) </strong> Passes str through sqlShield at it's most secure level, then replaces ' with '' (single quotes with 2 single quotes) and \ with \\.</li>
		<li><strong>sqlString(str) </strong> This replaces ' with '' (two single quotes)</li>
		<li><strong>removeHTML(str) </strong> This removes any HTML codes after exchanging BR tags with chr(10) (line feed)</li>
		<li><strong>CheckZero(num) </strong> if Num is not numeric, or num is empty or num is null, it returns 0.  otherwise, it returns num.</li>
		<li><strong>CheckBol(i)</strong> if i is possibly a true boolean value ("true" or 1) then returns true.  If i is "false" or 0, returns false.</li>
		<li><strong>CheckNull(i)</strong> if i is null or empty, returns true.</li>
		<li><strong>CheckNumeric(i)</strong> if i is numeric, returns true.</li>
		<li><strong>checkInt(i)</strong> returns 0 or returns i converted to type int if i is numeric.</li>
		<li><strong>checkLng(i)</strong> returns 0 if i isn't numeric. Otherwise, converts i to long and returns that.</li>
		<li><strong>checkDbl(i)</strong> returns 0 if i isn't numeric. Otherwise, converts i to double and returns.</li>
		<li><strong>checkStr(i)</strong> returns an empty string ("") if i is empty or null. Otherwise returns i.</li>
		<li><strong>decrypt(i)</strong> simple decryption (reverses encrypt below).</li>
		<li><strong>encrypt(i)</strong> simple encryption.</li>
		<li><strong>validhtml(i)</strong> replaces any &amp; with &amp;amp;</li>
		<li><strong>noAnchor(i) </strong> replaces # (anchor) symbol.</li>
		<li><strong>iift(val1, val2, ctype)</strong> If val1 is a non-empty value of type ctype, return val1. Otherwise, return val2.</li>
		<li><strong>ReplaceWithCase(strText, strFind)</strong> Replace any occurance of StrFind in strText with HTML codes to prevent SQL attacks, maintaining original upper/lower/mixed case.</li>
		<li><strong>ReverseHTMLCode(inText)</strong> reverses the html code substitution done in ReplaceWithCase.</li>
		<li><strong>BadWordFilter(s) </strong> Replaces any occurance of curse words from the badwords table in s with the badwords replace value.</li>
		
	</ul>
	<br /><a href="#top">Return to Top</a><br />
</p>
</div><!-- End Holder 1 -->
<%
cor.str.wri "</div>" & cor.modbox.printBoxBottom
call cor.tpl.footer()
call cor.off()
%>