﻿<!--#include file="db/_soop_pageglobal.asp" -->
<!--#include file="common.asp"-->
<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
'********************************************************************
'** geckoHeadlines for SooP 2.0
'** Initially written for SooP 1.x by Dan Bodenstein 
'** http://www.scriptgecko.com
'******************************************************************** 
'
Dim  x
'cor.lng.includeSection("cor_xmlMgmt,mod_xmlGH")

'cor.cfg.includeSection("gh2")

'
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'Check for News Moderator 
If NOT gh_isModerator() AND NOT GH_isAdmin() then
	call cor.msg(lngInsufficientPermission)
	cor.redir "./"
End if

Dim iTopicID

iTopicID = cor.filter.checkInt(cor.io.q("tid"))
intHeadline_ID = cor.filter.checkInt(cor.io.q("hid"))
GH_HeadLine.Topic_ID = iTopicID

GH_Settings.Read()
GH_Headline.Read(intHeadline_ID)
Dim strGHIconFolder,strGHSkinIconFolder

strGHIconFolder = cor_sWebroot &"uploads/assets/gh_icons/"
If Not cor.butil.isEmptyStr(GH_Settings.ImageSkinDir) Then strGHSkinIconFolder = replace(GH_Settings.ImageSkinDir,"[skinpath]",cor_sSkinPath,1,-1,1) 'Added for Skinable


call cor.tpl.init("gh2mgmt")		'Call the Soop Section


Dim arrGHTopic
If intHeadline_ID > 0 then 
	GH_Headline.Read(intHeadline_ID)
'	GH_Headline.AuthorID =
elseif iTopicID > 0 then
	cor_sql = "SELECT t.ttitle,t.tbody, t.tmemberid FROM " & cor_dbpre & "topics AS t WHERE t.tid=" & iTopicID
	cor.dal.open arrGHTopic , cor_sql, array()
	GH_Headline.Article = arrGHTopic(1,0)
	GH_Headline.Title = arrGHTopic(0,0)
'	GH_Headline.AuthorID = arrGHTopic(2,0)
else
	intHeadline_ID = 0
end if

Dim strGHTitle,ValidationErrMsg
if request("hid")>0 then
	strGHTitle = lngEdit & " "& lngGHArticle
else
	strGHTitle = lngGHAddaNew & " "& lngGHArticle
end if
'
'Check Validation on Submit
if cor_bPostback then 
	if Len(validateHeadline) > 0 then
		cor.str.wri validateHeadline
		call cor.butil.errorMsg(lngErrorDisplayLine1,lngValidationFail,True,3000,false,,0,false)
	else
		with GH_Headline
			.ID					= cor.filter.checkInt(cor.io.f("HeadlineID"))
			.Title				= cor.io.f("Title")
			.CategoryID			= cor.io.f("Cat_ID")
			.Article 			= cor.filter.clnEditor(cor.io.f_rtf("Article"))
			.Status				= cor.io.f("Status")
			If .ID <> 0 Then
				.Date_Added		= cor.butil.cvUxTime(cor.io.f("DateAdded"))
			Else
				.Date_Added		= cor.butil.cvUxTime(now())
			End if
			.ArticleDate		= cor.butil.cvUxTime(cor.io.f("ArticleDate"))
			.Source				= cor.io.f("Source")
			.GroupAccess		= Replace(cor.io.f("GroupAccess"), " " ,"")
			.SourceURL			= cor.io.f("SourceURL")
			If cor.io.f("altImage") <> "" then 
				.Image			= cor.io.f("altImage")
			elseif cor.io.f("CatImage") <>"" Then
				.Image			= cor.io.f("CatImage")
			else
				.Image			= cor.io.f("GHImage")
			End If
			If .Image = cor_sSkinImg & "spacer.gif" then .Image = ""
			.Expires		= cor.butil.cvUxTime(cor.io.f("Expires"))
			.Link			= cor.io.f("Link")
			.Priority		= cor.io.f("Priority")
			.LinkURL		= cor.io.f("LinkURL")
			.MainNews		= cor.io.f("MainNews")
			.Topic_ID		= cor.filter.checkInt(cor.io.f("TopicID"))
			.LinkTopic 		= cor.io.f("LinkTopic")
			.RelatedLinks	= cor.io.f("RelatedLinks")
			if .topic_id = 0 then .topic_id = ""	'trap nulls for FK integrity
	
			If .ID = 0 then
				cor_sql = "INSERT INTO " & cor_dbpre & "gh_headlines " _
					& "(Author_ID, GHStatus, Date_Added, Title, Article, Article_Date, Source,SourceURL, GHImage, GroupAccess," _
					& " RelatedLinks, GHExpires, GHPriority, Link, LinkURL, Cat_ID, Topic_ID, LinkTopic)" _
					& " VALUES ({0},{1},{2},{3},{4},{5},{6},{7},{8},{9},{10},{11},{12},{13},{14},{15},{16},{17})"
				cor.dal.exec cor_sql, array(cor_lUserID, .Status, .Date_Added, .Title, .Article, .ArticleDate, .Source, .SourceURL, .Image, .GroupAccess, .RelatedLinks, .Expires, .Priority, .Link, .LinkURL, .CategoryID, .Topic_ID, .LinkTopic)
			else
				cor_sql = "UPDATE " & cor_dbpre & "gh_headlines SET" _
						& " GHStatus= {0}, Title= {1}, Article= {2}, Article_Date= {3}, Source= {4}, SourceURL= {5}, GHImage= {6}," _
						& " GroupAccess= {7}, RelatedLinks= {8}, Link= {9}, LinkURL= {10}, GHExpires= {11}, GHPriority= {12}," _
						& " Cat_ID= {13}, LinkTopic= {14}, Topic_ID= {15}" _
						& " WHERE Headline_ID=" & .ID
				cor.dal.exec cor_sql, array(.Status, .Title, .Article, .ArticleDate, .Source, .SourceURL, .Image, .GroupAccess, .RelatedLinks, .Link, .LinkURL, .Expires, .Priority, .CategoryID, .LinkTopic, .Topic_ID)
			end if
		end with

		if gh_Settings.CacheOutgoingRSS = False then
			call cor.butil.successMsg(lngGHArticleSaved,lngValidationSuccess,true,4000,true,"gh_mgmt_articles.asp",6000,false)
		else
			call cor.butil.successMsg(lngGHArticleSaved,lngValidationSuccess,true,4000,true,"gh_mgmt_forcecache.asp?articles",6000,false)
		end if
	end If
	response.end
end if

Dim strIcons, saryIcons, rootFolder, files, strFileUploadPath, strFileUploadPathPlain
Dim ghfso,ghfile
Dim strFileUploadPathPlainStripped 'Added for Skinable

strFileUploadPathPlain = GH_Settings.ImageSkinDir  'Added for Skinable
strIcons = ""

If GH_Settings.useSkinImages then
	strFileUploadPathPlainStripped = replace(lcase(GH_Settings.ImageSkinDir),"[skinpath]",cor_sSkinPath,1,-1,1)
	strFileUploadPathPlainStripped = replace(strFileUploadPathPlainStripped,cor_sPortalDomainPath,"",1,-1,1)
End If

' Render page 
'
call cor.tpl.header(strGHTitle,"")	'Call the Header with Title string




call ghEdit()						'Call main Page from sub
call cor.tpl.footer()				'Call the Footer
call cor.off()						'Close all open objects


function ghEdit


saryIcons = Split(lcase(strIcons),",")'
Call arraySort(saryIcons)
%>
<script type="text/javascript"><!-- <![CDATA[

function onAssetChange(){document.getElementById('myImage').src = document.getElementById('altImage').value;}
function modalDialogShow_IE(url,width,height){ //IE
	return window.showModalDialog(url,window,"dialogWidth:"+width+"px;dialogHeight:"+height+"px;edge:Raised;center:Yes;help:No;Resizable:Yes;Maximize:Yes");
	}
function modalDialogShow_Moz(url,width,height){ //Moz
	var left = screen.availWidth/2 - width/2;
	var top = screen.availHeight/2 - height/2;
	activeModalWin = window.open(url, "", "width="+width+"px,height="+height+",left="+left+",top="+top);
	window.onfocus = function(){if (activeModalWin.closed == false){activeModalWin.focus();};};
	}
var sActiveAssetInput;
function setAssetValue(v){ //required by the asset manager
	document.getElementById(sActiveAssetInput).value = v;
	}
function openAsset(s){
	sActiveAssetInput = s
	if(navigator.appName.indexOf('Microsoft')!=-1)
		document.getElementById(sActiveAssetInput).value=modalDialogShow_IE("assetman3.asp?mode=2&ffilter=image",640,465); //IE
	else
		modalDialogShow_Moz("assetman3.asp?mode=2&ffilter=image",640,465); //Moz
	}

//JQuery.Form Validation

$(document).ready(function() {
	$('form#GHEdit').submit(function() {
			$('form#GHEdit').ajaxSubmit({target: "#form_results"});
			return false;
	});
});

// ]]> --></script>
<% 
cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">" & lngGHArticle & " " & lngGHEditor & "</h4></div></div>"
cor.str.wri "<div id=""ghContentBlock"" class=""modular"">"
cor.str.wri ghAdminMenu
%>
<p><%= lngCompleteForm %></p>

<form class="soop ajaxfrm" name="GHEdit" id="GHEdit" action="gh_mgmt_editor.asp" method="post">
<input type="hidden" id="HeadlineID" name="HeadlineID" value="<%=GH_Headline.ID%>"/>
<input type="hidden" id="AuthorID" name="AuthorID" value="<%=GH_Headline.AuthorID%>"/>
<fieldset>
	<legend><%= strGHTitle %></legend>

<ul class="row">
	<li>
		<ul class="col">
			<li class="label req-ico ico-sprt"><label for="Title"><%= lngGHHlTitle %></label></li>
			<li class="input"><input class="frmText required" id="Title" name="Title" type="text" size=30 maxlength=255 value="<%= GH_Headline.Title %>" />
			<%= lngGHEnterNameForArticle %>
			</li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="Status"><%= lngGHArticleStatus %></label></li> 
			<li class="input">
			<select name="Status">
				<option value="Unpublished" <% if lcase(gh_headline.status) = "unpublished" then response.write ("selected=""selected""")%> ><%= lngUnpublished %></option>
				<option value="Published" <% if lcase(gh_headline.status) = "published" then response.write ("selected=""selected""")%> ><%= lngPublished %></option>
				<option value="Archive" <% if lcase(gh_headline.status) = "archive" then response.write ("selected=""selected""")%> ><%= lngGHArchive %></option>
			</select>
			</li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label req-ico ico-sprt"><label for="Cat_ID"><%=lngCategory %></label></li>
			<li class="input">
<%
dim oCombo
set oCombo = new class_comboBuilder
oCombo.ElementID = "cat_id"
oCombo.SelectedValue = GH_Headline.CategoryID
oCombo.BuildComboFromDB "SELECT T1.cat_id, T1.category_name FROM " & cor_dbpre & "gh_category AS T1 ORDER BY T1.Sequence"
oCombo.CreateCombo()
set oCombo = nothing
%>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="Priority"><%= lngGHPriority %></label></li>
			<li class="input">
			<select name="Priority">
				<option value="1" <% if cint(gh_headline.priority) = 1 then response.write ("selected=""selected""")%> ><%= lngGHHigh %></option>
				<option value="2" <% if cint(gh_headline.priority) = 2 then response.write ("selected=""selected""")%> ><%= lngGHMedium %></option>
				<option value="3" <% if cint(gh_headline.priority) = 3 then response.write ("selected=""selected""")%> ><%= lngGHNormal %></option>
				<option value="4" <% if cint(gh_headline.priority) = 4 then response.write ("selected=""selected""")%> ><%= lngGHLow %></option>
			</select> <%= lngGHSelectPriorityOfArticleHighPriorityAppearTop %>
			</li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="TopicID"><%= lngGHLinkTopic %></label></li>
			<li class="input">
			<% 
			Set oCombo = New class_comboBuilder
			oCombo.ElementID = "TopicID"
			oCombo.DisplayDefault = true
			if isempty(GH_HeadLine.Topic_ID) or isnull(GH_HeadLine.Topic_ID) or GH_HeadLine.Topic_ID = 0 then
				'
			else
				oCombo.SelectedValue = GH_HeadLine.Topic_ID
			end if
			oCombo.BuildComboFromDB "SELECT t.tid, t.ttitle FROM " & cor_dbpre & "topics AS t WHERE t.tlocked<>1 ORDER BY t.ttitle"
			oCombo.CreateCombo()
			set oCombo = Nothing
			cor.str.wri lngGHIfArticleLinkedTopicPleaseEnterTopicID
			%>
			</li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="LinkTopic"><%= lngGHTopicLinkInArticle %></label></li>
			<li class="input">
<%
			Set oCombo = New class_comboBuilder
			oCombo.ElementID = "LinkTopic"
			oCombo.DisplayDefault = true
			if isempty(GH_HeadLine.LinkTopic) or isnull(GH_HeadLine.LinkTopic) or GH_HeadLine.LinkTopic = 0 then
				oCombo.SelectedValue = 0
			else
				oCombo.SelectedValue = 1
			end if
			oCombo.AddOption 0,lngGHDoNotLinkTopic
			oCombo.AddOption 1,lngGHLinkTheTopic
			oCombo.CreateCombo()
			set oCombo = Nothing
%>
			<%= lngGHSelectWetherYouWouldLikeProvidePhysicalLinkArticle %>
			</li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label req-ico ico-sprt"><label for="Article"><%= lngGHArticle %></label></li>
			<li class="inputFull">
<%
'If cor_bUseRichEditor Then
	'enable image/attachment uploading
	if cor_lUserID <>2 Then
		cor_bImageUpload = true
		cor_bAttachments = true
	end if
'	Response.Write "			<table border=""0"" width=""100%"" style=""border:inset 1px;""><tr><td>"
	response.write 				cor.rte.invoke( GH_Headline.Article, "article", "100%", 605, "Default")
'	response.write "			</td></tr></table>"
'Else
'	Response.Write "			<textarea id=""Article"" name=""Article"" cols=""70"" rows=""70"">" & Gh_Headline.Article &"</textarea>"
'End If
%>
			</li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label req-ico ico-sprt"><label for="ArticleDate"><%= lngGHArticleDate %></label></li>
			<li class="input">
			<input class="frmText dateRange" id="ArticleDate" type="text" size="8" maxlength="25" name="ArticleDate" value="<%= GH_Headline.ArticleDate %>" />
			<%= lngGHEnterDateOfTheArticle %>.
			</li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label req-ico ico-sprt"><label for="Expires"><%= lngGHExpirationDate %></label></li>
			<li class="input">
			<input class="frmText dateRange" id="Expires" type="text" size="8" maxlength="15" name="Expires" value="<%= GH_Headline.Expires %>" />
			<%= lngGHEnterTheDateTheArticleWillMoveIntoTheArchives %>
<!-- Attach the datepicker to dateinput after document is ready -->
<script type="text/javascript"><!--
// Customize two date pickers to work as a date range
$().ready(function(){
	$('#ArticleDate').datepicker({rangeSelect: false, numberOfMonths: [2, 3], stepMonths: 6, changeMonth: false, changeYear: false});
	$('#Expires').datepicker({rangeSelect: false, numberOfMonths: [2, 3], stepMonths: 6, changeMonth: false, changeYear: false});
});
// --></script>
			</li>
		</ul>
	</li>
</ul>
</fieldset>
<fieldset>
	<legend><%= lngGHArticleOptionalLinksThmbImg %></legend>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="Link"><%= lngGHLinkName %></label></li> 
			<li class="input"><input class="frmText" type="text" size=40 maxlength=255 name="Link" value="<%=GH_Headline.Link%>" /> <%= lngGHIfYouWantToIncludeALinkWithArticleEnterTheLinkName %></li>
		</ul>
	</li>
	<li>
		<ul class="col">
			<li class="label"><label for=""><%= lngGHLinkURL %></label></li> 
			<li class="input"><input class="frmText" type="text" size=40 maxlength=255 name="LinkURL" value="<%=GH_Headline.LinkURL%>" /> <%= lngGHEnterTheURLForAboveLink %></li>
		</ul>
	</li>
	<li>
		<ul class="col">
			<li class="label"><label for="Source"><%= lngGHArticleSource %></label></li> 
			<li class="input"><input class="frmText" type="text" size=40 maxlength=255 name="Source" value="<%=GH_Headline.Source%>" /> <%= lngGHEnterTheNameSourceExCNNcomMSNBCcom %></li>
		</ul>
	</li>
	<li>
		<ul class="col">
			<li class="label"><label for=""><%= lngGHArticleSourceURL %></label></li> 
			<li class="input"><input class="frmText" type="text" size=40 maxlength=255 name="SourceURL" value="<%=GH_Headline.SourceURL%>" /> <%= lngGHEnterTheSourceURLtoProvideLink %></li>
		</ul>
	</li>
	<li>
		<ul class="col">
			<li class="label"><label for=""><%= lngGHRelatedLinks %></label></li> 
			<li class="input"><input class="frmText" type="text" size=70 maxlength=255 name="RelatedLinks" value="<%=GH_Headline.RelatedLinks%>" /><br / ><%= lngGHRelatedLinksDescription %></li>
		</ul>
	</li>
	<li>
		<ul class="col">
			<li class="label">
			<label for=""><%=lngGHArticleThmbImage %></label>
	<% if len(GH_Headline.Image) > 0 Then %>
		<img class="right" id="myImage" src="<%= GH_Headline.Image %>" title="" alt="" />
	<% else %>
		<img id="myImage" src="<%= cor_sSkinImg %>spacer.gif" title="" alt="" />
	<% end if %>
			</li> 
		<li class="input">
		<div class="holder1 alignMiddle">
		<span class="holder2"><input class="frmText" type="text" size="30" name="altImage" id="altImage" value="<%= GH_Headline.Image %>" onchange="onAssetChange()" />&nbsp;</span>
		<span class="holder2"><div class="ui button"><a href="javascript:openAsset('altImage');"><span><%= lngBrowseImage %></span></a></div></span>
		</div>
<%
set oCombo = New class_comboBuilder
oCombo.ElementID = "CatImage"
dim strippedGHIconFolder
if GH_Settings.useSkinImages then
	strippedGHIconFolder = cor_sPortalDomainPath & replace(strGHSkinIconFolder,cor_sWebroot,"",1,1,1)
	if GH_Headline.Image <>"" Then oCombo.SelectedValue = Replace(Replace(GH_Headline.Image,strippedGHIconFolder,"",1,1,1),".gif", "",1,1,1)
	oCombo.AddEvent "onchange","javascript: if (CatImage.options[CatImage.selectedIndex].value==''){ myImage.src='" & cor_sSkinImg & "spacer.gif'; altImage.value=''; }else{ myImage.src='" & strGHSkinIconFolder & "'+CatImage.options[CatImage.selectedIndex].value; altImage.value='" & strFileUploadPathPlain & "'+CatImage.options[CatImage.selectedIndex].value; }"
	oCombo.BuildComboFromFolder "." & strGHSkinIconFolder,".gif"
else
	strippedGHIconFolder = cor_sPortalDomainPath & replace(strGHIconFolder,cor_sWebroot,"",1,1,1)
	if GH_Headline.Image <>"" Then oCombo.SelectedValue = Replace(Replace(GH_Headline.Image,strippedGHIconFolder,"",1,1,1),".gif", "",1,1,1)
	oCombo.AddEvent "onchange","javascript:if (CatImage.options[CatImage.selectedIndex].value==''){ myImage.src='" & cor_sSkinImg & "spacer.gif';altImage.value=''; }else{ myImage.src='" & strGHIconFolder & "'+CatImage.options[CatImage.selectedIndex].value+'.gif'; altImage.value=myImage.src; }"
	oCombo.BuildComboFromFolder strGHIconFolder,".gif"
end if
oCombo.CreateCombo()
set oCombo = nothing
%>
		</li>
		</ul>
	</li>
</ul>
</fieldset>
<% if GH_Settings.useGroupAccess then %>
<fieldset>
	<legend><%= lngGHArticleGroupPermissions %></legend>
<ul class="row">
	<li>
		<ul class="col">
			<li class="inputFull"><label for="GroupAccess"></label>
	<%
	Dim oCheckBox
	set oCheckBox = new class_checkboxBuilder
	oCheckBox.UseCheckAll = true
	oCheckBox.CheckAllID = "grpchkall"
	oCheckBox.ElementID = "GroupAccess"
	oCheckBox.ClassName ="checkboxblock"
	If NOT cor.butil.isEmptyStr(GH_Headline.GroupAccess) then
		oCheckBox.CheckedValue = cor.filter.checkStr(Replace(GH_Headline.GroupAccess," ","",1,-1,1))
	Else
		oCheckBox.CheckedValue = ""
	End If
	oCheckBox.BuildCheckBoxFromDB "SELECT g.gid, g.gname FROM " & cor_dbpre & "groups AS g ORDER BY g.gname"
	oCheckBox.CreateCheckBox()
	set oCheckBox = nothing
	%>
			</li>
		</ul>
	</li>
<% else %>
<input type="hidden" name="GroupAccess" value="" />
<% end if %>
</ul>
</fieldset>


	<div class="buttonOuterWrap"><div class="buttonInnerWrap">
	<div class="ui button"><button type="submit" class="frmButton" name="save" value="<%= lngSave %>"><span><%= lngSave %></span></button></div>
	</div></div>

</form>
<%
cor.str.wri "</div>"
cor.modbox.printBoxBottom
set GH_Headline = Nothing 
End Function


function validateHeadline()
	'if intdo = cor_cDoEdit Then
	'	if cor.io.f("HeadlineID") < 0 then cor.str.add "<script type=""text/javascript"">$('<div class=""errorfrm error"">" & lngGH & "</div>').insertBefore('#GHEdit');</script>"
	'end if
	dim errmsg
	cor.str.wri "<script type=""text/javascript"">$('label[class^=errorfrm error]').remove();</script>"

	if len(cor.io.f("Title")) <= 0 then cor.str.add "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngGHTitleUndef & "</label>').insertAfter('#Title');</script>"
	if cor.io.f("Cat_ID") = "" then cor.str.add "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngGHCategoryErr & "</label>').insertAfter('#cat_id');</script>"
	if len(cor.io.f_rtf("Article")) <= 0 then cor.str.add "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngGHArticleErr & "</label>').insertBefore('#article');</script>"
	if not isdate(cor.io.f("ArticleDate")) then cor.str.add "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngGHArticleDateErr & "</label>').insertAfter('#ArticleDate');</script>"
	if not isdate(cor.io.f("Expires")) then cor.str.add "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngGHExpiresErr & "</label>').insertAfter('#Expires');</script>"
	if cor.butil.cvUxTime(cor.io.f("ArticleDate")) > cor.butil.cvUxTime(cor.io.f("Expires")) then
		cor.str.add "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngGHDateRangeErr & "</label>').insertAfter('#Expires');</script>"
	end if
	validateHeadline = cor.str.build
	cor.str.wri validateHeadline
end function



function arraySort(aSort)
Dim j,k,sTemp
For j = 0 to ubound(aSort)
	for k = j to ubound(aSort)
		If aSort(j) > aSort(k) then
			sTemp = aSort(k)
			aSort(k) = aSort(j)
			aSort(j) = sTemp
		end if
	next
Next
arraySort = aSort
End function 
%>