<!--#include file="db/_soop_pageglobal.asp" -->
<!--#include file="common.asp" -->
<%
'----------------------------------------------------------------------------------------------------------------------------------------------
'SOOP Phoenix
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'----------------------------------------------------------------------------------------------------------------------------------------------
'********************************************************************
'** geckoHeadlines for SooP 2.0
'** Initially written for SooP 1.x by Dan Bodenstein 
'** http://www.scriptgecko.com
'********************************************************************

'Check for Admin access. For Admin only
If NOT GH_isAdmin() then
	call cor.msg(lngInsufficientPermission)
	cor.redir "./"
End if

Dim intPID, strMode, oCombo, rs,strPType
Dim blnHasFSO, iNumofCategories,x, riptag

intPID = cor.filter.checkInt(cor.io.r("pid"))
strMode = cor.filter.checkInt(cor.io.fq("do"))

If cor.filter.checkInt(cor.io.q("type"))=1 Then
	strPType = "user"
else
	strPType = "group"
end if

If strMode ="del" Then
	cor_sql = "DELETE FROM " & cor_dbpre & "gh_permissions Where Permissions_ID = {0}"
	cor.dal.exec cor_sql,array(cor.io.r("pid"))
	cor.redir "gh_mgmt_permissions.asp" 
End IF


call cor.tpl.init("gh2mgmt")		'initialisation and loading of config sections, language strings
'
call cor.tpl.header(lngGHPermissions,"")			'header and surrounding MOD boxes, CSS, javascripts etc...
'

cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">" & lngGHPermissions & "</h4></div></div>"
cor.str.wri "<div class=""modular"">"
cor.str.wri ghAdminMenu

if cor_bPostback then
	Call SavePermissions	'content - via function
elseif strMode ="1" or strMode ="2" then
	Call EditPermissions
else
	Call ListPermissions
end if

cor.str.wri "</div>"
cor.modbox.printBoxBottom


call cor.tpl.footer()				'closing MOD boxes and footer
'
call cor.off()						'ensure page disposal

Sub ListPermissions
%>
<script language="JavaScript"><!-- 
function deleteWarning(intID){
	Warn = confirm('<%= lngGHDeletePermission %>');
	if (Warn == true) {window.location='gh_mgmt_permissions.asp?mode=del&PID=' + intID;}
}
// --></script>
	<div class="ui button"><a href="gh_mgmt_permissions.asp?do=1&amp;type=1" title="<% = lngGHAddaNew & " " & lngUsername & " " & lngGHPermissions %>"><span><i class="add-ico ico-sprt"></i><% = lngGHAddaNew & " " & lngUsername & " " & lngGHPermissions %></span></a></div>
	<div class="ui button"><a href="gh_mgmt_permissions.asp?do=1&amp;type=2" title="<% = lngGHAddaNew & " " & lngGroup & " " & lngGHPermissions %>"><span><i class="add-ico ico-sprt"></i><% = lngGHAddaNew & " " & lngGroup & " " & lngGHPermissions %></span></a></div>
	<table class="soop">
	<tr>
		<th width="50%" class="tHeading">Description</th>
		<th class="tHeading center"> Type </th> 
		<th class="tHeading center">Permissions</th>
		<th class="tHeading"></td>
	</tr> 
<%
	cor_sql = "SELECT * from " & cor_dbpre & "gh_permissions;"
	cor.dal.openRS "rs", cor_sql, array()
	'rsCommon.Open cor_sql,adoCon
	If not cor.dal.rs.eof Then
		Do While NOT cor.dal.rs.eof
%>
	<tr>
		<td width="50%" align="left" class="text">
<%
		Dim editPermType,editPermName,editPermTypeID
		if cor.dal.rs("Author_ID") > 0 then
			cor_sql= "SELECT m.muser FROM " & cor_dbpre & "members AS m WHERE m.memberid={0}"
			editPermName = cor.dal.getValue(cor_sql, array(cor.dal.rs("Author_ID")))
			editPermType = "1"
			editPermTypeID = cor.dal.rs("Author_ID")
		else
			cor_sql= "SELECT g.gname FROM " & cor_dbpre & "groups AS g WHERE g.gid={0}"
			editPermName = cor.dal.getValue(cor_sql, array(cor.dal.rs("Group_ID")))
			editPermType = "2"
			editPermTypeID = cor.dal.rs("Group_ID")
		end if
%>
			<a href="gh_mgmt_permissions.asp?pid=<%=cor.dal.rs("permissions_id")%>&amp;do=2&amp;type=<%= editPermType %>"><%= editPermName%></a>
		</td>
		<td align="center" class="text"><% if cor.dal.rs("Author_ID") > 0 then Response.Write (lngUsername) else Response.Write(lngGroup) %></td>
		<td align="center" class="text">
<%
			If cor.dal.rs("Admin") then Response.Write ("News Admin")
			If cor.dal.rs("Moderator") then Response.Write ("News Moderator")
%>
		</td>
		<td align="center" class="text"><a class="ui" href="javascript:deleteWarning(<%=cor.dal.rs("permissions_id")%>);"><i title="<% = lngDelete & " " & editPermType & " " & lngGHPermissions %>" class="delete-ico ico-sprt">&nbsp;</i></a></td>
	</tr>
<%
		cor.dal.rs.Movenext
		Loop
	End If
%>

</table>

<%
End Sub

Sub SavePermissions
Dim saryGroups, saryUsers, X, sUniqueString, sNewTime
GH_Settings.Read()
with GH_Permissions
	.ID		= intPID
	If .ID = 0 and cor.io.f("Author") = "" AND cor.io.f("GROUP_ID") = "" then Exit sub
	If cor.io.f("Author") <> "" then 
		.Author_ID = cor.dal.getValue("SELECT memberid FROM " & cor_dbpre & "members WHERE memberid=" & cor.io.f("Author"),array())
		.Group_ID = ""
	end if
	If cor.io.f("Group_ID") <> "" then 
		.Group_ID = cor.io.f("Group_ID")
		.Author_ID = ""
	end if
	If lcase(cor.io.f("Permission")) = "admin" then 
		.isAdmin = 1 : .isModerator = 0
	else
		.isAdmin = 0 : .isModerator = 1
	end if
	.Flags = Replace(cor.io.f("Flags")," ","")
	If .ID = 0 then 

		cor_sql = "INSERT INTO " & cor_dbpre & "gh_permissions (Author_ID,Group_ID,Admin,Moderator,Flags) VALUES ({0},{1},{2},{3},{4})"
		cor.dal.exec cor_sql,array(.Author_ID, .Group_ID, .isAdmin, .isModerator, .Flags)
	else
		cor_sql = "UPDATE " & cor_dbpre & "gh_permissions SET Admin={0},Moderator={1},Flags={2} WHERE Permissions_ID={3}"
		cor.dal.exec cor_sql,array(.isAdmin, .isModerator, .Flags, .ID)
	end if
end with
	cor.redir "gh_mgmt_permissions.asp" 
response.end
End Sub

Sub EditPermissions
'***************************
' Edit MODE

If strmode=1 or strmode=2 then GH_Permissions.isModerator=1
	with GH_Permissions
		.Read(intPID)

	response.write strPType
%>
<form name="frmPermissions" id="frmPermissions" action="gh_mgmt_permissions.asp" method="post">
<input type="hidden" name="PID" value="<%=GH_Permissions.ID %>" />
<table width="100%" border="0" cellspacing="0" cellpadding="1" align="center"><tr>
	<td>
	<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr>
		<td>
		<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
			<td>
			<table width="100%" border="0" cellspacing="1" cellpadding="4"><tr>
				<td colspan="2" width="100%" class="tHeading"><%=lngEdit & " "& lngCategory%></td> 
			</tr>
<%
Dim oCheckBox
Select Case strMode
	Case cor_cDoNew
		if strPType="user" then
%>
			<tr>
				<td width="20%" align="left" class="text" >Member</td>
				<td align="left" class="text" >
<%
		set oCheckBox = new class_checkboxBuilder
		oCheckBox.UseCheckAll = false
		oCheckBox.ClassName ="checkboxblock"
		oCheckBox.ElementID = "Author"
		oCheckBox.BuildCheckBoxFromDB "SELECT m.memberid, m.muser FROM " & cor_dbpre & "members AS m WHERE m.mactive=1 AND m.memberid<>2 ORDER BY m.muser asc"
		oCheckBox.CreateCheckBox()
		set oCheckBox = nothing
%>
				</td>
			</tr>
<%
		else
%>
			<tr>
				<td width="20%" align="left" class="text" ><%=lngGroup %></td>
				<td align="left" class="text" >
<%
		'Dim oCheckBox
		set oCheckBox = new class_checkboxBuilder
		oCheckBox.UseCheckAll = false
		oCheckBox.ClassName ="checkboxblock"
		oCheckBox.ElementID = "Group_ID"
		oCheckBox.CheckedValue=.Group_ID
		oCheckBox.BuildCheckBoxFromDB "SELECT g.gid, g.gname FROM " & cor_dbpre & "groups AS g ORDER BY g.gname"
		oCheckBox.CreateCheckBox()
		set oCheckBox = nothing
%>
				</td>
			</tr>
<%
		end if
	Case cor_cDoEdit
		If strPType="user" Then
%>
			<tr>
				<td width="20%" align="left" class="text" ><%= lngMember %></td>
				<td align="left" class="text" >
<%
		set oCheckBox = new class_checkboxBuilder
		oCheckBox.UseCheckAll = false
		oCheckBox.ClassName ="checkboxblock"
		oCheckBox.ElementID = "Author"
		oCheckBox.CheckedValue=.Author_ID
		oCheckBox.BuildCheckBoxFromDB "SELECT m.memberid, m.muser FROM " & cor_dbpre & "members AS m WHERE m.mactive=1 AND m.memberid<>2 ORDER BY m.muser asc"
		oCheckBox.CreateCheckBox()
		set oCheckBox = nothing
%>
				</td>
			</tr>
<%
		Else
%>
			<tr>
				<td width="20%" align="left" class="text" ><%= lngGroup %></td>
				<td align="left" class="text">
<%
		'Dim oCheckBox
		set oCheckBox = new class_checkboxBuilder
		oCheckBox.UseCheckAll = false
		oCheckBox.ClassName ="checkboxblock"
		oCheckBox.ElementID = "Group_ID"
		oCheckBox.CheckedValue=.Group_ID
		oCheckBox.BuildCheckBoxFromDB "SELECT g.gid, g.gname FROM " & cor_dbpre & "groups AS g ORDER BY g.gname"
		oCheckBox.CreateCheckBox()
		set oCheckBox = nothing
%>
				</td>
			</tr>
<%
		End If
	
End Select

%>
			<tr>
				<td width="20%" align="left" class="text" >Permissions</td>
				<td align="left" class="text" >
					<input name="Permission" class="radio" type="radio" class="frmText" id="Permission" <% if .ismoderator then response.write("  checked=""checked""  " )%> value="MODERATOR" /> Allow user or group to add/edit articles.(News Moderator)<br />
					<input name="Permission" class="radio" type="radio" class="frmText" id="Permission" <% if .isadmin then response.write("  checked=""checked""  " )%> value="ADMIN" /> Allow user or group to add/edit articles, add/edit categories, control RSS feeds.(News Admin)<br />
				</td>
			</tr><tr>
				<td align="center" class="text" colspan=2><input class="frmButton" type="submit" name="Save" value="<%=lngGHSavePermissions %>" /></td>
			</tr></table>
			</td>
		</tr></table>
		</td>
	</tr></table>
	</td
</tr></table>
</form>
<p>

<%
	end with
End Sub
%>
