﻿<!--#include file="db/_soop_pageglobal.asp" -->
<!--#include file="common.asp" -->
<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

'********************************************************************
'** geckoHeadlines for SooP 2.0
'** Initially written for SooP 1.x by Dan Bodenstein 
'** http://www.scriptgecko.com
'******************************************************************** 
'
Dim intRSSFeed_ID, strMode
Dim blnHasFSO, iNumofCategories,x, riptag,y
Dim ValidationErrMsg
'Check for News Admin access. For News Admin only
If NOT GH_isAdmin() then
	call cor.msg(lngInsufficientPermission)
	cor.redir "./"
End if

strMode = lcase(cor.io.r("mode"))

'
'Read Passed Variables to determine mode.
intRSSFeed_ID = cor.filter.checkInt(cor.io.r("RSSID"))

if strMode ="del" then 
	cor_sql = "DELETE FROM " & cor_dbpre & "gh_rssfeed Where RSSFeed_ID = {0}"
	cor.dal.exec cor_sql,array(cor.io.r("CatID"))
	cor.redir "gh_mgmt_rssfeeds.asp" 
End IF

if strMode ="reset" then 
	cor_sql = "UPDATE " & cor_dbpre & "gh_rssfeed SET LastUpdate='" & cor.butil.cvUxTime(DateAdd("d",-1,now())) & "' Where RSSFeed_ID = {0}"
	cor.dal.exec cor_sql,array(cor.io.r("CatID"))
	cor.redir "gh_mgmt_rssfeeds.asp" 
End IF

call cor.tpl.init("gh2mgmt")			'Call the Soop Section

'Check Validation on Submit
if cor_bPostback then 
	if Len(validateRSSFeedImport) > 0 then
		cor.str.wri validateRSSFeedImport
		call cor.butil.errorMsg(lngErrorDisplayLine1,lngValidationFail,True,3000,false,,0,false)
	else
		Call GH_Save
	end if
	response.end
end if



' Render page 
'
call cor.tpl.header(lngGHmgmt & " " & lngGHRSSFeeds,"")	'Call the Header with Title string
'
call managefeeds				'Call main Page from sub
'
call cor.tpl.footer()				'Call the Header
call cor.off()						'Close all open objects
'

function managefeeds
%>
<script type="text/javascript" language="JavaScript"><!-- <![CDATA[
function deleteWarning(intID){
Warn = confirm('Are you sure you want to Delete this Feed?');
if (Warn == true) {window.location='gh_mgmt_rssfeeds.asp?mode=del&catid=' + intID;}
}
function resetWarning(intID){
Warn = confirm('Are you sure you want to Reset this Feed?');
if (Warn == true) {window.location='gh_mgmt_rssfeeds.asp?mode=reset&catid=' + intID;}
}
// ]]> --></script>
<%
cor.modbox.printBoxTop
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">" & lngGHRSSFeeds & "</h4></div></div>"
cor.str.wri "<div class=""modular"">"
cor.str.wri ghAdminMenu


if strMode ="edit" then 
	Call EditRSSFeed() 
else %>
	<table class="soop" width="100%" border="0" cellspacing="2" cellpadding="0"><tr>
		<th width="33%"><%= lngGHFeedName %></th>
		<th width="5%"><%= lngGHOrder %></th>
		<th width="5%"><%= lngGHFrontpage %></th>
		<th class="center"><%= lngGHLastUpdate %></th>
		<th class="center"><%= lngGHTTL %></th>
		<th colspan="3"><%= lngActions %></th>

	</tr>
<%
	Dim rs, riptest, strTemp, iMin,iHour
	cor_sql = "SELECT t1.MainPage, t1.RSSFeed_ID, t1.Title, t1.Sequence, t1.lastupdate, t1.TTL FROM " & cor_dbpre & "gh_rssfeed AS t1 ORDER BY t1.Sequence"
	cor.dal.openRS "rs", cor_sql, array()

	strTemp = lngNo
	If not cor.dal.rs.eof then
		Do While NOT cor.dal.rs.eof
			If cor.dal.rs("MainPage") = 1 then strTemp = lngYes'"True"
%>
	<tr>
		<td width="33%" align="left" class="text" >
			<a href="gh_mgmt_rssfeeds.asp?RSSID=<%=cor.dal.rs("rssfeed_id")%>&amp;mode=edit"><%=cor.dal.rs("Title")%></a>
		</td>
		<td align="center" class="text"><%= cor.dal.rs("Sequence") %></td>
		<td align="center" class="text"><%= strTemp %></td>
		<td align="center" class="text">
			<%= cor.butil.cvLcidTime(cor.dal.rs("lastupdate"))%><!-- ' & "<br />" & cor.butil.cvLcidTime(cor.dal.rs("lastupdate")) -->
		</td>
		<td align="center" class="text">
<%
			ihour = int(cInt(cor.dal.rs("TTL"))/60)
			imin = cInt(cor.dal.rs("TTL")) - (ihour * 60)
			if iHour > 0 then
				Response.Write (ihour)
				if imin = 0  then response.write (" "&lngGHhours) else Response. write (" " & lngGHhr)
			end if
			if iMin > 0 then
				Response.Write (imin)
				if iHour = 0 then Response.Write (" "&lngGHMinutes) else Response.Write (" " & lngGHmin)
			end if
%>
		</td>
		<td><a title="<% = lngDelete %>" href="javascript:deleteWarning(<%=cor.dal.rs("rssfeed_id")%>);"><span><i class="delete-ico ico-sprt"></i></span></a></td>
		<td><div class="ui button"><a title="<%= lngGHResetFeed %>" href="javascript:resetWarning(<%=cor.dal.rs("rssfeed_id")%>);"><span><i class="reset-ico ico-sprt"></i><%= lngGHResetFeed %></span></a></div></td>
		<td><a href="gh_mgmt_rssfilters.asp?RSSID=<%=cor.dal.rs("rssfeed_id")%>"><%= lngEditFilters %></a></td>
	</tr>
<%
			cor.dal.rs.Movenext
			strTemp = lngNo'"False"
		Loop
	end if

%>
	<tr >
		<td colspan="8" style="border-top:solid 1px #000000;"><a href="gh_mgmt_rssfeeds.asp?FeedID=0&amp;mode=edit"><% = lngGHAddaNew & " " & lngGHRSSFeed%></a></td>
	</tr></table>
<% end if


'
'------------------------------------------------------------------------------------------------------------------------------------------
'
cor.str.wri "</div>"
cor.modbox.printBoxBottom
End Function
'<!--include file="core/footer.asp" -->




 sub EditRSSFeed
'***************************
' Edit MODE

If Request("mode") = "edit" then
	GH_RssFeed.Read(intRSSFeed_ID)
	with GH_RssFeed
%>
<script type="text/javascript"><!-- <![CDATA[
$(document).ready(function(){
	$('form#frmRSS').submit(function() {
			$('form#frmRSS').ajaxSubmit({target: "#form_results"});
		return false;
	});
	$('#import').click(function(){
		var rssurl = $('#URL').val();
		$('#form_results').load('gh_mgmt_getfeeddata.asp?feed='+rssurl+'&test=1');
		return false;
	});
});

// ]]> --></script>
<p><%= lngCompleteForm %></p>
<form class="soop ajaxfrm" name="frmRSS" id="frmRSS" action="gh_mgmt_rssfeeds.asp" method="post">
<input type="hidden" name="RSSID" value="<%=.ID %>" />
<fieldset>
	<legend>
<%
	If .ID =0 Then
		cor.str.wrn lngGHAddaNew & " "& lngGHRSSFeeds
	Else
		cor.str.wrn lngEdit & " "& lngGHRSSFeeds
	End If
%></legend>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label req-ico ico-sprt"><label for="Title"><%=lngGHFeedTitle%></label></li> 
			<li class="input"><input class="frmText required" type="text" name="Title" id="Title" value="<%=.Title%>" size="30" maxlength="255" /></li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label req-ico ico-sprt"><label for="URL"><%=lngGHFeedURL%></label></li>
			<li class="input"><input class="frmText required" type="text" name="URL" id="URL" size="60" value="<%= .URL %>" />
			<a id="import" href="gh_mgmt_getfeeddata.asp"><%= lngGHImport %></a></li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label req-ico ico-sprt"><label for="Description"><%=lngGHDescription%></label></li> 
			<li class="input"><textarea class="frmText required" name="Description" id="Description" value="<%=.Description%>" rows="5" cols="50"></textarea></li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for=""><%=lngGHTTL%></label></li> 
			<li class="input">
<% 
dim oCombo
set oCombo = New class_comboBuilder
oCombo.ElementID = "TTL"
oCombo.SelectedValue = .TTL
For X = 5 to 60 step +5
	oCombo.AddOption X,X & lngGHMinutes
Next
For X = 75 to 120 step +15
	oCombo.AddOption X,X & lngGHMinutes
next
Y=4
For X = 240 to 1440 step +120
	oCombo.AddOption X,Y & lngGHhours
	y=y+2
next
oCombo.CreateCombo()
set oCombo = nothing
 %>

			</li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="Sequence"><%=lngGHSequence%></label></li> 
			<li class="input"><input class="frmText required" name="Sequence" id="Sequence" type="text" value="<%=.Sequence%>" size="5" maxlength="5" /></li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="input"><input class="checkbox" type="checkbox" name="MainPage" value="True"<%if .mainpage = 1 then response.write " checked=""checked"""%> /> <label for="MainPage"><%= lngGHCheckFeedViewedFrontpage %></label></li>
		</ul>
	</li>
</ul>
</fieldset>
<fieldset>
	<legend><%= lngGHImageInfo %></legend>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="ImageURL"><%= lngGHImgURL %></label></li> 
			<li class="input"><input name="ImageURL" id="ImageURL" type="text" class="frmText" value="<%=.ImageURL%>" size="40" /></li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="Image">Image</label></li> 
			<li id="image" class="input"></li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="ImageTitle"><%= lngGHImgTitle %></label></li> 
			<li class="input"><input name="ImageTitle" id="ImageTitle" type="text" class="frmText" value="<%=.ImageTitle%>" size="40" /></li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="ImageLink"><%= lngGHImgLink %></label></li> 
			<li class="input"><input name="ImageLink" id="ImageLink" type="text" class="frmText" value="<%=.ImageLink%>" size="40" /></li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="ImageWidth"><%= lngGHImgWdth %></label></li> 
			<li class="input"><input name="ImageWidth" id="ImageWidth" type="text" class="frmText" value="<%=.ImageWidth%>" size="10" /></li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="ImageHeight"><%= lngGHImgHght %></label></li> 
			<li class="input"><input name="ImageHeight" id="ImageHeight" type="text" class="frmText" value="<%=.ImageHeight%>" size="10" /></li>
		</ul>
	</li>
</ul>
</fieldset>
<div class="buttonOuterWrap"><div class="buttonInnerWrap">
<div class="ui button"><button type="submit" class="frmButton" id="Save" name="Save" value="<%=lngGHSaveFeed %>"><span><%=lngGHSaveFeed %></span></button></div>
</div></div>
</form>

<%

cor.str.wri "</div>"
cor.modbox.printBoxBottom
set GH_RssFeed = Nothing 

end with
end if
end sub


Sub GH_Save
Dim saryGroups, saryUsers, X, sUniqueString, sNewTime, riptemp
If cor.io.f("MainPage") = "True" then riptemp = 1 else riptemp = 0
with GH_RSSFeed
	.ID				= intRSSFeed_ID
	.Title			= cor.io.f("Title")
	.Description	= cor.io.f("Description")
	.URL			= cor.io.f("url")
	.ttl			= Cint(cor.io.f("TTL"))
	.MainPage		= riptemp
	.Sequence		= cor.io.f("Sequence")
	.ImageURL		= cor.io.f("ImageURL")
	.ImageTitle		= cor.io.f("ImageTitle")
	.ImageLink		= cor.io.f("ImageLink")
	.ImageWidth		= cor.io.f("ImageWidth")
	.ImageHeight	= cor.io.f("ImageHeight")
	If not isnumeric(.ImageWidth) or .ImageWidth = "" then .ImageWidth="0"
	If not isnumeric(.ImageHeight) or .ImageHeight = "" then .ImageHeight="0"
	If not isnumeric(.Sequence) or .Sequence = "" then .Sequence = "0"

	sNewTime = cor.butil.cvUxTime(DateAdd("n",(0-5-clng(.TTL)),now()))

'Call setDateDelimiter()

	If .ID = 0 then
		cor_sql = "INSERT INTO " & cor_dbpre & "gh_rssfeed (Title,URL,Description,LastUpdate,TTL,MainPage,Sequence,ImageURL,ImageTitle,ImageLink,ImageWidth,ImageHeight) VALUES (" & _
			"{0},{1},{2},{3},{4},{5},{6},{7},{8},{9},{10},{11})"
	else
		cor_sql = "UPDATE " & cor_dbpre & "gh_rssfeed SET Title={0}, URL={1}, Description={2}, LastUpdate={3}, TTL={4}, MainPage={5}, Sequence={6}, ImageURL={7}, ImageTitle={8}, ImageLink={9}, ImageWidth={10}, ImageHeight={11} " & _
			"WHERE RSSFeed_ID=" & .ID
	end if
	cor.dal.exec cor_sql, array(.Title, .URL, .Description, sNewTime, .TTL, .MainPage, .Sequence, .ImageURL, .ImageTitle, .ImageLink, .ImageWidth, .ImageHeight)

	cor.redir "gh_mgmt_rssfeeds.asp" 
end with

end sub 

function validateRSSFeedImport()
	dim errmsg
	cor.str.wri "<script type=""text/javascript"">$('label[class^=errorfrm error]').remove();</script>"
	if len(cor.io.f("Title")) <= 0 then cor.str.add "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngGHFeedTitleUndef & "</label>').insertAfter('#Title');</script>"
	if len(cor.io.f("URL")) <= 0 then cor.str.add "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngGHFeedURLErr & "</label>').insertAfter('#URL');</script>"
	if len(cor.io.f("Description")) <= 0 then cor.str.add "<script type=""text/javascript"">$('<label class=""errorfrm error"">" & lngGHFeedDescriptionErr & "</label>').insertBefore('#Description');</script>"
	validateRSSFeedImport = cor.str.build
	cor.str.wri validateRSSFeedImport
end function

%>