<!--#include file="db/_soop_pageglobal.asp" -->
<!--#include file="common.asp"-->
<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

'********************************************************************
'** geckoHeadlines for SooP 2.0
'** Initially written for SooP 1.x by Dan Bodenstein 
'** http://www.scriptgecko.com
'********************************************************************

''XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'Check for Admin access. For Portal Admin only
If NOT GH_isAdmin() then
	call cor.msg(lngInsufficientPermission)
	cor.redir "./"
End if

Dim strMode,iCatId,x

strMode = lcase(cor.filter.checkStr(cor.io.fq("mode")))
iCatId = cor.filter.checkInt(cor.io.q("CatID"))

call cor.tpl.init("gh2mgmt")		'initialisation and loading of config sections, language strings
'


If strMode = "del" then
	Call DeleteSubscriber()
elseif iCatId <> 0 then
	Call ShowSubscribers(iCatId)
else
	Call ShowList()
end if



call cor.tpl.footer()				'closing MOD boxes and footer
'
call cor.off()						'ensure page disposal

'
Sub ShowList()
	dim i_c,i_x, arrCats

	call cor.tpl.header(lngGHSubscriptionSummary,"")			'header and surrounding MOD boxes, CSS, javascripts etc...
	
	cor.modbox.printBoxTop
	cor.str.add "<div class=""titleBar t-bar""><div><h4 class=""title"">" & lngGHSubscriptionSummary & "</h4></div></div>"
	cor.str.add "<div class=""modular"">"
	cor.str.add ghAdminMenu


	cor.str.add("	<table class=""soop""><tr>")
	cor.str.add("		<th class=""center"">" & lngCategory & "</th> ")
	cor.str.add("		<th class=""center"">" & lngGHSubscribers & "</th> ")
	cor.str.add("		<th class=""center"">" & lngGHAlertsSent & "</th> ")
	cor.str.add("		<th class=""center"">&nbsp;</th> ")
	cor.str.adn("	</tr>")
	Dim rs
	cor_sql = "SELECT Cat_ID FROM " & cor_dbpre & "gh_category ORDER BY Sequence;"
	cor.dal.open arrCats, cor_sql,array()
	If Not cor.butil.eof(arrCats) Then
		for i_x = 0 to ubound(arrCats,2)
			call GH_Categories.Read(arrCats(0,i_x))
			with GH_Categories
				cor.str.add ("<tr>")
				cor.str.add ("		<td class=""tHeading left"">" & .Category_Name & "</td>")
				cor.str.adn ("		<td class=""text center"">")
				i_c = cor.dal.getValue("SELECT Count(ta.Author_ID) FROM " & cor_dbpre & "gh_alerts AS ta WHERE ta.Cat_ID={0}", array(.ID))
				cor.str.add (i_c & "</td>")
				i_c = cor.dal.getValue("SELECT Count(th.Headline_ID) FROM " & cor_dbpre & "gh_headlines AS th WHERE Cat_ID={0} AND AlertSent={1}",array(.ID,1))
				cor.str.adn ("		<td class=""text center"">")
				cor.str.add (i_c & "</td>")
				cor.str.adn ("		<td class=""text center"">")
				cor.str.add ("<a href=""gh_mgmt_subscribers.asp?catid=" & .ID & """>" & lngGHViewSubscribers & "</a></td>")
			end with
			cor.str.adn ("	</tr>")
		Next
	End If
	cor.str.add("</table>")
	cor.str.add"</div>"
	cor.str.wri cor.str.build
	cor.modbox.printBoxBottom
end sub

Sub ShowSubscribers(iCat)
	GH_Categories.ReaD(iCat)
	call cor.tpl.header(lngGHSubscribers & ": " & GH_Categories.Category_name,"")			'header and surrounding MOD boxes, CSS, javascripts etc...
	cor.modbox.printBoxTop
	cor.str.add "<div class=""titleBar t-bar""><div><h4 class=""title"">" & lngGHSubscribers & ": " & GH_Categories.Category_name & "</h4></div></div>"
	cor.str.adn "<div class=""modular"">"
	cor.str.add ghAdminMenu

	cor.str.add("		<table class=""soop""><tr> ")
	cor.str.add("			<td align=left class=""bold"">" & lngUsername & "</td> ")
	cor.str.add("			<td class=""bold"" align=""center"">" & lngRealName & "</td> ")
	cor.str.add("			<td class=""bold"" align=""center"">" & lngEmail & "</td> ")
	cor.str.add("			<td class=""bold"" align=""center"">&nbsp;</td> ")
	cor.str.adn("		</tr> ")
	cor_sql = "SELECT T1.Author_ID,T1.Unique_ID,T2.mmail,T2.mname,T2.muser from " & cor_dbpre & "gh_alerts AS T1 " & _
			"INNER JOIN " & cor_dbpre & "members AS T2 ON T2.MemberID = T1.Author_ID WHERE T1.Cat_ID=" & iCat & ";"
	'rsCommon.Open cor_sql,adoCon
	cor.dal.openRS "rs", cor_sql, array()
	If not cor.dal.rs.eof then
		Do While NOT cor.dal.rs.eof
			cor.str.add("<tr>" & vbcrlf)
			cor.str.add("	<td align=""tHeading left"" class=""text"">" & cor.dal.rs("muser") & "</td>")
			cor.str.adn("	<td align=""center"" class=""text"">")
			cor.str.add(cor.dal.rs("mname") & "&nbsp;</td>")
			cor.str.adn("	<td align=""center"" class=""text"">")
			cor.str.add(cor.dal.rs("mmail") & "</td>")
			cor.str.adn("	<td align=""center"" class=""text"">")
			cor.str.add("<a href=""javascript:deleteWarning('" & iCat & "','" & cor.dal.rs("muser") & "','" & cor.dal.rs("Unique_ID") & "');"">" & lngDelete & "</a></td>")
			cor.str.adn("</tr>")
		cor.dal.rs.Movenext
		Loop
	end if
	cor.dal.rs.Close
	cor.str.add("<tr>")
	cor.str.add("	<td colspan=""4""><a href=""gh_mgmt_subscribers.asp"">"& lngGHReturntoSummary & "</a></td>")
	cor.str.add("</tr></table>")
%>
<script language="JavaScript"><!-- <![CDATA[
function deleteWarning(catid,sname,intID){
Warn = confirm('<%=lngGHAdminAreYouSure2%> ' + sname + '.\n');
if (Warn == true) {window.location='gh_mgmt_subscribers.asp?mode=del&catid=' + catid + '&UID=' + intID;}}
//]]> --></script>
<%

	cor.str.add "</div>"
	cor.str.wri cor.str.build
	cor.modbox.printBoxBottom

End Sub

Sub DeleteSubscriber()
	dim uniqueID : uniqueID = cor.io.q("UID")
	If uniqueID <> "" Then
		cor.dal.exec "Delete FROM " & cor_dbpre & "gh_alerts WHERE Unique_ID={0}",array(uniqueID)
		Response.Write ("<span class=""text""><b>" & "The users subscription has been removed." & "</b></span><br /><br />")
	End If
	Call ShowSubscribers(iCatId)
End Sub

%>