﻿<!--#include file="db/_soop_pageglobal.asp" -->
<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<!--#include file="common.asp" -->
<%
'********************************************************************
'** geckoHeadlines for SooP 2.0
'** Initially written for SooP 1.x by Dan Bodenstein 
'** http://www.scriptgecko.com
'******************************************************************** 
'
'Make sure this page is not cached
call cor.butil.preventCaching()

dim x
dim sqlResultsQuery 
dim strSearchKeywords 
dim sarySearchWord 
dim intRecordPositionPageNum 
dim intTotalNumOfPages 
dim intRecordLoopCounter 
dim intLinkPageNum 
dim strSearchMode
dim sDesc,iMiddle
dim strSearchArchives
dim intHighlightLoopCounter
dim intArticlesPerPage 
dim intTotalMatches, intStartofPage, intEndofPage
dim module_box
'
intArticlesPerPage = 10
'
cor.lng.includeSection("mod_xmlGH")

'
'Read in the search criteria
strSearchKeywords	= cor.filter.removeHTML(trim(mid(cor.io.q("KW"), 1, 35)))
strSearchMode		= cor.filter.removeHTML(trim(mid(cor.io.q("SM"), 1, 3)))
strSearchArchives	= cor.io.q("ARC")
strSearchKeywords	= replace(strSearchKeywords,"'","&squo;",1,-1,1)
strSearchKeywords	= replace(strSearchKeywords, "_", " ")
strSearchKeywords	= cor.filter.checkStrSQL(strSearchKeywords)
sarySearchWord		= split(trim(strSearchKeywords), " ")

if strSearchKeywords <> "" Then
	'Get Page Number
	if cor.io.q("pg")<>"" AND isNumeric(cor.io.q("pg")) Then
		intRecordPositionPageNum = cor.io.q("pg")
	else
		intRecordPositionPageNum = 1
	end if
	sqlResultsQuery = "SELECT T1.Headline_ID FROM " & cor_dbpre & "gh_headlines AS T1 WHERE ("
	'if the user has selected all or any words then build the where clause with the words to be searched
	if strSearchMode = "2" OR strSearchMode = "1" Then
		sqlResultsQuery = sqlResultsQuery & buildSQL ("T1.Article", sarySearchWord)
	else
		sqlResultsQuery = sqlResultsQuery & "T1.Article LIKE '%" & strSearchKeywords & "%'"
	end if
	sqlResultsQuery	= sqlResultsQuery & ") "
	if strSearchArchives = "" then
		sqlResultsQuery = sqlResultsQuery & " AND T1.GHStatus ='Published' "
	end if
	sqlResultsQuery	= sqlResultsQuery & " ORDER BY T1.Article_Date DESC;"
end if

gh_settings.read()

dim intColumCount

' Render page 
'
call cor.tpl.init("gh2")			'Call the Soop Section
call cor.tpl.header(lngSearch & " " & lngGHResults,"")	'Call the Header with Title string
'
call ghsearch()				'Call main Page from sub
'
call cor.tpl.footer()				'Call the Header
call cor.off()						'Close all open objects
'

function ghsearch
call display_column2()
set gh_Headline = nothing
end function

sub display_column2()
	'call openGHBoxing(lngSearch & " " & lngGHResults & cor_sTitleDelim & lngGHModTitle,false) 'sub to handle display of graphic borders
	'build search box
	cor.str.wri gh_SearchBox(true,false)
	'build results box
	cor.str.wri "<div class=""modular"">"

	if strSearchKeywords = "" Then '<strSearchKeywords>
		cor.str.wri "<div align=""center"" class=""bold"">" & lngGHNoKeywordEntered &"<br /><br /></div>"
	else
		cor.dal.openRSp "rs", intRecordPositionPageNum, intArticlesPerPage, sqlResultsQuery, array()
		'if there are no results display an error msg
		if cor.dal.rs.eof Then '<rs.eof>
			cor.str.wri "<div align=""center"" class=""bold"">" & lngNoSearchResults &"<br /><br /></div>"
		end if

	'if there are records found say how many
		if NOT cor.dal.rs.eof Then
			cor.str.wri "<table align=""center"" width=""99%"" border=""0"" cellpadding=""0"" cellspacing=""0"" summary=""""><!-- <show records> -->"
			cor.str.wri "<tr>"
			cor.str.wri "<td colspan=""3"" class=""tHeading"">&nbsp;" & lngGHMatchingArticles & "</td>"
			cor.str.wri "</tr>"
			'
			'Count the number of pages there are in the recordset calculated by the PageSize attribute set above
			intTotalNumOfPages	= cor.dal.rs.pageCount
			intTotalMatches		= cor.dal.rs.recordCount
			intStartofPage		= (intArticlesPerPage * intRecordPositionPageNum)-(intArticlesPerPage-1)
			intEndofPage		= (intStartofPage +(intArticlesPerPage-1))
			if intEndofPage > intTotalMatches then intEndofPage = intTotalMatches
			'
			cor.str.wri "<tr>"
			cor.str.wri "<td colspan=""3"" class=""alignTop"">"
			'
			cor.str.wri "<div class=""text holder2"">"
			cor.str.wri "	<b>" & lngGHFound   & "</b> " & intTotalMatches & "&nbsp;&nbsp;&nbsp;"
			cor.str.wri "	<b>" & lngGHShowing & "</b> " & intStartofPage  & " " & lngGHto & " " & intEndofPage
			cor.str.wri "</div>"
			If intTotalNumOfPages > 1 Then
			cor.str.wri "<div class=""holder3"">"
			call pageNum()
			cor.str.wri "</div>"
			End If
			cor.str.wri "<div class=""text holder1"">" & lngGHYourSearchfor & "&nbsp;'" & strSearchKeywords & "'&nbsp;" & lngGHHasFound & "&nbsp;" & intTotalMatches & "&nbsp;" & lngGHResults & "</div>"

			cor.str.wri "</td>"
			cor.str.wri "</tr>"

			for intRecordLoopCounter = 1 to intArticlesPerPage
				if cor.dal.rs.eof then exit for
				gh_Headline.Read(cor.dal.rs("Headline_ID"))
				if gh_Headline.hasAccess(cor_iGroupID) then
					if intRecordLoopCounter > 1 then
						cor.str.wri "<tr>" 
						cor.str.wri "<td colspan=""3"" align=""center""><hr /></td>"
						cor.str.wri "</tr>" 
					end if

					with gh_Headline
					for intHighlightLoopCounter = 0 To ubound(sarySearchWord)
						'replace the search words with highlited ones
						.Title = replace(.Title, sarySearchWord(intHighlightLoopCounter), "<span class=""highlight"">" & sarySearchWord(intHighlightLoopCounter) & "</span>", 1, -1, 1)
					Next
					'
					cor.str.wri "<tr>"
					cor.str.wri "<td rowspan=""2"" class=""text alignTop"">" & (intStartofPage + (intRecordLoopCounter-1)) & ".</td>"
'					cor.str.wri "<td rowspan=""2"" class=""text"" style=""vertical-align:top;"">" & (intRecordLoopCounter) & ".</td>"
					cor.str.wri "<td class=""bold""><a class=""boldLink"" href=""gh_showarticle.asp?hid=" & .ID & "&amp;KW=" & replace(strSearchKeywords, " ", "+") & """>" & .Title & "</a></td>"
					cor.str.wri "<td class=""text right alignTop"">" & cor.butil.datetime(.ArticleDate, 1) & "</td>"
					cor.str.wri "</tr>"
					'=============================================
					' TRIM DESCRIPTION
					'=============================================
					sDesc = cor.filter.removeHTML(.Article)
					sDesc = replace(replace(sDesc,"[AD-L]",""),"[AD-R]","")
					if len(sDesc) > 200 then
						iMiddle = instr(200,sDesc," ")
						if iMiddle = 0 then
							iMiddle = instr(200,sDesc,".")
							if iMiddle = 0 then iMiddle=200
						end if
						sDesc = left(sDesc, iMiddle) & "..."
					end if
					for intHighlightLoopCounter = 0 To ubound(sarySearchWord)
						'replace the search words with highlited ones
						sDesc = replace(sDesc, sarySearchWord(intHighlightLoopCounter), "<span class=""highlight"">" & sarySearchWord(intHighlightLoopCounter) & "</span>", 1, -1, 1)
					Next
					'===========================================
					'
					cor.str.wri "<tr>"
					cor.str.wri "<td colspan=""2"" class=""text"">" & sDesc & "&nbsp;</td>"
					cor.str.wri "</tr>"
					'
					end with

				end if
				cor.dal.rs.moveNext
			next
			intRecordLoopCounter = intRecordLoopCounter+1
			cor.str.wri "<tr>"
			cor.str.wri "<td colspan=""3"" align=""right"">" : call pageNum() : cor.str.wri "</td>"
			cor.str.wri "</tr>"
			'
			cor.str.wri "</table><!-- </show records> -->"

			'
			cor.dal.closeRS("rs")
		end if '</rs.eof>
	end if '</strSearchKeywords>
	cor.str.wri "</div>"

end sub

'------------------------------------------------------------------------------------------------------------------------------------------
' Helper functions
'------------------------------------------------------------------------------------------------------------------------------------------
'
' function to build SQL query's for seach all or any words
'
'------------------------------------------------------------------------------------------------------------------------------------------
function buildSQL (strTable, sarySearchWord)
	dim ssql
	dim intSQLLoopCounter
	intSQLLoopCounter = 0
	cor.str.clear
	'Search for the first search word
	cor.str.adn "((T1.Article LIKE '%" & sarySearchWord(0) & "%'"
	cor.str.adn " OR T1.Title LIKE '%" & sarySearchWord(0) & "%')"
	'Loop to search for each search word entered by the user
	for intSQLLoopCounter = 1 To ubound(sarySearchWord)
		if strSearchMode = "1" Then
			cor.str.adn " AND "
		else
			cor.str.adn " OR "
		end if
		cor.str.adn "(T1.Article LIKE '%" & sarySearchWord(intSQLLoopCounter) & "%'"
		cor.str.adn " OR T1.Title LIKE '%" & sarySearchWord(intSQLLoopCounter) & "%')"
	next
	'Close the end of the search words in the SQL query by closing the bracket
	cor.str.adn ")"
	buildSQL = cor.str.build
end function
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
'
'
'------------------------------------------------------------------------------------------------------------------------------------------
sub pageNum()
	if intTotalNumOfPages > 1 Then
		dim pageNo
		set pageNo = New class_pageNo
		pageno.TotalPages		= intTotalNumOfPages
		pageno.PageLinks		= intArticlesPerPage
		pageno.CurrentPage		= intRecordPositionPageNum
		pageno.BaseUrl			= "<a href=""" & cor_sWebroot & "gh_searchresults.asp?kw=" & replace(strSearchKeywords, " ", "+") & "&amp;sm=" & strSearchMode & "&amp;arc=" & strSearchArchives
		pageno.pageNumPrefix	= "&amp;pg"
		pageno.printLinks
	else
		cor.str.wri "&nbsp;"
	end if
end sub
%>
