﻿<!--#include file="db/_soop_pageglobal.asp" -->
<!--#include file="common.asp" -->
<!--#include file="core/classes/class_sendmail.asp" -->
<!--#include file="mods/classes/class_guestbook.asp" -->
<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

'
' page-level global variables
'
dim oCombo
dim intDo 
'
' activate do-step controller
'
intDo = cor.filter.checkInt(cor.io.fq("do"))
if intDo = 0 then intDo = cor_cDoNew
'
call cor.tpl.init("GuestBook")

' Added to prevent hacker from directly linking to Guestbook Form can only get here from the guestbook.asp page.
If NOT cor_bPostback AND instr(1,cor_sReferer,"guestbook.asp",1)=0 then cor.redir(cor_sWebroot)
'
cor.guestbook.init_io()
cor.guestbook.controller(intDo)
'
' Init template system
'
call cor.tpl.header("GuestBook","")
cor.modbox.printBoxTop
'
call guestbook_form()
'
cor.modbox.printBoxBottom
call cor.tpl.footer()
call cor.off()

Function guestbook_form()

%>
<script type="text/javascript"><!-- <[CDATA[
$(document).ready(function(){
	$('form.#frmGuestbook').submit(function() { 
		$('form.#frmGuestbook').ajaxSubmit({target: "#form_results"});
		return false;// ! Important always return false to prevent standard browser submit and page navigation
	});
});
// ]]> --></script>

<div id="GuestBookForm" class="modular">
<form action="" class="soop ajaxfrm" id="frmGuestbook" method="post">
<input type="hidden" name="do" value="<%= intDo %>" />
<input type="hidden" name="pg" value="<%= cor.guestbook.iPage %>" />
<input type="hidden" name="id" value="<%= cor.guestbook.iID %>" />
<input type="hidden" name="member" value="<%= cor.guestbook.iMember %>" />

<p><%= lngCompleteForm %></p>
<fieldset>
<legend><%= lngGuestbookGeneralInfo %></legend>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label req-ico ico-sprt"><label for="name"><%= lngGuestBookName %></label></li>
			<li class="input">
<% if cor.guestbook.bDisabled then %>
<%= cor.guestbook.sName %>
<input type="hidden" name="name" value="<%= cor.guestbook.sName %>" />
<% else %>
<input type="text" id="name" name="name" size="30" value="<%= cor.guestbook.sName %>" maxlength="100" />
<% end if %>
			</li>
		</ul>
	</li>
	<li>
<ul class="col">
<li class="label req-ico ico-sprt"><label for="email"><%= lngGuestBookEmail %></label></li>
<li class="input">
<% if cor.guestbook.bDisabled then %>
<%= cor.guestbook.sEmail %>
<input type="hidden" name="email" value="<%= cor.guestbook.sEmail %>" />
<% else %>
<input type="text" id="email" name="email" size="50" value="<%= cor.guestbook.sEmail %>" maxlength="100" />
<% end if %>
</li>
</ul>
</li>
<li>
<ul class="col">
<li class="label"><label for="homepage"><%= lngGuestBookHomePage %></label></li>
<li class="input"><input type="text" id="homepage" name="homepage" size="50" value="<%= cor.guestbook.sHomepage %>" maxlength="50" /></li>
</ul>
</li>

<li>
<ul class="col">
<li class="label"><label for="country"><%= lngLocation %></label></li>
<li class="input">
<%
set oCombo = new class_comboBuilder
oCombo.ElementID = "country"
oCombo.SelectedValue = cor.guestbook.iCountry
if  cor.guestbook.bDisabled then
	oCombo.DisplayDefault = false
	oCombo.BuildComboFromDB "SELECT c.countryID, c.country FROM " & cor_dbpre & "country AS c WHERE c.countryID=" & cor.guestbook.util.getCountryByUserID(cor_lUserID)
else
	oCombo.BuildComboFromDB "SELECT c.countryID, c.country FROM " & cor_dbpre & "country  AS c ORDER BY c.country"
end if
oCombo.CreateCombo()
set oCombo = nothing
%>
</li>
</ul>
</li>

</ul>
</fieldset>

<fieldset>
<legend><%= lngGuestBookComments %>&nbsp;<b class="ui"><i class="req-ico ico-sprt">&nbsp;</i></b></legend>
<ul class="row">
<li>
<ul class="col req textarea">
<li class="input">
<%= cor.rte.invoke( cor.guestbook.sComments, "comments", "100%", 200, "GuestBook") %>
</li>
</ul>
</li>
</ul>
</fieldset>

<% if cor.guestbook.bCaptcha then %>
<fieldset>  
<legend><%= lngGuestbookSecurity %></legend>
<ul class="row">
<li>
<ul class="col">
<li class="label"><label><%= lngConfirmSecurityCode %></label></li>
<li class="input">
<img id="secureImages<%=cor.filter.encrypt("guestbook")%>" src="<%= cor_sWebroot %>securecode.asp?r=<%= clng(Rnd * 10000000) %>&id=<%=cor.filter.encrypt("guestbook")%>" alt="" />&nbsp;
<a class="secureImg" rel="<%=cor.filter.encrypt("guestbook")%>" href="javascript:void(0)"><%= lngTextReload %></a>
</li>
</ul>
</li>
<li>
<ul class="col">
<li class="label req-ico ico-sprt"><label for="securityCode"><%= lngConfirmSecurityCode %></label></li>
<li class="input">
<input type="text" id="securityCode" name="securityCode" class="{validate:{required:true,minLength:<%= cor_iCaptchaLength %>}}" />
<input type="hidden" id="sessionName" name="sessionName" value="<%=cor.filter.encrypt("guestbook")%>" />
</li>
</ul>
</li>
</ul>
</fieldset>
<% end if %>

<div class="buttonOuterWrap"><div class="buttonInnerWrap">
<% if intDo = cor_cDoNew then %>
<div class="ui button"><button type="submit" id="Submit" name="Submit" value="<%= lngGuestBookAdd %>"><span><%= lngGuestBookAdd %></span></button></div>
<% elseif cor_bAdmin OR cor.guestbook.bAuthor then %>
<div class="ui button"><button type="submit" id="Submit" name="Submit" value="<%= lngGuestBookEditSave %>"><span><%= lngGuestBookEditSave %></span></button></div>
<% end if %>
<div class="ui button"><button type="reset" id="Reset" name="Reset" value="<%= lngGuestBookClear %>"><span><%= lngGuestBookClear %></span></button></div>
<div class="ui button"><button type="button" id="Cancel" name="Cancel" value="Cancel" onclick="javascript:window.location.href='guestbook.asp?pg=<%= cor.guestbook.iPage %>'"><span><%= lngCancel %></span></button></div>
</div></div>
</form>
</div>
<%
End Function
%>
