﻿<!--#include file="db/_soop_pageglobal.asp" -->
<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<!--#include file="common.asp" -->

<!--#include file="core/classes/class_sendmail.asp" -->
<!--#include file="core/classes/class_members.asp" -->
<!--#include file="core/classes/class_members_html.asp" -->
<%
'
'--- local variables
'
dim oCombo
dim intDo
dim bAcceptTerms
dim strModalClass

'
' Init do-step controller
'
intDo = cor.filter.checkInt(cor.io.fq("do"))

if intDo=0 then intDo=cor_cDoMemberView
'/* Fixes navigation for buttons depending on the modals cookie status */
If request.cookies("emb") = 1 Then
	strModalClass = "class=""ModalHideAndRedirect"""
Else
	strModalClass = ""
end if

'------------------------------------------------------------------------------------------------------------------------------------------
'
' Validate username against existing users
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
If cor.io.q("muser") <> "" Then
	Dim strSname, i
	strSname = cor.io.q("muser")
	If strSname <> "" Then
			Dim arrNames, blnName
			blnName = "true"
			cor_sql = "SELECT m.muser FROM " & cor_dbpre & "members AS m"
			cor.dal.open arrNames, cor_sql, array()
			For i = 0 To UBound(arrNames,2)
				If lcase(trim(strSname)) = lcase(trim(arrNames(0,i))) Then blnName = "false"
				'Response.Write arrNames(0,i) & "<br />"
			Next
			Response.Write(blnName)
			response.end
	End If
End If
'
'cor.butil.preventCaching()
call cor.tpl.init("Members")
cor.member.init_io()


cor.member.init_members()
cor.member.controller(intDo)



call DoThisPage

call cor.tpl.footer()
call cor.off()

'------------------------------------------------------------------------------------------------------------------------------------------
sub DoThisPage
  select case intDo
	Case cor_cDoMemberNew
	'------------------------------------------------------------------------------------------------------------------------------------------
	' New registration
	'------------------------------------------------------------------------------------------------------------------------------------------
		Call cor.tpl.header(lngMemberNew,"")
		cor.member.html.js()
	cor.str.wri cor.modbox.printBoxTop
	cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngMemberNew&"</h4></div></div>"

%>
<div class="modular"><!-- Open Modular -->
<form id="profile" name="profile" class="soop" action="member_form.asp" method="post"><!--<cor_cDoMemberNew>-->
	<input type="hidden" name="do" value="<%= cor_cDoMemberNew %>" />

	<fieldset>
		<legend><%= lngMemberRequiredInfo %></legend>
		<ul class="row"><!-- <row> -->
			<li><% cor.member.html.muser(true) %></li>
			<li><% cor.member.html.mpassAdd() %></li>
			<li><% cor.member.html.mmail(true) %></li>
		</ul><!-- </row> -->
	</fieldset>

	<fieldset>
		<legend><%= lngMemberAdditionalInfo %></legend>
		<ul class="row"><!-- <row> -->
			<li><% cor.member.html.mname(true)			%></li>
			<li><% cor.member.html.mlocation(true)		%></li>
			<li><% cor.member.html.mdateofbirth(true)	%></li>
			<li><% cor.member.html.mgender(true)		%></li>
			<li><% cor.member.html.mhomepage(true)		%></li>
			<li><% cor.member.html.mmsn(true)			%></li>
			<li><% cor.member.html.micq(true)			%></li>
			<li><% cor.member.html.myahoo(true)			%></li>
			<li><% cor.member.html.maim(true)			%></li>
		</ul><!-- </row> -->
	</fieldset>

<% if cor_bAdmin then '<admin> if admin then title and group ID of the member may be changed from default %>
	<fieldset>
		<legend><%= lngMemberAdminSettings %></legend>
		<ul class="row"></ul><!-- <row> -->
			<li><% cor.member.html.mtitle(true) %></li>
			<li><% cor.member.html.mgname(true) %></li>
		</ul><!-- </row> -->
	</fieldset>
<% end if '</admin> %>

	<fieldset>
		<legend><%= lngSettings %></legend>
		<ul class="row"><!-- <row> -->
			<li><% cor.member.html.mskin(true)		%></li>
			<li><% cor.member.html.mlanguage(true)	%></li>
			<li><% cor.member.html.msign(true)		%></li>
			<li><% cor.member.html.mshowmail(true)	%></li>
			<li><% cor.member.html.mhtmlemail(true)	%></li>
			<li><% cor.member.html.mautologin(true)	%></li>
			<li><% cor.member.html.mshowactive(true)	%></li>
			<li><% cor.member.html.mshowsig(true)	%></li>
			<li><% cor.member.html.mpmnotify(true)	%></li>
			<li><% cor.member.html.mreplynotify(true)	%></li>
			<li><% cor.member.html.mtimezone(true)	%></li>
		</ul><!-- </row> -->
	</fieldset>
<%
If cor.member.bCaptcha And Not cor_bAdmin Then '<bCaptcha> 
	cor.member.html.securityCode()
end if '</bCaptcha>
%>
	
	<div class="buttonOuterWrap">
		<div class="buttonInnerWrap">
			<div class="ui button">
				<button title="Register" value="Register" type="submit" id="register">
				<span><%= lngRegister %></span>
				</button>
			</div>
		</div>
	</div>
</form><!--</cor_cDoMemberNew>-->
</div><!-- /modular -->

<%
cor.str.wri cor.modbox.printBoxBottom
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Consulting a profile
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
case cor_cDoMemberView
call cor.tpl.header(lngMemberView,"")
cor.member.html.js()
cor.str.wri cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngMemberView&"</h4></div></div>"


%>
<div class="modular"><!-- Start modular -->

<ul class="row">
	<li><% cor.member.html.muser(false)		%></li>
	<li><% cor.member.html.mtitle(false)	%></li>
	<li><% cor.member.html.mgname(false)	%></li>
	<li><% cor.member.html.memberStatus()	%></li>
	<li><% cor.member.html.mavatar(false)	%></li>
	<li><% cor.member.html.mreggad()		%></li>
	<li><% cor.member.html.mnoofposts()		%></li>

<% if cor.member.io_mshowsig	<> "" AND  cor.member.io_msign <> "" then %><li><% cor.member.html.msign(false) %></li><% end if %>
<% if cor.member.io_mlocation	<> "" then %>	<li><% cor.member.html.mlocation(false) %></li><% end if %>
<% if cor.member.io_mdateofbirth<> 0 then %>	<li><% cor.member.html.mdateofbirth(false) %></li><% end if %>
<% if cor.member.io_mgender		<> "" then %>	<li><% cor.member.html.mgender(false) %></li><% end if %>
<% if cor.member.io_mshowmail	<> 0 OR cor_bAdmin then %>	<li><% cor.member.html.mmail(false) %></li><% end if %>
<% if cor.member.io_mhomepage	<> "http://" then %>	<li><% cor.member.html.mhomepage(false) %></li><% end if %>

<% if cor.member.io_mmsn		<> "" then %><li><% cor.member.html.mmsn(false)			%></li><% end if %>
<% if cor.member.io_micq		<> "" then %><li><% cor.member.html.micq(false)			%></li><% end if %>
<% if cor.member.io_myahoo		<> "" then %><li><% cor.member.html.myahoo(false)		%></li><% end if %>
<% if cor.member.io_maim		<> "" then %><li><% cor.member.html.maim(false)			%></li><% end if %>

<% if cor.member.io_mid = cor_lUserID OR cor_bAdmin OR cor_bModerator Then ' for personal use only %>
	<li><% cor.member.html.mwarnings()			%></li>
	<li><% cor.member.html.mskin(false)			%></li>
	<li><% cor.member.html.mlanguage(false)		%></li>
	<li><% cor.member.html.mhtmlemail(false)	%></li>
	<li><% cor.member.html.mautologin(false)	%></li>
	<li><% cor.member.html.mshowactive(false)	%></li>
	<li><% cor.member.html.mpmnotify(false)		%></li>
	<li><% cor.member.html.mreplynotify(false)	%></li>
	<li><% cor.member.html.mtimezone(false)		%></li>
<% end if %>
</ul><!-- </row> -->
<br />
<% if cor.member.io_mnoofposts > 0 Then %>
	<div class="holder1">
		<div class="buttonOuterWrap"><div class="buttonInnerWrap">
			<div class="ui button"><a <%= strModalClass %> href="fora_searchm.asp?q=%25&amp;mode=<%= cor_cFilterModeAnyWord %>&amp;ordertime=<%= cor_cTimeAll %>&amp;searchin=<%= cor_cFilterSearchInBoth %>&amp;forum=all&amp;order1=<%= cor_cOrderLatest %>&amp;order2=<%= cor_cOrderDesc %>&amp;mid=<%= cor.member.io_mid %>"><span><%= lngMemberShowAllPosts %></span></a></div>
		</div></div>
	</div>
<% end if %>
	<div class="holder1">
		<div class="buttonOuterWrap"><div class="buttonInnerWrap">
			<% if cor.member.io_mid <> cor_lUserID then %>
			<div class="ui button"><a <%= strModalClass %> href="pm_form.asp?do=<%= iif(cor_bAdmin OR cor_bModerator, cor_cDoNewPMList, cor_cDoNewPM) %>&amp;to=<%= cor.member.io_mid %>" title="<%= lngMemberSendPM %>"><span><i class="pm-ico ico-sprt"></i><%= lngMemberSendPM %></span></a></div>
			<% end if %>
			<% if NOT cor_bGuest Then %>
				<% if cor_bMember AND cor.member.io_mid <> cor_lUserID then %>
					<div class="ui button"><a <%= strModalClass %> href="member_form.asp?do=<%= cor_cDoMemberAddBuddy %>&amp;mid=<%= cor.member.io_mid %>" title="<%= lngMemberAddBuddy %>"><span><i class="addbuddy-ico ico-sprt"></i><%= lngMemberAddBuddy %></span></a></div>
				<% end if %>
			<% end if %>
			<% if cor_bMember AND (cor.member.io_mid = cor_lUserID OR cor_bAdmin) then %>
				<div class="ui button "><a <%= strModalClass %> href="member_form.asp?do=<%= cor_cDoMemberUpdate %>&amp;mid=<%= cor.member.io_mid %>" title="<%= lngEdit %>"><span><i class="edit-ico ico-sprt"></i><%= lngEdit %></span></a></div>
			<% end if %>
			<% if cor_bAdmin then %>
				<div class="ui button"><a <%= strModalClass %> href="member_form.asp?do=<%= cor_cDoMemberWarn %>&amp;mid=<%= cor.member.io_mid %>" title="<%= lngMemberWarn %>"><span><i class="warn-ico ico-sprt"></i><%= lngMemberWarn %></span></a></div>
				<% If cor.member.io_mbanned = 0 Then%>
				<div class="ui button"><a <%= strModalClass %> href="member_form.asp?do=<%= cor_cDoMemberBan %>&amp;mid=<%= cor.member.io_mid %>" title="<%= lngMemberBan %>"><span><i class="ban-ico ico-sprt"></i><%= lngMemberBan %></span></a></div>
				<% Else %>
				<div class="ui button"><a <%= strModalClass %> href="member_form.asp?do=<%= cor_cDoMemberUnBan %>&amp;mid=<%= cor.member.io_mid %>" title="<%= lngMemberUnBan %>"><span><i class="yes-ico ico-sprt"></i><%= lngMemberUnBan %></span></a></div>
				<% End If %>
			<% end if %>
		</div></div>
	</div>
</div><!-- Close modular -->
<%
cor.str.wri cor.modbox.printBoxBottom
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Editing a profile
'
'------------------------------------------------------------------------------------------------------------------------------------------
case cor_cDoMemberUpdate
call cor.tpl.header(lngMemberUpdate,"")
cor.member.html.js()
cor.str.wri cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngMemberUpdate&"</h4></div></div>"

%>
<div class="modular">
	<form id="profile" class="soop" action="member_form.asp?mid=<%= cor.member.io_mid %>" method="post"><!--<cor_cDoMemberUpdate>-->
		<input type="hidden" name="do" value="<%= cor_cDoMemberUpdate %>" />
		<input type="hidden" name="mid" value="<%= cor.member.io_mid %>" />

	<fieldset>
		<legend><%= lngMemberRequiredInfo %></legend>
		<ul class="row"><!-- <row> -->
<% if cor_bAdmin then %>
			<li><% cor.member.html.muser(true) %></li>
<% else %>
			<li><% cor.member.html.muser(false) %></li>
<% end if %>
			<li><% cor.member.html.mmail(true) %></li>
		</ul><!-- </row> -->
	</fieldset>

	<fieldset>
		<legend><%= lngMemberAdditionalInfo %></legend>
		<ul class="row"><!-- <row> -->
			<li><% cor.member.html.mname(true)		%></li>
			<li><% cor.member.html.mlocation(true)	%></li>
			<li><% cor.member.html.mdateofbirth(true) %></li>
			<li><% cor.member.html.mgender(true)	%></li>
			<li><% cor.member.html.mavatar(true)	%></li>
			<li><% cor.member.html.mhomepage(true)	%></li>
			<li><% cor.member.html.mmsn(true)		%></li>
			<li><% cor.member.html.micq(true)		%></li>
			<li><% cor.member.html.myahoo(true)		%></li>
			<li><% cor.member.html.maim(true)		%></li>
		</ul><!-- </row> -->
	</fieldset>

<% if cor_bAdmin then '<admin> if admin then title and group ID of the member may be edited/changed %>
	<fieldset>
		<legend><%= lngMemberAdminSettings %></legend>
		<ul class="row"><!-- <row> -->
			<li><% cor.member.html.mtitle(true) %></li>
			<li><% cor.member.html.mgname(true) %></li>
		</ul><!-- </row> -->
	</fieldset>
<% end if '</admin> %>

	<fieldset>
		<legend><%= lngSettings %></legend>
		<ul class="row"><!-- <row> -->
			<li><% cor.member.html.mskin(true)		%></li>
			<li><% cor.member.html.mlanguage(true)	%></li>
			<li><% cor.member.html.msign(true)		%></li>
			<li><% cor.member.html.mshowmail(true)	%></li>
			<li><% cor.member.html.mhtmlemail(true)	%></li>
			<li><% cor.member.html.mautologin(true)	%></li>
			<li><% cor.member.html.mshowactive(true)	%></li>
			<li><% cor.member.html.mshowsig(true)	%></li>
			<li><% cor.member.html.mpmnotify(true)	%></li>
			<li><% cor.member.html.mreplynotify(true)	%></li>
			<li><% cor.member.html.mtimezone(true)	%></li>
		</ul><!-- </row> -->
	</fieldset>

	<div class="buttonOuterWrap">
		<div class="buttonInnerWrap">
			<div class="ui button">
				<button title="EditProfile" value="EditProfile" type="submit" id="EditProfile">
				<span><%= lngMemberEditProfile %></span>
				</button>
			</div>
		</div>
	</div>
	
</form><!--</cor_cDoMemberUpdate>-->

<form id="profilepass" class="soop" method="post" action="member_form.asp?mid=<%= cor.member.io_mid %>"><!--<cor_cDoMemberUpdatePass>-->
	<input type="hidden" name="do" value="<%= cor_cDoMemberUpdatePass %>" />
	<input type="hidden" name="mid" value="<%= cor.member.io_mid %>" />

	<fieldset>
		<legend><%= lngMemberUpdatePass %>:</legend>
		<ul class="row"><!-- <row> -->
			<li><% cor.member.html.mpassChange() %></li>
		</ul><!-- </row> -->
	</fieldset>

	<div class="center">
	<div class="buttonOuterWrap"><div class="buttonInnerWrap">
		<div class="ui button">
			<button id="EditPass" type="submit" name="EditPass" value="<%= lngMemberEditPass %>"><span><%= lngMemberEditPass %></span></button>
		</div>
	</div></div>
	<!-- <input value="" /> -->
	</div>
	<br /><br />
</form><!--</cor_cDoMemberUpdatePass>-->
</div><!-- Close modular -->
<%
cor.str.wri cor.modbox.printBoxBottom
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Activate membership by admin
'
'------------------------------------------------------------------------------------------------------------------------------------------
case cor_cDoMemberActivateAdm
call cor.tpl.header(lngMemberActivate,"")
cor.member.html.js()
cor.str.wri cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngMemberActivate&"</h4></div></div>"
%>
<div class="modular"><!-- start modular -->
<form action="member_form.asp?mid=<%= cor.member.io_mid %>" method="post" class="soop" id="activateadm" name="activateadm">
<fieldset>
<legend><%=lngMemberActivate%></legend>
<ul class="row">
<li>
<input type="hidden" name="do" value="<%= cor_cDoMemberActivateAdm %>" />
<input type="hidden" name="mid" value="<%= cor.member.io_mid %>" />
<%= lngMemberActivationCheckbox %>
<ul class="col">
<li class="label">
<strong><%= cor.member.io_muser %></strong>
</li>
<li class="input">
<input class="checkbox" type="checkbox" name="mactive" value="1" />
</li>
</ul>
</li>
</ul>
<div style="float:none;" class="ui button">
	<button id="activate" type="submit" name="activate" value="<%= lngMemberActivateNow %>"><span><%= lngMemberActivateNow %></span></button>
</div>
</fieldset>
<br /><br />
<fieldset>
<legend><%=lngMemberAlternateOption%></legend>
<ul class="row">
<li>
<%= lngMemberActivateEmailAdmin %>
<ul class="col">
<li class="label">
Email
</li>
<li class="input">
<input type="text" name="mmail" size="40" value="<%= cor.member.io_mmail %>" />
</li>
</ul>
</li>
</ul>
<div class="ui button">
	<button id="activate" type="submit" name="activate" value="<%= lngMemberResendActivationEmail %>"><span><%= lngMemberResendActivationEmail %></span></button>
</div>
</fieldset>
</div>
</form>
</div><!-- Close modular -->
<%
cor.str.wri cor.modbox.printBoxBottom
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Activate membership (special case where activity is usually performed at page load via GET from activation email)
'
'------------------------------------------------------------------------------------------------------------------------------------------
case cor_cDoMemberActivate
call cor.tpl.header(lngMemberActivate,"")
cor.member.html.js()
cor.str.wri cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngMemberActivate&"</h4></div></div>"
%>
<div class="modular"><!-- start modular -->
<% if cor.member.io_mactive = 1 Then %>
<div style="text-align:center; padding:30px;"><%= lngMemberAlreadyActivated %></div>
<% elseif cor.member.iMailsent = 1 Then %>
<div style="text-align:center; padding:30px;"><%= lngMemberActivationMailSent %></div>
<% else %>
<form id="memberactivate" name="memberactivate" action="member_form.asp?mid=<%= cor.member.io_mid %>" method="post" class="soop">
<fieldset>
<legend><%= lngMemberActivateNow %></legend>
<ul class="row">
<li>
<input type="hidden" name="do" value="<%= cor_cDoMemberActivate %>" />
<input type="hidden" name="mid" value="<%= cor.member.io_mid %>" />
<%= lngMemberNeedActivationMsg & lngMemberEnterActivationCodeMsg %><br /><br />
<ul class="col">
<li class="label">
<%=lngMemberActivationCode%>
</li>
<li class="input">
<input type="text" name="mactivatecode" size="40" value="" />
</li>
</ul>
</li>
</ul>
<div class="ui button">
	<button id="activate" type="submit" name="activate" value="<%= lngMemberActivateNow %>"><span><%= lngMemberActivateNow %></span></button>
</div>
</fieldset>
<br /><br />
<fieldset>
<legend><%= lngMemberAlternateOption %></legend>
<ul class="row">
<li>
<%= lngMemberActivateEmail %><br /><br />
<ul class="col">
<li class="label">
<%= lngEmail %>
</li>
<li class="input">
<input type="text" name="mmail" size="40" value="<%= cor.member.io_mmail %>" />
</li>
</ul>
</li>
</ul>
<div class="ui button">
	<button id="resend" type="submit" name="resend" value="<%= lngMemberResendActivationEmail %>"><span><%= lngMemberResendActivationEmail %></span></button>
</div>
</fieldset>
</form>
<% end if %>
</div><!-- Close modular -->
<%
cor.str.wri cor.modbox.printBoxBottom

'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Request Password
'
'------------------------------------------------------------------------------------------------------------------------------------------
Case cor_cDoMemberNewPass
call cor.tpl.header(lngMemberRequestPass,"")
cor.member.html.js()
cor.str.wri cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngMemberRequestPass&"</h4></div></div>"
%>
<form class="soop" id="newpass" name="newpass" action="member_form.asp?mid=<%= cor.member.io_mid %>" method="post">
<div class="modular"><!-- start modular -->
<fieldset>
<legend><%= lngMemberRequestPass %></legend>
<ul class="row">
<li>
<%= lngMemberConfirmWithEmail %><br /><br />
<ul class="col">
<li class="label">
<%= lngEmail %>
</li>
<li class="input">
<input type="hidden" name="do" value="<%= cor_cDoMemberNewPass %>" />
<input type="hidden" name="mid" value="<%= cor.member.io_mid %>" />
<input type="text" name="mmail" size="40" value="<%= cor.member.io_mmail %>" />
</li>
</ul>
</li>
</ul>
<div class="ui button">
	<button id="requestpass" type="submit" name="requestpass" value="<%= lngMemberRequestOk %>"><span><%= lngMemberRequestOk %></span></button>
</div>
</div><!-- Close modular -->
</form>
<%
cor.str.wri cor.modbox.printBoxBottom
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Warn member (admin/mod)
'
'------------------------------------------------------------------------------------------------------------------------------------------
case cor_cDoMemberWarn
call cor.tpl.header(lngMemberWarnTitle,"")
cor.member.html.js()
cor.str.wri cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngMemberWarnTitle&"</h4></div></div>"
%>
<div class="modular"><!-- start modular -->
<div class="center">
<b><%= cor.member.io_muser %></b> <%= lngMemberWarned %> <b><%= cor.member.io_mwarnings %></b> <%= lngMemberTimes %>
<form id="warning" name="warning" action="member_form.asp?mid=<%= cor.member.io_mid %>" method="post">
<input type="hidden" name="do" value="<%= cor_cDoMemberWarn %>" />
<input type="hidden" name="mid" value="<%= cor.member.io_mid %>" />
<%= lngMemberSureToWarn %> <b><%= cor.member.io_muser %></b> <%= iif(cor.member.io_mname<>"", "(" & cor.member.io_mname & ")", "") %>?
<br /><br />
<div class="buttonOuterWrap">
	<div Class="buttonInnerWrap">
		<div class="ui button">
			<button id="deletebtn" type="submit" name="deletebtn" value="<%= lngYes %>"><span><%= lngYes %></span></button>
		</div>
	</div>
</div>
</form>
</div>
</div><!-- Close modular -->
<%
cor.str.wri cor.modbox.printBoxBottom
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Ban member (admin)
'
'------------------------------------------------------------------------------------------------------------------------------------------
case cor_cDoMemberBan
call cor.tpl.header(lngMemberBanTitle,"")
cor.member.html.js()
cor.str.wri cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngMemberBanTitle&"</h4></div></div>"
%>
<div class="modular"><!-- start modular -->
<div class="center">
<% if cor.member.io_mbanned > 0 Then %>
	<%= lngMemberBannedMsg %>
<% else %>
	<form class="soop" id="memberban" name="memberban" action="member_form.asp?mid=<%= cor.member.io_mid %>" method="post">
	<input type="hidden" name="do" value="<%= cor_cDoMemberBan %>" />
	<input type="hidden" name="mid" value="<%= cor.member.io_mid %>" />
	<input type="hidden" name="mbanned" value="<%= cor.member.io_mbanned %>" />
	<%= lngMemberSureToBan %> <b><%= cor.member.io_muser %></b> <%= iif(cor.member.io_mname<>"", "(" & cor.member.io_mname & ")", "") %>?
	<br /><br />
	<div class="buttonOuterWrap">
	<div Class="buttonInnerWrap">
		<div class="ui button">
			<button id="banmember" type="submit" name="banmember" value="<%= lngYes %>"><span><%= lngYes %></span></button>
		</div>
	</div>
	</div>
	</form>
<% end if %>
</div>
</div><!-- Close modular -->
<%
cor.str.wri cor.modbox.printBoxBottom
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Un-ban member (admin)
'
'------------------------------------------------------------------------------------------------------------------------------------------
case cor_cDoMemberUnban
call cor.tpl.header(lngMemberUnbanTitle,"")
cor.member.html.js()
cor.str.wri cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngMemberUnbanTitle&"</h4></div></div>"
%>
<div class="modular"><!-- Close modular -->
<div class="center">
<% if cor.member.io_mbanned = 0 Then %>
	<%= lngMemberUnbanned %>
<% else %>
	<form id="memberunban" name="membernban" class="soop" action="member_form.asp?mid=<%= cor.member.io_mid %>" method="post">
	<input type="hidden" name="do" value="<%= cor_cDoMemberUnban %>" />
	<input type="hidden" name="mid" value="<%= cor.member.io_mid %>" />
	<input type="hidden" name="mbanned" value="<%= cor.member.io_mbanned %>" />
	<%= lngMemberSureToUnban %> <b><%= cor.member.io_muser %></b> <%= iif(cor.member.io_mname<>"", "(" & cor.member.io_mname & ")", "") %>?
	<br /><br />
	<div class="buttonOuterWrap">
	<div Class="buttonInnerWrap">
		<div class="ui button">
			<button id="unbanmember" type="submit" name="unbanmember" value="<%= lngYes %>"><span><%= lngYes %></span></button>
		</div>
	</div>
	</div>
	</form>
<% end if %>
</div>
</div><!-- Close modular -->
<%
cor.str.wri cor.modbox.printBoxBottom
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' Delete member (admin)
'
'------------------------------------------------------------------------------------------------------------------------------------------
case cor_cDoMemberDelete
call cor.tpl.header(lngMemberDelete,"")
cor.member.html.js()
cor.str.wri cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngMemberDelete&"</h4></div></div>"
%>
<div class="modular"><!-- Close modular -->
<% if cor.member.io_mid = 0 Then
		response.write lngMemberDeleted
	else 

	%>
<div class="center">
<form id="deletemember" name="deletemember" class="soop" action="member_form.asp?mid=<%= cor.member.io_mid %>" method="post">
<input type="hidden" name="do" value="<%= cor_cDoMemberDelete %>" />
<input type="hidden" name="mid" value="<%= cor.member.io_mid %>" />
<input type="hidden" name="doYes" value="Yes" />
<%= lngMemberSureToDelete %> <b><%= cor.member.io_muser %></b> <%= iif(cor.member.io_mname<>"", "(" & cor.member.io_mname & ")", "") %>?
<br /><br />
<b><%= lngMemberSureToDeleteWarn %></b>
<br /><br />
<%= lngMemberNoPostsDeleteMsg %>
<br /><br />
<div class="buttonOuterWrap">
	<div Class="buttonInnerWrap">
		<div class="ui button">
			<button id="deletebtn" type="submit" name="deletebtn" value="<%= lngYes %>"><span><%= lngYes %></span></button>
		</div>
	</div>
</div>
</form>
</div
<% end if %>
</div><!-- Close modular -->
<%
cor.str.wri cor.modbox.printBoxBottom
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' display terms
'
'------------------------------------------------------------------------------------------------------------------------------------------
case cor_cDoMemberTerms
	Call cor.tpl.header(lngMemberNew,"")
	cor.member.html.js()
	cor.modbox.printBoxTop
	cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngMemberNew&"</h4></div></div>"
	cor.str.add "<div class=""modular""><!-- Open Modular -->"
	'Display the terms, as found in the languages folder.
	cor.str.add GetTerms
	'Display the Ok and Cancel buttons.- Centered
	cor.str.add "<div class=""buttonOuterWrap""><div class=""buttonInnerWrap"">"
	cor.str.add "	<div class=""ui button""><a href=""" & cor_sWebroot & "member_form.asp?do=" & cor_cDoMemberNew & "&#38;ter=1"" title=""" & lngOk & """><span><em class=""enabled-ico ico-sprt""></em>" & lngOk & "</span></a></div>"
	cor.str.add "	<div class=""ui button""><a href=""" & cor_sWebroot & """ title=""" & lngCancel & """><span><em class=""disabled-ico ico-sprt""></em>" & lngCancel & "</span></a></div>"
	cor.str.add "</div>"
	cor.str.add "</div></div>"
	'done.
	cor.str.wri cor.str.build
	cor.modbox.printBoxBottom
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
' unknown action
'
'------------------------------------------------------------------------------------------------------------------------------------------
case else
cor.str.wri cor.modbox.printBoxTop
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">"&lngUnknownActivity&"</h4></div></div>"
	cor.msg lngUnknownActivity
cor.str.wri cor.modbox.printBoxBottom
end select
end sub



function GetTerms
	'load the new user terms of agreement to show to user.
	'we are storing this file in the Languages folder, because multilingual sites may have multiple copies of the file.
	'It is stored as text so site admins can drop in their own file.
	dim strFilePath			:	strFilePath = server.mappath(cor_sWebroot &"core/languages/" & trim( cor_sLanguage) & ".RegistrationTerms.html")
	dim strText				:	strText = ""
	dim p_objReader
	call cor.obj.init("fso")
	set p_objReader = cor.obj.fso.openTextFile(strFilePath, 1, false)
	'read the file contents
	Do Until p_objReader.atEndOfStream
		strText = strText & p_objReader.ReadLine & vbcrlf
	Loop
	'clean up
	p_objReader.close
	set p_objReader = nothing
	'return results
	GetTerms = strText
end function
'
%>
