﻿<!--#include file="db/_soop_pageglobal.asp" -->
<!--#include file="common.asp" -->
<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
if NOT cor_bAdmin or NOT cor_bModerator Then cor.redir "./"

dim intDo
dim intID		:	intID	=	0
dim intPage
dim arrTemp
dim errorMsg
'
dim strModalClass
dim xIP			:	xIP			=	""
dim xDate		:	xDate		=	now()
dim xcomment	:	xComment 	= 	""
dim xEmail		:	xEmail		=	""
dim xDuration	:	xDuration	=	0

if cor_bPostback Then
	intID			= cor.filter.checkLng(cor.io.f("id"))
	xIP				= cor.filter.checkStr(cor.io.f("ip"))
	xDate			= cor.butil.cvUxTime(Now())
	xComment		= cor.filter.checkStr(cor.io.f("comment"))
	xEmail			= cor.filter.checkStr(cor.io.f("email"))
	xDuration		= cor.filter.checkInt(cor.io.f("duration"))
	intPage			= cor.filter.checkInt(cor.io.f("pg"))
	if instr(xEmail, "@") = 0 OR instr(xEmail, ".") = 0 then xEmail = ""	'valid emails include an @ and at least one . somewhere.
	if instr(xIP, ".") = 0 then xIP = ""									'valid ip address / range must have periods in it somewhere.
	if instr(xIP, "@") > 0 then xIP = ""									'valid IP addresses do not have email @ signs
	if len(xEmail) > 3 OR len(xIP) > 3 then
		select case cor.filter.checkInt(cor.io.f("do"))
			case cor_cDoNew
				cor_sql = "INSERT INTO " & cor_dbpre & "banlist (iip, idate, icomment, iemail, iduration) VALUES ({0},{1},{2},{3},{4})"
				cor.dal.exec cor_sql, array(xIP,xDate,xComment,xEmail,xDuration)
				cor.redir cor_sWebroot & "mgmt_bans.asp?rebuild=1&pg=" & intPage
			case cor_cDoEdit
				cor_sql = "UPDATE " & cor_dbpre & "banlist SET iip={1}, idate={2}, icomment={3}, iemail={4}, iduration={5} WHERE iid = {0}"
				cor.dal.exec cor_sql, array(intID,xIP,xDate,xComment,xEmail,xDuration)
				cor.redir cor_sWebroot & "mgmt_bans.asp?rebuild=1&pg=" & intPage
		end select
	end if
else ' if form not yet posted
	intDo	= cor.filter.checkInt(cor.io.q("do"))
	intPage	= cor.filter.checkInt(cor.io.q("pg"))
	intID	= cor.filter.checkLng(cor.io.q("id"))
	xIP		= cor.filter.checkstr(cor.io.q("ip"))
	xemail	= cor.filter.checkstr(cor.io.q("email"))
	select case intDo
		case cor_cDoEdit
			'--------------------0-------1---------2--------
			cor_sql = "SELECT iid, iip, idate, icomment, iemail, iduration FROM " & cor_dbpre & "banlist WHERE iid={0}" 
			cor.dal.open arrTemp, cor_sql, array(intID)
			if cor.butil.eof(arrTemp) Then cor.redir "./"
			xIP			= cor.filter.checkstr(arrTemp(1,0))
			xDate		= cor.butil.cvLcidTime(arrTemp(2,0))
			xEmail		= cor.filter.checkstr(arrTemp(3,0))
			xDuration	= cor.filter.checkInt(arrTemp(4,0))
		case cor_cDoDelete
			cor_sql = "DELETE FROM " & cor_dbpre & "banlist WHERE iid={0}"
			cor.dal.exec cor_sql, array(intID)
			cor.redir "mgmt_bans.asp?rebuild=1&pg=" & intPage
	end select
end if
'

call cor.tpl.init("mgmt")
call cor.tpl.header(lngMgmtBanIPTitle,"")
call mgmt_add()
call cor.tpl.footer()
call cor.off()


sub mgmt_add()
cor.modbox.printBoxTop
%>
<div id="mgmtBans" class="modular text">
<form action="mgmt_bansm.asp" class="soop" id="frmBans" name="frmBans" method="post">
<input type="hidden" id="do" name="do" value="<%= intDo %>" />
<input type="hidden" id="id" name="id" value="<%= intID %>" />
<input type="hidden" id="pg" name="pg" value="<%= intPage %>" />

<p><%= lngCompleteForm %></p>

<fieldset>
<legend><%= lngMgmtBanIPTitle %></legend>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label ico-sprt req-ico"><label for="ip"><%=lngMgmtBanIP%></label></li>
			<li class="input"><input type="text" id="ip" name="ip" size="15" value="<%= xIP %>" /><br />
			<em style="font-size:xx-small;"><%= lngMgmtBanIPNote %></em></li>
		</ul>
	</li>
	<li>
		<ul class="col">
			<li class="label ico-sprt req-ico"><label for="email"><%=lngMgmtBanEmail%></label></li>
			<li class="input"><input type="text" id="email" name="email" size="25" value="<%= xEmail %>" maxlength="200" /></li>
		</ul>
	</li>
	<li>
		<ul class="col">
			<li class="label ico-sprt req-ico"><label for="date"><%=lngMgmtBanDate%></label></li>
			<li class="input"><label for="date"><%= xDate %></label></li>
		</ul>
	</li>
	<li>
		<ul class="col">
			<li class="label ico-sprt req-ico"><label for="duration"><%=lngMgmtBanDuration%></label></li>
			<li class="input"><input type="text" id="duration" name="duration" size="8" value="<%= xDuration %>" /><br />
			<em><%= lngMgmtBanDurationNote %></em></li>
		</ul>
	</li>
	<li>
		<ul class="col textarea">
			<li class="label ico-sprt req-ico"><label for="comment"><%=lngMgmtBanComment%></label></li>
			<li class="input"><textarea id="comment" name="comment" rows="5"><%= xComment %></textarea><br /></li>
		</ul>
	</li>	
</ul>
</fieldset>

<%cor.str.wri "<div class=""buttonOuterWrap""><div class=""buttonInnerWrap"">"

if intDo = cor_cDoNew OR intDo = cor_cDoCopy Then
%>
		<div class="ui button"><button type="submit" id="Submit" name="Submit" value="<%=lngSaveChanges%>" onclick="parent.$.akModalHideAndRedirect('<%= cor_sWebroot %>mgmt_bans.asp');"><span><%=lngMgmtAddBan%></span></button></div>
<% else 'edit/copy %>
		<div class="ui button"><button type="submit" id="Submit" name="Submit" value="<%=lngSaveChanges%>" onclick="parent.$.akModalHideAndRedirect('<%= cor_sWebroot %>mgmt_bans.asp');"><span><%=lngMgmtUpdateBan%></span></button></div>

<% End If %>
		<div class="ui button"><button type=" button" id="Cancel" name="Cancel" value="<%=lngCancel%>" onclick="parent.$.akModalRemove();return false;"><span><%=lngCancel%></span></button></div>
</div></div>
</form>
</div>
<%
cor.modbox.printBoxBottom
end sub
%>
