﻿<!--#include file="db/_soop_pageglobal.asp" -->
<%
'-------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'-------------------------------------------------------------------------------------------------
%>
<!--#include file="common.asp" -->
<!--#include file="core/includes/inc_adovbsVars.asp"-->
<%
if NOT cor_bAdmin Then cor.redir "./"	'if user isn't an admin, kick back to default.asp
dim intDo	:	intDo = cor.filter.checkInt(cor.io.q("do"))
call cor.tpl.init("gh2")
call cor.tpl.header("SooP DB Maintenance Tools","")			'header and surrounding MOD boxes, CSS, javascripts etc...
cor.modbox.printBoxTop
	call Controller
cor.modbox.printBoxBottom
call cor.tpl.footer()								'closing MOD boxes and footer
call cor.off()
'
'===============================================================================
sub Controller
%>
	<div class="modular"><hr /><h2> Soop Database Maintenance Tools</h2>
	<div class="buttonOuterWrap"><div class="buttonInnerWrap">	
		<div class="ui button"><a href="mgmt_dbbackup.asp?do=1" title="backup">
			<span><i class="copy-ico ico-sprt"></i>Backup Database</span></a></div>
		<div class="ui button"><a href="mgmt_dbbackup.asp?do=2" title="restore">
			<span><i class="unsubscribe-ico ico-sprt"></i>Restore Database</span></a></div>
	</div></div>
	<div class="holder1"><!--<holder1>--><br />
<%
	select case intDo
	case 1
		select case lcase(cor_sDatabaseType)
		case "mssql"
			cor.str.wri "Sorry, Can't do it."
			'Backupmsdb
		case "mysql"
			cor.str.wri "Sorry, Can't do it."
			'Backupmydb
		case else
			compactdb
		end select
	case 2
		cor.str.wri "<strong>Restore functions not yet implemented.<br />Have a nice day!</strong><br />"
	case else
		cor.str.wri "Choose an option above."
		if lcase(cor_sDatabaseType) = "access" then
			cor.str.wri "<br /><em>(for Access Databases, Backup also Compacts the database, recovering unused space.)</em>"
		end if
	end select
	cor.str.wri "<br /><hr /></div></div>"
end sub

sub CompactDb
	'backup and compact an Access DB
	If lcase(cor_sDatabaseType) <> "access" Then	
		'Check to see if the user is using an access database
		cor.str.wri "This function only works on Access databaases"
		exit sub
	End If
	dim src		:	src = cor_sDbPathAndName
	dim des 	:	des = replace(cor_sDbPathAndName, ".mdb", "." & cor.butil.cvUxTime(Now) & ".mdb", 1, -1, 1)
	cor.str.wri "<ol>"
	'Step 1, make a backup.
	cor.str.wri "<li> Source Access database at <strong>" & src & "</strong><br />"
	Dim objFSO   		'Holds the FSO object
	Set objFSO = Server.CreateObject("Scripting.FileSystemObject")
	closedb		'make sure db isn't in use.
	objFSO.CopyFile src, des		'Back up the database
	cor.str.wri " backed up to <strong>" & des & "</strong>.</li>"
	'Step 2, prepare src for compacting
	Dim objJet  	'Holds the jet database engine object
	Set objJet = Server.CreateObject("JRO.JetEngine")
	dim cpt		:	cpt = replace(cor_sDbPathAndName, ".mdb", "_tmp.mdb", 1, -1, 1)
	dim strC	:	strC = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source="
	'step 3 Compact database
	if objFSO.FileExists(cpt) then		objFSO.DeleteFile cpt
	objJet.CompactDatabase strC & des, strC & cpt
	cor.str.wri "<li>Database compacted to temporary file.</li>"
 	Set objJet = Nothing	
	'step 4 Delete old database
	objFSO.DeleteFile src
	cor.str.wri "<li>Deleted original source database.</li>"
	'step 5 Rename temporary database to old name
	objFSO.MoveFile cpt, src
	cor.str.wri "<li>Renamed temporary (compacted) file to <strong>" & src & "</strong>.</li>"
	cor.str.wri"</ol><br /><strong>Done!</strong>"
	Set objFSO = Nothing
end sub
sub closeDB()
	'* if pooling disabled keep the same connection for whole page lifecycle
	'if NOT poolingEnabled Then exit sub
	if isObject(cor.dal.ado) Then ' connection reused by pooling
		if cor.dal.ado.state = cor_cStateOpen Then cor.dal.ado.close()
		'* obj=empty ensures it's being de-referenced to a plain variable, so isObject() could catch it
		'* set to nothing does not affect pooling [http://www.sql-server-performance.com/articles/per/asp_ado_pooling_p2.aspx]
		set cor.dal.ado = nothing :	cor.dal.ado = empty
	end if
end sub
sub BackupMSDB
	If lcase(cor_sDatabaseType) <> "mssql" Then	
		'Check to see if the user is using an access database
		cor.str.wri "This function does not work on Access databaases"
		exit sub
	End If
'	in theory, the BACKUP DATABASE script below could work.  However, the odds of that are pretty damn slim, since the server name is unlikely 
'	to be the same on a given ISP's LAN as it is on the internet.  Likewise, the www user isn't going to have write permissions on the server.
'	in other words, you can't get there from here.
'	other ideas?
'	I suppose we could go table by table and copy data from table X in src to table X in an Access db.
'	That seems DAMN ugly and pretty slow, but it could work.
	
	'	if cor_sCustomProvider = "" Then cor_sCustomProvider = "Provider=SQLOLEDB.1;"
	'	cor_sCon = cor_sCustomProvider & "Server=" & cor_sSQLServerName & 
	'	";User ID=" & cor_sSqlDbUserName & 
	'	";Password=" & cor_sSqlDbPassword & ";Database=" & cor_sSqlDbName
'	dim bcon, sql, dp
	'dp = "\\" & request.servervariables("SERVER_NAME") & "\"
	'dp = dp & server.mappath("db\")
'	set bcon = Server.CreateObject("ADODB.Connection")
'	bcon.Open cor_sCon
'	sql = "BACKUP DATABASE ["& cor_sSqlDbName &"] TO DISK = N'" & _
'		dp & "\msSQL." & cor.butil.cvUxTime(Now) & ".bak' " & _
'		" WITH NOFORMAT, NOINIT, NAME = N'backup', SKIP, NOREWIND, NOUNLOAD, STATS = 10"
'	bcon.Execute(sql)
'	response.write sql
end sub
%>