<!--#include file="db/_soop_pageglobal.asp" -->
<%
'-------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'-------------------------------------------------------------------------------------------------
%>
<!--#include file="common.asp" -->
<!--#include file="core/includes/inc_adovbsVars.asp"-->
<%
if NOT cor_bAdmin Then cor.redir "./"	'if user isn't an admin, kick back to default.asp
dim adoxconn, table, field, rsfields, strTable
dim key, col, stxt, cmd, param, xPK, xFK, FieldName, xi, FKName
dim PK(), FK()
dim Column
Set rsFields = Server.CreateObject("ADODB.Recordset")
rsFields.ActiveConnection = cor.dal.ado
call cor.tpl.init("mgmt")
call cor.tpl.header("SooP DB Schema","")			'header and surrounding MOD boxes, CSS, javascripts etc...
'-----------------------------------
''Use this line to execute SQL statements against the DB.
''	 (some risk to doing this, as there's no safety check to insure the SQL is valid)
'ExecSQL("/fk.sql")
'-----------------------------------
cor.str.wri "<hr />"
call MgmtDbSchema()		'								'content - via function
cor.str.wri "<hr /><br />"
call cor.tpl.footer()								'closing MOD boxes and footer
call cor.off()

sub MgmtDbSchema
	cor.str.wri "<h1>SooP Phoenix Database Schema</h1>"
	'cor.str.wri "<h2>Note, leaving this file active on your site represents a security risk.  Don't do it!</h2>"
	cor.str.wri "<p><strong>Bold</strong> text indicates Primary Keys (as does the <em>(PK)</em> flag).<br /></p>"
	cor.str.wri "<table>"
	'Show Database Schema!
	select case lcase(cor_sDatabaseType)
	case "access", "mssql"
		Set adoxConn = Server.CreateObject("adox.catalog")
		adoxConn.activeConnection = cor.dal.ado
		Set Table = adoxConn.Tables
		For Each Table In Table
			If UCase(Table.Type)="TABLE" Then	'not a system table.
				xPK = 0 	:	xFK = 0	:	redim PK(xPK)	:	redim FK(3, xFK)		'zero out keys
				strTable = Table.Name
				cor.str.wri "<tr><td colspan=""4""><h3>" & strTable & "</h3></td></tr>" & vbcrlf
				GetKeys(Table)		'Get primary and foreign keys!
				GetCols(Table)		'Get Columns!
			End If
		Next
		Set Table = Nothing
		Set adoxConn = Nothing
	end select
	cor.str.wri "</table>"
end sub

sub GetCols(byRef Table)
	'Get columns,compare to key data
	for each column in Table.columns
		Fieldname = column.Name
		'Is this a key of some kind?
		for xi = 0 to ubound (PK,1)							'Test PKs
			if lcase(column.Name) = lcase(pk(xi)) then			'this is a primary key col
				FieldName = "<strong>" & FieldName & " <em>(PK)</em></strong>" 
				exit for
			end if
		next
		FKName = "&nbsp;"
		for xi = 0 to ubound(fk,2)							'Test FKs
			if lcase(column.Name) = lcase(fk(0, xi)) then		'this is a foreign key col
				FKName = "<strong><em>FK [" & FK(2, xi) & ":</em> (" & fk(1, xi) & ")]</strong>"
				exit for
			end if
		next
		'output our results
		cor.str.wri "  <tr><td width=""30"">&nbsp;</td><td>" & Fieldname & "</td>" 
		select case cor_sDatabaseType
		case "Access"
			cor.str.wri  "<td>" & AccDataType(Column) & "</td>"
		case "MSSQL"
			cor.str.wri  "<td>" & MSDataType(Column) & "</td>"
		case else	'mysql
			cor.str.wri  "<td>" & MSDataType(Column) & "</td>"
		end select
		
		cor.str.wri "<td>" & FKName & "</td>"
		cor.str.wri "</tr>" & vbcrlf
	Next
end sub
sub GetKeys(byRef Table)
	for each key in table.keys	
		select case key.type
		case 1,3 						'Primary key
			select case cor_sDatabaseType
			case "Access"
				for each col in key.columns
					redim preserve PK(xPK + 1)
					PK(xPK) = col.name
					xPK = xPK + 1
				next
			case "MSSQL"
				setMSSQLpk(strTable)
			end select
		case 2 'FK
			for each col in key.columns
				redim preserve FK(3, (xFK + 1))
				FK(0, xFK) = col.Name
				FK(1, xFK) = key.RelatedTable & "." & Col.RelatedColumn
				FK(2, xFK) = key.Name
				xFK = xFK + 1
			next
		case else		'unknown key type!
			cor.str.wri "<tr><td colspan=""4""><em>" & table.Name & "." & col.Name & " : " & _
				key.relatedTable & "." & col.relatedcolumn & " (" & key.name & ")(" & key.type & ")</em></td></tr>"
		end select
	next
end sub
function MSDataType(byref Column)
	dim t, df, ns, p
	dim DataType
	t = cint(column.type)
	select case t
	case 0
		DataType = "No value!"
	case 2			'2 byte
		DataType = "SmallInt (" & column.Precision & "." & column.NumericScale & ")"
	case 3		 	'4 byte
		DataType = "Int (" & column.Precision & ")"		
	case 4
		DataType = "Single (" & column.Precision & "." & column.NumericScale & ")"
	case 5
		DataType = "Float (" & column.Precision & ")"	'." & column.NumericScale & ")"
	case 6
		DataType = "currency (" & column.Precision & "." & column.NumericScale & ")"
	case 7
		DataType = "Date since Jan 1 1901"
	case 8
		DataType = "varchar (" & column.DefinedSize & ")"
	case 9
		DataType = "COM!"
	case 10
		DataType = "32b err code"
	case 11
		DataType = "Boolean"
	case 12
		DataType = "Variant (" & column.DefinedSize & ")"
	case 13
		DataType = "COM!"
	case 14
		DataType = "Fixed numeric (" & column.Precision & "." & column.NumericScale & ")"	
	case 16
		DataType = "TinyInt(" & column.Precision & "." & column.NumericScale & ")"	 '1 byte
	case 17
		DataType = "TinyInt + (" & column.Precision & "." & column.NumericScale & ")"	 'unsigned
	case 18
		DataType = "SmallInt + (" & column.Precision & "." & column.NumericScale & ")"	 ' Unsigned 2 byte
	case 19
		DataType = "Int + (" & column.Precision & "." & column.NumericScale & ")"	
	case 20
		DataType = "BigInt (" & column.Precision & "." & column.NumericScale & ")"	 '8 bytes
	case 21
		DataType = "BigInt + (" & column.Precision & "." & column.NumericScale & ")"	 '8 byte unsigned
	case 64
		DataType = "File Time 100-ns intervals since jan 1 1601"
	case 72
		DataType = "GUID (" & column.DefinedSize & ")"
	case 128
		DataType = "binary"
	case 129
		DataType = "string (" & column.DefinedSize & ")"
	case 130
		DataType = "nVarChar (" & column.DefinedSize & ")"
	case 131
		DataType = "fixed numeric (" & column.Precision & "." & column.NumericScale & ")"
	case 132
		DataType = "User Defined (" & column.DefinedSize & ")"
	case 133
		DataType = "Date value"
	case 134
		DataType = "Time value"
	case 135
		DataType = "Date / Time stamp"
	case 136
		DataType = "4-byte chapter IDs child rows"
	case 138
		DataType = "Prop Variant (" & column.DefinedSize & ")"
	case 139
		DataType = "Numeric Var (" & column.Precision & "." & column.NumericScale & ")"	
	case 200
		DataType = "VarChar (" & column.DefinedSize & ")"
	case 201
		DataType = "Long VarChar (" & column.DefinedSize & ")"
	case 202
		DataType = "nVarChar (" & column.DefinedSize & ")"
	case 203
		DataType = "nVarChar (MAX)"	' (" & column.DefinedSize & ")"
	case 204
		DataType = "binary var (" & column.DefinedSize & ")"
	case 205
		DataType = "long binary var (" & column.DefinedSize & ")"
	case Else
		dataType = cstr(t) & " ?"
	end select 
	'attributes inclues adColNullable
	'properties includes "Autoincrement"
	MSDataType = DataType
end function

function AccDataType(byref Column)
	dim t, df, ns, p, datatype
	t = cint(column.type)
	select case t
	case 0
		DataType = "No value!"
	case 2			'2 byte
		DataType = "SmallInt (" & column.Precision & "." & column.NumericScale & ")"
	case 3		 	'4 byte
		DataType = "Long Int (" & column.Precision & ")"		
	case 4
		DataType = "single (" & column.Precision & "." & column.NumericScale & ")"
	case 5
		DataType = "Double (" & column.Precision & ")"
	case 6
		DataType = "currency (" & column.Precision & "." & column.NumericScale & ")"
	case 7
		DataType = "Date since Jan 1 1901"
	case 8
		DataType = "varchar (" & column.DefinedSize & ")"
	case 9
		DataType = "COM!"
	case 10
		DataType = "32b err code"
	case 11
		DataType = "Boolean"
	case 12
		DataType = "Variant (" & column.DefinedSize & ")"
	case 13
		DataType = "COM!"
	case 14
		DataType = "Fixed numeric (" & column.Precision & "." & column.NumericScale & ")"	
	case 16
		DataType = "TinyInt(" & column.Precision & "." & column.NumericScale & ")"	 '1 byte
	case 17
		DataType = "TinyInt + (" & column.Precision & "." & column.NumericScale & ")"	 'unsigned
	case 18
		DataType = "SmallInt + (" & column.Precision & "." & column.NumericScale & ")"	 ' Unsigned 2 byte
	case 19
		DataType = "Int + (" & column.Precision & "." & column.NumericScale & ")"	
	case 20
		DataType = "BigInt (" & column.Precision & "." & column.NumericScale & ")"	 '8 bytes
	case 21
		DataType = "BigInt + (" & column.Precision & "." & column.NumericScale & ")"	 '8 byte unsigned
	case 64
		DataType = "File Time 100-ns intervals since jan 1 1601"
	case 72
		DataType = "GUID (" & column.DefinedSize & ")"
	case 128
		DataType = "binary"
	case 129
		DataType = "string (" & column.DefinedSize & ")"
	case 130
		DataType = "nVarChar (" & column.DefinedSize & ")"
	case 131
		DataType = "fixed numeric (" & column.Precision & "." & column.NumericScale & ")"
	case 132
		DataType = "User Defined (" & column.DefinedSize & ")"
	case 133
		DataType = "Date value"
	case 134
		DataType = "Time value"
	case 135
		DataType = "Date / Time stamp"
	case 136
		DataType = "4-byte chapter IDs child rows"
	case 138
		DataType = "Prop Variant (" & column.DefinedSize & ")"
	case 139
		DataType = "Numeric Var (" & column.Precision & "." & column.NumericScale & ")"	
	case 200
		DataType = "VarChar (" & column.DefinedSize & ")"
	case 201
		DataType = "Long VarChar (" & column.DefinedSize & ")"
	case 202 'nVarChar
		DataType = "Text (" & column.DefinedSize & ")"
	case 203
		DataType = "Memo"	' (" & column.DefinedSize & ")"
	case 204
		DataType = "binary var (" & column.DefinedSize & ")"
	case 205
		DataType = "long binary var (" & column.DefinedSize & ")"
	case Else
		dataType = cstr(t) & " ?"
	end select 
	if column.properties("Autoincrement") = True then DataType = Datatype & " (AutoNumber)"
	AccDataType = DataType
end function
sub ExecSQL(fname)
	on error resume next
 	set cmd = server.createobject("ADODB.Command")
	cmd.activeConnection = cor.dal.ado
	dim objFSO, objFile, objFTS,  r
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	set objFile = objFSO.GetFile(server.mappath(fname))
	set objFTS = objFile.OpenAsTextStream()
	cmd.commandtype = adCmdText
	do while objFTS.AtEndOfStream <> True
		cmd.CommandText = objFTS.readline
		cmd.Execute r
	loop
	objFTS.close
	set objFTS = nothing
	set objFile = nothing
	set objFSO = nothing
'	'intQAID = right(qaid, len(qaid) - 1)
'	
'	cmd.commandtext = "update AnswerSum set Sumvalue = sumvalue + 1 where qaid = " & qAID 
'	cmd.Execute r
end sub
sub setMsSQLpk(strTable)
	dim msSQL
	msSql = "SELECT  K.COLUMN_NAME, k.ORDINAL_POSITION  " & _
			"  FROM  INFORMATION_SCHEMA.TABLE_CONSTRAINTS T " & _
			" INNER JOIN   INFORMATION_SCHEMA.KEY_COLUMN_USAGE K ON T.CONSTRAINT_NAME = K.CONSTRAINT_NAME  " & _
			" WHERE T.CONSTRAINT_TYPE = 'PRIMARY KEY'  " & _
			"   AND T.TABLE_NAME = '" & strTable & "' " & _
			" ORDER BY K.ORDINAL_POSITION "
		rsFields.Source = msSql 
        rsFields.CursorType = 0
        rsFields.CursorLocation = 2
        rsFields.LockType = 1
        rsFields.Open()
        if rsfields.eof and rsfields.bof then
			'no pk!
		else
			rsfields.movefirst
			'response.write "<tr><td colspan=""3""><em>" 
			do until rsfields.eof
				redim preserve PK(xPK + 1)
				PK(xPK) = rsFields(0)
				xPK = xPK + 1		
				'response.write strTable & "." & rsFields(0) & " " 
				rsfields.movenext
			loop
			'response.write " (PK)</em></td></tr>" & vbcrlf
        end if
		rsfields.close
end sub
%>
