<%
Sub SaveSettings
	'******** Save values to file
	Dim strSettings, strPath
	cor.str.add "<" & "%"
	cor.str.add "'***************************************************************************************"
	cor.str.add "'*          __  __   __   __      o  __    __ _|_   __  |   |    ___   __              *"
	cor.str.add "'*        __)  (__) (__) |__)     | |  ) __)   |_, (__( |_, |_, (__/_ |  '             *"
	cor.str.add "'*                       |                                                             *"
	cor.str.add "'***************************************************************************************"
	cor.str.add "'*                                                                                     *"
	cor.str.add "'*        File Created with Soop Portal Phoenix Installer V1.0a                        *"
	cor.str.add "'*         Authors: Steve Podmore aka ph4nt0m , Brian aka Hooded, Charles aka Cadius   *"
	cor.str.add "'*         Based on Soop Setings file Creator by Hooded                                *"
	cor.str.add "'*         Configuration file written " & now & "                           *"
	cor.str.add "'*                                                                                     *"
	cor.str.add "'***************************************************************************************"
	cor.str.add "'"
	cor.str.add "'--------------------------------------------------------------------------------"
	cor.str.add "' Basic Configuration"
	cor.str.add "'"
	cor.str.add "'--- LCID where your site is hosted"
	cor.str.add "const cor_cGlobalLCID           = " & cor.io.f("slcid")
	cor.str.add "'"
	cor.str.add "'--- LCID to be used if your server LCID is a different language. i.e Dutch, Spanish etc."
	cor.str.add "const cor_cCalendarLCID         = " & cor.io.f("glcid")
	cor.str.add "'"
	cor.str.add "'--- html direction for support of RTL/LTR languages"
	cor.str.add "cor_sHtmlDir                    = """ & cor.io.f("htmldir") & """"
	cor.str.add "'"
	cor.str.add "'--- SooPPortal root folder "
	cor.str.add "const cor_sWebroot              = """ & cor.io.f("webroot") & """"
	cor.str.add "'"
	cor.str.add "'--- Protocol being used for this Portal"
	cor.str.add "cor_sServerProtocol             = """ & cor.io.f("protocol") & """"
	cor.str.add "'"
	cor.str.add "'--- IIS version number ""major.minor"" this site is hosted"
	cor.str.add "const cor_iIISver               = """ & cor.io.f("iissrev") & """"
	cor.str.add "'"
	cor.str.add "'--------------------------------------------------------------------------------"
	cor.str.add "' Database Configuration"
	cor.str.add "'"
	Session("webaddress") = Replace(Session("webaddress"), "http://", "", 1, -1, 1)
	Session("webaddress") = Replace(Session("webaddress"), "https://", "", 1, -1, 1)

	cor.str.add "'--- type of database used (Access - MSSQL - mysql)"
	If Session("databasetype") = "mssql2000" Then Session("databasetype") = "mssql"
	If Session("databasetype") = "mssql2005" Then Session("databasetype") = "mssql"
	If Session("databasetype") = "mssql2008" Then 
		Session("databasetype") = "mssql"
		Session("sqlsvrcustom") = "Provider=SQLNCLI10;"
	End If
	If Session("databasetype") = "mysql351" Then Session("databasetype") = "mysql"
	If Session("databasetype") = "mysql51" Then
		Session("databasetype") = "mysql"
		Session("sqlsvrcustom") = "Driver={MySQL ODBC 5.1 Driver};SET CHARACTER SET utf8;"
	End If
	cor.str.add "' Database table prefix:"
	cor.str.add "cor_dbpre                       = """ & Session("dbprefix") & """ "
	cor.str.add "' Database engine: "
	cor.str.add "cor_sDatabaseType               = """ & Session("databasetype") & """"
	If Session("databasetype") = "access" Then
		cor.str.add "' MS Access-only parameters"
		cor.str.add "'--- Database file path (MS-Access only)"
		cor.str.add "cor_sDbPathAndName              = """ & Session("sqlpathname") & """"
	Else
		cor.str.add "' MS Sql and MySQL parameters"
		cor.str.add "'--- Instance name of the DB Server"
		cor.str.add "cor_sSQLServerName              = """ & Session("sqlsvrname") & """"
		cor.str.add "'--- Database name on the Server"
		cor.str.add "cor_sSqlDbName                  = """ & Session("sqldbname") & """"
		cor.str.add "'--- User name (usually 'sa' or 'root')"
		cor.str.add "cor_sSqlDbUserName              = """ & Session("sqldbuser") & """"
		cor.str.add "'--- Password (for SQL Server Authentication)"
		cor.str.add "cor_sSqlDbPassword              = """ & Session("sqldbpass") & """"
		if session("databasetype") = "mysql" then
			cor.str.add "'--- MySQL Database port:"
			cor.str.add "cor_iMySqlPort                  = " & Session("mysqlport")
		end if	
	End If
	cor.str.add "'"
	cor.str.add "'-------------------------------------------------------------------------------------------------------"
	cor.str.add "'--- path to save logs files"
	cor.str.add "cor_sLogsPath                   = """ & cor.io.f("svrlogpath") & """"
	cor.str.add "'--- default Cookie prefix"
	cor.str.add "cor_sCookieName                 = """ & cor.io.f("srvcookiename") & """"
	cor.str.add "'--- default Application/Session variables prefix"
	cor.str.add "cor_pre                         = """ & cor.io.f("svrprefix") & """"
	cor.str.add "'--- custom connection string (empty to use default)"
	cor.str.add "cor_sCustomProvider             = """ & Session("sqlsvrcustom") & """"
	cor.str.add "'"
	cor.str.add "'-------------------------------------------------------------------------------------------------------"
	cor.str.add "' Plugin editor"
	cor.str.add "'"
	cor.str.add "cor_bUseRichEditor              = " & iif(cor.io.f("userteyes")="true","true","false")
	cor.str.add "cor_bTinyMCE                    = " & iif(cor.io.f("rtetype")="tinymce","true","false")
	cor.str.add "'NOT AVAILABLE: cor_bFCK        = " & iif(cor.io.f("rtetype")="RTE","true","false")
	cor.str.add "'NOT AVAILABLE: cor_bRTE        = " & iif(cor.io.f("rtetype")="FCK","true","false")
	cor.str.add "'--- Calendar: start of the week"
	cor.str.add "const cor_cWeekStart            = " & cor.io.f("weekstart")
	cor.str.add "cor_iDateFormat                 = 7 "
	cor.str.add "'"
	cor.str.add "'------------------------------------------------------------------------"
	cor.str.add "' Advanced Configuration"
	cor.str.add "'"
	cor.str.add "'--- enable/disable connection pooling"
	cor.str.add "const cor_cEnableConnectionPooling  = " & iif(cor.io.f("dbconnectionpooling")="true","true","false")
	cor.str.add "'"
	cor.str.add "'********************************************************"
	cor.str.add "' Appl vars cache types (when changed should also reset application pool for them to take effect)"
	cor.str.add "'"
	cor.str.add "'--- enable/disable cache of some common queries"
	cor.str.add "const cor_cUseSysCache          = " & iif(cor.io.f("usesyscache")="true","true","false")
	cor.str.add "'"
	cor.str.add "'--- enable/disable cache of language files"
	cor.str.add "const cor_cUseLangCache         = " & iif(cor.io.f("uselangcache")="true","true","false")
	cor.str.add "'"
	cor.str.add "'--- enable/disable cache of menus"
	cor.str.add "const cor_cUseMenuCache         = " & iif(cor.io.f("usemenucache")="true","true","false")
	cor.str.add "'"
	cor.str.add "'********************************************************"
	cor.str.add "'"
	cor.str.add "'--- enable/disable SqlShield for all request.form/querystring requests"
	cor.str.add "const cor_cUseSqlShield         = " & iif(cor.io.f("useSqlShield")="true","true","false")
	cor.str.add "'"
	cor.str.add "'--- enable/disable referrer header protection (i.e. protect against posts from other domains)"
	cor.str.add "const cor_bEnableRefer          = " & iif(cor.io.f("enablerefer")="true","true","false")
	cor.str.add "'"
	cor.str.add "'--- enable/disable email sender"
	cor.str.add "const cor_cEmailSender          = " &iif( cor.io.f("emailsend")="true","true","false")
	cor.str.add "'"
	cor.str.add "'--- enable/disable built-in auditing"
	cor.str.add "cor_bEnableAudit                = " & iif(cor.io.f("enableaudit")="true","true","false")
	cor.str.add "'"
	cor.str.add "'--- enable/disable built-in debugging"
	cor.str.add "cor_bEnableDebug                = " & iif(cor.io.f("debugging")="true","true","false")
	cor.str.add "'"
	cor.str.add "cor_bUseW3                      = " & iif(cor.io.f("usew3")="true","true","false")
	cor.str.add "'"
'	cor.str.add "'--- enable/disable browser checker"
'	cor.str.add "cor_bBrowserChecker             = " & iif(cor.io.f("browserchecker")="true","true","false")
'	cor.str.add "' 		check browsers up to version"
'	cor.str.add "cor_iUpToBrowserVersion         = " & cor.io.f("browserver")
'	cor.str.add "'"
	cor.str.add "'--- min/max allowed length of passwords"
	cor.str.add "const cor_cMinPassLen           = " & cor.io.f("passmin")
	cor.str.add "const cor_cMaxPassLen           = " & cor.io.f("passmax")
	cor.str.add "'"
	cor.str.add "'--- check for default IIS post allowances"
	cor.str.add "const cor_bMaxPostSzIIS         = " & iif(cor.io.f("maxpostsz")="true","true","false")
	cor.str.add "'"
	cor.str.add "'--- max size allowed for any (text) posts"
	cor.str.add "cor_lPostMaxSymbols             = " & cor.io.f("maxpostsymbols")
	cor.str.add "'"
	cor.str.add "'--- max size allowed for any (text) posts"
	cor.str.add "cor_lUploadSizeImage            = " & cor.io.f("szimage")
	cor.str.add "cor_lUploadSizeMedia            = " & cor.io.f("szmedia")
	cor.str.add "cor_lUploadSizeFile             = " & cor.io.f("szfile")
	cor.str.add "cor_lUploadSizeMisc             = " & cor.io.f("szmisc")
	cor.str.add "cor_lUploadTypesImage           = """ & cor.io.f("imgtype") & """"
	cor.str.add "cor_lUploadTypesMedia           = """ & cor.io.f("mediatype") & """"
	cor.str.add "cor_lUploadTypesFile            = """ & cor.io.f("filetype") & """"
	cor.str.add "cor_lUploadTypesMisc            = """ & cor.io.f("misctype") & """"
	cor.str.add "'"
	cor.str.add "server.scriptTimeout            = " & cor.io.f("scripttimeout")
	cor.str.add "session.timeout                 = " & cor.io.f("sessiontimeout")
	cor.str.add "'"
	cor.str.add "cor_bCached                     = " & iif(cor.io.f("bcache")="true","true","false")
	cor.str.add "cor_sAuditFile                  = """ & cor.io.f("audit") & """"
	cor.str.add "'"
	cor.str.add "'--- show in footer additional information"
	cor.str.add "const cor_cShowProcessInfo      = " & iif(cor.io.f("showprocessinfo")="true","true","false")
	cor.str.add "const cor_cShowSoopIcons        = " & iif(cor.io.f("showsoopicons")="true","true","false")
	cor.str.add "'"
	cor.str.add "'--- page title subsection delimiter"
	cor.str.add "cor_sTitleDelim                 = """ & cor.io.f("titledelim") & """"
	cor.str.add "'"
	cor.str.add "'--- # of characters in captcha check images "
	cor.str.add "cor_iCaptchaLength              = 6 "

	strSettings = cor.str.build
	strPath = Replace(cor.io.f("webroot") & "db/", "/", "\")
	call writeSoopSettings(strSettings,"_soop_settings.asp", strPath)
	strSettings = ""
	strPath = ""
	cor.redir "soopsetup.asp?sec=3"
End Sub

sub writeSoopSettings(lines, filename, filepath)
	dim myFile,sMsg,settingPath
	'
	'if NOT cor_bEnableAudit then exit sub
	call cor.obj.init("fso")
	settingPath = Server.MapPath(filepath)
	if cor.obj.fso.fileExists(settingpath & "\" & filename) then
		cor.obj.fso.movefile settingpath & "\" & filename, settingPath & "\" & filename & "." & cor.butil.cvUxTime(Now)
	end if
	set myFile = cor.obj.fso.CreateTextFile(settingPath & "\" & filename, true,0)
	myFile.writeline(lines) 
	If InStr(filename, ".asp") > 0 Then
		myFile.write "%"
		myFile.write ">"
	End If
	myFile.close
	set myFile = nothing
End Sub

%>