﻿<%@ codepage = 65001 %>
<% option explicit %>
<!--#include file="core/includes/inc_globalVariables.asp"-->
<!--#include file="core/includes/inc_globalConstants.asp"-->
<!--#include file="db/_soop_setup_status.asp" -->
<!--#include file="core/classes/class_string.asp"-->
<!--#include file="core/classes/class_baseUtils.asp"-->
<!--#include file="core/classes/class_filters.asp"-->
<!--#include file="core/classes/class_dal.asp" -->
<!--#include file="core/classes/class_objectsPool.asp"-->
<!--#include file="core/classes/class_languageParser.asp" -->
<!--#include file="core/classes/class_io.asp" -->
<!--#include file="core/classes/class_configHandler.asp"-->
<!--#include file="core/classes/class_combobuilder.asp"-->
<!--#include file="core/classes/class_permissions.asp" -->
<!--#include file="core/classes/class_Utils.asp"-->
<!--#include file="core/classes/class_login.asp" -->
<!--#include file="core/classes/class_sha256.asp" -->
<!--#include file="setup/setup_boot.asp" -->
<!--#include file="setup/setup_options.asp" -->
<!--#include file="setup/setup_files.asp" -->
<!--#include file="setup/setup_subs.asp" -->
<!--#include file="setup/setup_Functions.asp" -->
<!--#include file="setup/setup_step1.asp" -->
<!--#include file="setup/setup_step2.asp" -->
<!--#include file="setup/setup_step3.asp" -->
<!--#include file="setup/setup_step4.asp" -->
<!--#include file="setup/setup_stepE.asp" -->
<%
'---------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'---------------------------------------------------------------------------------------
'
' Soop Portal Phoenix Installer v1.0a
' Author: Steve Podmore aka ph4nt0m, Brian aka Hooded, Charles aka Cadius
' Based on original idea from Brian aka Hooded
' Much code pilfered from the excellent GeckoInstaller By Dan Bodenstein
'---------------------------------------------------------------------------------------
if cor_sSetupComplete = True then RESPONSE.redirect("default.asp")	'Seup has been completed, we should not be here.
'--- SooPPortal root folder
Dim cor_sWebroot, cor_cUseMenuCache
cor_sWebroot= Replace(lcase(Request.ServerVariables("SCRIPT_NAME")),"soopsetup.asp","")
' Appl vars cache types (when changed should also reset application pool to take them effect)

const cor_cUseSysCache	= false		'--- enable/disable cache of some common queries
const cor_cUseLangCache	= false		'--- enable/disable cache of language files
Const cor_bEnableRefer	= True		'--- enable/disable referrer header protection (posts from other domains)
Const cor_cEmailSender	= true		'--- enable/disable email sender
cor_bEnableAudit		= False		'--- enable/disable built-in auditing
cor_bEnableDebug		= True		'--- enable/disable built-in debugging
cor_bUseW3 				= False		'--- set to true if your domain uses www
'cor_bBrowserChecker	= false		'--- enable/disable browser checker
cor_iUpToBrowserVersion = 10		'--- check browsers up to version
const cor_cMinPassLen	= 2			'--- min/max allowed length of passwords
const cor_cMaxPassLen	= 30
server.scriptTimeout	= 90
session.timeout			= 20
cor_sTitleDelim			= " - "		'--- page title subsection delimiter
if cdbl(Right(Request.ServerVariables("SERVER_SOFTWARE"),3))>= 5 then	'--- IIS 5.1+ required
	response.codepage	= 65001
else
	session.CodePage	= 65001
end if
Dim strStep
response.charset	= "utf-8"
response.buffer		= true
cor_sCharset		= "utf-8"
response.write cor_cPageDocType
set cor = new class_boot

cor.boot()

If lcase(request.serverVariables("REQUEST_METHOD")) = "post" And cor.io.f("setupp") = "1" Then Call saveCon
If lcase(request.serverVariables("REQUEST_METHOD")) = "post" And cor.io.f("setupp") = "1b" Then Call StartInstall(session("sFile"),false)
If lcase(request.serverVariables("REQUEST_METHOD")) = "post" And cor.io.f("setupp") = "rmv" Then Call StartInstall(session("sFile"),true)
If lcase(request.serverVariables("REQUEST_METHOD")) = "post" And cor.io.f("setupp") = "2" Then Call SaveSettings
If lcase(request.serverVariables("REQUEST_METHOD")) = "post" And cor.io.f("setupp") = "3" Then Call SaveConfig
If lcase(request.serverVariables("REQUEST_METHOD")) = "post" And cor.io.f("setupp") = "sd" Then Call savedbsettings
If lcase(request.serverVariables("REQUEST_METHOD")) = "post" And cor.io.f("setupp") = "tc" Then Call testCon(cor.io.f("databasetypef"))

cor.lng.start("english")
cor.lng.includeSection ("cor_xmlCore,cor_xmlSetup")

If cor.io.q("sec") <> "" Then  strStep = "Step " & cor.io.q("sec")
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<title><%= cor.util.pageTitle("Soop Portal Phoenix Installation "& strStep,"" ) %></title>
	<link rel="STYLESHEET" type="text/css" href="setup/setup.css">
	<script src="core/jscss/jquery-1.3.2.min.js" type="text/javascript"></script>
	<script src="core/jscss/jquery.validate.js" type="text/javascript"></script>
	<script src="core/jscss/jquery.plugins.js" type="text/javascript"></script>
	<script src="setup/setup.js" type="text/javascript"></script>
</head>
<body id="oneCol">
<div id="Wrapper">
<div id="innerWrapper">
<%
	dim inPagehtt		: inPagehtt = split(lcase(Request.ServerVariables("SERVER_PROTOCOL")),"/")
	dim inPageSrcURL	: inPageSrcURL =  inPagehtt(0) & "://" & Request.ServerVariables("HTTP_HOST") & Request.ServerVariables("PATH_INFO")
	dim strPath			: strPath = Replace(cor.io.f("webroot") & "db/", "/", "\")
	Dim arrayInstalls, intLoop, strIniFile, pi
	Dim oCombo,arLCID,i,arID
	Dim strPart			: strPart = cor.io.q("sec")
	if isnull(strPart) or isEmpty(strPart) or len(strPart) < 1 then strPart = "0"
	for pi = len(inpageSrcURL) to 1 step -1
		if mid(inPageSrcURL, pi, 1) = "/" then
			inPageSrcURL = left(inPageSrcURL, pi)
			exit for
		end if
	next
	Select Case strPart
		Case "1"
			doStep1
		Case "1b"
			doStep1b
		Case "2"
			DoStep2
		Case "3"
			doStep3
		case "4"
			doStep4
		Case Else
			doStepElse
	End Select
%>
</div>
</div>
</body>
</html>
<%
set cor = Nothing
%>
