﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_banners
	public	banner_id
	public	bannerzone_id
	public	bannertype_id
	public	banner_title
	public	banner_url
	public	bannerimage_url
	public	banner_url_target
	public	banner_enabled
	public	banner_startdate
	public	banner_enddate
	public	banner_html
	public	bannerzone
	public	bannerzone_enabled
	public	bannertype
	public	bannertype_enabled
	public	banner_impressions
	public	banner_hits
	Public	banner_kind	'1 image, 2 html, 4 javascript
	public	actiontype	'1 = banners, 2 = bannertypes, 3 = bannerzones
	public	actioncmd	'1 = create, 2 = edit, 3 = Copy, 4 = delete
	private sMsg
	private p_sql
	'cvUxTime (to unix) cvLcidTime (from unix)


	private sub class_initialize()
		banner_url_target	= "_blank"
		ClearValues
	end sub
	'
	private sub class_terminate()
		banner_url_target	= Empty
		ClearValues
	end sub

	private sub ClearValues
		banner_id			= 0
		bannerzone_id		= 0
		bannertype_id		= 0
		banner_title		= Empty
		banner_url			= 0
		bannerimage_url		= 0
		banner_enabled		= 0
		banner_startdate	= Empty
		banner_enddate		= Empty
		banner_html			= Empty
		bannerzone			= Empty
		bannerzone_enabled	= 0
		bannertype			= Empty
		bannertype_enabled	= 0
	end sub

	public sub init_io()
		if cor_bPostback then
			actioncmd = cor.filter.checkInt(cor.io.f("do"))
			actiontype = cor.filter.checkInt(cor.io.f("btype"))
			bannertype_id = cor.filter.checkInt(cor.io.f("id"))
			bannerzone_id = cor.filter.checkInt(cor.io.f("id"))
			select case actiontype
				case 1, 4
					if actioncmd = cor_cDoEdit then banner_id = cor.filter.checkInt(cor.io.f("id"))
					banner_title 		= cor.util.textField(cor.io.f("bannertitle"))
					bannerzone_id		= cor.filter.checkInt(cor.io.f("zoneid"))
					bannertype_id		= cor.filter.checkInt(cor.io.f("typeid"))
					banner_enabled		= cor.filter.checkInt(cor.io.f("bannerenabled"))
					banner_startdate	= cor.butil.cvUxTime(cor.io.f("bannerstart"))
					banner_enddate		= cor.butil.cvUxTime(cor.io.f("bannerend"))
					banner_url			= cor.util.linkField(cor.io.f("bannerlinkurl"))
					bannerimage_url		= cor.util.linkField(cor.io.f("bannerimageurl"))
					banner_url_target	= cor.util.textField(cor.io.f("bannertarget"))
					banner_kind			= cor.filter.checkInt(cor.io.f("bannerkind"))
					banner_html 		= cor.filter.clnEditor(cor.io.f_rtf("bannerhtml"))
				case 2
					if actioncmd 		= cor_cDoEdit then bannertype_id = cor.filter.checkInt(cor.io.f("id"))
					bannertype			= cor.util.textField(cor.io.f("bannertype"))
					bannertype_enabled	= cor.filter.checkInt(cor.io.f("bannertypeenabled"))
				case 3
					if actioncmd 		= cor_cDoEdit then bannerzone_id = cor.filter.checkInt(cor.io.f("id"))
					bannerzone			= cor.util.textField(cor.io.f("bannerzone"))
					bannerzone_enabled	= cor.filter.checkInt(cor.io.f("bannerzoneenabled"))
				case else
				'
			end select
		Else
			actioncmd = cor.filter.checkInt(cor.io.q("do"))
			actiontype = cor.filter.checkInt(cor.io.q("t"))
			banner_id = cor.filter.checkInt(cor.io.q("id"))
			bannertype_id = cor.filter.checkInt(cor.io.q("id"))
			bannerzone_id = cor.filter.checkInt(cor.io.q("id"))
			banner_kind =  cor.filter.checkInt(cor.io.q("k"))
		end if
	end sub

public sub controller()
		'if cor_bPostback then
			select case actioncmd
				case cor_cDoNew
					If actiontype = 1 Then
						Call addBanner()
					elseif actiontype = 2 then 
						call addBannerType()
					elseif actiontype = 3 then 
						call addBannerZone()
					ElseIf actiontype = 4 Then
						Call addBanner()
					else
						'
					end if
				case cor_cDoEdit
					If actiontype = 1 then
						Call editBanner()
					elseif actiontype = 2 then 
						call editBannerType()
					elseif actiontype = 3 then 
						call editBannerZone()
					ElseIf actiontype = 4 then
						Call editBanner()
					else
						'
					end if
				case cor_cDoDelete
					If actiontype = 1 then
						Call deleteBanner()
					elseif actiontype = 2 then 
						call deleteBannerType()
					elseif actiontype = 3 then 
						call deleteBannerZone()
					ElseIf actiontype = 4 then
						Call deleteBanner()
					else
						'
					end if
				case else
					'
			end select
		'end if
	end sub

	private sub addBanner()
		if banner_kind = 1 then 'image banner
			p_sql = "INSERT INTO " & cor_dbpre & "banners " _
				& "(Banner_Title,Banner_Pic_URL,Banner_URL,Banner_Target,BannerZone_ID,BannerType_ID,BannerEnabled,Banner_StartDate,Banner_EndDate)" _
				& " VALUES ({0},{1},{2},{3},{4},{5},{6},{7},{8})"
				cor.dal.exec p_sql, array(banner_title,bannerimage_url,banner_url,banner_url_target,bannerzone_id,bannertype_id,banner_enabled,banner_startdate,banner_enddate)
		ElseIf banner_kind = 2 then 'html banner
			p_sql = "INSERT INTO " & cor_dbpre & "banners " _
				& "(Banner_Title,BannerZone_ID,BannerType_ID,BannerEnabled,Banner_Html,Banner_StartDate,Banner_EndDate)" _
				& " VALUES ({0},{1},{2},{3},{4},{5},{6})"
				cor.dal.exec p_sql, array(banner_title,bannerzone_id,bannertype_id,banner_enabled,banner_html,banner_startdate,banner_enddate)
		ElseIf banner_kind = 3 then 'html banner
			p_sql = "INSERT INTO " & cor_dbpre & "banners " _
				& "(Banner_Title,BannerZone_ID,BannerType_ID,BannerEnabled,Banner_Html,Banner_StartDate,Banner_EndDate)" _
				& " VALUES ({0},{1},{2},{3},{4},{5},{6})"
				cor.dal.exec p_sql, array(banner_title,bannerzone_id,bannertype_id,banner_enabled,banner_html,banner_startdate,banner_enddate)
		ElseIf banner_kind = 4 then 'javascript banner
			p_sql = "INSERT INTO " & cor_dbpre & "banners " _
				& "(Banner_Title,BannerZone_ID,BannerType_ID,BannerEnabled,Banner_Html,Banner_StartDate,Banner_EndDate)" _
				& " VALUES ({0},{1},{2},{3},{4},{5},{6})"
				cor.dal.exec p_sql, array(banner_title,bannerzone_id,bannertype_id,banner_enabled,banner_html,banner_startdate,banner_enddate)
		end if
	end sub
	
	private sub addBannerType()
		p_sql = "INSERT INTO " & cor_dbpre & "bannertypes (BannerType,BannerTypeEnabled) VALUES ({0},{1})"
		cor.dal.exec p_sql, array(bannertype,bannertype_enabled) 
	end sub
	
	private sub addBannerZone()
		p_sql = "INSERT INTO " & cor_dbpre & "bannerzones (BannerZone,BannerZoneEnabled) VALUES ({0},{1})"
		cor.dal.exec p_sql, array(bannerzone,bannerzone_enabled) 
	end sub
	
	private sub editBanner()
		if banner_kind = 1 then 'image banner
			p_sql = "UPDATE " & cor_dbpre & "banners SET Banner_Title={0},Banner_Pic_URL={1},Banner_URL={2},Banner_Target={3},BannerZone_ID={4}," _
				& "BannerType_ID={5},BannerEnabled={6},Banner_StartDate={7},Banner_EndDate={8}" _
				& " WHERE Banner_ID={9}"
			cor.dal.exec p_sql, array(banner_title,bannerimage_url,banner_url,banner_url_target,bannerzone_id,bannertype_id,banner_enabled,banner_startdate,banner_enddate,banner_id)
		ElseIf banner_kind = 2 then 'html banner
			p_sql = "UPDATE " & cor_dbpre & "banners SET Banner_Title={0},BannerZone_ID={1},BannerType_ID={2},BannerEnabled={3},Banner_Html={4}," _
				& "Banner_StartDate={5},Banner_EndDate={6} WHERE Banner_ID={7}"
			cor.dal.exec p_sql, array(banner_title,bannerzone_id,bannertype_id,banner_enabled,banner_html,banner_startdate,banner_enddate,banner_id)
		ElseIf banner_kind = 3 then 'html banner
			p_sql = "UPDATE " & cor_dbpre & "banners SET Banner_Title={0},BannerZone_ID={1},BannerType_ID={2},BannerEnabled={3},Banner_Html={4}," _
				& "Banner_StartDate={5},Banner_EndDate={6} WHERE Banner_ID={7}"
			cor.dal.exec p_sql, array(banner_title,bannerzone_id,bannertype_id,banner_enabled,banner_html,banner_startdate,banner_enddate,banner_id)
		ElseIf banner_kind = 4 then 'javascript banner
			p_sql = "UPDATE " & cor_dbpre & "banners SET Banner_Title={0},BannerZone_ID={1},BannerType_ID={2},BannerEnabled={3},Banner_Html={4}," _
				& "Banner_StartDate={5},Banner_EndDate={6} WHERE Banner_ID={7}"
			cor.dal.exec p_sql, array(banner_title,bannerzone_id,bannertype_id,banner_enabled,banner_html,banner_startdate,banner_enddate,banner_id)
		end if
	end Sub
	
	private sub editBannerType()
		p_sql = "UPDATE " & cor_dbpre & "bannertypes SET BannerType={0}, BannerTypeEnabled={1} WHERE BannerType_ID={2}"
		cor.dal.exec p_sql, array(bannertype, bannertype_enabled, bannertype_id)
	end sub
	
	private sub editBannerZone()
		p_sql = "UPDATE " & cor_dbpre & "bannerzones SET BannerZone={0}, BannerZoneEnabled={1} WHERE BannerZone_ID={2}"
		cor.dal.exec p_sql, array(bannerzone, bannerzone_enabled, bannerzone_id)
	end sub
	
	private Sub deleteBanner()
		p_sql = "DELETE FROM " & cor_dbpre & "banners WHERE Banner_ID={0}"
		cor.dal.exec p_sql, array(banner_id)
		cor.redir "mgmt_banners.asp"
	end sub
	
	private sub deleteBannerZone()
		if Len(cor.dal.getValue("SELECT b.banner_title FROM " & cor_dbpre & "banners AS b WHERE b.BannerZone_ID ={0}", array(bannerzone_id))) = 0 Then
			p_sql = "DELETE FROM " & cor_dbpre & "bannerzones WHERE BannerZone_ID={0}"
			cor.dal.exec p_sql, array(bannerzone_id)
		else
			'Call deleteErrZone()
			cor.redir "mgmt_banners.asp?e=z"
		end if
	end sub
	
	private sub deleteBannerType()
		if Len(cor.dal.getValue("SELECT b.banner_title FROM " & cor_dbpre & "banners AS b WHERE b.BannerType_ID ={0}", array(bannertype_id))) = 0 Then
			p_sql = "DELETE FROM " & cor_dbpre & "bannertypes WHERE BannerType_ID={0}"
			cor.dal.exec p_sql, array(bannertype_id)
		Else
			'Call deleteErrType()
			cor.redir "mgmt_banners.asp?e=t"
		end if
	end Sub
	
end class
'
'<#late-binding hook
function boot_class_banners : boot_class_banners = true : end Function 
'/>
%>