﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
'SOOP 2.0 - Phoenix core (rev.2)
'
' Revision 2.0001 - initial 22/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
'
' class_debug 2.3
' Debug Information Class
' Original: Microsoft - http://support.microsoft.com/default.aspx?scid=KB;EN-US;q288965&
' Formatting: Mike - http://www.planet-source-code.com/vb/scripts/ShowCode.asp?txtCodeId=7475&lngWId=4
' Added many features incl Mozilla, database, editing and repost: Hunter Beanland - http://www.geocities.com/hbeanland/
'
class class_debug
	private p_requestTime
	private p_requestTimer
	private p_FinishTimer
	private p_Data
	private p_DB_Data
	private DivSetStatus
	private DivSets()
	public Show
	public AllVars
	public editing
	public ClassFile

	private sub class_initialize()
		p_requestTime = Now()
		p_requestTimer = Timer()
		AllVars = true
		editing = true
		ClassFile = "./"
		set p_Data = server.createObject("Scripting.Dictionary") 
		redim DivSets(2)
		DivSets(0) = "<tr><td><div id=sect#sectname# class='dbgDivSetsHeader' onclick=""javascript:togglePanel('data#sectname#');"">|#title#<DIV id=data#sectname# class='dbgDivSetsBody' style='display:none;' onclick=""window.event.cancelBubble = true;"">#data#|</div></div>|"
		DivSets(1) = "<tr><td><div id=sect#sectname# class='dbgDivSetsHeader' onclick=""javascript:togglePanel('data#sectname#');"">|#title#<DIV id=data#sectname# class='dbgDivSetsBody' style='display:block;' onclick=""window.event.cancelBubble = true;"">#data#|</div></div>|"
		DivSets(2) = "<tr><td><div id=sect#sectname# class='dbgDivSetsHeader' style='font-weight:normal;'>|#title#<div id=data#sectname# class='dbgDivSetsBody'>|#data#</div></div>|"
		DivSetStatus = "0,0,0,0,0,0,0,0,0,0,0"
	end sub

	public sub print(label, output)
		if err.number<>0 then 
			call p_Data.Add(ValidLabel(label), "!!! Error: " & err.number & " " &	err.Description)
			err.clear 
		else 
			call p_Data.Add(ValidLabel(label), output)
		end if
	end sub

	private function validLabel(byval label)
		dim i, lbl
		i=0
		lbl = label
		do
			if not p_Data.Exists(lbl) then exit do
			i = i+1
			lbl=label & "(" & i & ")"
		loop until i=100
		ValidLabel = lbl
	end function
 
	private sub printCookiesInfo(byval DivSetNo)
		dim tbl, cookie, key, tmp
		tbl = "<form name=dbgCookies action='" & ClassFile & "' method=post><input type=hidden name=DebugInfoCookies value=true />"
		for each cookie in request.cookies
    		if NOT request.cookies(cookie).HasKeys Then
        		if editing then
        			tbl = AddRowEdit(tbl, cookie, request.cookies(cookie))
        		else
        			tbl = AddRow(tbl, cookie, server.htmlEncode(request.cookies(cookie)))
        		end if
			else
    			for each key in request.cookies(cookie)
        			if editing then
        				tbl = AddRowEdit(tbl, cookie & "(" & key & ")", request.cookies(cookie)(key))
        			else
        				tbl = AddRow(tbl, cookie & "(" & key & ")", server.htmlEncode(request.cookies(cookie)(key)))		
        			end if
				next 
			end if
		next 
		if editing and request.cookies.count > 0 then tbl = tbl & "<tr><td colspan='2'><a href='javascript:document.dbgCookies.submit();'>Save Updates</a></td></tr>"
		tbl = tbl & "</form>"
		tbl = MakeTable(tbl)
		if request.cookies.count <= 0 then DivSetNo = 2
		tmp = replace(replace(replace(DivSets(DivSetNo),"#sectname#","COOKIES"),"#title#","COOKIES"),"#data#",tbl)
		response.write replace(tmp,"|", vbcrlf)
	end sub

	private sub printSummaryInfo(byval DivSetNo)
		dim tmp, tbl
		tbl = AddRow(tbl, "Time of request",p_requestTime)
		tbl = AddRow(tbl, "Elapsed Time",FormatNumber(p_FinishTimer - p_requestTimer,3,-1) & " seconds")
		tbl = AddRow(tbl, "request Type",request.serverVariables("REQUEST_METHOD"))
		tbl = AddRow(tbl, "Status Code",response.Status)
		tbl = AddRow(tbl, "Script Engine",ScriptEngine & " " & ScriptEngineMajorVersion & "." & ScriptEngineMinorVersion & "." & ScriptEngineBuildVersion)
		tbl = MakeTable(tbl)
		tmp = replace(replace(replace(DivSets(DivSetNo),"#sectname#","SUMMARY"),"#title#","SUMMARY INFO"),"#data#",tbl)
		response.write replace(tmp,"|", vbcrlf)
	end sub

	private sub printDatabaseInfo(byval DivSetNo)
		dim tbl
		if p_DB_Data = "" then DivSetNo =2
		tbl = MakeTable(p_DB_Data)
		tbl = replace(replace(replace(DivSets(DivSetNo),"#sectname#","DATABASE"),"#title#","DATABASE INFO"),"#data#",tbl)
		response.write replace(tbl,"|", vbcrlf)
	end sub

	private sub printCollection(Byval Name, ByVal Collection, ByVal CollectType, ByVal ShowInputBox)
	dim vItem, tbl, Temp, DivSetNo
	if CollectType = 2	then
		tbl = "<form name=dbgCollection" & CollectType & " action='" & request.serverVariables("URL") & "' method=get><input type=hidden name=DebugInfo" & CollectType & " value=true />"
	elseif CollectType = 3 then
		tbl = "<form name=dbgCollection" & CollectType & " action='" & request.serverVariables("URL") & "' method=post><input type=hidden name=DebugInfo" & CollectType & " value=true />"
		else
		tbl = "<form name=dbgCollection" & CollectType & " action='" & ClassFile & "?DebugInfo" & CollectType & "=true' method=post>"
		end if
		for each vItem In Collection
			if isObject(Collection(vItem)) and CollectType <> 2 and CollectType <> 3 and CollectType <> 7 then
				tbl = AddRow(tbl, vItem, "{object}")
			elseif isNull(Collection(vItem)) then
				tbl = AddRow(tbl, vItem, "{null}")
			elseif isarray(Collection(vItem)) then
				tbl = AddRow(tbl, vItem, "{array}")
			elseif (CollectType = 2 and vItem <> "DebugInfo2") or (CollectType = 3 and vItem <> "DebugInfo3") or (CollectType <> 2 and CollectType <> 3) then
		if AllVars or ((CollectType = 7 and vItem <> "ALL_HTTP" and vItem <> "ALL_RAW") or CollectType <> 7) then
			if ShowInputBox then
				if Collection(vItem) <> "" then tbl = AddRowEdit(tbl, vItem, Collection(vItem))
			else
				if Collection(vItem) <> "" then tbl = AddRow(tbl, vItem, server.htmlEncode(Collection(vItem)))
			end if
			' & " {" & TypeName(Collection(vItem)) & "}")
		else
			tbl = AddRow(tbl, vItem, "...")
		end if
		end if
		next
		select case CollectType
		case 5
			if ShowInputBox then
				tbl = tbl & "<tr><td colspan='2'><hr /></td></tr>"
				tbl = AddRowEdit(tbl,"Locale ID",(Session.LCID))
				tbl = AddRowEdit(tbl,"Code Page",Session.CodePage)
				tbl = AddRow(tbl,"Session ID",session.sessionID)
			else
				tbl = tbl & "<tr><td colspan='2'><hr /></td></tr>"
				tbl = AddRow(tbl,"Locale ID",Session.LCID & " (&H" & Hex(Session.LCID) & ")")
				tbl = AddRow(tbl,"Code Page",Session.CodePage)
				tbl = AddRow(tbl,"Session ID",session.sessionID)
			end if
		case 7
			if editing then
				tbl = tbl & "<tr><td colspan='2'><hr /></td></tr>"
				tbl = AddRowEdit(tbl,"Timeout",server.scriptTimeout)
			else
				tbl = tbl & "<tr><td colspan='2'><hr /></td></tr>"
				tbl = AddRow(tbl,"Timeout",server.scriptTimeout)
			end if
	end select
	if (ShowInputBox or CollectType = 7) and Collection.count > 0 then 
		if CollectType = 2 or CollectType = 3 then
			tbl = tbl & "<tr><td colspan='2'><a href='javascript:document.dbgCollection" & CollectType & ".submit();'>Re-post</a></td></tr>"
		else
			tbl = tbl & "<tr><td colspan='2'><a href='javascript:document.dbgCollection" & CollectType & ".submit();'>Save Updates</a></td></tr>"
		end if
	end if	
	tbl = tbl & "</form>"
		tbl = makeTable(tbl)
		DivSetNo = DivSetStatus(CollectType)
		if Collection.count <= 0 then DivSetNo =2
		tbl = replace(replace(DivSets(DivSetNo),"#title#",Name),"#data#",tbl)
		tbl = replace(tbl,"#sectname#",replace(Name," ",""))
		response.write replace(tbl,"|", vbcrlf)
	end sub
	
	private function addRow(byval t, byval var, byval val)
		t = t & "<TR style='vertical-align:top;'><TD>" & var & "<TD>= " & val & "</TR>|"
		addRow = t
	end function

	private function addRowEdit(byval t, byval var, byval val)
		t = t & "<TR style='vertical-align:top;'><TD>" & var & "<TD>= <input type=text name=" & var & " value='" & val & "' size=" & len(val)+(len(val)\3)+1 & " class=dbgEditField /></TR>|"
		addRowEdit = t
	end function

	private function makeTable(byval tdata)
		tdata = "<table summary='' border=0 style=""font-size:10pt;font-weight:normal;"">" + tdata + "</Table>|"
		makeTable = tdata
	end function

	public sub display
		p_FinishTimer = Timer()
		dim x
		DivSetStatus = split(DivSetStatus,",")
		Show = split(Show,",")
		for x = 0 to ubound(Show)
			DivSetStatus(x) = Show(x)
		next
		response.write "<style>.dbgDivSetsHeader{font-weight:bold;border:1;outset;silver;cursor:hand;background:#f8f8f8;color:#000000;padding-left:4;padding-right:4;padding-bottom:2;}" & vbcrlf
		response.write ".dbgDivSetsBody{border:1;inset;silver;cursor:text;display:none;background:#f8f8f8;padding-left:8;}" & vbcrlf
		response.write ".dbgEditField{background:#f8f8f8;border:#000000 1px solid;}</style>" & vbcrlf
		response.write "<script language='javascript'>function togglePanel(panelName) {if (document.getElementById(panelName).style.display=='none'){document.getElementById(panelName).style.display='block';}else{document.getElementById(panelName).style.display='none';}} </script>" & vbcrlf
		response.write "<br /><table summary='' id=dbgInfo width=100% cellspacing=0 border=0 style=""font-family:arial;font-size:9pt;font-weight:normal;""><tr><td><div style=""border:1 outset buttonhighlight;background:#dcdcdc;color:white;padding:4;font-size:11pt;font-weight:bold;"">"
		response.write "<span onclick=""javascript:document.getElementById('dbgInfo').style.display='none';"" style='cursor:hand;'><font face='wingdings' color=white>x</font></span> Debug Information:</div>" & vbcrlf
		call printSummaryInfo(DivSetStatus(0))
		call printCollection("VARIABLES", p_Data, 1, false)
		'On error resume next
		call printCollection("QUERYSTRING", request.querystring, 2, editing)
		call printCollection("FORM", request.form, 3, editing)
		'On error goto 0
		call printCookiesInfo(DivSetStatus(4))
		call printCollection("SESSION", Session.Contents(), 5, editing)
		call printCollection("APPLICATION", Application.Contents(), 6, editing)
		call printCollection("SERVER VARIABLES", request.serverVariables(), 7,false)
		call printDatabaseInfo(DivSetStatus(8))
		call printCollection("SESSION STATIC OBJECTS", Session.StaticObjects(), 9,false)
		call printCollection("APPLICATION STATIC OBJECTS", Application.StaticObjects(), 10, false)
		response.write "</table>"
	end sub

	private sub class_terminate()
		call Display()
		set p_Data = nothing
	end sub

end class

'Collection editing routines - called from self
'Must use QueryString as Form can interfere with file upload (binary reads)
sub debug_goBack
	response.write "<script language='javascript'>history.back();</script>"
end sub

sub debug_checkUpdateCollections
	dim cItem
	'Cookies
	if  request.querystring("DebugInfoCookies") = "true" then
		for each cItem in request.form
			if instr(1,cItem,"!") > 0 then
				response.cookies(left(cItem,instr(1,cItem,"!")-1)(right(cItem,len(cItem)-instr(1,cItem,"!")))) = request.form(cItem)
			elseif cItem <> "DebugInfoCookies" then 
				response.cookies(cItem) = request.form(cItem)
			end if	
		next
		debug_goBack
	end if
	'Session
	if request.querystring("DebugInfo5") = "true" then
		for each cItem in request.form
			if request.form("Locale ID") <> "" then 
				if isNumeric(request.form("Locale ID")) then
					session.LCID = clng(request.form("Locale ID"))
				else
					session.LCID = clng("&H" & request.form("Locale ID"))
				end if	
			elseif 	request.form("Code Page") <> "" then
				if isNumeric(request.form("Code Page")) then session.CodePage = clng(request.form("Code Page"))
			elseif cItem <> "DebugInfo5" then
				session(cItem) = request.form(cItem)
			end if	
		next
		debug_goBack
	end if
	'Application
	if request.querystring("DebugInfo6") = "true" then
		for each cItem in request.form
			if cItem <> "DebugInfo6" then
				application.lock
				application(cItem) = request.form(cItem)
				application.unlock
			end if
		next
		debug_goBack
	end if
	'Server Variables
	if request.querystring("DebugInfo7") = "true" then
		if request.form("Timeout") <> "" and isNumeric(request.form("Timeout")) then server.scriptTimeout = clng(request.form("Timeout"))
		debug_goBack
	end if
end sub

'Check to see if the class is calling itself - to edit some of the collections
debug_checkUpdateCollections

'<#late-binding hook
function boot_class_debug : boot_class_debug = true : end function
'/>

%>
