﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_imageBrowser ':: global, class_string, class_objectsPool

	public ImagePath				' Image Path Server not MapPath!!!
	public ImageTypes				' Image Types seperated by | pipe symbol
	public Width					' Width of the box (non popup)
	public Height					' Height of the box (non popup)
	public Columns					' Number of columns of images.
	public ShowFilename				' Show the file name under the image
	public Field					' the field to return the filename to
	public ImageSRC					' The ID of the Image src to show the selected image to
	public CloseOnClick				' Close the window on click (should not be used with non-popup)
	public ReturnFullPath			' Return the FULL PATH and IMAGE NAME. (false = Imagename only)
	public usePopup					' Use Popup version.
	
	
	private sub class_initialize()	
    	ImagePath 		= ""
    	ImageTypes		= ".jpg|.jpeg|.gif|.png"
    	ShowFilename	= true
    	Columns 		= 2
    	Width			= "100%"
    	Height			= ""
    	Field			= ""
    	ImageSRC		= ""
    	CloseOnClick	= false
    	ReturnFullPath	= false
    	usePopup 		= true
    	'
    	set str = new class_string
	end sub
	
	
	'
	private sub class_terminate
		set str = nothing
	end sub
	'
	private str
	'	
end class

'<#late-binding hook
function boot_class_imageBrowser : boot_class_imageBrowser = true : end function
'/>

%>
