﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
class class_media ':: global, class_objectsPool
	public extension
	public frequency
	public prefix
	public path
	public errImage
	'
	private sub class_initialize()
		extension	= "jpg"
		frequency	= "random"
		prefix		= "image"
		path		= "uploads/assets/calendar/"
		errImage	= "blank.gif"
	end sub
	'
	public function name()
		dim mediaNumber
		if cor_bFsoEnable Then
			select case frequency
				case "day" 'use a different image each day of the month
					mediaNumber = day(now())
					name = prefix & mediaNumber & "." & extension
					if Not(mediaCheck(name, cor_sWebroot & path)) Then name = errImage
				case "yday" 'use a different image each day of the year
					mediaNumber = datePart("y",now())
					name = prefix & mediaNumber & "." & extension
					if Not(mediaCheck(name, cor_sWebroot & path)) Then name = errImage
				case "wday" 'use a different image each weekday
					mediaNumber = datePart("w",now())
					name = prefix & mediaNumber & "." & extension
					if Not(mediaCheck(name, cor_sWebroot & path)) Then name = errImage
				case "week" 'use a different image each week of the month
					mediaNumber = weekday(now())
					name = prefix & mediaNumber & "." & extension
					if Not(mediaCheck(name, cor_sWebroot & path)) Then name = errImage
				case "yweek" 'use a different image each week of the year
					mediaNumber = datePart("ww",now())
					name = prefix & mediaNumber & "." & extension
					if Not(mediaCheck(name, cor_sWebroot & path)) Then name = errImage
				case "month" 'user a different image each month of the year
					mediaNumber = month(now())
					name = prefix & mediaNumber & "." & extension
					if Not(mediaCheck(name, cor_sWebroot & path)) Then name = errImage
				case else ' use a random image based on the number of mediaTotal
					Randomize timer
					mediaNumber = int(Rnd * mediaTotal(path,prefix))
					name = prefix & mediaNumber & "." & extension
					if Not(mediaCheck(name, cor_sWebroot & path)) Then name = errImage
			end select
		else
			name = errImage
		end if
	end function
	'
	private function mediaTotal(path,prefix)
		'On error resume next
		dim objFolder, objFile, objFiles
		'response.write "<br><hr><h2>cor_sWebroot: " & cor_sWebroot & "<br>"
		'response.write "path: " & path & "<br>"
		'response.write "prefix: " & prefix & "<br>"
		'response.flush
		'response.end
		call cor.obj.init("fso")
		dim xPath
		xPath = server.mappath(cor_sWebroot & path )
		if not cor.obj.fso.FolderExists(xpath) then
			' Woops! we're trying to load something from a folder that is not there.
			cor.str.wri "<!-- MediaTotal Error: Path Not Found: " & cor_sWebroot & path & " -->"
		else
			set objFolder = cor.obj.fso.GetFolder(xpath)
			set objFiles = objFolder.files
			for Each objFile in objFiles
				if left(lcase(objFile.name),len(prefix)) = lcase(prefix) Then mediaTotal = mediaTotal + 1
			Next
			if mediaTotal > 1 then mediaTotal = mediaTotal - 1
			set objFile   = nothing
			set objFolder = nothing
			if err.number<>0 then mediaTotal = 1
		end if
		'On error goto 0
	end function
	'
	private function mediaCheck(name, path)
		'On error resume next
		mediaCheck = false
		call cor.obj.init("fso")
		if cor.obj.fso.FileExists(server.mappath(path & name)) Then mediaCheck = true
		if err.number<>0 then mediaCheck = false
		'On error goto 0
	end function
	'
end class

'<#late-binding hook
function boot_class_media : boot_class_media = true : end function
'/>

%>