﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<% class class_members_html ':: class_members %>

<% sub muser(bEdit) %>
	<% if bEdit Then %>
	<ul class="col req">
	<li class="label"><label for="muser"><%= lngUserName %></label></li>
	<li class="input">
	<% If Not cor_bAdmin Then %>
	<input type="text" id="muser" name="muser" size="30" maxlength="30" value="<%= cor.member.io_muser %>" class="" />
	<% Else %>
	<input type="text" id="muser" name="muser" size="30" maxlength="30" value="<%= cor.member.io_muser %>" class="" />
	<% End If %>
	<br />(<%= lngMemberSelectNonExistantUsername %>)
	</li>
	</ul>
	<% Else %>
	<ul class="tcol">
	<li class="label"><%= lngName %></li>
	<li class="input"><%= cor.member.io_muser %> <%= iif(cor.member.io_mname<>"", " ("&cor.member.io_mname&")", "") %></li>
	</ul>
	<% End If %>
<% End Sub %>

<% Sub mpassAdd() %>
	<ul class="col req">
	<li class="label"><label for="mpass"><%= lngPassword %></label></li> 
	<li class="input"><input type="password" id="mpass" name="mpass" size="15" class="" maxlength="<%= cor_cMaxPassLen %>" /></li>
	</ul>
	</li>
	<li>
	<ul class="col req">
	<li class="label"><label for="newpass"><%= lngMemberNewPass2 %></label></li> 
	<li class="input"><input type="password" id="newpass" name="newpass" size="15" class="" maxlength="<%= cor_cMaxPassLen %>" /></li>
	</ul>
<% End Sub %>

<% sub mpassChange() %>
	<ul class="col req">
	<li class="label"><label for="newpass"><%= lngMemberNewPass %></label></li>
	<li class="input">
	<input id="newpass" name="newpass" type="password" class="" maxlength="<%= cor_cMaxPassLen %>" /></li>
	</ul>
	</li>
	<li>
	<ul class="col req">
	<li class="label"><label for="newpass2"><%= lngMemberNewPass2 %></label></li>
	<li class="input"><input name="newpass2" type="password" class="" maxlength="<%= cor_cMaxPassLen %>" /></li>
	</ul>
	</li>
	<% if NOT cor_bAdmin Then %>
	<li>
	<ul class="col req">
	<li class="label"><label for="currentpass"><%= lngMemberCurrentPass %></label></li>
	<li class="input">
	<input name="currentpass" type="password" class="" maxlength="<%= cor_cMaxPassLen %>" />
	</li>
	</ul>
	<div class="ui button">
		<button onclick="document.location = 'member_form.asp?do=<%= cor_cDoMemberNewPass %>&amp;mid=<%= cor.member.io_mid %>';" id="forgotpass" type="submit" name="forgotpass" value="<%= lngForgotPass %>"><span><%= lngForgotPass %></span></button>
	</div>
	<% Else %>
	</ul>
	<% end if %>
<% end sub %>

<% sub mmail(bEdit) %>	
	<% if bEdit Then %>	
		<ul class="col req">
			<li class="label"><label for="mmail"><%= lngMail %></label></li> 
			<li class="input">
			<input type="text" id="mmail" name="mmail" size="50" maxlength="255" value="<%= cor.member.io_mmail %>" class="" />
			<br />(<%= lngMemberSelectNonExistantEmail %>)
			</li>
		</ul>
	<% else %>
		<ul class="tcol">
			<li class="label"><%= lngMail %></li>
			<li class="input">
				<% If cor.io.q("modal")="1" Then %>
					<a <% if request.cookies("emb") = 1 Then cor.str.wrn " class=""ModalHideAndRedirect""" %> href="pm_form.asp?do=<%= iif(cor_bAdmin OR cor_bModerator, cor_cDoNewEmailList, cor_cDoNewEmail) %>&amp;to=<%= cor.member.io_mid %>"><span class="ui"><i class="email-ico ico-sprt">&nbsp;</i></span><%= lngMemberSendEmailTo %></a>
				<% Else %>
					<a class="doModal" rel="800:500" href="pm_form.asp?do=<%= iif(cor_bAdmin OR cor_bModerator, cor_cDoNewEmailList, cor_cDoNewEmail) %>&amp;to=<%= cor.member.io_mid %>"><span class="ui"><i class="email-ico ico-sprt">&nbsp;</i></span><%= lngMemberSendEmailTo %></a>
				<% End If %>
			</li>
		</ul>
	<% end if %>
<% end sub %>

<% sub mname(bEdit) %>
	<% if bEdit Then %>	
	<ul class="col info">
	<li class="label"><label for="mname"><%= lngRealName %></label></li>
	<li class="input"><input type="text" id="mname" name="mname" size="30" maxlength="255" value="<%= cor.member.io_mname %>" /></li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngRealName %></li>
	<li class="input"><%= cor.member.io_mname %></li>
	</ul>
	<% end if %>
<% end sub %>

<% sub mlocation(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mlocation"><%= lngLocation %></label></li>
	<li class="input">
	<%
	dim oCombo
	set oCombo = new class_comboBuilder
	oCombo.ElementID = "mlocation"
	oCombo.SelectedValue = iif(cor.member.io_mlocation<>"", cor.member.io_mlocation, cor_sDefaultLocationID)
	oCombo.BuildComboFromDB "SELECT c.countryID, c.country FROM " & cor_dbpre & "country AS c ORDER BY c.country"
	oCombo.CreateCombo()
	set oCombo = nothing
	%>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngLocation %></li>
	<li class="input"><%= cor.member.io_mlocationname %></li>
	</ul>
	<% end if %>
<% end sub %>

<% sub mdateofbirth(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mdateofbirth"><%= lngMemberDateOfBirth %></label></li> 
	<li class="input"><input type="text" id="datepicker" name="mdateofbirth" size="20" maxlength="30" value="<%= cor.butil.datetime(cor.butil.cvLCIDTime(cor.member.io_mdateofbirth-(cor.member.io_mtimezone*60*60)), vbShortDate) %>" /></li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberDateOfBirth %></li>
	<li class="input"><%= cor.butil.datetime(cor.butil.cvLcidTime(cor.member.io_mdateofbirth-(cor.member.io_mtimezone*60*60)), vbShortDate) %></li>
	</ul>	
	<% end if %>
<% end sub %>

<% sub mgender(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mgender"><%= lngGender %></label></li>
	<li class="input"> 
	<%
	dim oCombo
	set oCombo = New class_comboBuilder
	oCombo.ElementID = "mgender"
	oCombo.SelectedValue = cor.member.io_mgender
	oCombo.BuildComboFromFile cor.butil.getWebRoot() & "core\classes\gender.txt"
	oCombo.CreateCombo()
	set oCombo = nothing
	%>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngGender %></li>
	<li class="input">
	<%
	if cor.member.io_mgender ="m" then
		cor.str.wri cor.lng.GetKey("cor_xmlCombos","lngComboMale")
	elseif cor.member.io_mgender ="f" then
		cor.str.wri cor.lng.GetKey("cor_xmlCombos","lngComboFemale")
	else
		cor.str.wri lngDefaultCombo
	end if
	%>
	</li>
	</ul>
	<% end if %>
<% end sub %>

<% sub mhomepage(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mhomepage"><%= lngHomepage %></label></li> 
	<li class="input"><input type="text" id="mhomepage" name="mhomepage" size="30" maxlength="255" value="<%= iif(cor.member.io_mhomepage="", "http://", cor.member.io_mhomepage) %>" /></li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngHomepage %></li>
	<li class="input"><% if cor.member.io_mhomepage<>"" AND instr(cor.member.io_mhomepage, "://") > 0 then %><a target="_blank" href="<%= cor.member.io_mhomepage %>"><%= cor.member.io_mhomepage %></a><% end if %>&nbsp;</li>
	</ul>
	<% end if %>
<% end sub %>

<% sub mmsn(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mmsn"><%= lngMemberMSNMessenger %></label></li> 
	<li class="input"><input type="text" id="mmsn" name="mmsn" size="30" maxlength="255" value="<%= cor.member.io_mmsn %>" /></li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberMSN %></li>
	<li class="input"><%= cor.member.io_mmsn %></li>
	</ul>
	<% end if %>
<% end sub %>

<% sub micq(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="micq"><%= lngMemberICQNumber %></label></li> 
	<li class="input"><input type="text" id="micq" name="micq" size="30" maxlength="255" value="<%= cor.member.io_micq %>" /></li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberICQNumber %></li>
	<li class="input"><%= cor.member.io_micq %></li>
	</ul>
	<% end if %>
<% end sub %>

<% sub myahoo(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="myahoo"><%= lngMemberYahooMessenger %></label></li> 
	<li class="input"><input type="text" id="myahoo" name="myahoo" size="30" maxlength="255" value="<%= cor.member.io_myahoo %>" /></li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberYahooMessenger %></li>
	<li class="input"><%= cor.member.io_myahoo %></li>
	</ul>
	<% end if %>
<% end sub %>

<% sub maim(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="maim"><%= lngMemberAIMAddress %></label></li> 
	<li class="input"><input type="text" id="maim" name="maim" size="30" maxlength="255" value="<%= cor.member.io_maim %>" /></li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberAIMAddress %></li>
	<li class="input"><%= cor.member.io_maim %></li>
	</ul>
	<% end if %>  
<% end sub %>

<% sub mtitle(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mtitle"><%= lngTitle %></label></li>
	<li class="input"><input name="mtitle" size="40" type="text" id="mtitle" value="<%= cor.member.io_mtitle %>" /></li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngTitle %></li>
	<li class="input"><%= cor.member.io_mtitle %>&nbsp;</li>
	</ul>
	<% end if %>
<% end sub %>

<% sub mgname(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mgid"><%= lngGroup %></label></li>
	<li class="input">
	<%
	dim oCombo
	set oCombo = New class_comboBuilder
	oCombo.ElementID = "mgid"
	oCombo.SelectedValue = iif(cor.member.io_mgid>0, cor.member.io_mgid, cor.cfg.item("DefaultUserGroup"))
	oCombo.BuildComboFromDB "SELECT g.gid, g.gname FROM " & cor_dbpre & "groups AS g ORDER BY g.gname"
	oCombo.CreateCombo()
	set oCombo = nothing
	%>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngGroup %></li>
	<li class="input"><%= cor.member.io_mgname %></li>
	</ul>  
	<% end if %>
<% end sub %>

<% sub mskin(bEdit) %>
	<% if bEdit Then %>	
	<ul class="col req">
	<li class="label"><label for="mskin"><%= lngTheme %></label></li>
	<li class="input">
	<%
	dim oCombo
	set oCombo = New class_comboBuilder
	oCombo.ElementID = "mskin"
	oCombo.SelectedValue = iif(cor.member.io_mskin<>"", cor.member.io_mskin, cor.cfg.item("DefaultSkin"))
	oCombo.BuildComboFromFolder "./skins/",".skin"
	oCombo.CreateCombo()
	set oCombo = nothing
	%>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngTheme %></li>
	<li class="input"><%= cor.member.io_mskin %></li>
	</ul>  
	<% end if %>
<% end sub %>

<% sub mlanguage(bEdit) %>
	<% if bEdit Then %>	
	<ul class="col req">
	<li class="label"><label for="mlanguage"><%= lngLanguage %></label></li>
	<li class="input">
	<%
	dim oCombo
	set oCombo = New class_comboBuilder
	oCombo.ElementID = "mlanguage"
	oCombo.SelectedValue = iif(cor.member.io_mlanguage<>"", cor.member.io_mlanguage, cor.cfg.item("DefaultLang"))
	oCombo.BuildComboFromFolder "./core/languages/",".xml"
	oCombo.CreateCombo()
	set oCombo = nothing
	%>
	</li>	
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngLanguage %></li>
	<li class="input"><%= cor.member.io_mlanguage %></li>
	</ul>  
	<% end if %>
<% end sub %>
	
<% sub msign(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info textarea">
	<li class="label"><label for="msign"><%= lngSignature %></label></li>
	<li class="input">
	<%= cor.rte.invoke(cor.member.io_msign, "msign", "100%", 200, "GuestBook") %>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngSignature %></li>
	<li class="input"><%= cor.member.io_msign %>&nbsp;</li>
	</ul>
	<% end if %>
<% end sub %>	

<% sub mshowmail(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mshowmail"><%= lngMemberShowMail %></label></li>
	<li class="input">
	<select name="mshowmail" id="mshowmail">
	<option value="0" <% if cor.member.io_mshowmail=0 then response.write "selected='selected'" %>><%= lngNo %></option>
	<option value="1" <% if cor.member.io_mshowmail=1 then response.write "selected='selected'" %>><%= lngYes %></option>
	</select><br />
	(<%= lngMemberShowMailNotes %>)
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberShowMail %></li>
	<li class="input"><%= iif(cor.member.io_mshowmail=1, lngYes, lngNo) %></li>
	</ul>	
	<% end if %>
<% end sub %>

<% sub mhtmlemail(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mhtmlemail"><%= lngMemberHTMLemail %></label></li> 
	<li class="input">	
	<select name="mhtmlemail" id="mhtmlemail">
	<option value="1" <% if cor.member.io_mhtmlemail=1 then response.write "selected='selected'" %>><%= lngMemberHTML %></option>
	<option value="0" <% if cor.member.io_mhtmlemail=0 then response.write "selected='selected'" %>><%= lngMemberPlain %></option>
	</select>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberHTMLemail %></li>
	<li class="input"><%= iif(cor.member.io_mhtmlemail=1, lngMemberHTML, lngMemberPlain) %></li>
	</ul>	
	<% end if %>
<% end sub %>

<% sub mautologin(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mautologin"><%= lngMemberAutologinText %></label></li> 
	<li class="input">
	<select name="mautologin" id="mautologin">
	<option value="1" <% if cor.member.io_mautologin=1 then response.write "selected='selected'" %>><%= lngYes %></option>
	<option value="0" <% if cor.member.io_mautologin=0 then response.write "selected='selected'" %>><%= lngNo %></option>
	</select>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberAutologinText %></li>
	<li class="input"><%= iif(cor.member.io_mautologin=1, lngYes, lngNo) %></li>
	</ul>	
	<% end if %>
<% end sub %>

<% sub mshowactive(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mshowactive"><%= lngMemberShowActive %></label></li> 
	<li class="input">
	<select name="mshowactive" id="mshowactive">
	<option value="1" <% if cor.member.io_mshowactive=1 then response.write "selected='selected'" %>><%= lngYes %></option>
	<option value="0" <% if cor.member.io_mshowactive=0 then response.write "selected='selected'" %>><%= lngNo %></option>
	</select>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberShowActive %></li>
	<li class="input"><%= iif(cor.member.io_mshowactive=1, lngYes, lngNo) %></li>
	</ul>	
	<% end if %>
<% end sub %>

<% sub mshowsig(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mshowsig"><%= lngMemberShowSignature %></label></li> 
	<li class="input">
	<select name="mshowsig" id="mshowsig">
	<option value="1" <% if cor.member.io_mshowsig=1 then response.write "selected=""selected""" %>><%= lngYes %></option>
	<option value="0" <% if cor.member.io_mshowsig=0 then response.write "selected=""selected""" %>><%= lngNo %></option>
	</select>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberShowSignature %></li>
	<li class="input"><%= iif(cor.member.io_mshowsig=1, lngYes, lngNo) %></li>
	</ul>
	<% end if %>
<% end sub %>

<% sub mpmnotify(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mpmnotify"><%= lngMemberPMnotifyReceipt %></label></li> 
	<li class="input">
	<select name="mpmnotify" id="mpmnotify">
	<option value="1" <% if cor.member.io_mpmnotify=1 then response.write "selected=""selected""" %>><%= lngYes %></option>
	<option value="0" <% if cor.member.io_mpmnotify=0 then response.write "selected=""selected""" %>><%= lngNo %></option>
	</select>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberPMnotifyReceipt %></li>
	<li class="input"><%= iif(cor.member.io_mpmnotify=1, lngYes, lngNo) %></li>
	</ul>
	<% end if %>
<% end sub %>

<% sub mreplynotify(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mreplynotify"><%= lngMemberReplyNotifyReceipt %></label></li> 
	<li class="input">
	<select name="mreplynotify" id="mreplynotify">
	<option value="1" <% if cor.member.io_mreplynotify=1 then response.write "selected=""selected""" %>><%= lngYes %></option>
	<option value="0" <% if cor.member.io_mreplynotify=0 then response.write "selected=""selected""" %>><%= lngNo %></option>
	</select>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberReplyNotifyReceipt %></li>
	<li class="input"><%= iif(cor.member.io_mreplynotify=1, lngYes, lngNo) %></li>
	</ul>	
	<% end if %>
<% end sub %>

<%
sub mtimezone(bEdit)
	dim mtimezone
%>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mtimezone"><%= lngMemberTimezone %></label></li> 
	<li class="input">
<% 
	dim oCombo
	set oCombo = New class_comboBuilder
	oCombo.ElementID = "mtimezone"
	oCombo.SelectedValue = iif(cor.member.io_mtimezone <> "", cor.member.io_mtimezone, cor_dTimeZone)
	oCombo.BuildComboFromFile cor.butil.getWebRoot() & "core\classes\timezones.txt"
	oCombo.CreateCombo()
	set oCombo = nothing
%>
	<br /><%= lngMemberPresentServerTimeIs & " " & now() %>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberTimezone %></li>
	<li class="input">
	<%= cor.member.io_mtimezone %>
	<br /><%= lngMemberPresentServerTimeIs & " " & now() %>
	</li>
	</ul>	
	<% end if %>
<% end sub %>


<% sub securityCode() %>
<fieldset>  
<legend><%= lngSecurity %></legend>	
<ul class="row">
<li>
	<ul class="col">
	<li class="label"><label><%= lngConfirmSecurityCode %></label></li>
	<li class="input">
	<% Dim valSessionName : valSessionName = cor.filter.encrypt("register") %>
	<img id="secureImages<%=cor.filter.encrypt("register")%>" src="<%= cor_sWebroot %>securecode.asp?r=<%= clng(rnd * 10000000) %>&id=<%=cor.filter.encrypt("register")%>" alt="" />&nbsp;
	<a class="secureImg" rel="<%=cor.filter.encrypt("register")%>" href="javascript:void(0)"><%= lngTextReload %></a>
	<input type="hidden" id="sessionName" name="sessionName" value="<%=cor.filter.encrypt("register")%>" />
	</li>
	</ul>
</li>
<li>
	<ul class="col req">
	<li class="label"><label for="securityCode"><%= lngConfirmSecurityCode %></label></li>
	<li class="input"><input type="text" id="securityCode" name="securityCode" class="" /></li>
	</ul>
</li>
</ul>
</fieldset>
<% end sub %>

<% sub memberStatus() %>
	<ul class="tcol">
		<li class="label"><%= lngStatus %>
		<li class="input">
	<% if cor.util.checkOnline(cor.member.io_mid) then %>
			<span class="online" title="<%'= lngOnLine %>"></span>
	<!-- <img src="<%'= cor_sSkinImg %>icon_online.gif" alt="" /> -->
	<% else %>
			<span class="offline ico-sprt" title="<%= lngOffLine %>"></span>
	<!-- <img src="<%'= cor_sSkinImg %>icon_offline.gif" title="<%'= lngOffLine %>" alt="" /> -->
	<% end if %>
	
		</li>
	</ul>
<% end sub %>

<% sub mavatar(bEdit) %>
	<% if bEdit Then '<bEdit> %>

		<% if len(cor.member.io_mavatar) <> 0 then %>
	<ul class="col info">
	<li class="label"><label for="imgDisplay"><%= lngMemberAvatarCurrent %></label></li>
	<li class="input"><img id="imgDisplay" src="<%= cor.member.io_mavatar %>" title="<%= lngAvatar %>" alt="" <%= cor.util.avatarSz %> /></li>
	</ul>
	</li>
		<% else %>
	<ul class="col info">
	<li class="label"><label for="imgDisplay"><%= lngMemberAvatarCurrent %></label></li>
	<li class="input"><img id="imgDisplay" src="uploads/assets/calendar/blank.gif" title="<%= lngAvatar %>" alt="" <%= cor.util.avatarSz %> /></li>
	</ul>
	</li>
		<% end if %>
	<li>
	<ul class="col info">
	<li class="label"><label for="mavatar"><%= lngMemberAvatarChoose %></label></li>
	<li class="input">
	<input type="text" id="mavatar" name="mavatar" size="40" maxlength="255" value="<%= cor.member.io_mavatar %>" />
	
	<!--<div class="ui button">
	<a href="javascript:openAsset('mavatar');"><%= lngBrowseImage %></a>
	</div>
	-->
		<div class="buttonInnerWrap">
			<div class="ui button">
			<a title="Upload Avatar" href="javascript:openAsset('mavatar');">
			<span><%= lngBrowseImage %></span>
			</a>
			</div>
		</div>

	</li>
	</ul>
	<% else '<bEdit> %>
	<ul class="col">
	<li class="label"><%= lngAvatar %></li>
	<li class="input">
	<% if len(cor.member.io_mavatar)>0 Then %>
		<% If left(cor.member.io_mavatar,8)="uploads/" OR left(cor.member.io_mavatar,7)="uploads/assets/" Then%>
		<img src="<%= cor_sWebroot & cor.member.io_mavatar %>" class="avatar" id="avatar_img" title="<%= lngAvatar %>"<%= cor.util.avatarSz %> alt="<%= lngAvatar %>" />
		<% Else %>
			<% If left(lcase(cor.member.io_mavatar),7)="http://" Then%>
				<img src="<%= cor.member.io_mavatar %>" class="avatar" id="avatar_img" title="<%= lngAvatar %>"<%= cor.util.avatarSz %> alt="<%= lngAvatar %>" />
			<% Else %>
				<img src="<%= cor.member.io_mavatar %>" class="avatar" id="avatar_img" title="<%= lngAvatar %>"<%= cor.util.avatarSz %> alt="<%= lngAvatar %>" />
			<% End If %>
		<% End If %>
	<% End if %>
	</li>
	</ul>
<% end if '</bEdit> %>
<% end sub %>

<% sub mreggad() %>
	<ul class="col">
	<li class="label"><%= lngRegistered %></li>
	<li class="input"><%= cor.butil.cvLcidTime(cor.member.io_mreggad) %></li>
	</ul>
<% end sub %>

<% sub mwarnings() %>
	<ul class="tcol">
	<li class="label"><%= lngMemberWarnings %></li>
	<li class="input"><%= cor.member.io_mwarnings %>&nbsp;</li>
	</ul>
<% end sub %>

<% sub mnoofposts() %>
	<ul class="tcol">
	<li class="label"><%= lngMemberNumPosts %></li>
	<li class="input"><%= cor.member.io_mnoofposts %>&nbsp;</li>
	</ul>
<% end sub %>

<% sub mricheditor(bEdit) %>
	<% if bEdit Then %>
	<ul class="col info">
	<li class="label"><label for="mricheditor"><%= lngMemberRTEeditor %></label></li> 
	<li class="input">
	<select name="mricheditor" id="mricheditor">
	<option value="1" <% if cor.member.io_mricheditor=1 then response.write "selected='selected'" %>><%= lngYes %></option>
	<option value="0" <% if cor.member.io_mricheditor=0 then response.write "selected='selected'" %>><%= lngNo %></option>
	</select>
	</li>
	</ul>
	<% else %>
	<ul class="tcol">
	<li class="label"><%= lngMemberRTEeditor %></li>
	<li class="input"><%= iif(cor.member.io_mricheditor=1, lngYes, lngNo) %></li>
	</ul>	
	<% end if %>
<% end sub %>

<% sub js() %>
<script type="text/javascript">
$(document).ready(function() {
	var options = {
		target: '#form_results'
		};
	$('#profile').submit(function() {
		$(this).ajaxSubmit(options);
		return false; // <-- important!
	});
	$('#activateadm').submit(function() {
		$(this).ajaxSubmit(options);
		return false; // <-- important!
	});
	$('#memberactivate').submit(function() {
		$(this).ajaxSubmit(options);
		return false; // <-- important!
	});
	$('#newpass').submit(function() {
		$(this).ajaxSubmit(options);
		return false; // <-- important!
	});
	$('#profilepass').submit(function() {
		$(this).ajaxSubmit(options);
		return false; // <-- important!
	});
	$('#deletemember').submit(function() {
		$(this).ajaxSubmit(options);
		return false; // <-- important!
	});
	$('#warning').submit(function() {
		$(this).ajaxSubmit(options);
		return false; // <-- important!
	});
	$('#memberban').submit(function() {
		$(this).ajaxSubmit(options);
		return false; // <-- important!
	});
	$('#memberunban').submit(function() {
		$(this).ajaxSubmit(options);
		return false; // <-- important!
	});
});
</script>
<script type="text/javascript">
jQuery(function($){
$("#datepicker").datepicker();
});

function modalDialogShow_IE(url,width,height) //IE
	{
	return window.showModalDialog(url,window,
		"dialogWidth:"+width+"px;dialogHeight:"+height+"px;edge:Raised;center:Yes;help:No;Resizable:Yes;Maximize:Yes");
	}
function modalDialogShow_Moz(url,width,height) //Moz
	{
	var left = screen.availWidth/2 - width/2;
	var top  = screen.availHeight/2 - height/2;
	activeModalWin = window.open(url, "", "width="+width+"px,height="+height+",left="+left+",top="+top);
	window.onfocus = function(){if (activeModalWin.closed == false){activeModalWin.focus();};};
	}
var sActiveAssetInput;
function setAssetValue(v) //required by the asset manager
	{
	document.getElementById(sActiveAssetInput).value = v;
	}
function openAsset(s)
	{
	sActiveAssetInput = s
	if(navigator.appName.indexOf('Microsoft')!=-1)
//		document.getElementById(sActiveAssetInput).value=modalDialogShow_IE("assetman3.asp?mode=2&ffilter=image",640,465); //IE
		document.getElementById(sActiveAssetInput).value=modalDialogShow_IE("assetman3.asp?mode=1&ffilter=image",640,465); //IE
	else
		modalDialogShow_Moz("assetman3.asp?mode=1&ffilter=image",640,465); //Moz
	}
function InvalidMail(strAddress) 
	{
	var objRegExp  = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;
	if (objRegExp.test(strAddress)) 
		return false;
	else 
		return true;
	}
-->
</script>
<% end sub %>


<% end class %>
