﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

class class_modbox ':: global, class_string, class_baseUtils

	Public box_toggle
	Public box_hide
	Public box_tool_tip
	Public box_name
	Public box_id
	Public box_title_text
	Public box_content
	Public box_tool_tip_text

	Private Sub class_initialize()
		box_name			= ""
		box_toggle			= true
		box_title_text		= ""
		box_hide			= true
		box_content			= ""
		box_id				= 0
		box_tool_tip		= true
		box_tool_tip_text	= ""
		'
		set str = new class_string
	End Sub

	Public Function BoxTopHTML()
		dim box_title_CSS:		box_title_CSS		= "title"
		dim box_image_Path:		box_image_Path		= cor_sSkinPath
		if box_name = "" Then box_name = cor.butil.genUniqueId
		str.adn "<div id="""
		str.adn "module" & box_name
		'ML --------------------------------------------------------------------------------------------------
		if IsNull(cor_sClass) or cor_sClass = "" then cor_sClass = "module"
		str.adn """ class="""
		str.adn cor_sClass 
		str.adn """><!-- <module> -->"
		'----------------------------------------------------------------------------------------------------
		str.add "<div class=""rbt""><div><div>&nbsp;</div></div></div>"
		str.add "<div class=""rbl""><!-- <rbl> -->"
		str.add "<div class=""rbr""><!-- <rbr> -->"
		if  NOT cor.butil.isEmptyStr(box_title_text) Then
			str.add "<div class=""titleBar t-bar""><!-- <titleBar> -->"
			str.add "<div>" ' Add extra div for styling options
			str.adn "<h4 id=""mod"
			str.adn box_name
			str.adn """ class="""
			str.adn box_title_CSS & """>"
			str.adn box_title_text
			str.add "</h4>"
			str.add "<div class=""icons""><!-- <icons> -->"

			if cor.filter.checkBol(box_toggle) Then
				str.adn "<p><a class=""toggle ico-sprt"" id=""toggle" & box_name & """ href=""javascript:void(0);"" title=""Toggle"">&nbsp;</a></p>"
			end if
			if cor.filter.checkBol(box_hide) Then
				str.adn "<p><a class=""hide ico-sprt"" id=""hidemodule" & box_name & """ href=""javascript:void(0);"" title=""Hide"">&nbsp;</a></p>"
			end if
			if (cor.filter.checkBol(box_tool_tip) AND box_tool_tip_text <> "") Then
				str.adn "<p><a class=""tooltip-ico ico-sprt"" id=""show" & box_name & "tt" & """ href=""javascript:void(0);"" title=""Help"">&nbsp;</a></p>"
			end if
			str.add "</div><!-- </icons> -->" 	 'closing div class icons
			str.add "</div>" ' Close extra div fir styling options
			str.add "</div><!-- </titleBar> -->" 'closing div class Titlebar
		end if
		BoxTopHTML = str.build
	End Function

	Public Function BoxTabTopHTML()
		Dim box_title_CSS: 		box_title_CSS		= "title"
		Dim box_image_Path: 	box_image_Path		= cor_sSkinPath
		if box_name = "" Then box_name = cor.butil.genUniqueId
		str.adn "<div id="""
		str.adn "module" & box_name
		str.add """ class=""""><!-- <module> -->"
		str.add "<div class=""rbl""><!-- <rbl> -->"
		str.add "<div class=""rbr""><!-- <rbr> -->"
		BoxTabTopHTML = str.build
	End Function

	Public Function BoxBottomHTML()
		str.add "</div><!-- </rbr> -->"
		str.add "</div><!-- </rbl> -->"
		str.add "<div class=""rbb""><div><div>&nbsp;</div></div></div>"
		str.add "</div><!-- </module> -->"
		BoxBottomHTML = str.build
	End Function

	Public Function BoxContentHTML()
		if box_tool_tip_text <> "" Then
			str.add "<div class=""helpDiv tooltip"" id=""" & box_name & "tt" & """><p><i class=""tooltip ico-sprt"">&nbsp;</i>"
			str.adn box_tool_tip_text
			str.add "</p></div>"
		end if
		str.adn "<div id="""
		str.adn box_name
		str.add """ class=""modular text"">"
		str.adn box_content
		str.add "</div>"
		BoxContentHTML = str.build
	End Function

	Public Function BoxTTHTML()
		str.add "<div class=""helpDiv"" id=""" & box_name & "tt" & """><p class=""tooltip"">"
		str.adn box_tool_tip_text
		str.add "</p></div>"
		BoxTTHTML = str.build
	End Function

	Public Function BoxHTML(btoggle, bhide, btool_tip, bname, bid, btitle_text, byref bcontent, btool_tip_text)
		if cor.butil.isEmptyStr(bcontent) Then exit Function
		Dim outPut
		dim module_box
		set module_box = New class_modbox
		module_box.box_toggle = btoggle
		module_box.box_hide = bhide
		module_box.box_tool_tip = btool_tip
		if NOT cor.butil.isEmptyStr(btool_tip_text) Then module_box.box_tool_tip_text = btool_tip_text
		if NOT cor.butil.isEmptyStr(bname) Then module_box.box_name = bname
		if cor.filter.checkLng(bid) > 0 Then module_box.box_id = bid
		if NOT cor.butil.isEmptyStr(btitle_text) Then module_box.box_title_text = btitle_text
		module_box.box_content = bcontent
		outPut = module_box.BoxTopHTML & module_box.BoxContentHTML & module_box.BoxBottomHTML
		set module_box = nothing
		BoxHTML = outPut
	End Function
	
	Public Function TabBoxHTML(btoggle, bhide, btool_tip, bname, bid, btitle_text, byref bcontent, btool_tip_text)
		if cor.butil.isEmptyStr(bcontent) Then exit Function
		Dim outPut
		dim module_box
		set module_box = New class_modbox
		module_box.box_toggle = btoggle
		module_box.box_hide = bhide
		module_box.box_tool_tip = btool_tip
		if NOT cor.butil.isEmptyStr(btool_tip_text) Then module_box.box_tool_tip_text = btool_tip_text
		if NOT cor.butil.isEmptyStr(bname) Then module_box.box_name = bname
		if cor.filter.checkLng(bid) > 0 Then module_box.box_id = bid
		if NOT cor.butil.isEmptyStr(btitle_text) Then module_box.box_title_text = btitle_text
		module_box.box_content = bcontent
		outPut = module_box.BoxTabTopHTML & module_box.BoxContentHTML & module_box.BoxBottomHTML
		set module_box = nothing
		TabBoxHTML = outPut
	End Function
	
	public sub printBoxTop()
		response.write BoxTopHTML
	end sub

	Public Sub printBoxTabTop()
		response.write BoxTabTopHTML
	end Sub

	public sub printBoxBottom()
		response.write BoxBottomHTML
	end sub

	public sub printBoxContent()
		response.write BoxContentHTML
	end sub

	public sub printBoxTT()
		response.write BoxTTHTML
	end sub

	public sub printBox(btoggle, bhide, btool_tip, bname, bid, btitle_text, byref bcontent, btool_tip_text)
		response.write BoxHTML(btoggle, bhide, btool_tip, bname, bid, btitle_text, bcontent, btool_tip_text)
	end sub

	Public sub printTabBox(btoggle, bhide, btool_tip, bname, bid, btitle_text, byref bcontent, btool_tip_text)
		response.write TabBoxHTML(btoggle, bhide, btool_tip, bname, bid, btitle_text, bcontent, btool_tip_text)
	end Sub

	private sub class_terminate
		set str = nothing
	end sub

	private str

end class

'<#late-binding hook
function boot_class_modbox : boot_class_modbox = true : end function
'/>

%>