﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - initial 26/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
class class_permissions ':: global, class_baseUtils, class_filters, class_DAL, class_debug  
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function isAdmin()
		if cor_iGroupID = 1 Then
			isAdmin = true
		else
			isAdmin = false
		end if
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function isModerator()
		if cor_iGroupID = 3 Then
			isModerator = true
		else
			isModerator = false
		end if
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function debugPanel( strSwitch )
		if cor_bDebug Then
			
			str.add "<div class=""show"">"
			str.add "<h4>Debug Panel (Click to Expand)</h4>"
			str.add "<div>"
			str.add "<table summary='' class=""soop"" width=""100%"">"
	
			Select case lcase(strSwitch)
			case "forums"
				str.add "<tr><td width=""20%"">Member:</td><td>" 				& cor_lUserID 		& "</td></tr>"
				str.add "<tr><td width=""20%"">Group:</td><td>" 				& cor_iGroupID 		& "</td></tr>"
				str.add "<tr><td width=""20%"">Moderator:</td><td>" 			& cor_bModerator 	& "</td></tr>"
				str.add "<tr><td width=""20%"">&nbsp;</td><td>&nbsp;</td></tr>"
				str.add "<tr><td width=""20%"">Access to Forum:</td><td>" 		& cor_bRead 		& "</td></tr>"
				str.add "<tr><td width=""20%"">ReadOnly Forum:</td><td>" 		& cor_bReadOnly 	& "</td></tr>"
				str.add "<tr><td width=""20%"">&nbsp;</td><td>&nbsp;</td></tr>"
				str.add "<tr><td width=""20%"">Post Topics:</td><td>" 			& cor_bPost 		& "</td></tr>"
				str.add "<tr><td width=""20%"">Reply to Posts:</td><td>" 		& cor_bReply 		& "</td></tr>"
				str.add "<tr><td width=""20%"">Edit Own Posts:</td><td>" 		& cor_bEdit 		& "</td></tr>"
				str.add "<tr><td width=""20%"">Delete Own Posts:</td><td>" 		& cor_bDelete 		& "</td></tr>"
				str.add "<tr><td width=""20%"">&nbsp;</td><td>&nbsp;</td></tr>"
				str.add "<tr><td width=""20%"">Edit Others Posts:</td><td>" 	& cor_bEditAll 		& "</td></tr>"
				str.add "<tr><td width=""20%"">Delete Others Posts:</td><td>" 	& cor_bDeleteAll 	& "</td></tr>"
				str.add "<tr><td width=""20%"">&nbsp;</td><td>&nbsp;</td></tr>"
				str.add "<tr><td width=""20%"">Polls:</td><td>" 				& cor_bPoll 		& "</td></tr>"
				str.add "<tr><td width=""20%"">Voting:</td><td>" 				& cor_bVotes 		& "</td></tr>"
				str.add "<tr><td width=""20%"">&nbsp;</td><td>&nbsp;</td></tr>"
				str.add "<tr><td width=""20%"">RTE Editor:</td><td>" 			& cor_bUseRichEditor & "</td></tr>"
				str.add "<tr><td width=""20%"">&nbsp;</td><td>&nbsp;</td></tr>"
				str.add "<tr><td width=""20%"">Debugging:</td><td>" 			& cor_bDebug 		& "</td></tr>"
			end select
			str.add "</table>"
			str.add "</div>"
			str.add "</div>"
			response.write str.build
		end if
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	' This will read settings for the concerned forum
	'
	' TO DO: implement special settings on group or member level for the concerned forum
	'	  : password protected forums
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function setForumAccess( intForum )
		dim arrPerm
		dim x_i
		dim row_y
		'
		' admins get full access by default
		'
		if isAdmin() Then
			cor_bModerator 	 = true
			cor_bEditAll 	 = true
			cor_bDeleteAll 	 = true
			cor_bRead 		 = true
			cor_iModGroup	 = 1
			'
			cor_bReply 		 = true
			cor_bEdit 		 = true
			cor_bBan  		 = true	
			cor_bDelete 	 = true
			cor_bPoll 		 = true
			cor_bVotes 		 = true
			cor_bAttachments = true
			cor_bImageUpload = true
			cor_bShowPosts 	 = true
			cor_bShowTopics  = true	
			cor_bReadOnly 	 = false
			cor_bPost 		 = true
			exit function
		end if
		'
		' restrictive defaults (as guest)
		'	
		cor_bModerator 	 = false
		cor_bEditAll 	 = false
		cor_bDeleteAll 	 = false
		cor_bRead 		 = false
		cor_iModGroup	 = 2
		'
		cor_bReply 		 = false
		cor_bEdit 		 = false
		cor_bBan  		 = false
		cor_bDelete 	 = false
		cor_bPoll 		 = false
		cor_bVotes 		 = false
		cor_bAttachments = false
		cor_bImageUpload = false
		cor_bShowPosts 	 = false
		cor_bShowTopics  = false
		cor_bReadOnly 	 = true
		cor_bPost 		 = false
		'
		if NOT isNumeric(intForum) Then exit function
		if intForum=0 Then exit function
		'	
		'--0-----1---------2------------3----------4------5-------6--------7-------8--------9-------------10-------
		' sid, sperm, smembersonly, spermadmin, sreply, sedit, sdelete, screate, svote, sattachments, simageupload, 
		'--11------12----13-----14-------15----------16--------17-----18-------19----------------------------------
		' shide, sshow, suid, snormal, smoderate, sreadonly, spost, sname, spassword
		'
		row_y = getForumPermRow(intForum)
		'
		if  NOT cor.butil.eof(cor_aForumsPerm) AND row_y >=0 Then '<cor_aForumsPerm>
			'
			' If member's group can moderate this forum set it with moderator defaults
			'
			if  cor.filter.checkInt(cor_aForumsPerm(15,row_y)) = cor.filter.checkInt(cor_iGroupID) Then 
				cor_bModerator 	 = true
				cor_bEditAll 	 = true
				cor_bDeleteAll 	 = true
				cor_bRead 		 = true
				cor_iModGroup 	 = 3
				'
				cor_bReply 		 = true
				cor_bEdit 		 = true
				cor_bBan		 = true
				cor_bDelete 	 = true
				cor_bPoll 		 = true
				cor_bVotes 		 = true
				cor_bAttachments = true
				cor_bImageUpload = true
				cor_bShowPosts 	 = true
				cor_bShowTopics  = true	
				cor_bReadOnly 	 = false
				cor_bPost 		 = true 
				exit function
			end if
			'
			'--- Set ordinary member access
			'
			' find if member's group has rights to read this forum
			if NOT isNull(cor_aForumsPerm(1,row_y)) Then
				arrPerm = split( cor_aForumsPerm(1,row_y) , "," )
				for x_i = 0 to ubound(arrPerm)
					if  cor.filter.checkInt(arrPerm(x_i)) = cor.filter.checkInt(cor_iGroupID) Then
						cor_bRead = true
						exit for
					end if
				next
			end if
			'
			if cor.filter.checkInt(cor_aForumsPerm(4, row_y)) = 1 Then cor_bReply 	  	= true
			if cor.filter.checkInt(cor_aForumsPerm(5, row_y)) = 1 Then cor_bEdit 		= true
			if cor.filter.checkInt(cor_aForumsPerm(6, row_y)) = 1 Then cor_bDelete 	  	= true
			if cor.filter.checkInt(cor_aForumsPerm(7, row_y)) = 1 Then cor_bPoll 		= true
			if cor.filter.checkInt(cor_aForumsPerm(8, row_y)) = 1 Then cor_bVotes 	  	= true
			if cor.filter.checkInt(cor_aForumsPerm(9, row_y)) = 1 Then cor_bAttachments = true
			if cor.filter.checkInt(cor_aForumsPerm(10,row_y)) = 1 Then cor_bImageUpload = true
			if cor.filter.checkInt(cor_aForumsPerm(11,row_y)) = 1 Then cor_bShowPosts   = true
			if cor.filter.checkInt(cor_aForumsPerm(12,row_y)) = 1 Then cor_bShowTopics  = true
			if cor.filter.checkInt(cor_aForumsPerm(16,row_y)) = 1 Then cor_bReadOnly 	= true
			if cor.filter.checkInt(cor_aForumsPerm(17,row_y)) = 1 Then cor_bPost 		= true
			'
			' if a guest, and access has been allowed to this forum, BUT readonly = false
			' then guests could post and reply but nothing else, such as deleting own posts, editing own posts, etc.
			'
			if  cor_bGuest Then '<cor_bGuest>
				if  cor.filter.checkInt(cor_aForumsPerm(16,row_y)) = 1 Then 
					cor_bReadOnly = true
					cor_bPost 	  = false
					cor_bReply 	  = false
				end if
				cor_bEdit 	= false
				cor_bDelete = false
			end if '</cor_bGuest>
			'
		end if '</cor_aForumsPerm>
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function getForumPermRow(fid)
		dim x_i
		getForumPermRow = -1
		if cor.butil.eof(cor_aForumsPerm) Then exit function
		for x_i = 0 to ubound(cor_aForumsPerm,2)
			if cor_aForumsPerm(0,x_i) = fid Then getForumPermRow = x_i : exit function
		next
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function checkMenuPerm(menuCond, menuPerm, menuActive)
		select case cor.filter.checkint(menuCond)
			case 1 ' Display all time
				if (checkPerm(menuPerm, cor_iGroupID)>0) and (menuActive <> 0) Then
					checkMenuPerm = 1 'true
				else
					checkMenuPerm = 0 'false
				end if
			case 2 ' Only when Logged On - so NOT belonging to group 2 Guests !!!
				if cor_bMember AND NOT cor_bGuest AND (checkPerm(menuPerm,cor_iGroupID)>0) AND (menuActive <> 0)  Then
					checkMenuPerm = 1 'true
				else
					checkMenuPerm = 0 'false
				end if
			case 3 ' Only When Logged Off
				if NOT cor_bMember AND cor_bGuest AND (menuActive <> 0) Then
					checkMenuPerm = 1 'true
				else
					checkMenuPerm = 0 'false
				end if
			case else ' Display all time
				checkMenuPerm = 1 'true
		end select
	end function
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'------------------------------------------------------------------------------------------------------------------------------------------
	public function checkPerm(Permission, Pattern)
		dim intCount, intPerm
		checkPerm = 0 'false
		if isEmpty(Permission) or isnull (Permission) then Permission = " "
		intPerm = split(Permission,",")
		for intCount = 0 to ubound(intPerm)
			if cor.filter.checkInt(intPerm(intCount)) = cor.filter.checkInt(Pattern) AND cor.filter.checkInt(Pattern) > 0 Then
				checkPerm = 1 'true
				exit function
			end if
		next
	end function
	'
	private sub class_initialize
		set str = new class_string
	end sub
	'
	private sub class_terminate
		set str = nothing
	end sub
	'
	private str
	private p_sql
end class 

'<#late-binding hook
function boot_class_permissions : boot_class_permissions = true : end function
'/>

%>