<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
'Revision 2.0001 - initial 27/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
class class_stats ':: global, class_baseUtils, class_DAL, class_io

	public exec
	public update
	public error

	private sub class_initialize()
		exec   = "new"
		update = true
		error  = ""
	end sub

	public sub doStat()
		'On error resume next
		dim ssql, arrStat, ix
		'
		dim st_sessionid 	: st_sessionid 	 = session.sessionID
		dim st_authorID 	: st_authorID 	 = cor_lUserID
		dim st_datetime 	: st_datetime 	 = Now()
		dim st_referrer		: st_referrer 	 = cor_sReferer
		dim st_ip 			: st_ip			 = cor.butil.IP()
		dim st_useragent 	: st_useragent 	 = request.serverVariables("HTTP_USER_AGENT")
		dim st_querystring	: st_querystring = request.serverVariables("QUERY_STRING")
		dim st_remotehost	: st_remotehost	 = request.serverVariables("REMOTE_HOST")
		dim st_language		: st_language 	 = request.serverVariables("HTTP_ACCEPT_LANGUAGE")
		dim st_os 			: st_os			 = request.serverVariables("SERVER_SOFTWARE")
		'
		select case lcase(exec)
		case "update"
			ssql = "UPDATE " & cor_dbpre & "stats SET st_authorid={0}, st_datetime={1}, st_referrer={2}, st_ip={3}, st_useragent={4}, st_querystring={5}, st_remotehost={6}, st_language={7}, st_os={8} " _
				 & "WHERE "  & cor_dbpre & "stats.st_sessionid={9}"
			cor.dal.exec ssql, array(st_authorID, st_datetime, st_referrer, st_ip, st_useragent, st_querystring, st_remotehost, st_language, st_os, st_sessionid)
			'
		case "new"
			ssql = "INSERT INTO " & cor_dbpre & "stats (st_authorid, st_datetime, st_referrer, st_ip, st_useragent, st_querystring, st_remotehost, st_language, st_os, st_browser) VALUES ({0},{1},{2},{3},{4},{5},{6},{7},{8})" 
			cor.dal.exec ssql, array(st_authorID, st_datetime, st_referrer, st_ip, st_useragent, st_querystring, st_remotehost, st_language, st_os)
			'
		case else
			' not applicable
		end select

		if err.number<>0 Then 
			update = false
			error  = err.description
		else
			update = true
			if session(cor_pre&"user_stat") = "update" then session(cor_pre&"user_stat") = "done"
		end if
		'On error goto 0
	end sub
	'
	private p_sql
end class

'<#late-binding hook
function boot_class_stats : boot_class_stats = true : end function
'/>
%>
