<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<%
class class_string
	'
	public property let growSize(size)
		intSize = size
	end Property
	'	
	' for custom delimited arrays
	public property let delim(str)
		sdelim = str
	end Property
	'
	public sub wri(byref text)
		response.write text & vbcrlf
	end sub
	'
	public sub wrn(byref text)
		response.write text
	end sub
	'
	public sub add(byref text)
		if  intValues >= ubound(varData) then
			redim preserve varData(ubound(varData) + intSize)
		end if
		varData(intValues) = text & ""	'handle nulls
		intValues = intValues + 1
		' for less verbosity add extra separator here (usually vbcrlf)
		varData(intValues) = sdelim
		intValues = intValues + 1
	end sub
	'
	public sub adn(byref text)
		if  intValues > ubound(varData) then
			redim preserve varData(ubound(varData) + intSize)
		end if
		varData(intValues) = text & ""  'handle nulls
		intValues = intValues + 1
	end sub

	public function BuildButton (strurl, strtitle, strbuttonType, strText, strAClass)
		'build a button using standard sprites.
		'call example to build an Add button:
		'cor.str.BuildButton("mgmt_addUser.asp", lngAdd, "add", lngAdd, False)
		'strUrl is the href url we are sending user to.
		'strTitle is <a tag's title= text
		'strButtonType is a reference to the actual icon to be used
		'strText is text between the <a...> and the </a> tags
		'blnModal turns on the <a class=doModal when true
		dim strBClass						'select the button
		select case lcase(strButtonType)
		case "search"
			strBClass = "search"
		case "folderlocked"
			strBClass = "folderlocked"
		case "add"
			strBClass = "add"
		case "edit"
			strBClass = "edit"
		case "print"
			strBClass = "print"
		case "prev"
			strBClass = "prev"
		case "next"
			strBClass = "next"
		case else
			strBClass = ""
		end select
		if len(strBClass) > 2 then strBClass = " class=""" & strBClass & "-ico ico-sprt"""
		BuildButton = "<div class=""ui button"">"
		if len(strAClass) > 2 then				'select a class (modal)
			BuildButton = BuildButton  & "<a class=""" & strAClass & """ "
		else
			BuildButton = BuildButton  & "<a "
		end if
		BuildButton = BuildButton &"href=""" & strUrl & """ title=""" & strTitle & """>" & _
					"<span><i" & strBClass & "></i>" & strText & "</span></a></div>"
	end function

	public function build()
		redim preserve varData(intValues)
		build = join(varData, "")
		erase varData
		call class_initialize
	end function
	'
	public sub clear
		erase varData
		call class_initialize
	end sub
	'
	private sub class_initialize()
		intSize    = 100
		redim varData(intSize)
		intValues  = 0
		sdelim 	   = vbcrlf
	end sub
	'
	private varData, intValues
	private intSize
	private sdelim
	'	
end class

'<#late-binding hook
function boot_class_string : boot_class_string = true : end function
'/>
%>
