﻿<%
'---------------------------------------------------------------------------------------------------------------------------
'
'
'
'---------------------------------------------------------------------------------------------------------------------------
Function tpl_header( blnBanners, blnInpageTools, bHeaderLines )

	cor.str.add "<div id=""header""><!-- <header> -->"
	cor.str.add "<div id=""headerContent"" class=""t-bar""><div class=""t-bar""><div class=""t-bar""><div><!-- <headerContent> -->"
	if bHeaderLines then
		cor.str.add "<div class=""mtitle"">"
		cor.str.add "<h3 class=""mSectionTitle"">" & cor_sSectionTitle & "</h3>"
		cor.str.add "<h1 class=""mSiteTitle"">" & lngWebSiteTitleLogo & "</h1>"
		cor.str.add "<h2 class=""mPageTitle"">"& cor.filter.ReverseHTMLCode(replace(cor_sPageTitle,cor_sTitleDelim," ")) & "</h2>"
		cor.str.add "</div>"
	end if
	cor.str.add "<div class=""mbanner"">"
	if blnBanners Then
		cor.str.add cor.butil.PrintBanner(1)
	end If
	cor.str.add "</div>"
	if blnInpageTools Then
		cor.str.add tpl_inPageTools()
	end if
	cor.str.add "</div></div></div></div><!-- </headerContent> -->"
	cor.str.add "</div><!-- </header> -->"

	tpl_header = cor.str.build

End Function
'---------------------------------------------------------------------------------------------------------------------------
'
'
'
'---------------------------------------------------------------------------------------------------------------------------
Function tpl_hmenu()

	cor.str.add "<div class=""hmenuOuterWrap""><div class=""hmenuInnerWrap"">"
	cor.str.add "<div id=""menubar""><!-- <menubar> -->"
	cor.str.add cor_sMenuH
	cor.str.add "</div><!-- </menubar> -->"
	cor.str.add "</div></div>"

	tpl_hmenu = cor.str.build

End Function
'---------------------------------------------------------------------------------------------------------------------------
'
'
'
'---------------------------------------------------------------------------------------------------------------------------
Function tpl_footer( bFooterMenu, bFooterIcons, bShowProcessInfo, bShowLicense )

	if bFooterMenu <> 0 then
		cor.str.add "<div id=""footerMenu""><!-- <footerMenu> -->"
		cor.str.add tpl_bottommenu()
		cor.str.add "<br /><br /><div>"
	end if
	'
	cor.str.add "<div id=""footer"" class=""modular""><!-- <footer> -->"
	cor.str.add "<div class=""holder1""><!-- <selfClear> -->"
	if bShowProcessInfo Then
		cor.str.add "<div class=""holder2""><p>" & vbcrlf & lngThisPageWasGeneratedIn & "&nbsp;" & FormatNumber(Timer() - cor_dStartTime, 4) & "&nbsp;" & lngSeconds & "</p>"
		if  NOT cor_cUseSqlShield OR cor_bModerator Then
			cor.str.add "<p>" & lngIOShieldOff & "&nbsp;"
		elseif cor_cUseSqlShield Then
			cor.str.add "<p>" & lngIOShieldOn  & "&nbsp;"
		end if
		cor.str.add "(" & lngDBcalls & " " & cor_iQueriesTotal & ")&nbsp;-&nbsp;" & iif(cor_bCached, lngCached, lngNotCached) & "&nbsp;-&nbsp;" & cor.butil.datetime(now(),cor_iDateFormat)
		cor.str.add	"</p></div><!-- </holder2> -->"
	end if
	cor.str.add "<div class=""holder3""><!-- <holder3> -->"
	if bShowLicense then
		'*****************************************************************************************************
		'***** WARNING - REMOVAL OR MODIFICATION OF THE CODE BELOW WILL VIOLATE THE LICENSE AGREEMENT ********
		'*****************************************************************************************************
		cor.str.add "<p><a href=""http://www.soopportal.org"" title=""" & lngPoweredBySOOPPortal & cor_SoopCoreVersion & """ target=""_blank"">SOOP Portal</a>&nbsp;" & cor_SoopCoreVersion & " (" & cor_sDatabaseType & ")</p>"
		'*****************************************************************************************************
		'***** WARNING - REMOVAL OR MODIFICATION OF THE CODE ABOVE WILL VIOLATE THE LICENSE AGREEMENT ********
		'*****************************************************************************************************
	end if
	if bFooterIcons Then
		cor.str.add "<p><a target=""_blank"" href=""http://validator.w3.org/check/referer"" title="""& lngValidXHTML &"""><span class=""xhtml-logo logoicons""></span></a>"
		cor.str.add "<a target=""_blank"" href=""http://jquery.com"" title=""" & lngPoweredWithJQuery & """><span class=""jquery-logo logoicons""></span></a>"
		cor.str.add "<a target=""_blank"" href=""http://www.soopportal.org"" title=""" & lngPoweredBySOOPPortal & cor_SoopCoreVersion & """><span class=""powered-logo logoicons""></span></a></p>"
	end if
	cor.str.add "</div><!-- </holder3> -->"
	cor.str.add "</div><!-- </holder1> -->"
	cor.str.add "</div><!-- </footer> -->"
	call cor.modbox.printBox(false,false,false,"moduleFooter",0,"", cor.str.build,"")

	tpl_footer = cor.str.build
	
End Function
'---------------------------------------------------------------------------------------------------------------------------
'
'
'
'---------------------------------------------------------------------------------------------------------------------------
Function tpl_graphfooter( bFooterMenu, bFooterIcons, bShowProcessInfo, bShowLicense )

	if bFooterMenu <> 0 then
		cor.str.add "<div id=""footerMenu""><!-- <footerMenu> -->"
		cor.str.add tpl_bottommenu()
		cor.str.add "<br /><br /><div>"
	end if
	'
	cor.str.add "<div id=""footer"" class=""modular""><!-- <footer> -->"
	cor.str.add "<div id=""footerContent""><!-- <footerContent> -->"
	cor.str.add "<div>"
	cor.str.add "<div>"
	cor.str.add "<div class=""floatRight"">"
	if bShowProcessInfo Then
		cor.str.add lngThisPageWasGeneratedIn & "&nbsp;" & FormatNumber(Timer() - cor_dStartTime, 4) & "&nbsp;" & lngSeconds & "&nbsp;&nbsp;<br />"
		if  NOT cor_cUseSqlShield OR cor_bModerator Then
			cor.str.add lngIOShieldOff & "&nbsp;"
		elseif cor_cUseSqlShield Then
			cor.str.add lngIOShieldOn  & "&nbsp;"
		end if
		cor.str.add "(" & lngDBcalls & " " & cor_iQueriesTotal & ")&nbsp;&nbsp;"
		cor.str.add iif(cor_bCached, lngCached, lngNotCached) & "<br />"
		cor.str.add cor.butil.datetime(now(),cor_iDateFormat)
	end if
	cor.str.add "<br />" 
	if bShowLicense then
		'*****************************************************************************************************
		'***** WARNING - REMOVAL OR MODIFICATION OF THE CODE BELOW WILL VIOLATE THE LICENSE AGREEMENT ********
		'*****************************************************************************************************
		cor.str.add "<a href=""http://www.soopportal.org"" title=""SOOPPortal"" target=""_blank"">SOOP Portal Phoenix</a>&nbsp;" & cor_SoopCoreVersion & " (" & cor_sDatabaseType & ")<br /><br />"
		'*****************************************************************************************************
		'***** WARNING - REMOVAL OR MODIFICATION OF THE CODE ABOVE WILL VIOLATE THE LICENSE AGREEMENT ********
		'*****************************************************************************************************
	end if
	if bFooterIcons Then
		cor.str.add "<p><a target=""_blank"" href=""http://validator.w3.org/check/referer"" title="""& lngValidXHTML &"""><span class=""xhtml-logo logoicons""></span></a>"
		cor.str.add "<a target=""_blank"" href=""http://jquery.com"" title=""" & lngPoweredWithJQuery & """><span class=""jquery-logo logoicons""></span></a>"
		cor.str.add "<a target=""_blank"" href=""http://www.soopportal.org"" title=""" & lngPoweredBySOOPPortal & cor_SoopCoreVersion & """><span class=""powered-logo logoicons""></span></a></p>"
	end if
	cor.str.add "</div>"
	cor.str.add "</div></div></div></div><!-- </footerContent> -->"
	cor.str.add "</div><!-- </footer> -->"
	'
	tpl_graphfooter = cor.str.build
	
End Function
'---------------------------------------------------------------------------------------------------------------------------
'
'
'
'---------------------------------------------------------------------------------------------------------------------------
Function tpl_bottommenu()

	dim strLabel, strXMLlabel, strURL, arrMenu, i, x, strTemp
	
	if not IsNull(cor.cfg.item("bottomMenu")) and cor.cfg.item("bottomMenu") <> "-" then
		arrMenu = Split(cor.cfg.item("bottomMenu"),",")
		for i = 0 To ubound(arrMenu)
			x = inStr(arrMenu(i),"|")
			strLabel = Mid(arrMenu(i),1,x-1)
			strURL = Mid(arrMenu(i),x+1)
					strXMLlabel = cor.lng.getKey("cor_xmlSoopMenu",strLabel)
					if isNull(strXMLlabel) OR strXMLlabel = "" Then strXMLlabel = strLabel
			cor.str.add "<div class=""ui button petite""><a href=""" &  strURL  & """><span>" &  strXMLlabel  & "</span></a></div>"
		next
	end if

	tpl_bottommenu = cor.str.build

End Function
'
'---------------------------------------------------------------------------------------------------------------------------
'
'
'
'---------------------------------------------------------------------------------------------------------------------------
function tpl_inPageTools()

	'Print icons across the top for site-wide functionality
	cor.str.add "<div class=""inpagetools"">"
	' shared variables SERVER_PROTOCOL
	dim inPagehtt		: inPagehtt = split(lcase(Request.ServerVariables("SERVER_PROTOCOL")),"/")
	dim inPageSrcURL	: inPageSrcURL =  inPagehtt(0) & "://" & Request.ServerVariables("HTTP_HOST") & _
							Request.ServerVariables("PATH_INFO") & "?" & Request.ServerVariables("QUERY_STRING")
'	cor.str.adn "<form method=""get"" id=""frmSearch"" action=""search.asp""><input type=""text"" id=""gsearch"" name=""gsearch"" maxlength=""100"" size=""10"" />"
'	cor.str.adn " <b class=""ui""><a class=""search-ico ico-sprt"" title=""Search"" onclick=""javascript:$('#frmSearch').submit();"">&nbsp;</a></b>&nbsp;|&nbsp;"
'	cor.str.add "</form>"
	'cor.str.add "<b class=""ui"">"
'	cor.str.add "<form method=""get"" id=""frmSearch"" action=""search.asp"" border=""1px;"">"
'	cor.str.add "<input type=""text"" id=""q"" name=""q"" maxlength=100 size=10 /> "	
'	cor.str.add "<b class=""ui""><a class=""search-ico ico-sprt"" title=""" & lngSearch & """ onclick=""javascript:$('#frmSearch').submit();"">&nbsp;</a></b>"
		'cor.str.add "<button id=""wu_submit"" type=""submit"" value=""" & lngSearch & """ title=""" & lngSearch & """><span><i class=""search-ico ico-sprt""></i> </span></button>"  '
'	cor.str.add "</form>&nbsp;|&nbsp;"
	'
	cor.str.add "<b class=""ui""><a class=""search-ico ico-sprt"" href=""search.asp " & "title=""" & lngSearch & """>&nbsp;</a></b>&nbsp;|&nbsp;"
	cor.str.add "<b class=""ui""><a class=""doModal print-ico ico-sprt"" href=""printpage.asp?ref=" & server.URLEncode(inPageSrcURL) & "&amp;pt=" & lngPrintPage & """ " & "title=""" & lngPrintPage & """ rel=""700:700"">&nbsp;</a></b>&nbsp;|&nbsp;"
	cor.str.add "<b class=""ui""><a class=""doModal pm-ico ico-sprt"" href=""pagetools.asp?do=" & cor_cDoNewEmailContactUs & "&amp;ref=" & server.URLEncode(inPageSrcURL) & """ " & "title=""" & lngContactUs & """ rel=""680:600"">&nbsp;</a></b>&nbsp;|&nbsp;"
	cor.str.add "<b class=""ui""><a class=""doModal email-ico ico-sprt"" href=""pagetools.asp?do=" & cor_cDoNewEmailFriendPage & "&amp;KeepThis=true&amp;ref=" & server.URLEncode(inPageSrcURL) & """ title=""" & lngEmailPageFriend & """ rel=""700:720"">&nbsp;</a></b>"

	cor.str.add "</div>"
	
	tpl_inPageTools = cor.str.build
	
end Function
'
'---------------------------------------------------------------------------------------------------------------------------
'
'
'
'---------------------------------------------------------------------------------------------------------------------------
function tpl_banner( sLine1, sLine2, sGraphic )

	cor.str.add "<div class=""banner"">"
	cor.str.add "<div class=""bannerContent"">"
	cor.str.add "<div>"
	cor.str.add "<h4>" & sLine1  & "</h4>"
	cor.str.add sLine2  & ""
	cor.str.add "</div>"
	cor.str.add "</div>"
	cor.str.add "</div>"
	
	tpl_banner = cor.str.build	
	
End Function

%>
