<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

' Important:
'-----------
' - Change constant values only if you know what you're doing. 
' - Do not change them after SooP has been online for a long time, or it could mess it up with referrals/cached url's)
' - '0' (zero) constant values not allowed

'--- DO tasks: generic tokens

const cor_cDoNew				= 1
const cor_cDoEdit				= 2
const cor_cDoCopy				= 3
const cor_cDoDelete				= 4
const cor_cDoReSync				= 15
const cor_cDoRecalculate		= 16
'
'--- DO tasks: member profile mgmt
'
const cor_cDoMemberView			= 1
const cor_cDoMemberNew			= 2
const cor_cDoMemberActivate		= 3
const cor_cDoMemberActivateAdm	= 4
const cor_cDoMemberUpdate		= 5
const cor_cDoMemberUpdatePass	= 6
const cor_cDoMemberNewPass		= 7
const cor_cDoMemberWarn			= 8
const cor_cDoMemberBan			= 9
const cor_cDoMemberUnban		= 10
const cor_cDoMemberAddBuddy		= 11
const cor_cDoMemberDelBuddy		= 12
const cor_cDoMemberDelete		= 13
const cor_cDoMemberTerms		= 14		'show member terms
'
'--- login/logout
'
const cor_cLogin 				= 1
const cor_cLogout 				= 2
const cor_cLoginCheck			= 3
'
'
'--- action tokens (dual IO)
'
const cor_cSelect				= 1
const cor_cInsert				= 2
const cor_cUpdate				= 3
'
'--- action sources (dual IO)
'
const cor_cForm					= 1
const cor_cSql					= 2
const cor_cAttr					= 3
const cor_cForm1Sql2			= 4
const cor_cSql1Form2			= 5
const cor_cAttr1Form2			= 6
const cor_cAttr1Sql2			= 7
const cor_cForm1Attr2			= 8
const cor_cSql1Attr2			= 9
'
'--- value types for IO comparisons
'
const cor_cAut					= 1
const cor_cInt					= 2
const cor_cDbl					= 3
const cor_cLng					= 4
const cor_cStr					= 5
const cor_cBool					= 6
const cor_cDate					= 7
const cor_cTime					= 8
const cor_cSoopBool				= 9
const cor_cStrEmpty				= 10

'
'--- sql shield types
'
const cor_cShieldNone			= 1
const cor_cShieldSql			= 2
const cor_cShieldXSS			= 3
const cor_cShieldSqlXSS			= 4
'
' cross-script boolean-safe constants
' true  :: msAccess: -1 (default ANSI-89 SQL), msSQL/mysql: 1, JS: > 0, ASP: <> 0. 
' false :: 0 for all
'
const cor_cAnsi89true 			= -1
const cor_cUtrue 				=  1
const cor_cUfalse				=  0
'
'------------------------------------
' used ASP constants
'------------------------------------
'--- FSO
const cor_cForReading			= 1
const cor_cForWriting			= 2
const cor_cForappending			= 8
'--- ADO
'CursorLocation 
const cor_cUseServer			= 2
const cor_cUseClient			= 3
'CursorTypes
const cor_cForwardOnly			= 0
const cor_cOpenStatic			= 3
'LockTypes
const cor_cLockReadOnly			= 1
const cor_cLockPessimistic		= 2
const cor_cLockOptimistic		= 3
const cor_cLockBatchOptimistic	= 4
'
const cor_cStateOpen			= 1
const cor_cStateClosed			= 0
'stream
const cor_cTypeBinary			= 1
const cor_cTypeText 			= 2
'
'--- filters - leave these here as used in many places
'
const cor_cFilterModeAnyWord	= 1
const cor_cFilterModeAllWords	= 2
const cor_cFilterModePhrases	= 3
const cor_cFilterSearchInTitle	= 4
const cor_cFilterSearchInBody	= 5
const cor_cFilterSearchInBoth	= 6
'
'--- Orders
'
const cor_cOrderLatest			= 1
const cor_cOrderTitle			= 2
const cor_cOrderViews			= 3
const cor_cOrderReplies			= 4
'
const cor_cOrderDesc			= 5
const cor_cOrderAsc				= 6
'
const cor_cOrderRegistered		= 7
const cor_cOrderName			= 8
const cor_cOrderUserName		= 9
'
'--- Time
'
const cor_cTimeNew				= 1
const cor_cTimeYesterday		= 2
const cor_cTimeThisWeek			= 3
const cor_cTime2Weeks			= 4
const cor_cTimeThisMonth		= 5
const cor_cTimeThisYear			= 6
const cor_cTimeAll				= 7
'
'--- DO tasks: PM - as close to members handling left here
'
const cor_cDoViewPMIn			= 1
const cor_cDoViewPMOut			= 2
const cor_cDoNewPM				= 3
const cor_cDoNewPMList			= 4
const cor_cDoNewPMReply			= 5
const cor_cDoEditPM				= 6
const cor_cDoDelPM				= 7
const cor_cDoDelPMAll			= 8
const cor_cDoNewEmail			= 9
const cor_cDoNewEmailList		= 10
const cor_cDoNewEmailContactUs	= 11
const cor_cDoNewEmailFriendPage	= 12

'
%>
