﻿<!--#include file="db/_soop_pageglobal.asp" -->
<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
' Revision 2.00 - initial 15/02/2008
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------
%>
<!--#include file="common.asp" -->
<%
call cor.tpl.init("faq")
call cor.tpl.header("Page Structure","")

dim strSkinPath
'original TABLE style tag:
'style="background: rgb(236, 238, 236) url(../skins/boodata/img/16px-sprite.png) no-repeat scroll 8px 16px; line-height: 16px; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;" border="0" cellpadding="0" cellspacing="0">

'we need the path to the skin icons:
strSkinPath = cor_sSkinCss
dim i
for i = len(strSkinPath) to 1 step -1
	if mid(strSkinPath, i, 1) = "/" then
		strSkinPath = left(strSkinPath, i)
		exit for
	end if
next

'<!DOCTYPE HTML PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
'<html><head>
'	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
'	<title>Page Structure</title>
'	<link rel="STYLESHEET" type="text/css" href="page-structure_files/boodata.css">
'	<style type="text/css"><!--
'	pre{font: normal 12px/16px "Courier New", Courier, monospace;}
'	p{margin: 0 0 5px 0;text-indent: 20px;line-height:16px;}
'	h2,h3,h4{margin: 0 0 5px 0;}
'	b pre{font: bold 12px/16px "Courier New", Courier, monospace;background:#eceeec;}
'	ol, ul, li{margin:.3em .3em .3em 1.2em;}
'	--></style>
'
'</head><body>
cor.str.wri cor.modbox.printBoxTop & "<div class=""modular text"">"
%>
<h1 class="center">Page Structure.</h1>
<p>Almost everything in our pages is built using 3 nested div tags.</p><pre>	&lt;div&gt;
	    &lt;div&gt;
		&lt;div&gt;&amp;nbsp;&lt;/div&gt;
	    &lt;/div&gt;
	&lt;/div&gt;</pre>

<h3>The Wrapper</h3>
<ol>
	<li><b><pre>&lt;div id="wrapper"&gt;&lt;!-- &lt;wrapper&gt; --&gt;</pre></b>
	</li>
</ol>
<p>The top level div that holds everything in the page from the start
of the main site header to the end of the footer. This is the first div
opened and the last closing div next to the close body tag.</p>
<h3>The Header</h3>
<div id="header"><!-- <header> -->
	<div id="headerContent" class="t-bar"><div class="t-bar"><div class="t-bar">
		<div><!-- <headerContent> -->
			<div class="mtitle">
				<h3 class="mSectionTitle">Section Management Title</h3>
				<h1 class="mSiteTitle">Language File,lngWebSiteTitleLogo</h1>
				<h2 class="mPageTitle">cor.util.pageTitle(strHeader,strSearch)</h2>
			</div>
			<div class="mbanner">
				<a target="_blank" href="http://www.soopportal.org"><img alt="Soop Portal" src="uploads/assets/banners/soopportal.org.ani.gif"></a>
			</div>
		</div>
	</div></div></div><!-- </headerContent> -->
</div><!-- </header> -->
<pre>&lt;div id="header"&gt;&lt;!-- &lt;header&gt; --&gt;
    &lt;div id="headerContent" class="t-bar"&gt;&lt;div class="t-bar"&gt;&lt;div class="t-bar"&gt;
	&lt;div&gt;&lt;!-- &lt;headerContent&gt; --&gt;
	    &lt;div class="mtitle"&gt;
		&lt;h3 class="mSectionTitle"&gt;SoopPortal&lt;/h3&gt;
		&lt;h1 class="mSiteTitle"&gt;SooP Portal - Phoenix core&lt;/h1&gt;
		&lt;h2 class="mPageTitle"&gt;Page Generated Title&lt;/h2&gt;
	    &lt;/div&gt;
	    &lt;div class="mbanner"&gt;
		&lt;a target='_blank' href="/banner_id.asp?banner_id=1"&gt;
			&lt;img alt="Soop Portal" src="uploads/assets/banners/soopportal.org.ani.gif" /&gt;&lt;/a&gt;
	    &lt;/div&gt;
	&lt;/div&gt;
    &lt;/div&gt;&lt;/div&gt;&lt;/div&gt;&lt;!-- &lt;/headerContent&gt; --&gt;
&lt;/div&gt;&lt;!-- &lt;/header&gt; --&gt;
</pre>

<ol>
	<li><b><pre>&lt;div id="header"&gt;&lt;!-- &lt;header&gt; --&gt;</pre></b>
	The first div with the id of <b>header</b> is the main container element for the sites main header. It sets up the height and the margin defaults.
	</li>
	<li>
	The next row is the 3 nested div elements, like I displayed in the first code sample.
	<ul>
		<li><b><pre>&lt;div id="headerContent" class="t-bar"&gt;</pre></b> the <b>headerContent</b> id is used to set some the background images position. The <b>t-bar</b>
class is used to tell the browser which sprite to use. In this case the
t-bar points to the img/titlebars.png sprite. This is the element that
holds the repeated part of the header</li>
		<li><b><pre>&lt;div class="t-bar"&gt;</pre></b>
this div is targeted via it's parent div elements id so no special
class needed here. This div is used to display the left side of the
header. Yup the the t-bar class tell the browser what sprite to use,
but this time the class get over ruled by directly targeting another
image which has the pretty birdy with the fancy shading. The image is
/img/header.jpg.</li>
		<li><b><pre>&lt;div class="t-bar"&gt;</pre></b> this is the right hand side of the header. Again it's targeted via it's parents <b>headerContent</b>
id. The t-bar class point to the sprite to use, we aren't doing
anything fancy on this side so it just shows the selected position of
the titlebars.png sprite.</li>
	</ul>
	</li>
	<li><b><pre>&lt;div&gt;&lt;!-- &lt;headerContent&gt; --&gt;</pre></b>
This is a wrapper div that contains the headers content. This div is
relatively positioned so the 2 div elements on the next level can be
positioned absolutely. <ul>
			<li><b><pre>&lt;div class="mtitle"&gt;</pre></b> This div
holds the text heading displayed in the header. It is positioned
absolute so not to wrap when the browser window is resized <ol style="list-style-type: decimal;">
				<li><b><pre>&lt;h3 class="mSectionTitle"&gt;SoopPortal&lt;/h3&gt;</pre></b>
				This header gets it's text from the <b>Section Management Title</b> field.
				</li>
				<li><b><pre>&lt;h1 class="mSiteTitle"&gt;SooP Portal - Phoenix core&lt;/h1&gt;</pre></b>
				This text comes from the language files, the variable is <b>lngWebSiteTitleLogo</b>.
				</li>
				<li><b><pre>&lt;h2 class="mPageTitle"&gt;Page Generated Title&lt;/h2&gt;</pre></b>
				This part of the title comes from the function <b>cor.utils.pagetitle(strHeader,strSearch)</b>
				</li>
			</ol>
			</li>
			<li><b><pre>&lt;div class="mbanner"&gt;</pre></b>
This is the second absolutely positioned div in the header. This div
holds a place to display a banner ad in the sites main header. </li>
		</ul>
	</li>
	<li><b><pre>	    &lt;/div&gt;
	&lt;/div&gt;
    &lt;/div&gt;&lt;/div&gt;&lt;/div&gt;&lt;!-- &lt;/headerContent&gt; --&gt;
&lt;/div&gt;&lt;!-- &lt;/header&gt; --&gt;</pre></b>
	We now close all the open div elements in order to complete the main header</li>
</ol>

<h3>The Columns</h3>
<pre>    &lt;div id="innerWrapper"&gt;&lt;!-- &lt;innerWrapper&gt; --&gt;
	&lt;div id="left-col"&gt;&lt;!-- &lt;left-col#1&gt; --&gt;
	&lt;/div&gt;&lt;!-- &lt;/left-col#1&gt; --&gt;
	&lt;div id="content"&gt;&lt;!-- &lt;content#2&gt; --&gt;
	&lt;/div&gt;&lt;!-- &lt;/content#2&gt; --&gt;
	&lt;div id="right-col"&gt;&lt;!-- &lt;right-col#3&gt; --&gt;
	&lt;/div&gt;&lt;!-- &lt;/right-col#3&gt; --&gt;
    &lt;/div&gt;&lt;!-- &lt;/innerWrapper&gt; --&gt;</pre>
<ol>
	<li><b><pre>&lt;div id="innerWrapper"&gt;&lt;!-- &lt;innerWrapper&gt; --&gt;</pre></b>The id <b>innerWrapper</b>
is the main container element for the columns. Unlike most of the
elements we make using nested divs these we make by floating 3 div side
by side.</li>
	<li><b><pre>	&lt;div id="left-col"&gt;&lt;!-- &lt;left-col#1&gt; --&gt;
	&lt;/div&gt;&lt;!-- &lt;/left-col#1&gt; --&gt;</pre></b>The id <b>left-col</b>
is the first column. It has a width, set as a percentage usually, and
is floated left. We set the right margin for this column, to maintain
the desired spacing between the <b>left-col</b> and the <b>content</b>
columns. The left side comes up hard against the
#innerwrapper-#wrapper-#body. The body margins are whats controlling
the space along the left side of the document.</li>
	<li><b><pre>	&lt;div id="content"&gt;&lt;!-- &lt;content#2&gt; --&gt;
	&lt;/div&gt;&lt;!-- &lt;/content#2&gt; --&gt;</pre></b>The id <b>content</b> column is use to display the main part of the page. It should be floated left and not have any margins set.</li>
	<li><b><pre>	&lt;div id="right-col"&gt;&lt;!-- &lt;right-col#3&gt; --&gt;
	&lt;/div&gt;&lt;!-- &lt;/right-col#3&gt; --&gt;</pre></b>The id <b>right-col</b>
width is set using a percentage and requires no margins. The right side
space is held by the body like column 1 is. This column is floated
right to create the spacing between the content column and it.</li>
	<li><b><pre>&lt;/div&gt;&lt;!-- &lt;/innerWrapper&gt; --&gt;</pre></b>
	The last column is followed by the closing of the <b>innerWrapper</b> div.
	</li>
</ol>
<p>The real trick to designing the columns is not to have the widths
and margins add up to 100%. This would be fine in Mozilla browsers but
it gives Internet Explorer the jitters(for lack of a better word to
describe the effect.) While you resize your browser window column 3
will bounce up and down below the the other two columns acting like
there is not enough room for it to display beside them.</p>
Stylesheet Definition Sample eg :<pre>     div#left-col {float:left;width:20%;margin: 0 5px 0 0;}
      div#content {float:left;width:59%;margin: 0;overflow:hidden;}
    div#right-col {float:right;width:20%;margin: 0;overflow:hidden;}
</pre><br>
<p>The math is fairly simple. <b>20% + 59% + 20% = 99%</b>. There is also another <b>.5%</b> to add for the <b>5px</b>
 right margin on the left column. This brings the total width up tp 99.5% of clients browser window. The last <b>.5%</b> is displayed between the <b>Content</b> and the <b>Right</b> columns with out actually defining it in the css. This allows IE the breathing room it needs to prevent the jitters.</p>

<h3>The Module Box</h3>
<div id="innerWrapper">

<div id="right-col">
<div id="moduleWelcomeUser" class="module"><!-- <module> -->
    <div class="rbt"><div><div>&nbsp;</div></div></div>
	<div class="rbl"><!-- <rbl> -->
	    <div class="rbr"><!-- <rbr> -->
		<div class="titleBar t-bar"><!-- <titleBar> -->
		    <div><!-- Added to allow for different styling methods -->

			<div id="modWelcomeUser" class="title">Welcome Guest</div>
			<div class="icons"><!-- <icons> -->
<p><a class="toggle ico-sprt" id="toggleWelcomeUser" href="javascript:void(0);" title="Toggle"> </a></p><p><a class="hide ico-sprt" id="hidemoduleWelcomeUser" href="javascript:void(0);" title="Hide"> </a></p><p><a class="tooltip-ico ico-sprt" id="showWelcomeUsertt" href="javascript:void(0);" title="Help">&nbsp;</a></p></div><!-- </icons> -->
		    </div><!-- close extra div for different styling methods -->
		</div><!-- </titleBar> -->
		<div id="WelcomeUser" class="modular text"><!-- <Start Modbox Content> -->
			This is Where the content of the module is displayed
		</div><!-- </End Modbox Content> -->
	    </div><!-- </rbr> -->
	</div><!-- </rbl> -->
    <div class="rbb"><div><div>&nbsp;</div></div></div>
</div><!-- </module> -->
<!-- </Module_WelcomeUser> -->
</div>


<pre>&lt;!-- &lt;Module_WelcomeUser&gt; --&gt;
&lt;div id="moduleWelcomeUser" class="module"&gt;&lt;!-- &lt;module&gt; --&gt;

    &lt;div class="rbt"&gt;&lt;div&gt;&lt;div&gt;&amp;nbsp;&lt;/div&gt;&lt;/div&gt;&lt;/div&gt;

    &lt;div class="rbl"&gt;&lt;!-- &lt;rbl&gt; --&gt;
	&lt;div class="rbr"&gt;&lt;!-- &lt;rbr&gt; --&gt;

	    &lt;div class="titleBar t-bar"&gt;&lt;!-- &lt;titleBar&gt; --&gt;
		&lt;div&gt;&lt;!-- Added to allow for different styling methods --&gt;
		    &lt;div id="modWelcomeUser" class="title"&gt;Welcome Guest&lt;/div&gt;
		    &lt;div class="icons"&gt;&lt;!-- &lt;icons&gt; --&gt;
			&lt;p&gt;&lt;a class="toggle ico-sprt" id="toggleWelcomeUser" href="javascript:void(0);" 
				title="Toggle"&gt;&amp;nbsp;&lt;/a&gt;&lt;/p&gt;
			&lt;p&gt;&lt;a class="hide ico-sprt" id="hidemoduleWelcomeUser" href="javascript:void(0);" 
				title="Hide"&gt;&amp;nbsp;&lt;/a&gt;&lt;/p&gt;
			&lt;p&gt;&lt;a class="tooltip-ico ico-sprt" id="showWelcomeUsertt" href="javascript:void(0);" 
				title="Help"&gt;&amp;nbsp;&lt;/a&gt;&lt;/p&gt;
		    &lt;/div&gt;&lt;!-- &lt;/icons&gt; --&gt;
		&lt;/div&gt;&lt;!-- close extra div for different styling methods --&gt;
	    &lt;/div&gt;&lt;!-- &lt;/titleBar&gt; --&gt;
	    &lt;div id="WelcomeUser" class="modular text"&gt;&lt;!-- &lt;Start Modbox Content&gt; --&gt;

		This is Where the content of the module is displayed

	    &lt;/div&gt;&lt;!-- &lt;/End Modbox Content&gt; --&gt;

	&lt;/div&gt;&lt;!-- &lt;/rbr&gt; --&gt;
    &lt;/div&gt;&lt;!-- &lt;/rbl&gt; --&gt;

    &lt;div class="rbb"&gt;&lt;div&gt;&lt;div&gt;&amp;nbsp;&lt;/div&gt;&lt;/div&gt;&lt;/div&gt;

&lt;/div&gt;&lt;!-- &lt;/module&gt; --&gt;
&lt;!-- &lt;/Module_WelcomeUser&gt; --&gt;
</pre>
</div>
<ol>
	<li><b><pre>&lt;div id="moduleWelcomeUser" class="module"&gt;&lt;!-- &lt;module&gt; --&gt;</pre></b>
	The opening div is the Modbox main container. It has  3 sets of 3 nested div elements. We target this div through it's class <b>module</b> and set the margin for this div to 0, for the top, left and right sides.
	We give the bottom margin a value of 5px, this sets the vertical space between modboxes. The id <b>moduleWelcomeUser</b> is used by some jquery scripts.
	</li>
	<li><b><pre>&lt;div class="rbb"&gt;&lt;div&gt;&lt;div&gt;&amp;nbsp;&lt;/div&gt;&lt;/div&gt;&lt;/div&gt;</pre></b>
The second line holds our first set of three nested divs. This set
builds the top row of the round box. This works pretty much exactly the
same as the main header does. <ul>
		<li><b>&lt;div class="rbt"&gt;</b> This div displays the repeated part of the background sprite. The <b>rbt</b> class tells us this is the Round Box Top row.</li>
		<li><b>&lt;div&gt;</b> This div displays the top left corner sprite</li>
		<li><b>&lt;div&gt;</b> This div displays the top right corner sprite</li>
	</ul>
	</li>
	<li>
	<b><pre>&lt;div class="rbl"&gt;&lt;!-- &lt;rbl&gt; --&gt;
    &lt;div class="rbr"&gt;&lt;!-- &lt;rbr&gt; --&gt;</pre></b>These two div elements are the second and third div elements in our set of 3 nested div elements.
	These div elements are using the main container div <b>module</b> as the first div in the set.
	These div elements used a different sprite than the rest of the box<b>(img/box_sides_sprite.png)</b>. This is so the sprite can be repeated along the y axis.

		<ul>
			<li>The class <b>rbl</b> Round Box Left side div is used to display the sprite for the mods left border.</li>
			<li>The class <b>rbr</b> Round Box Right side div is used to display the sprite for the mods right border.</li>
		</ul>
	</li>
	<li>
	<b><pre>	    &lt;div class="titleBar t-bar"&gt;&lt;!-- &lt;titleBar&gt; --&gt;
		&lt;div&gt;&lt;!-- Added to allow for different styling methods --&gt;</pre></b>
The titlebar div is a container div that holds the various parts the
make up the title block. This div has it's position set to relative so
that the next 2 div elements can be absolutely positioned.<br>
	It has a <b>t-bar</b> class added to it, so the browser knows what sprite to load <b>img/titlebars.png</b> in the background.<br>
	<b>Important</b> Setting the left and right margins of this div allows you to display the proper amount of the <b>img/box_sides_sprite.png</b> creating the desired border width/effect.<br>
	The second div without any class is added so a skinner can apply a deferent styling technique
	<ul>
		<li><b><pre>&lt;div id="modWelcomeUser" class="title"&gt;Welcome Guest&lt;/div&gt;</pre></b>
		This div holds the modules titles text. It is absolutely positioned.
		</li>
		<li><b><pre>&lt;div class="icons"&gt;&lt;!-- &lt;icons&gt; --&gt;</pre></b>
		This div is also absolutely positioned. It contains the toggle icons used to control the box.
		<ol>
			<li><b><pre>&lt;p&gt;&lt;a class="toggle ico-sprt" id="toggleWelcomeUser" href="javascript:void(0);"
	title="Toggle"&gt;&amp;nbsp;&lt;/a&gt;&lt;/p&gt;</pre></b>
			</li>
			<li><b><pre>&lt;p&gt;&lt;a class="hide ico-sprt" id="hidemoduleWelcomeUser" href="javascript:void(0);"
	title="Hide"&gt;&amp;nbsp;&lt;/a&gt;&lt;/p&gt;</pre></b>
			</li>
			<li><b><pre>&lt;p&gt;&lt;a class="tooltip-ico ico-sprt" id="showWelcomeUsertt" href="javascript:void(0);"
	title="Help"&gt;&amp;nbsp;&lt;/a&gt;&lt;/p&gt;</pre></b>
			</li>
This time we are using the anchor to display the background sprite. The
first part of the class (toggle,hide,tooltip-ico) tells the browser
what icon we want the second part (ico-sprt) tells the browser which
sprite to find it in. </ol> I guess the only real import thing to say here is that these
classes are scripted quite heavily. Remember that js is a case
sensitive language so treat the css in the same manner with case
sensitivity in mind. </li>
	</ul>
	</li>
	<li><b><pre>&lt;div id="WelcomeUser" class="modular text"&gt;&lt;!-- &lt;Start Modbox Content&gt; --&gt;</pre></b>
	The <b>modular</b> div is the modboxes <u>main content container</u>. We use this div to set the <b>background-color</b> for the modbox. As with the title div the margins must be properly adjusted for the skin.<br>
	<b>Important</b> Setting the left and right margins of this div allows you to display the proper amount of the <b>img/box_sides_sprite.png</b> creating the desired border width/effect.
	</li>
	<li><b><pre>	    &lt;/div&gt;&lt;!-- &lt;/End Modbox Content&gt; --&gt;

	&lt;/div&gt;&lt;!-- &lt;/rbr&gt; --&gt;
    &lt;/div&gt;&lt;!-- &lt;/rbl&gt; --&gt;</pre></b>
	These 3 divs simple close the <b>modular</b> div then the <b>rbr</b>(round box right) div then the <b>rbl</b>(round box left) div.
	</li>
	<li><b><pre>&lt;div class="rbb"&gt;&lt;div&gt;&lt;div&gt;&amp;nbsp;&lt;/div&gt;&lt;/div&gt;&lt;/div&gt;</pre></b>
	One more set of 3 nested divs creates the bottom row of the modbox.
	<ul>
		<li><b>&lt;div class="rbb"&gt;</b> This div displays the repeated part of the background sprite. The <b>rbb</b> class tells us this is the Round Box Bottom row.</li>
		<li><b>&lt;div&gt;</b> This div displays the bottm left corner sprite</li>
		<li><b>&lt;div&gt;</b> This div displays the bottm right corner sprite</li>
	</ul>
	</li>
	<li><b><pre>&lt;/div&gt;&lt;!-- &lt;/module&gt; --&gt;
&lt;!-- &lt;/Module_WelcomeUser&gt; --&gt;</pre></b>
Closes the modbox.
	</li>
</ol>
<%
cor.str.wri "</div>" & cor.modbox.printBoxBottom
call cor.tpl.footer()
call cor.off()
%>