﻿<!--#include file="db/_soop_pageglobal.asp" -->
<!--#include file="common.asp"-->
<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

'********************************************************************
'** geckoHeadlines for SooP 2.0
'** Initially written for SooP 1.x by Dan Bodenstein 
'** http://www.scriptgecko.com
'******************************************************************** 
'
Dim intRSSFeed_ID, strMode
Dim blnHasFSO, iNumofCategories,x, riptag
'Check for Admin access. For Portal Admin only
If NOT GH_isAdmin() then
	call cor.msg(lngInsufficientPermission)
	cor.redir "./"
End if

strMode = lcase(cor.io.r("mode"))
'
cor.lng.includeSection("cor_xmlMgmt,mod_xmlGH")
'
'Read Passed Variables to determine mode.
intRSSFeed_ID = cor.filter.checkInt(cor.io.r("RSSID"))
GH_RssFeed.Read(intRSSFeed_ID)

' if there is no section ID, then send them back to the sections page.
call cor.tpl.init("gh2mgmt")			'Call the Soop Section

if strMode ="del" then 
		cor_sql = "DELETE FROM " & cor_dbpre & "gh_rssfilter Where Filter_ID = {0}"
		'adoCon.Execute strSQL
		cor.dal.exec cor_sql, array(cor.io.r("FilterID"))
		cor.redir "gh_mgmt_rssfilters.asp?RSSID=" & intRSSFeed_ID 
End IF

'Check Validation on Submit
if cor_bPostback then 
	if Len(validateRSSFeedFilter) > 0 then
		cor.str.wri validateRSSFeedFilter
		call cor.butil.errorMsg(lngErrorDisplayLine1,lngValidationFail,True,3000,false,,0,false)
	else
		Call GH_Save
	end if
	response.end
end if



' Render page 
'
call cor.tpl.header("Filters for " & GH_RssFeed.Title,"")	'Call the Header with Title string
'
call managefeeds				'Call main Page from sub
'
call cor.tpl.footer()				'Call the Header
call cor.off()						'Close all open objects

function managefeeds
%>
<script type="text/javascript" language="JavaScript"><!--
//Check form Validation
function deleteWarning(intID){
Warn = confirm('Delete this Filter?');
if (Warn == true) {window.location='gh_mgmt_rssfilters.asp?mode=Del&RSSID=<%=intRSSFeed_ID%>&FilterID=' + intID;}
}
// --></script>
<%
cor.modbox.printBoxTop
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
cor.str.wri "<div class=""titleBar t-bar""><div><h4 class=""title"">" & lngGHRSSFeeds & "</h4></div></div>"
cor.str.wri "<div class=""modular"">"
cor.str.wri ghAdminMenu

if strMode ="add" then 
	Call EditCategory() 
else 
%>

	<table width="100%" border="0" cellspacing="1" cellpadding="4"><tr>
		<td width="100" class="tHeading">Filter Type</td>
		<td class="tHeading">Filtered content</td>
		<td width="100"  class="tHeading">&nbsp;</td>
	</tr> 
<%

	cor_sql = "Select " & cor_dbpre & "gh_rssfilter.* from " & cor_dbpre & "gh_rssfilter WHERE RSSFeed_ID={0}"
	cor.dal.openRS "rs", cor_sql,array(intRSSFeed_ID)
	If not cor.dal.rs.eof then
		Do While NOT cor.dal.rs.eof 
%>
	<tr>
		<td width="100" align="left" class="text" ><% if cor.dal.rs("FilterType") = "C" then Response.Write "Category" else Response.Write "Title" %></td>
		<td class="text"><%=cor.dal.rs("Filter")%></td>
		<td><a href="javascript:deleteWarning(<%=cor.dal.rs("filter_id")%>);"><% = lngDelete %></a></td>
	</tr>
<%
			cor.dal.rs.Movenext
		Loop
	end if
%>

	<tr >
		<td colspan="4" style="border-top:solid 1px #000000;"><a href="gh_mgmt_rssfilters.asp?FilterID=0&amp;mode=add&amp;RSSID=<%=intRSSFeed_ID %>"><% = lngGHAddFilter %></a></td>
	</tr></table>

<% end if %>

<%
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
cor.str.wri "</div>"
cor.modbox.printBoxBottom
End Function
'<!-- #include file="core/footer.asp" -->


 sub EditCategory
'***************************
' Edit MODE


If Request("mode") = "add" then
GH_RssFeed.Read(intRSSFeed_ID)

  with GH_RssFeed %>
<script type="text/javascript"><!-- <![CDATA[
$(document).ready(function(){
	$('form#frmRSSFilter').submit(function() {
			$('form#frmRSSFilter').ajaxSubmit({target: "#form_results"});
		return false;
	});
});

// ]]> --></script>
<p><%= lngCompleteForm %></p>
<form class="soop" name="frmRSSFilter" id="frmRSSFilter" action="gh_mgmt_rssfilters.asp" method="post">
<input type="hidden" name="RSSID" value="<%=GH_RSSFeed.ID %>" />
<fieldset>
	<legend>
<%
		cor.str.wrn lngEdit & " "& lngGHRSSFeeds & " for " & .Title
%></legend>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label"><label for="Filter Type">Filter Type</label></li> 
			<li class="input">						<select name="FilterType">
							<option value="C">Catagory Filter</option>
							<option value="T">Title Filter</option>
						</select></li>
		</ul>
	</li>
</ul>
<ul class="row">
	<li>
		<ul class="col">
			<li class="label req-ico ico-sprt"><label for="Filter Text">Filter Text</label></li>
			<li class="input"><input class="frmText required" type="text" name="Filter" id="Filter" size="60" value="" /></li>
		</ul>
	</li>
</ul>
</fieldset>
<div class="buttonOuterWrap"><div class="buttonInnerWrap">
<div class="ui button"><button type="submit" class="frmButton" id="Save" name="Save" value="Save Filter"><span>Save Filter</span></button></div>
</div></div>
</form>

<% 
end with 
end if 
end sub 





Sub GH_Save
Dim saryGroups, saryUsers, X, sUniqueString, sNewTime
		cor_sql = "INSERT INTO " & cor_dbpre & "gh_rssfilter(RSSFeed_ID,FilterType,Filter) VALUES ({0},{1},{2})"
	'response.write strSQL
	'adoCon.Execute strSQL
	cor.dal.exec cor_sql, array(intRSSFeed_ID, cor.io.f("FilterType"), Replace(cor.io.f("Filter"),"'","''"))
'	Set rsCommon = nothing
'	set adoCon = nothing
'	Response.End 
	cor.redir "gh_mgmt_rssfilters.asp?RSSID=" & intRSSFeed_ID
end sub

function validateRSSFeedFilter()
	dim errmsg
	cor.str.wri "<script type=""text/javascript"">$('label[class^=errorfrm error]').remove();</script>"
	if len(cor.io.f("Filter")) <= 0 then cor.str.add "<script type=""text/javascript"">$('<label class=""errorfrm error"">Filter is needed</label>').insertAfter('#Filter');</script>"
	validateRSSFeedFilter = cor.str.build
	cor.str.wri validateRSSFeedFilter
end function
%>
