<%
'-----------------------------------------------------------------------------------------------'
' SOOP 2.0 - Phoenix (TNG)																		'
'																								'
' Revision 2.00 - initial 15/02/2008															'
'																								'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences	'
'-----------------------------------------------------------------------------------------------'

Function Module_BannerZones(blnToggleModule,Module_Permission, Module_ID, Module_Parameters, blnTab)

	if Module_Permission = 0 Then exit Function
	If Module_Parameters = "" Then exit Function
	If Not cor_bBanners Then Exit Function
	'Define Variables
	Dim rndMax, rndNumber, Topic_Html, strBannerTitle, intBanner_ID, strBoxTitle, intBoxInstance

	If ubound(split(Module_Parameters, ",")) <> 2 Then Exit Function

	'Get Module Parameters
	intBoxInstance		= cor.filter.checkInt(split(Module_Parameters,",")(0))
	intBanner_ID		= cor.filter.checkInt(split(Module_Parameters,",")(1))
	strBoxTitle			= cor.filter.checkStr(split(Module_Parameters,",")(2))

	'Check for banners in this zone
	Dim chkZone
	chkZone = cor.dal.getValue("SELECT b.Banner_ID FROM " & cor_dbpre & "banners AS b WHERE (b.BannerZone_ID = {0})",array(intBanner_ID))
	If isEmpty(chkZone) Or IsNull(chkZone) Then Exit Function
	
	'Set Module Box
	Dim Module_Name : Module_Name = "BannerZone" & intBoxInstance
	Dim Header_Text : Header_Text = strBoxTitle
	Dim Module_Hide : Module_Hide = blnToggleModule 
	Dim Module_tool_Tip : Module_tool_Tip = True
	Dim Module_Tool_Tip_Text : Module_Tool_Tip_Text = cor_sModTT

	cor.str.add "<dl class=""soop"">"
	cor.str.add "<dd class=""center"">"
	cor.str.add cor.butil.printBanner(intBanner_ID)
	cor.str.add "</dd>"
	cor.str.add "</dl>"

	'===========================================================
	If blnTab then
	Call cor.modbox.printTabBox(blnToggleModule,Module_Hide,Module_tool_Tip,Module_Name,Module_ID,Header_Text,cor.str.build,Module_Tool_Tip_Text)
	Else
	Call cor.modbox.printBox(blnToggleModule,Module_Hide,Module_tool_Tip,Module_Name,Module_ID,Header_Text,cor.str.build,Module_Tool_Tip_Text)
	End If
'
End Function
'
'<#late-binding hook (do not remove)
Function boot_Module_BannerZones : boot_Module_BannerZones = true : end function
'/>
%>