﻿<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

'********************************************************************
'** geckoHeadlines for SooP 2.0
'** Initially written for SooP 1.x by Dan Bodenstein 
'** http://www.scriptgecko.com
'******************************************************************** 

function Module_GeckoHeadlines(blnToggleModule,Module_Permission, Module_ID, Module_Parameters, blnTab)
	'
	if Module_Permission = 0 Then exit function
	'
	dim arrFeeds
	dim X
	dim Module_Name
	dim strCatID
	dim strFeeds
	dim blnSHOWFOOTERTOP
	dim rip

	'
	cor.lng.includeSection("mod_xmlGH")

	gh_settings.read()

	dim blnShowHeader : blnShowHeader = gh_Settings.showHeader

	strCatID = cor.filter.checkInt(cor.io.fq("catid"))

	gh_checkCatId(strCatID)

	blnSHOWFOOTERTOP	= gh_Settings.showFooterTop
	Module_Name			= lngGHModTitle

If strCatID <> "" Then
	'if NOT cor.butil.isEmptyStr(gh_Settings.GHHeader) Then gh_Settings.GHHeader = replace(gh_Settings.GHHeader,"[skinpath]",cor_sSkinImg,1,-1,1)

	If blnShowHeader= 1 Then cor.str.wri ghNewsHeader(blnTab) ' sub to load News header outside modbox

	If Not blnTab Then
		call openGHBoxing(Module_Name,false) 'sub to handle display of graphic borders
	Else
		cor.modbox.printBoxTabTop()
	End If

	If blnShowHeader= 2 then cor.str.wri ghNewsHeader(false) ' sub to load News header inside modbox

	cor.str.wri "<div class=""modular"">"' <!-- mod open -->
	cor.str.wri "	<div class=""holder1 ghsubheader"">"' <!-- hldr1 open -->
	

	cor.str.wrn "		<span class=""holder2"">"
	if gh_Settings.ShowRealDate Then
		cor.str.wrn cor.butil.datetime(cDate(now()),vbLongDate)
	else
		cor.str.wrn cor.butil.datetime(cor.butil.cvLcidTime(gh_Settings.LastArticleDate),vbLongDate)
	end if
	cor.str.wri "</span>"
	cor.str.wri "		<span class=""holder3"">" & gh_Settings.GreetUser & "</span>"

	cor.str.wri "		</div>"'<!-- hldr1 close -->

	cor.str.wri "		<div class=""holder1 ghfrontpageblock"">"' <!-- hldr1 open -->

	cor.str.wri gh_ShowHeadlines(10,"")

	cor.str.wri "	</div>"'<!-- hldr1 close -->
	cor.str.wri "</div>"'<!-- mod close -->

	If NOT blnTab then call closeGHBoxing() 'sub to handle display of graphic borders

End If

	if gh_Settings.ShowSubscription<>0 then
		'If blnTab then cor.str.add"<div class=""titleBar t-bar""><h4 class=""title"">" & lngGHEmailAlerts & "</h4></div>"
		cor.str.add gh_modSubscriptionBox(blnTab)
		If NOT blnTab then
			Call cor.modbox.printBox(false,false,false,"ghsubscribe","ghsubscribe",lngGHSubscribe & " " & lngGHto & " " & lngGHEmailAlerts,cor.str.build,"")
		else
			cor.str.wri cor.str.build
		end if
	end if

	if gh_Settings.ShowSearchonMain<>0 then
		'If blnTab then cor.str.add"<div class=""titleBar t-bar""><h4 class=""title"">" & lngGHSearchNewsArticles & "</h4></div>"
		cor.str.add gh_SearchBox(true,blnTab)
		If NOT blnTab then
			Call cor.modbox.printBox(false,false,false,"ghsearchbox","ghsearchbox",lngGHSearchNewsArticles,cor.str.build,"")
		else
			cor.str.wri cor.str.build
		end if
	end if

	if gh_Settings.ShowFeedsAvailable<>0 then
		cor.str.add gh_ShowExternalRSSFeedBox(blnTab)
		If NOT blnTab then
			Call cor.modbox.printBox(false,false,false,"ghRSSFeedsAvailable","ghRSSFeedsAvailable",lngGHRSSFeedsAvailable,cor.str.build,"")
		else
			cor.str.wri cor.str.build
		end if
	end if
	dim rss_feed_num, x_i
	cor_sql = "Select tc.RSSFeed_ID, tc.title from " & cor_dbpre & "gh_rssfeed AS tc where tc.MainPage=1 order by tc.sequence;"
	cor.dal.getRows rss_feed_num, 100, cor_sql, array()
	'cor.str.wri rss_feed_num
	if not cor.butil.eof(rss_feed_num) Then
	  	for x_i = 0 to ubound(rss_feed_num,2) 
	  		rip = rss_feed_num(0,x_i)
			cor.str.add GH_ShowRSSFeed(rip,1,true)		
			If NOT blnTab then
				Call cor.modbox.printBox(false,false,false,"GH_ShowRSSFeed","GH_ShowRSSFeed",rss_feed_num(1,x_i),cor.str.build,"")
			else
				cor.str.wri cor.str.build
			end if
		next
	end if
	
	If blnTab then call closeGHBoxing() 'sub to handle display of graphic borders

end function
'
'<#late-binding hook (do not remove)
function boot_Module_GeckoHeadlines : boot_Module_GeckoHeadlines = true : end function
'/>

%>
