<%
Function Module_MoodyTabs(blnToggleModule,Module_Permission, Module_ID, Module_Parameters, blnTab)
	'
	'-----------------------------------------------------------------------------------------------------------------------------------------------------------------
	'
	' Module MoodyTabs for SooP Phoenix,
	' This module will allow you to add a Tabular display module to any column on your Phoenix site,
	' The module now supports multi instance use too so you can have multiple instances of tabs running on the same page,
	' 
	' PARAMETERS EXPLAINED !!!
	' 
	' Parameter 1: Slide and Fade, Setting this to True will make your tabs use both the slide and fade animations, True/False
	' Parameter 2: Slide, Setting this to True will make your tabs use only the slide animation
	' Parameter 3: Fade, setting this to True will make your tabs use only the fade animation
	' Parameter 4: Rotate, Setting this to true will make your tabs auto rotate to the next tab after a given time delay
	' Parameter 5: RotateDelay, To be used in conjunction with parameter 4, this is the time delay in milliseconds between tab rotations
	' Parameter 6: Instance, This is the instance ID for defining between multiple instance of the tabs module IMPORTANT !!! this should be a unique numerical value
	'
	' Example Parameter String: False,True,False,True,5000,1
	'
	'------------------------------------------------------------------------------------------------------------------------------------------------------------------
	dim strMoodyTabDivs	:	strMoodyTabDivs = "</div> </div> </div> <div class=""rbb""> <div> <div> </div> </div> </div> </div>"
	'cor.str.wri"<link rel=""stylesheet"" type=""text/css"" href=""" & cor_sSkinPath & "jquery.tabs.css"" />"
	'cor.str.wri "<script src=""" & cor_sWebroot & "core/jscss/ui.tabs.js"" type=""text/javascript""></script>"
	'Define Variables
	Dim ssql, tsql, arrTabs, intId, strName, blnModule, intModuleId, blnDocument, intDocumentId, arrModDetails
	Dim blnOffsite, strOffsitePath, blnDbDriven, strDbContent, blnSlideFade, blnSlide, blnFade, x_i
	Dim strModParam, strModName, strDisplayDoc, blnFaq, intFaqId, strFaqQuestion, strFaqAnswer
	Dim blnGh, intGhId, strGhContent, strGhImage, strGhArticleDate, strGhArticleTitle, blnRss, strRssUrl
	Dim blnRotate, intRotateDelay, intInstance, arrPerms
'
	If Module_Permission = 0  Then Exit Function
	If ubound(split(Module_Parameters, ",")) <> 5 Then Exit Function
'
	'Get Module Parameters
	blnSlideFade = CBool(split(Module_Parameters,",")(0))
	blnSlide = CBool(split(Module_Parameters,",")(1))
	blnFade = CBool(split(Module_Parameters,",")(2))
	blnRotate = CBool(Split(Module_Parameters,",")(3))
	intRotateDelay = cor.filter.checkInt(Split(Module_Parameters,",")(4))
	intInstance = cor.filter.checkint(Split(Module_Parameters,",")(5))
'
	' Javascript functions for forms etc
	cor.str.wri "<script type=""text/javascript""><!-- <[CDATA["
	If blnSlideFade Then
		cor.str.wri "$(function() {"
		cor.str.wrn "	$('#tabs" & intInstance & "').tabs({ fx: { opacity: 'toggle', height: 'toggle'}, cookie: { expires: 365 }})"
		if blnRotate then
		cor.str.wrn ".tabs('rotate'," & intRotateDelay & ")"
		End If
		cor.str.wri ";"
		cor.str.wri "});"
	ElseIf blnFade Then
		cor.str.wri "$(function() {"
		cor.str.wrn "	$('#tabs" & intInstance & "').tabs({ fx: { opacity: 'toggle'}, cookie: { expires: 365 }})"
		if blnRotate then
		cor.str.wrn ".tabs('rotate'," & intRotateDelay & ")"
		End If
		cor.str.wri ";"
		cor.str.wri "});"
	ElseIf blnSlide Then
		cor.str.wri"$(function() {"
		cor.str.wrn"	$('#tabs" & intInstance & "').tabs({ fx: { height: 'toggle' }, cookie: { expires: 365 }})"
		if blnRotate then
		cor.str.wrn ".tabs('rotate'," & intRotateDelay & ")"
		End If
		cor.str.wrn ";"
		cor.str.wri "});"
	Else
		cor.str.wri"$(function() {"
		cor.str.wrn"	$('#tabs" & intInstance & "').tabs({cookie: { expires: 365 }})"
		if blnRotate then
		cor.str.wrn ".tabs('rotate'," & intRotateDelay & ")"
		End If
		cor.str.wri ";"
		cor.str.wri "});"
	End If
	cor.str.wri "// ]]> --></script>"

	'Set Module Box
	Dim Module_Name : Module_Name = "MoodyTabs" & intInstance
	Dim Header_Text : Header_Text = "MoodyTabs"  & intInstance
	Dim Module_Hide : Module_Hide = 0 
	Dim Module_tool_Tip : Module_tool_Tip = False
	Dim Module_Tool_Tip_Text : Module_Tool_Tip_Text = cor_sModTT
	'
	'
	'-----------------0------1-----------2----------3------------4------------5--------------6-----------7---------------8------------9------------
	ssql = 	"SELECT t.tid, t.ttabname, t.tmodule, t.tmoduleid, t.tdocument, t.tdocumentid, t.toffsite, t.toffsitepath, t.tdbdriven, t.tdbcontent, "
	'----------------10------11--------12------------13--------------14----------15-------------16---------17-----------18-----------
	ssql = ssql & "t.tfaq, t.tfaqid, t.tgharticle, t.tgharticleid, t.trssfeed, t.trssfeedurl, t.tactive, t.ttaborder, t.tauthorid, t.tpermissions "
	ssql = ssql & "FROM " & cor_dbpre & "tabs AS t WHERE t.tactive = 1 AND t.tinstance = {0} ORDER BY t.ttaborder"
	'Response.Write ssql
	cor.dal.open arrTabs, ssql, array(intInstance)
	If Not cor.butil.eof(arrTabs) Then

'		<!-- This is the tabs container -->
		cor.str.wri "<div id=""moodytabscontainer" & intInstance & """ class=""moodycontainer"">"
'		<!-- This is the tabs holder div -->
		cor.str.wri "	<div id=""tabs" &intInstance & """>"
		cor.str.wri "		<ul class=""ui ui-tabs-nav"">"

		For x_i = 0 to ubound(arrTabs,2)
			DisplayTheseTabs 1, arrTabs, x_i
		Next

		cor.str.wri "		</ul>"
		cor.str.wri "	</div>"
'		<!-- End of tabs section -->
'		<!-- This is the tabs display divs -->

		For x_i = 0 to ubound(arrTabs,2)
			DisplayTheseTabs 2, arrTabs, x_i
		Next

'		<!-- End of tabs display divs -->
		cor.str.wri "</div>"
'		<!-- End of moodytabs container div -->

	Else
		Exit Function
	End If
	'===========================================================
	If blnTab Then
		Call cor.modbox.printTabBox(blnToggleModule,Module_Hide,Module_tool_Tip,Module_Name,Module_ID,Header_Text,cor.str.build,Module_Tool_Tip_Text)
	Else
		Call cor.modbox.printBox(blnToggleModule,Module_Hide,Module_tool_Tip,Module_Name,Module_ID,Header_Text,cor.str.build,Module_Tool_Tip_Text)
	End If
	'
end Function
'
private sub DisplayTheseTabs(setAction, byref arrTTabs, x_i)
	'taken from arrTabs
	Dim intId, strName, blnModule, intModuleId, blnDocument, intDocumentId
	Dim blnOffsite, strOffsitePath, blnDbDriven, strDbContent, blnFaq, intFaqId
	Dim strDisplayDoc, strFaqQuestion, strFaqAnswer, blnGh, intGhId, blnRss, strRssUrl, arrPerms
	'
	dim tabPerms
	'
	if arrTTabs(19,x_i)<>"" or not isnull(arrTTabs(19,x_i)) then
		tabPerms = cor.butil.checkPerm(arrTTabs(19,x_i),cor_iGroupID)
	else
		tabPerms = true
	end if
	'
	if not tabPerms then exit sub
	'
	intId				= arrTTabs(0,x_i)
	strName 			= arrTTabs(1,x_i)
	blnModule 			= arrTTabs(2,x_i)
	intModuleId			= arrTTabs(3,x_i)
	blnDocument			= arrTTabs(4,x_i)
	intDocumentId		= arrTTabs(5,x_i)
	blnOffsite			= arrTTabs(6,x_i)
	strOffsitePath		= arrTTabs(7,x_i)
	blnDbDriven			= arrTTabs(8,x_i)
	strDbContent		= arrTTabs(9,x_i)
	blnFaq				= arrTTabs(10,x_i)
	intFaqId			= arrTTabs(11,x_i)
	blnGh				= arrTTabs(12,x_i)
	intGhId				= arrTTabs(13,x_i)
	blnRss				= arrTTabs(14,x_i)
	strRssUrl			= arrTTabs(15,x_i)

	select case setAction
	case 1	'the original For..Next loop of the arrTabs items
		dim href
		if blnModule = 1 or blnDocument = 1 or blnDbDriven = 1 or blnFaq or blnGh = 1 or blnRss = 1 then
			href = "#tab" & intId 		'set the url's href to the intID of this data
		elseif blnOffsite = 1 then		'set the href to the external site path
			href = strOffsitePath 
		else							'oops!
			href=""
		end if
		if len(href) > 0 then			'if we have an HREF to go to, then output a list item.
			cor.str.wri "<li><a class=""ui-tabs-nav"" href=""" & href & """><span>" & strName & "</span></a></li>"	
		end if
	case 2				'the second for..next loop from the main function
		Dim strModParam, strModName, arrModDetails, tsql, div1, div2, div3
						', strDisplayDoc, blnFaq, intFaqId, strFaqQuestion, strFaqAnswer
		Dim strGhContent, strGhImage, strGhArticleDate, strGhArticleTitle
				'Dim blnRotate, intRotateDelay, arrPerms
		'This div setup gets used quite a lot below.
		div1 = "<div id=""tab" & intID & """ class=""ui-tabs-panel ui-tabs-hide"">"
		div2 = vbtab & "<div class=""rbl""><div class=""rbr"">"
		div3 = vbtab & "<div class=""modular text"" style=""padding: 15px 15px 5px 15px;"">"
		if blnModule = 1 then	
			tsql = "SELECT m.Module_name, m.Module_Parameters " & _
				"FROM " & cor_dbpre & "modules AS m " & _
				"WHERE m.Module_ID = " & intModuleId
			cor.dal.open arrModDetails, tsql, array()
			strModParam = trim(arrModDetails(1,0))
			strModName = arrModDetails(0,0) & "(1,True," & intModuleId & ",""" & strModParam & """,True)"
			cor.str.wri div1
			cor.str.wri vbtab & Eval(strModName) 
			cor.str.wri "</div>"
		ElseIf blnDocument = 1 then
			cor.str.wri div1 & vbcrlf & vbtab 
			Call Module_DisplayDoc(1,True,,"" & intDocumentId & "",True) 
			cor.str.wri "</div>"
		ElseIf blnDbDriven = 1 Then 
			cor.str.wri div1 & vbcrlf & div2 & vbcrlf & div3
			cor.str.wri	vbtab & vbtab & "<br />" & strDbContent & "<br /><br />" & vbcrlf & vbtab & "</div>	</div></div>"
			cor.str.wri vbtab & "<div class=""rbb""><div><div>" & vbcrlf & "</div></div></div></div>"
		ElseIf blnFaq = 1 Then
			cor.lng.includeSection("mod_xmlFAQ")
			tsql = "SELECT T1.faqid, T1.faqQuestion, T1.faqAnswer " _ 
				& "FROM " & cor_dbpre & "faq AS T1 WHERE T1.faqID = " & intFaqId
			cor.dal.open arrModDetails, tsql, array()
			strFaqQuestion = arrModDetails(1,0)
			strFaqAnswer = arrModDetails(2,0)
			cor.str.wri div1 & vbcrlf & div2 & vbcrlf & div3
			cor.str.wri "<br /><div class=""pagelink"">"
			cor.str.wri "&nbsp;<font size=""5""><b>" & lngFaqLetterQ & "</b></font>&nbsp;"
			cor.str.wri "<b>" & strFaqQuestion & "</b>&nbsp;</div><br /><br />"
			cor.str.wri "<div class=""pagelink"">&nbsp;<font size=""5"">"
			cor.str.wri "<b>" & lngFaqLetterA & "</b></font>&nbsp;" &  strFaqAnswer & "</div>"
			cor.str.wri "<br />	<br />	</div>	</div>	</div>"
			cor.str.wri "<div class=""rbb""><div><div>" & vbcrlf & "</div></div></div></div>"
		ElseIf blnGh = 1 Then
			cor.lng.includeSection("mod_xmlFAQ")
			tsql = "SELECT g.Headline_ID, g.ghImage, g.Article, g.Title, g.Article_Date " & _
				"FROM " & cor_dbpre & "gh_headlines AS g " & _
				"WHERE g.Headline_ID = " & intGhId
			cor.dal.open arrModDetails, tsql, array()
			strGhContent = arrModDetails(2,0)
			strGhImage = arrModDetails(1,0)
			strGhArticleTitle = arrModDetails(3,0)
			strGhArticleDate = arrModDetails(4,0)
			cor.str.wri div1 & vbcrlf & div2 & vbcrlf & div3
			cor.str.wri "<p><span class=""tiHeading"">" &  strGhArticleTitle & "</span><br /><br />"
			cor.str.wri "<img style=""padding-left: 10px; padding-bottom: 10px"" border=""0""" & _
						" align=""right"" width=""80"" src=""" &  strGhImage & """/>"
			cor.str.wri strGhContent & "</p>"
			cor.str.wri "</div></div></div>	<div class=""rbb""><div><div>	</div></div></div></div>"
		ElseIf blnRss = 1 Then 
			cor.str.wri div1 & vbcrlf & div2 & vbcrlf & div3
			Call DisplayFeed(strRssUrl)
			cor.str.wri "</div></div></div>	<div class=""rbb""><div><div>	</div></div></div></div>"
		End If 
	end select
end sub
'
Sub DisplayFeed(sURL)
	Dim URLToRSS, MaxNumberOfItems, MainTemplateHeader, MainTemplateFooter, Keyword1
	Dim Keyword2, ItemTemplate, ErrorMessage, xmlHttp, RSSXML, xmlDOM, RSSItems, RSSItemsCount
	Dim j, i, RSSItem, RSSdescription, RSSCommentsLink, child, RSSDate, RSStitle, RSSLink
	Dim ItemContent, RSSCategory, RSSImage, RSSImageLink, CategoryItems, categoryitem
	URLToRSS = sURL
	MaxNumberOfItems = 30
	MainTemplateHeader = "<table>"
	MainTemplateFooter = "</table>"
	Keyword1 = ""		:		Keyword2 = ""
	ItemTemplate = "<tr><td><strong>{DATE}</strong><br/><strong>{CATEGORY}</strong><br /><a target=""_blank"" href=" & _
				"""{LINK}""" & ">{TITLE}</a><br />{DESCRIPTION}<br /><br /></td></tr>"
	ErrorMessage = "Error has occured while trying to process " &URLToRSS & "<BR>Please contact web-master"
	Set xmlHttp = Server.CreateObject("MSXML2.ServerXMLHTTP.3.0")
	xmlHttp.Open "GET", URLToRSS, false
	xmlHttp.Send()
	RSSXML = xmlHttp.ResponseText
	Set xmlDOM = Server.CreateObject("MSXML2.DomDocument.3.0")
	xmlDOM.async = False
	xmlDOM.validateOnParse = False
	xmlDom.resolveExternals = False
	If not xmlDOM.LoadXml(RSSXML) Then
		ErrorMessage = "Can not load XML:" & vbCRLF & xmlDOM.parseError.reason & vbCRLF & ErrorMessage
	End If
	Set xmlHttp = Nothing ' clear HTTP object
	Set RSSItems = xmlDOM.getElementsByTagName("item")
	RSSItemsCount = RSSItems.Length-1
	if RSSItemsCount = -1 Then
		Set SSItems = xmlDOM.getElementsByTagName("entry")
		RSSItemsCount = RSSItems.Length-1
	End If
	Set xmlDOM = Nothing ' clear XML
	if RSSItemsCount > 0 then
		cor.str.wri MainTemplateHeader
	End If
	j = -1
	For i = 0 To RSSItemsCount
		Set RSSItem = RSSItems.Item(i)
		RSSdescription="&nbsp;" 
		RSSCommentsLink="&nbsp;"
		for each child in RSSItem.childNodes
			Select case lcase(child.nodeName)
			case "title"
				RSStitle = child.text
			case "link"
				If RSSLink = "" Then
					If child.Attributes.length>0 Then
						RSSLink = child.GetAttribute("href")
						if (RSSLink <> "") Then
							if child.GetAttribute("rel") <> "alternate" Then
								RSSLink = ""
							End If
						End If
					End If ' if has attributes
					If RSSLink = "" Then
						RSSlink = child.text
					End If
				End If
			case "description"
				RSSdescription = child.text
			case "content" ' atom format
				RSSdescription = child.text
			case "published"' atom format
				RSSDate = child.text
			case "pubdate"
				RSSDate = child.text
			case "comments"
				RSSCommentsLink = child.text
			case "category"
				Set CategoryItems = RSSItem.getElementsByTagName("category")
				RSSCategory = ""
				for each categoryitem in CategoryItems
					if RSSCategory <> "" Then
						RSSCategory = RSSCategory & ", "
					End If
					RSSCategory = RSSCategory & categoryitem.text
				Next
			End Select
		next
		If (InStr(RSSTitle,Keyword1)>0) or (InStr(RSSTitle,Keyword2)>0) or (InStr(RSSDescription,Keyword1)>0) or (InStr(RSSDescription,Keyword2)>0) then
		
			j = J+1
			if J<MaxNumberOfItems then
				ItemContent = Replace(ItemTemplate,"{LINK}",RSSlink)
				ItemContent = Replace(ItemContent,"{TITLE}",RSSTitle)
				ItemContent = Replace(ItemContent,"{DATE}",RSSDate)
				ItemContent = Replace(ItemContent,"{COMMENTSLINK}",RSSCommentsLink)
				ItemContent = Replace(ItemContent,"{CATEGORY}",RSSCategory)

				Response.Write Replace(ItemContent,"{DESCRIPTION}",RSSDescription)
				ItemContent = ""
				RSSLink = ""
			End if
		End If
	Next
	if RSSItemsCount > 0 then
		cor.str.wri MainTemplateFooter
	else
		cor.str.wri ErrorMessage
	End If
end sub
'
'<#late-binding hook (do not remove)
Function boot_Module_MoodyTabs : boot_Module_MoodyTabs = True : End Function
'/>
%>
