﻿<%
'---------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'---------------------------------------------------------------------------------------------
' This is Random News Box (RNB) For GeckoHeadlines on Soop Portal Phoenix version: 1.03
' Ported to Soop Phoenix by Ph4nt0m
' Advice and assistance provided by kokopelli
' Based on original concept and code for ND by Monloup
' Adapted for GeckoHeadlines for Soop Raven by Q
'---------------------------------------------------------------------------------------------
' RANDOM NEWS BOX (RNB) PARAMETERS EXPLAINED...
' Parameter 0: Box Instance (A Number) - You can run multiple Random News Boxes, and each RNB "instance" you run can display news from a seperate GeckoHeadlines news category  -- HOWEVER -- each Random News Box MUST have a unique "Box Instance" number. For Example your first RNB would have a Box Instance of 1 and your second RNB has a Box Instance of 2. NOTE: When you add multiple instances of Random News Boxes you only need to have one (1) single include statement in your mods/_init_mods.asp script.
' PARAMETER 1: Box Title (A Text String) - This is the title of your Random News Box. Example: My Random News Box. Each instance of Random News Box can have a different title.
' PARAMETER 2: News Category (A Number) - Each instance of RNB can pull news from a separate GeckoHeadlines news category. If you enter a zero (0) your RandomNewsBox will pull news from ALL GeckoHeadlines categories. If you enter the number 1 your RandomNewsBox will pull news from GeckoHeadlines category number 1. If you enter the number 2 your RandomNewsBox will pull news from GeckoHeadlines category number 2.
' PARAMETER 3: Show Image (A Number) - This setting will determine if the associated Article Image is displayed in RNB, allowed values are 1 = Display Article Image |0 = Hide Article Image
' PARAMETER 4: Image Width Param (A Number) - This number establishes the pixel width that images which are associted with your GeckoHeadlinews news articles will be trimmed to when they are presented in your Random News Box. We recommend a value of 80 or 100 (80 pixels or 100 pixels).
' PARAMETER 5: Trim Text Length (A Number) - This is the length that the GeckoHeadlines article text will be trimmed to when it is presented in your Random News Box. Example (and recommended value): 250
' PARAMETER 6: Show Category Name (A Number) - RNB can display the GeckoHeadlines Category Name above the Article Title. 1 = Show Category Name | 0 = DO Not Show Category Name.
' PARAMETERS EXAMPLE #1: 1,Random Soop News,0,1,80,250,1
' In the above example, You are running one (1) RNB, Your box is titled: Random Soop News, You are displying news from all GeckoHeadlines categories, you are displaying associated article images, associated article images will be trimmed to 80 pixels wide, GeckoHeadlines article text will be trimmed to 250 characters when it is presented in your Random News Box,GeckoHeadlines Category Names are being displayed.
' PARAMETERS EXAMPLE #2: 2,Box News - Instance 2,0,6,100,300,0
' In the above example, You are running two (2) Random News Boxes, Your box is titled: Box News - Instance 2, You are displying news from  GeckoHeadlines category #6,you are not displaying associated article images, GeckoHeadlines article text will be trimmed to 300 characters when it is presented in your Random News Box,,GeckoHeadlines Category Names are being suppressed (not shown).
'---------------------------------------------------------------------------------------------

function Module_RandomNewsBox(blnToggleModule,Module_Permission, Module_ID, Module_Parameters, blnTab)

	cor.lng.includeSection("mod_xmlGH")
	if Module_Permission = 0 Then exit Function
	If Module_Parameters = "" Then exit Function
	
	'Define Variables
	Dim rndMax, rndNumber, Topic_Html, Topic_Title, intOrder, intCatID, intHeadlineID, intBoxInstance, arrRT,GroupAccess
	Dim Cat_Name, strTemp, strImage, strBoxTitle, ssql, intImgHeight, intImgWidth, intTrimLength, intShowCatname,intShowImage

	If ubound(split(Module_Parameters, ",")) <> 6 Then Exit Function

	'Get Module Parameters
	intBoxInstance = cor.filter.checkInt(split(Module_Parameters,",")(0))
	strBoxTitle = cor.filter.checkStr(split(Module_Parameters,",")(1))
	intCatID = cor.filter.checkInt(split(Module_Parameters,",")(2))
	intShowImage = cor.filter.checkInt(Split(module_parameters,",")(3))
	intImgWidth = cor.filter.checkInt(Split(Module_Parameters,",")(4))
	intTrimLength = cor.filter.checkInt(Split(Module_Parameters,",")(5))
	intShowCatname = cor.filter.checkInt(Split(Module_Parameters,",")(6))

	'Set Module Box
	Dim Module_Name : Module_Name = "RandomNewsBox" & intBoxInstance
	dim Header_Text : Header_Text = strBoxTitle 
	Dim Module_Hide : Module_Hide = blnToggleModule 
	Dim Module_tool_Tip : Module_tool_Tip = True
	Dim Module_Tool_Tip_Text : Module_Tool_Tip_Text = cor_sModTT

		'-------------0---------------1---------2----------3---------4--------5---------6------------
	ssql = "SELECT gh.Headline_ID, gh.GHImage, gh.Article,gh.Cat_ID,gh.Title,gc.Cat_ID,gc.Category_Name,gh.GroupAccess "_
			& "FROM " & cor_dbpre & "gh_headlines AS gh " _
			& "INNER JOIN " & cor_dbpre & "gh_category AS gc ON gh.Cat_ID = gc.Cat_ID " _
			& "WHERE gh.GHstatus = 'Published'"
			If intCatID<>0 Then ssql = ssql & " AND gh.Cat_ID = " & intCatID

	'Response.Write ssql & "<br>"
	cor.dal.open arrRT, ssql, array()
	'

	If cor.butil.eof(arrRT) Then
		exit function
	else
	'</EOF>
	' Get the total number of records returned for the randomizer
		rndMax = Ubound(arrRT,2)
		
		'check if more than one record returned
		If rndMax <> 0 Then
			' Randomize the record selected from the Array
			rndNumber = cor.butil.random(0,rndMax)
		Else
			rndNumber = rndMax
		End If
		cor.str.wri "<!--  rndNumber: " & rndNumber  & " rndMax: " & rndMax & "  -->"
		intHeadlineID = arrRT(0,rndNumber)						' Holds the headline ID
		strImage = arrRT(1,rndNumber)							' Holds the path to the image
		Topic_Html = arrRT(2,rndNumber) 						' Holds the article text
		intCatID = cor.filter.checkInt(arrRT(3,rndNumber))		' Holds the headline cat id
		Topic_Title = arrRT(4,rndNumber) 						' Holds the article title
		Cat_Name= arrRT(6,rndNumber) 							' Holds the category name
		GroupAccess= arrRT(7,rndNumber)

		'Main HTML For Module
		cor.str.add "<div class=""holderm"">"
		cor.str.add "<dl class=""soop ghNewsItem"">"
		If gh_Headline.hasAccess(GroupAccess) Then
			cor.str.add "<dt class=""titlebar2 t-bar ghNewsItem"">"
			If intShowCatname = "1" Then
				cor.str.add "<a href=""gh_categorynews.asp?catid=" & intCatID & """ target=""_self"" class=""bold"">" & Cat_Name & "</a><br />"
			End If
			cor.str.add "<a href=""gh_showarticle.asp?hid=" & intHeadlineID & """ target=""_self"" class=""lgText"">" & Topic_Title & "</a>"
			cor.str.add "</dt>"
			cor.str.add "<dd class=""ghNewsItem"">"
			If strImage <> "" And intShowImage = "1" Then
				cor.str.add "<a title=""" & Topic_Title & """ href=""" & cor_sWebroot & "gh_showarticle.asp?hid=" &  intHeadlineID & """ target=""_self"">"
				cor.str.add "<img alt="""&strImage&""" class=""right"" width=""" & intImgWidth & """ src=""" & strImage & """ border=""0"" /></a>"
			End If
			cor.str.add gh_TrimDescription(Topic_Html,intTrimLength,intHeadlineID,intCatID,True)
			cor.str.add "</dd>"
			cor.str.add "<dd>"
			cor.str.add "<div class=""buttonOuterWrap""><div class=""buttonInnerWrap"">"
			cor.str.add "<div class=""ui button""><a href='gh_showarticle.asp?hid=" & intHeadlineID & "'><span>" & lngRead & " " & lngGHArticle & "</span></a></div>"
			cor.str.add "</div></div>"
			cor.str.add "</dd>"
			cor.str.add "</dl>"
		Else '</EOF>
			cor.str.add "<dl class=""soop"">"
			cor.str.add "<dt class=""tiHeading"">"
			cor.str.add lngGHNoNews
			cor.str.add "</dt>"
			cor.str.add "</dl>"
		End If
	End If '</EOF>
	cor.str.add "</div>"

	'===========================================================
	If blnTab then
		Call cor.modbox.printTabBox(blnToggleModule,Module_Hide,Module_tool_Tip,Module_Name,Module_ID,Header_Text,cor.str.build,Module_Tool_Tip_Text)
	Else
		Call cor.modbox.printBox(blnToggleModule,Module_Hide,Module_tool_Tip,Module_Name,Module_ID,Header_Text,cor.str.build,Module_Tool_Tip_Text)
	End If
	'
end Function
'
'<#late-binding hook (do not remove)
function boot_Module_RandomNewsBox : boot_Module_RandomNewsBox = true : end function
'/>
%>