<%
'------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------

':: class_media, class_calendar 
function Module_SmallCalendar(blnToggleModule,Module_Permission, Module_ID, Module_Parameters, blnTab)
	'On error resume next
	if Module_Permission = 0 	Then exit function
	if Module_Parameters = "" 	Then 
		response.write cor.butil.breakpoint("No Calendar Parameters...")
		exit function	
	end if
	'	
	dim Module_Name : Module_Name = "SmallCalendar" '& Module_ID
	dim Module_ClassName : Module_ClassName = "SmallCalendar"
	dim Header_Text : Header_Text = lngModCalendar
	dim toggleCookie, media, Module_box
	dim Module_Hide : Module_Hide = true
	dim Module_tool_Tip : Module_tool_Tip = true
	dim Module_Tool_Tip_Text : Module_Tool_Tip_Text = cor_sModTT
	'
	dim arrModule_Parameters
	dim currentMonth
	dim currentDay
	dim currentYear
	dim calendar_grid
	dim dayLinks
	'dim calText			'legacy variable no longer used.
	dim intParam
	dim blnShowMedia	:	blnShowMedia = false
	dim blnShowClock	:	blnShowClock = true	
	dim strMediaPath	:	strMediaPath = "uploads/assets/calendar/"
	dim strMediaPrefix	:	strMediaPrefix = "nature"
	'
	dim helper : set helper = new helper_SmallCalendar
	'
	arrModule_Parameters = split(Module_Parameters,",")
	intParam = ubound(arrModule_Parameters)
	select case intParam
	case 0
		dayLinks = cor.filter.checkInt(arrModule_Parameters(0))
	case 2
		dayLinks = cor.filter.checkInt(arrModule_Parameters(0))
		blnShowMedia = cor.filter.checkBol(arrModule_PArameters(1))
		blnShowClock = cor.filter.checkBol(arrModule_PArameters(2))
	case 3
		dayLinks = cor.filter.checkInt(arrModule_Parameters(0))
		blnShowMedia = cor.filter.checkBol(arrModule_PArameters(1))
		blnShowClock = cor.filter.checkBol(arrModule_PArameters(2))
		strMediaPath = arrModule_Parameters(3)
		strMediaPath = replace(strMediaPath, "[skin]", cor_sSkinPath)
	case 4
		dayLinks = cor.filter.checkInt(arrModule_Parameters(0))
		blnShowMedia = cor.filter.checkBol(arrModule_PArameters(1))
		blnShowClock = cor.filter.checkBol(arrModule_PArameters(2))
		strMediaPath = arrModule_Parameters(3)
		strMediaPath = replace(strMediaPath, "[skin]", cor_sSkinPath)
		strMediaPrefix = arrModule_Parameters(4)
	case else
		dayLinks = 0
	end select
	strMediaPath = replace(strMediaPath, "\", "/")
	'strMediaPath = replace(strMediaPath, " ", "")
	if instr(strMediaPrefix, "/") > 0 or instr(strMediaPrefix, "\") or instr(strMediaPrefix, " ") then strMediaPrefix = "nature"
	if left(strMediaPath,1) = "/" then strMediaPath = right(strMediaPath, len(strMediaPath) - 1)
	if right(strMediaPath,1) <> "/" then strMediaPath = strMediaPath & "/"
	'
	if cor.filter.checkInt(cor.io.q("qDay")) > 0 Then
		currentDay = cor.filter.checkInt(cor.io.q("qDay"))
	else
		currentDay = Day(now())
	end if
	if cor.filter.checkInt(cor.io.q("qMonth")) > 0 Then
		currentMonth = cor.filter.checkInt(cor.io.q("qMonth"))
	else
		currentMonth = Month(now())
	end if
	if cor.filter.checkInt(cor.io.q("qYear")) > 0 Then
		currentYear = cor.filter.checkInt(cor.io.q("qYear"))
	else
		currentYear = Year(now())
	end if
	set media = new class_media
	media.extension = "jpg"
	media.frequency = "random"
	media.prefix 	= strMediaPrefix
	media.path 		= strMediaPath
	media.errImage 	= "blank.gif"
	
	set calendar_grid = new class_calendar
	calendar_grid.weekStartDay = cor_cWeekStart
	calendar_grid.currentDay = currentDay
	calendar_grid.currentMonth = currentMonth
	calendar_grid.currentYear = currentYear
	calendar_grid.CalendarType = "small"
	calendar_grid.eventType = "year"
	calendar_grid.CalendarCellSize = 25
	'
	if dayLinks = 1 Then
		calendar_grid.blnEnableEvents = true
		calendar_grid.dayLink = cor_sWebroot & "calendar.asp?mode=list"
		calendar_grid.withLinks = true
	else
	calendar_grid.blnEnableEvents = false
		calendar_grid.dayLink = ""
		calendar_grid.withLinks = false
	end if
	'
	'
	calendar_grid.CalendarHeader = true
	calendar_grid.CalendarHeaderText = lngModCalendarHeader  
	'
	calendar_grid.CalendarFooter = true
	'
	if dayLinks = 1 Then
		calendar_grid.CalendarFooterText = "<a href=""" & cor_sWebroot & "calendar_year.asp?qYear=" _
			& currentYear & "&amp;type=year"">" & currentYear & "&nbsp;" & lngModFullCalendar & "</a>"
	Else
		calendar_grid.CalendarFooterText = currentYear
	end If
	'
	calendar_grid.useMedia = blnShowMedia
	calendar_grid.mediaPath = cor_sWebroot & strMediaPath '& "uploads/assets/calendar/"
	calendar_grid.mediaObjectType = ".jpg"
	calendar_grid.mediaObjectURL = media.name
	calendar_grid.useFlashClock = blnShowClock
	calendar_grid.srcFlashClock = "clock.swf" '"clock.swf"
	calendar_grid.widthFlashClock = 150
	calendar_grid.heightFlashClock = 150
	call helper.getMonthEvents(False, false, 0, calendar_grid.currentMonth, calendar_grid.currentDay, calendar_grid.currentYear, calendar_grid)
	calendar_grid.PrintCalendar()
	If blnTab then
	Call cor.modbox.printTabBox(blnToggleModule,Module_Hide,Module_tool_Tip,Module_Name,Module_ID,Header_Text,calendar_grid.strCalendar,Module_Tool_Tip_Text)
	Else
	Call cor.modbox.printBox(blnToggleModule,Module_Hide,Module_tool_Tip,Module_Name,Module_ID,Header_Text,calendar_grid.strCalendar,Module_Tool_Tip_Text)
	End If
	'
	set calendar_grid = nothing
	set media = nothing
	'On error goto 0
end function
'
'<#late-binding hook (do not remove)
function boot_Module_SmallCalendar : boot_Module_SmallCalendar = true : end function
'/>
'
'-----------------------------------------------------------------------------------------------------------------------------
'
'helper class
'
'------------------------------------------------------------------------------------------------------------------------------
class helper_SmallCalendar

	public sub getMonthEvents(blnDay, blnOnlyTag, eventCat, currMonth, currDay, currYear, calendarClass)
		dim sqlDate
		dim lowLimit
		dim highLimit
		dim dayCount
		dim eventsFound
		dim blnOk
		dim adoRec
		dim weekFreq
		dim dayOCur
		dim dateOcur
		dim yearFreq
		dim arrEvents
		dim eventsCounter
		dim ssql
		
		lowLimit  = currDay
		highLimit = currDay
		blnOk	 = 1
		sqlDate   = cstr(currMonth & "/01/" & currYear)
		'----------------0------------1---------------2---------------------3----------------4-------------------5-----------------6------------------
		ssql = "SELECT T1.event_ID, T1.event_title, T1.event_Description, T1.event_Recur , T1.event_RecurFreq, T1.event_EndDate, T1.event_StartDate " _
			 & "FROM " & cor_dbpre & "events AS T1 WHERE T1.event_EndDate >={0} " _
			 & "AND T1.event_Approved = {1} AND T1.event_public = {2}"
		if eventCat > 0 then ssql = ssql & " AND T1.EventCat_ID = " & eventCat 
		ssql = ssql & " ORDER By T1.event_EndDate ASC"
		cor.dal.open arrEvents, ssql, array(cor.butil.cvUxTime(sqlDate), blnOk, blnOk)
		'
		if cor.butil.eof(arrEvents) Then exit sub
		eventsFound = 0
		dim strAde	
		dim blnCE				
		dim strAddDayEventTitle
		dim intAddDayDayCount
		dim intAddDayEventDayCount
		for eventsCounter = 0 to ubound(arrEvents,2)
			dim event_ID 			: event_ID 			= arrEvents(0,eventsCounter)
			dim event_title 		: event_title 		= arrEvents(1,eventsCounter)
			dim event_Description 	: event_Description = arrEvents(2,eventsCounter)
			dim event_Recur			: event_Recur 		= arrEvents(3,eventsCounter)
			dim event_RecurFreq 	: event_RecurFreq 	= arrEvents(4,eventsCounter)
			dim event_EndDate 		: event_EndDate 	= arrEvents(5,eventsCounter)
			dim event_StartDate 	: event_StartDate 	= arrEvents(6,eventsCounter)
			if Month(event_StartDate) < currMonth Then
				lowLimit = 1
			else
				lowLimit = Day(event_StartDate)
			end if
			if Month(event_EndDate) > currMonth Then
				highLimit = DaysInMonth(currMonth, currYear)
			else
				highLimit = Day(event_EndDate)
			end if
			if blnDay then
				lowLimit  = currDay
				highLimit = currDay
			end if
			'The following code was mostly redundant in the select case cor_filter.checkLng(event_recur) clause.
			'    More work at the beginning to set variables, less work later to define the outcome
			'
			'Set default values
			strAddDayEventTitle = event_title
			blnCE = checkEvent(blnDay, cor.filter.checkLng(event_Recur), event_StartDate, event_EndDate, currDay, currMonth, currYear, 0, 0) 
			intAddDayDayCount = dayCount
			intAddDayEventDayCount = dayCount
			'set variables for event add.
			select case cor.filter.checkLng(event_Recur)
			case 0
				intAddDayDayCount = day(event_EndDate)
				intAddDayEventDayCount = day(event_EndDate)
			case 7
				weekFreq = split(event_RecurFreq,",")
				strAddDayEventTitle = strAddDayEventTitle & dayCount
				blnCE = checkEvent(blnDay, 7, event_StartDate, event_EndDate, dayCount, currMonth, currYear, weekFreq, 0) 
			case 12
				highLimit = cor.filter.checkInt(event_RecurFreq)
				lowLimit  = cor.filter.checkInt(event_RecurFreq)
				intAddDayDayCount = cor.filter.checkInt(event_RecurFreq)
				blnCE = checkEvent(blnDay, 12, event_StartDate, event_EndDate, dayCount, currMonth, currYear,  cor.filter.checkInt(event_RecurFreq), 0) 
				intAddDayEventDayCount = cor.filter.checkInt(event_RecurFreq)
			case 366
				yearFreq  = split(event_RecurFreq,",")
				highLimit = yearFreq(0)
				lowLimit  = yearFreq(0)
				blnCE = checkEvent(blnDay, 366, event_StartDate, event_EndDate, dayCount, currMonth, currYear, cor.filter.checkInt(yearFreq(0)), cor.filter.checkInt(yearFreq(1)))
				intAddDayDayCount = cor.filter.checkInt(yearFreq(0))
				intAddDayEventDayCount = cor.filter.checkInt(yearFreq(0))
			end select
			strAde = "<div style=""padding-top:2px;padding-bottom:2px"" ><div class=""eventDay"">" & _
				"<a class='doModal' href=""" & cor_sWebroot & "pop_up_events.asp?EID=" & event_ID & _
				""">" & event_title & "</a></div></div>"
			'all the variables have been defined above.  Time to add the events!
			for dayCount = lowLimit to highLimit
				if blnCE Then
					if blnDay Then
						eventsFound = eventsFound + 1
						call printLongEvent(event_ID, event_title, DayCount)
					elseif blnOnlyTag Then
						calendarClass.AddDayEvents strAddDayEventTitle, intAddDayDayCount
					else
						eventsFound = eventsFound + 1
						calendarClass.AddDayEvents strAde, intAddDayEventDayCount 
					end if
				end if
			next
		next
	end sub
	'--------------------------------------------------------------------------------------------------------------------------------
	'
	'----------------------------------------------------------------------------------------------------------------------------------
	public function checkEvent(blnType, recurType, begin_Date, end_Date, cDay, cMonth, cYear, dayFreq, MonthFreq)
		'On error resume next
		dim sCounter
		checkEvent = false
		select case recurType
			case 0
				if Month(begin_Date) = cMonth AND Year(begin_Date) = cYear Then checkEvent = true
				if blnType Then if Day(begin_date) <> cDay Then checkEvent = false
			case 1
				if cMonth >= Month(begin_Date) AND cYear >= Year(begin_Date) Then checkEvent = true
				if blnType Then if cDay < Day(begin_date) Then checkEvent = false
			case 7
				if cMonth >= Month(begin_Date) and cYear >= Year(begin_Date) Then 'and cDay >= Day(begin_Date) Then
					for sCounter = 0 to ubound(dayFreq)
						checkEvent = false
						if cor.filter.checkInt(dayFreq(sCounter)) = cor.filter.checkInt(WeekDay(MonthName(cMonth) & " " & cDay & ", " & cYear,cor_cWeekStart)) Then
							checkEvent = true
							exit function
						end if
					next
				end if
			case 12
				if dayFreq = cDay and cMonth >= Month(begin_date) and cYear >= Year(begin_Date) Then checkEvent = true
			case 366
				if dayFreq = cDay AND monthFreq = cMonth and cYear >= Year(begin_Date) Then checkEvent = true
			case else
				checkEvent = false
		end select
		'On error goto 0
	end function
	'------------------------------------------------------------------------------------------------------------------------------
	'
	'----------------------------------------------------------------------------------------------------------------------------
	public sub printLongEvent(intEventID, strEventTitle, intDayCount)
		cor.str.wri "<a class='doModal' href=""" & cor_sWebroot & "pop_up_events.asp?EID=" & intEventID & """>"
		cor.str.wri strEventTitle & "</a>" & intDayCount & "<br />" 
	end sub

end class

%>
