﻿<%
'--------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'--------------------------------------------------------------------------------------------------------------------------

'
'--------------------------------------------------------------------------------------------------------------------------
'
' Utility (partial) class 
'
'--------------------------------------------------------------------------------------------------------------------------
class class_forum_utils ':: global, class_string, class_baseUtils, class_filters, class_DAL, class_io, class_languageParser
	'--------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------
	public function forumName(sID)
		if cor.filter.checkInt(sID) = 0 Then
			forumName = ""
			exit function
		end if
		dim adoRec
		dim arrForumN
		p_sql = "SELECT f.sname FROM " & cor_dbpre & "forums AS f WHERE f.sid={0}" 
		cor.dal.openPaged arrForumN, 1, 1, p_sql, array(cor.filter.checkInt(sID))
		if NOT cor.butil.eof(arrForumN) Then
			forumName = arrForumN(0,0)
		else
			forumName = ""
		end if
	end function
	'
	'--------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------
	public function buildForumsList( strCombo, strID )
		dim oCombo
		set oCombo = New class_comboBuilder
		oCombo.ElementID	  = strID
		oCombo.ClassName	  = "jump"
		oCombo.Title		  = "fora_forum.asp?fid="
		oCombo.DefaultText	  = strCombo
		oCombo.DisplayDefault = true
		'--------------------------------------0------1--------2--------3---------4----------------
		oCombo.BuildComboFromDBIndent "SELECT f.sid, f.sname, f.sleft, f.sright, f.ssublevel FROM " & cor_dbpre & "forums AS f WHERE f.suid > 0 ORDER BY f.sleft"
		buildForumsList = oCombo.ReturnCombo()
		set oCombo = nothing
	end function	
	'
 
	
	public function parseLatest(sLastTopic)
		dim aLast, aLastLinkArr, aLastLink, sTmpLatest
		if isNull(sLastTopic) Then exit function
		if inStr (sLastTopic, "||") = 0 then parseLatest = sLastTopic : exit function
		aLast = split(sLastTopic, "||") 
		if ubound(aLast) <> 5 Then parseLatest = sLastTopic : exit function
		aLastLinkArr = split(aLast(4),"|")
		if isArray(aLastLinkArr) and Ubound(aLastLinkArr) > 0 Then aLastLink ="#a" & aLastLinkArr(1)
		cor.str.add cor.util.postdate(aLast(0)) & "<br /><span>" & lngAuthor & ": </span>"
		if cor_bGuest then
			cor.str.add "<span class=""bold"">" & aLast(2) & "</span>"
		else
			cor.str.add "<a class=""doModal"" href=""member_form.asp?mid=" & aLast(1) & """>" & aLast(2) & "</a>" & _
				"<br /><a class=""preview"" rel='" & aLast(5) & "' href='fora_topic.asp?fid=" & aLast(3) & "&amp;tid=" & aLast(4) & aLastLink &"'><b class=""ui""><i class=""rightarrow-ico ico-sprt"">&nbsp;</i></b></a>" 
		end if
		parseLatest = cor.str.build
	end function

	'
	'--------------------------------------------------------------------------------------------------------------------------
	'
	'
	'
	'--------------------------------------------------------------------------------------------------------------------------
	public function buildLatest(byval id, sSelector)
		dim arrLatestPost, arrLatestTopic, arrLatest
		'	
		if lcase(sSelector) = "both" then
			'
			' Select top post and top topic ordered by creation date
			'
			'POST
			'Charles added muser to replace pmember
			'------------------0------1--------------2-----------3----------4-----------5------------6----------
			p_sql	= "SELECT p.pid, p.pdatecreate, p.ptopicid, m.muser, 'p' AS typ, p.pmemberid, p.pforumid " & _
					" FROM " & cor_dbpre & "posts AS p INNER JOIN " & cor_dbpre & "members as m ON (m.MemberID = p.pmemberid) " & _
					" WHERE p.pforumid={0} AND p.pistopic=0 ORDER BY p.pdatecreate DESC"
			cor.dal.getRows arrLatestpost, 1, p_sql, array(id)
			'
			'TOPIC (first post)
			'------------------0----------1--------------2------3----------4-----------5------------6-----------
			p_sql	= "SELECT '' AS pid, t.tdatecreate, t.tid, m.muser, 't' AS typ, t.tmemberid, t.tforumid " _
					& " FROM " & cor_dbpre & "topics AS t  INNER JOIN " & cor_dbpre & "members as m ON (m.MemberID = t.tmemberid) " & _
					" WHERE t.tforumid={0} ORDER BY t.tdatecreate DESC"
			cor.dal.getRows arrLatesttopic, 1, p_sql, array(id)
			'
			' if no EOF then compare dates
			if NOT cor.butil.eof(arrLatestPost) AND NOT cor.butil.eof(arrLatestTopic) Then
				if  arrLatestPost(1,0) > arrLatestTopic(1,0) then
					arrLatest = arrLatestPost
				else
					arrLatest = arrLatestTopic
				end if
			else
				if cor.butil.eof(arrLatestPost)  Then arrLatest = arrLatestTopic
				if cor.butil.eof(arrLatestTopic) Then arrLatest = arrLatestPost
			end if
			if isarray(arrLatestTopic) then erase arrLatestTopic
			if isarray(arrLatestPost)  then erase arrLatestPost
			'		
			if  NOT cor.butil.eof(arrLatest) Then
				if  lcase(arrLatest(4,0)) = "p" Then
					'1,5,3,6,2,0
					buildLatest	 = cor.util.postdate(arrLatest(1,0)) & "<br /><span>" & lngAuthor & ":</span><a class=doModal href=""member_form.asp?mid=" & arrLatest(5,0) & """>" & arrLatest(3,0) & "</a><br /><a class=preview rel='lp' href='fora_topic.asp?fid=" & arrLatest(6,0) & "&amp;tid=" & arrLatest(2,0) & "|" & arrLatest(0,0) &"'><span class=goto>&nbsp;</span></a>"  
					cor_sLastTopic	 = arrLatest(1,0) & "||" & arrLatest(5,0) & "||" & arrLatest(3,0) & "||" & arrLatest(6,0) & "||" & arrLatest(2,0) & "|" & arrLatest(0,0) & "||" & "lp"
					cor_lLastPid	 = arrLatest(0,0)
					cor_dLastTime	 = arrLatest(1,0)
					cor_lLastTid	 = arrLatest(2,0)
					cor_lLastMid	 = arrLatest(5,0)
					cor_lLastMuser	 = arrLatest(3,0)
				else ' "t"
					'1,5,3,6,2
					buildLatest	 = cor.util.postdate(arrLatest(1,0)) & "<br /><span>" & lngAuthor & ":</span><a class=doModal href=""member_form.asp?mid=" & arrLatest(5,0) & """>" & arrLatest(3,0) & "</a><br /><a class=preview rel='lt' href='fora_topic.asp?fid=" & arrLatest(6,0) & "&amp;tid=" & arrLatest(2,0) &"'><span class=goto>&nbsp;</span></a>"  
					cor_sLastTopic	 = arrLatest(1,0) & "||" & arrLatest(5,0) & "||" & arrLatest(3,0) & "||" & arrLatest(6,0) & "||" & arrLatest(2,0) & "||" & "lt"
					cor_lLastPid	 = 0
					cor_dLastTime	 = arrLatest(1,0)
					cor_lLastTid	 = arrLatest(2,0)
					cor_lLastMid	 = arrLatest(5,0)
					cor_lLastMuser	 = arrLatest(3,0)
				end if
				erase arrLatest
			else
				buildLatest		 = "-"
				cor_lLastPid		 = 0
				cor_dLastTime		 = 0
				cor_lLastTid		 = 0
				cor_lLastMid		 = 0
				cor_lLastMuser		 = "Guest"
			end if
			'
		else'
			'POST
			'charles again with the p.pmember stuff
			'------------------0------1--------------2-----------3----------4-----------5------------6----------
			p_sql	= "SELECT p.pid, p.pdatecreate, p.ptopicid, m.muser, 'p' AS typ, p.pmemberid, p.pforumid " _
					& " FROM " & cor_dbpre & "posts AS p INNER JOIN " & cor_dbpre & "members AS m ON (m.MemberID = p.pmemberid) " & _
					" WHERE p.ptopicid={0} AND p.pistopic = 0 ORDER BY p.pdatecreate DESC"
			cor.dal.getRows arrLatestPost, 1, p_sql, array(id)
			'
			if NOT cor.butil.eof(arrLatestPost) Then
				'1,5,3,6,2,0
				buildLatest			= cor.util.postdate(arrLatestPost(1,0)) & "<br /><span>" & lngAuthor & ":</span><a class=doModal href='member_form.asp?mid=" & arrLatestPost(5,0) & "'>" & arrLatestPost(3,0) & "</a><br /><a class=preview rel=lp href='fora_topic.asp?fid=" & arrLatestPost(6,0) & "&amp;tid=" & arrLatestPost(2,0) & "|" & arrLatestPost(0,0) &"'><span class=goto>&nbsp;</span></a>"  
				cor_sLastTopic		= arrLatestPost(1,0) & "||" & arrLatestPost(5,0) & "||" & arrLatestPost(3,0) & "||" & arrLatestPost(6,0) & "||" & arrLatestPost(2,0) & "|" & arrLatestPost(0,0) & "||" & "lp"
				cor_lLastPid		= arrLatestPost(0,0)
				cor_dLastTime		= arrLatestPost(1,0)
				cor_lLastTid		= arrLatestPost(2,0)
				cor_lLastMid		= arrLatestPost(5,0)
				cor_lLastMuser		= arrLatestPost(3,0)
			else
			'
			'TOPIC (first post)
			'------------------0----------1--------------2------3----------4-----------5------------6----------
			p_sql	= "SELECT '' AS pid, t.tdatecreate, t.tid, m.muser, 't' AS typ, t.tmemberid, t.tforumid " & _
					" FROM " & cor_dbpre & "topics AS t  INNER JOIN " & cor_dbpre & "members as m ON (m.MemberID = t.tmemberid) " & _
					" WHERE t.tid={0} ORDER BY t.tdatecreate DESC"

				cor.dal.getRows arrLatestTopic, 1, p_sql, array(id)
				if NOT cor.butil.eof(arrLatestTopic) then
					'1,5,3,6,2
					buildLatest		= cor.util.postdate(arrLatestTopic(1,0)) & "<br /><span>" & lngAuthor &":</span><a class=doModal href='member_form.asp?mid=" & arrLatestTopic(5,0) & "'>" & arrLatestTopic(3,0) & "</a><br /><a class=preview rel=lt href='fora_topic.asp?fid=" & arrLatestTopic(6,0) & "&amp;tid=" & arrLatestTopic(2,0) & "'><span class=goto>&nbsp;</span></a>"  
					cor_sLastTopic		= arrLatestTopic(1,0) & "||" & arrLatestTopic(5,0) & "||" & arrLatestTopic(3,0) & "||" & arrLatestTopic(6,0) & "||" & arrLatestTopic(2,0) & "||" & "lt"
					cor_lLastPid		= 0
					cor_dLastTime		= arrLatestTopic(1,0)
					cor_lLastTid		= arrLatestTopic(2,0)
					cor_lLastMid		= arrLatestTopic(5,0)
					cor_lLastMuser		= arrLatestTopic(3,0)
				else
					buildLatest		= "-"
					cor_lLastPid		= 0
					cor_dLastTime		= 0
					cor_lLastTid		= 0
					cor_lLastMid		= 0
					cor_lLastMuser		= "Guest"
				end if
			end if
		end if
	end function
	'
	'--------------------------------------------------------------------------------------------------------------------------
	'
	' Get new posts since last visit
	'
	'--------------------------------------------------------------------------------------------------------------------------
	
	
	public function newPosts(byval topicId)
		dim arrChecknewPosts
		dim cok_fidlastread, cok_tidnewposts
		dim tdatelast, tanswers, tforumid
		'
		'-------------------0----------1---------2----------
		p_sql = "SELECT t.tdatelast, t.tanswers, t.tforumid FROM " & cor_dbpre & "topics AS t WHERE t.tid = {0}"
		cor.dal.open arrChecknewPosts, p_sql, array(topicId)
		tdatelast = arrChecknewPosts(0,0)
		tanswers = arrChecknewPosts(1,0)
		tforumid = clng(arrChecknewPosts(2,0))
				'
		'if ubound(arrChecknewposts,2) < 1 then 
		'	newPosts = false
		'	exit function
		'end if
		'cok_fidlastread = cor.filter.checkInt(request.cookies(cor_sCookieName&"fidlastread")tforumid)
		'cok_tidnewposts = cor.filter.checkLng(request.cookies(cor_sCookieName&"tidnewposts")(topicId))
		'
		dim cookieKey
		cok_fidlastread = -1
		cok_tidnewposts = -1
		if request.cookies(cor_sCookieName&"fidlastread").haskeys then
			for each cookieKey in request.cookies(cor_sCookieName&"fidlastread")
				'response.write "=" & cookieKey & "/" & tforumid & "|" & request.cookies(cor_sCookieName&"fidlastread")(cookieKey) & "<br />"
				if clng(cookieKey) = tforumid then 
					cok_fidlastread = request.cookies(cor_sCookieName&"fidlastread")(cookieKey)
					exit for
				end if
			next
		end if
		if request.cookies(cor_sCookieName&"tidnewposts").haskeys then
			for each cookieKey in request.cookies(cor_sCookieName&"tidnewposts")
				if clng(cookieKey) = topicId then 
					cok_tidnewposts = request.cookies(cor_sCookieName&"tidnewposts")(cookieKey)
					exit for
				end if
			next
		end if
		'if  cok_fidlastread > arrChecknewPosts(0,0) Then
		'	newPosts = false
		'elseif arrChecknewPosts(0,0) < cor.butil.cvUxTime(Dateadd("m", -1, now())) then
		'	newPosts = false
		'elseif arrChecknewPosts(0,0) > cor_dLastVisit Then
		'	newPosts = true
		'elseif cok_tidnewposts = 0 then
		'	newPosts = true
		'elseif cok_tidnewposts < clng(tanswers) then
		'	newPosts = true
			'cor.butil.saveCookieAr "tidnewposts", topicId, clng(tanswers)
		'else
		'	newPosts = false
		'end if
		if clng(cok_fidlastread) > 0 and clng(arrChecknewPosts(0,0)) > clng(cok_fidlastread) then
			newPosts = true
		'elseif clng(arrChecknewPosts(0,0)) > clng(cor_dLastVisit) Then 
		'	newPosts = true
		else
			newposts = false
		end if
	end function   
	'--------------------------------------------------------------------------------------------------------------------------
	'
	'--------------------------------------------------------------------------------------------------------------------------
	public function crumbTree( intItem, blnEnd )
		dim arrParents
		dim intParents
		dim arrFora
		dim strOld
		dim strLabel
		dim strString
		dim strName
		strLabel = ""
		dim breedLeft, breedRight
		'----------------0------1--------2---------3--------4-----------
		p_sql = "SELECT f.sid, f.sleft, f.sright, f.sname, f.suid FROM " & cor_dbpre & "forums AS f WHERE f.sid = {0}" 
		cor.dal.open arrFora, p_sql, array(intItem) 
		if NOT cor.butil.eof(arrFora) Then
			str.add "<div class=""breadcrumb"">"
			if blnEnd Then
				strName = "<a href=""" & "fora_forum.asp?fid=" & arrFora(0,0) & """>" & arrFora(3,0) & "</a>"
			else	
				strName = arrFora(3,0)
			end if
			breedLeft  = arrFora(1,0) 
			breedRight = arrFora(2,0)
			'----------------0------1--------2---------3--------4-------5------------
			p_sql = "SELECT f.sid, f.sleft, f.sright, f.sname, f.suid, f.sroot FROM " & cor_dbpre & "forums AS f WHERE f.sleft < {0} AND f.sright > {1} ORDER BY f.sleft"
			cor.dal.open arrParents, p_sql, array(breedLeft,breedRight)
			if NOT cor.butil.eof(arrParents) Then
				for intParents = 0 to ubound(arrParents, 2)
					select case arrParents(4,intParents)
					case 0
						strString = "<a href=""" & "fora_start.asp" & """>" & arrParents(3,intParents)  & "</a>"
					case 1
						strString = "<a href=""" & "fora_start.asp?mfid=" & arrParents(0,intParents) & """>" &  arrParents(3,intParents)  & "</a>"
						strOld	= arrParents(0,intParents)
					case else		
						'special - don't put mfid = 1 else forums list not ok...	
						if	arrParents(0,intParents) = 1 Then
							strString = "<a href=""" & "fora_start.asp"  & """>" &  arrParents(3,intParents)  & "</a>"
						else
							if cor.filter.checkLng(strOld) > 0 Then
								strString = "<a href=""" & "fora_forum.asp?fid=" & arrParents(0,intParents) & "&amp;mfid=" & strOld  & """>" & arrParents(3,intParents)  & "</a>"
							end if
						end if
					end select
					if isNull(strLabel) OR strLabel = "" Then
						strLabel = strLabel & "&nbsp;"		  & strString
					else
						strLabel = strLabel & "&nbsp;:&nbsp;" & strString
					end if
				next
			end if
			str.add  strLabel & "&nbsp;:&nbsp;<span class=""tiHeading"">" & strName & "</span>"
			str.add  "</div>"
			response.write str.build 
		end if	
	end function
	'--------------------------------------------------------------------------------------------------------------------------
	'
	' find the total number of pages of a chosen topic
	'
	'--------------------------------------------------------------------------------------------------------------------------
	public function totalPages(tid, postsPerPage)
		dim totalPosts
		'
		totalPosts   = clng(cor.dal.getValue("SELECT COUNT(*) FROM " & cor_dbpre & "posts AS p WHERE p.ptopicid = {0} AND p.pistopic = 0", array(cor.filter.checkLng(tid))))
		if  totalPosts > 0 AND postsPerPage > 0 Then
			if (totalPosts / postsPerPage) <> fix(totalPosts / postsPerPage) Then
				totalPages = fix(totalPosts / postsPerPage) + 1
			else
				totalPages = (totalPosts / postsPerPage)
			end if
		else
			totalPages = 1
		end if
	end function
	
	'
	private sub class_initialize
		set str = new class_string
	end sub
	'
	private sub class_terminate
		set str = nothing
	end sub
	'
	private str, p_sql
	'
end class

%>
