<%
'------------------------------------------------------------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'------------------------------------------------------------------------------------------------------------------------------------------

'********************************************************************
'** geckoHeadlines for SooP 2.0
'** Initially written for SooP 1.x by Dan Bodenstein 
'** http://www.scriptgecko.com
'******************************************************************** 
'

'cor.cfg.includeSection("gh2")

class SGMOD_gh_Settings
	public ghBannerZone
	public showFooterTop
	public showHeader


	public Flags
	public DualRows
	public SingleRows
	public ImageSkinDir			'Added by Ripper Skinnable
	public ImageDirWebRoot
	public greeting
	public AllowAllRSSFeed
	public ShowSingleImages
	public ShowFeedsAvailable
	public ShowRealDate
	public ShowThirdColumn
	public ShowCatName
	public ShowSubscription
	public ShowFrontPageSubscription
	public ShowTableofContents
'	public AlwaysExpandTOC
	public ShowFrontPageNav
	public ShowSourceLinks
	public ShowArticleLinks
	public ShowForumLinks
	public DisableSubscriptions
	public CacheOutgoingRSS
	public ShowSearchonMain
	public ShowSearchOnFront
	public ShowSearchonArticle
	public Force2Columns
	public useCategoryFormat
	public useGroupAccess
	public MakeTitleLink
	public ImageTitle
	public ImageURL
	public ImageWidth
	public ImageHeight
	public ImageLink
	public showLinkSources
	public showSummaryImage
	public showForumAuthor
	public useSkinImages
	public showViewCount
	public CurrentUser

	private sub class_initialize()
		ghBannerZone				= 1
		showFooterTop				= 1

		showHeader					= 1

		Flags						= ""
		DualRows					= 4
		SingleRows					= 2
		ImageSkinDir				= ""
		ImageDirWebRoot				= ""
		greeting					= ""
		AllowAllRSSFeed				= false
		ShowSingleImages			= false
		ShowFeedsAvailable			= false
		ShowRealDate				= false
		ShowThirdColumn				= false
		ShowCatName					= false
		ShowSubscription			= false
		ShowTableofContents			= false
'		AlwaysExpandTOC				= false
		ShowFrontPageNav			= false
		ShowFrontPageSubscription	= false
		ShowSourceLinks				= false
		ShowArticleLinks			= false
		ShowForumLinks				= false
		DisableSubscriptions		= false
		CacheOutgoingRSS			= false
		ShowSearchonMain			= false
		ShowSearchOnFront			= false
		ShowSearchonArticle			= false
		MakeTitleLink				= false
		Force2Columns				= false
		useCategoryFormat			= false
		useGroupAccess				= false
		useSkinImages				= false 'added by ripper
		showViewCount				= false 'added by ripper
		ImageURL					= ""
		ImageTitle					= ""
		ImageLink					= ""
		ImageWidth					= "0"
		ImageHeight					= "0"
		showLinkSources				= false
		showSummaryImage			= false
		showForumAuthor				= false
	end sub

	public sub Read()
		dim ssql
		dim rsGH
		dim arrGH ,configCount

		'-----------------0----------------1-----------------2---------3------------4--------------5------------6-------------------7------------8------------9--------------10------------11-------------12--------------13---------
		ssql = "SELECT ts.ghBannerZone, ts.SHOWFOOTERTOP, ts.Flags, ts.DualRows, ts.SingleRows, ts.ImageDir, ts.ImageDirWebRoot, ts.greeting, ts.ImageURL, ts.ImageTitle, ts.ImageLink, ts.ImageWidth, ts.ImageHeight, ts.showHeader " _
			& "FROM " & cor_dbpre & "gh_settings AS ts"
		'Response.Write ssql
		cor.dal.open arrGH, ssql, array()

		if not cor.butil.eof(arrGH) then
			ghBannerZone		= arrGH(0,0)
			showFooterTop		= arrGH(1,0)
			Flags				= arrGH(2,0)
			DualRows			= arrGH(3,0)
			SingleRows			= arrGH(4,0)
			ImageSkinDir		= arrGH(5,0)
			ImageDirWebRoot		= arrGH(6,0)
			greeting			= arrGH(7,0)
			ImageURL			= arrGH(8,0)
			ImageTitle			= arrGH(9,0)
			ImageLink			= arrGH(10,0)
			ImageWidth			= arrGH(11,0)
			ImageHeight			= arrGH(12,0)

			showHeader			= arrGH(13,0)


			erase arrGH
			'
			if ImageWidth  = "0" then ImageWidth = ""
			if ImageHeight = "0" then ImageHeight = ""

			if instr(Flags,"A") > 0 then ShowThirdColumn			= true
			if instr(Flags,"B") > 0 then ShowFeedsAvailable			= true
			if instr(Flags,"C") > 0 then AllowAllRSSFeed			= true
			if instr(Flags,"D") > 0 then ShowRealDate				= true
			if instr(Flags,"E") > 0 then ShowSingleImages			= true
			if instr(Flags,"F") > 0 then ShowCatName				= true
			if instr(Flags,"G") > 0 then ShowSubscription			= true
			if instr(Flags,"H") > 0 then ShowFrontPageSubscription	= true
			if instr(Flags,"I") > 0 then ShowFrontPageNav			= true
'			if instr(Flags,"J") > 0 then AlwaysExpandTOC			= true
			if instr(Flags,"K") > 0 then ShowForumLinks				= true
			if instr(Flags,"L") > 0 then ShowSourceLinks			= true
			if instr(Flags,"M") > 0 then ShowArticleLinks			= true
			if instr(Flags,"N") > 0 then
				DisableSubscriptions		= true
				ShowSubscription			= false
				ShowFrontPageSubscription	= false
			end if
			if instr(Flags,"O") > 0 then CacheOutgoingRSS		= true
			if instr(Flags,"P") > 0 then ShowSearchonMain		= true
			if instr(Flags,"Q") > 0 then ShowSearchOnFront		= true
			if instr(Flags,"R") > 0 then ShowSearchonArticle	= true
			if instr(Flags,"S") > 0 then MakeTitleLink			= true
			if instr(Flags,"T") > 0 then useCategoryFormat		= true
			if instr(Flags,"U") > 0 then Force2Columns			= true
			if instr(Flags,"V") > 0 then useGroupAccess			= true
			if instr(Flags,"W") > 0 then showLinkSources		= true
			if instr(Flags,"X") > 0 then showSummaryImage		= true
			if instr(Flags,"Y") > 0 then showForumAuthor		= true
			if instr(Flags,"Z") > 0 then useSkinImages			= true 'added by ripper
			if instr(Flags,"1") > 0 then showViewCount			= true 'added by ripper 
		end if
	end sub

	public function GreetUser
		dim sTempName
		dim sGreetings
		dim intRnd
		dim arrayGreeting
		dim arrUser
		dim ssql

		if greeting <> "" then
			arrayGreeting = split(greeting,"|")

			ssql = "SELECT mname, muser FROM " & cor_dbpre & "members WHERE memberid = {0}"
			cor.dal.open arrUser, ssql, array(cor_lUserID)

			if Not cor.butil.eof(arrUser) then 
				sTempName = arrUser(0,0)
				if instr(sTempName," ")> 0 then 
					sTempName = left(sTempName,instrRev(sTempName," ")-1)
				end if
			else
				sTempName = cor_sLoggedInUsername
			end if

			if sTempName = "" OR IsNull(sTempName) OR IsEmpty(sTempName) then sTempName = cor_sLoggedInUsername

			sTempName = ucase(left(sTempName,1)) & mid(sTempName,2)

			Randomize
			intRnd = int((ubound(arrayGreeting)+1) * rnd())
			GreetUser = Replace(arrayGreeting(intRnd),"[X]", sTempName,1,-1,1)
		end if
		
	end function

	public function LastArticleDate
		LastArticleDate = cor.dal.getValue("SELECT t1.Article_Date FROM " & cor_dbpre & "gh_headlines AS t1 WHERE t1.GHStatus='published' ORDER BY t1.Article_date DESC",array())
		if NOT isDate(LastArticleDate) then LastArticleDate = cDate(cor.butil.datetime(now(),cor_iDateFormat))
	end function

end class
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
'
'
'------------------------------------------------------------------------------------------------------------------------------------------
class SGMOD_gh_Headline
	public ID
	public AuthorID
	public Author
	public Alias
	public Status
	public Date_Added
	public Title
	public Article
	public ArticleDate
	public Source
	public SourceURL
	public Image
	public FrontPage
	public Urgent
	public GroupAccess
	public Link
	public LinkURL
	public Priority
	public Expires
	public Category
	public CategoryID
	public Views
	public MainNews
	public Topic_ID
	public LinkTopic
	public AlertSent
'	public HeadlineColor
	public ForumAuthorID
	public ForumAuthor
	public RelatedLinks

	private sub class_initialize()
		ID				= 0
		AuthorID		= 2
		Author			= ""
		Status			= "Unpublished"
		Date_Added		= cor.butil.datetime(now(), vbShortDate)
		Title			= ""
		Article			= ""
		ArticleDate		= cor.butil.datetime(now(), vbShortDate)
		Source			= ""
		SourceURL		= ""
		Image			= ""
		FrontPage		= false
		Urgent			= false
		GroupAccess		= ""
		Link			= ""
		LinkURL			= ""
		Priority		= 3
		Expires			= cor.butil.datetime(DateAdd("d",30,now()), vbShortDate)
		Category		= ""
		CategoryID		= 0
		Views			= 0
		MainNews		= false
		Topic_ID		= 0
		LinkTopic		= false
		AlertSent		= 0
'		HeadlineColor	= ""
		ForumAuthorID	= 0
		ForumAuthor		= ""
		RelatedLinks	= ""
	end sub

	public function Read(iID)
		dim rsGH
		dim adoRec
		dim arrGH
		dim ssql
		if NOT isNumeric(iID) then Read = false : exit function
'			----------0---------------1-------------2-----------3---------4------------5--------------6----------------7----------8-------------9------
'			--10--------------11-------12----------13-------------14------------15---------16-----------17---
'			--18-----------19------------20------------21
'			--22-------23---------------24---
	ssql = "SELECT T1.Headline_ID, T1.Author_ID, T1.Article, T1.Title, T1.GHStatus, T1.Date_Added, T1.Article_Date, T1.source, T1.SourceURL, T1.GHImage, " _
		& "T1.GroupAccess, T1.Link, T1.LinkURL, T1.GHPriority, T1.GHExpires, T1.Cat_ID, T1.MainNews, T1.Views, " _
		& "T1.Topic_ID, T1.LinkTopic, T1.AlertSent, T1.RelatedLinks, " _
		& "T2.mname,T3.Category_Name, T2.muser, T5.muser, T5.MemberID "_
		& "FROM ((((" & cor_dbpre & "gh_headlines AS T1 " _
		& "LEFT JOIN " & cor_dbpre & "members AS T2 ON T1.Author_ID = T2.MemberID ) "_
		& "LEFT JOIN " & cor_dbpre & "gh_category AS T3 ON T3.Cat_ID = T1.Cat_ID ) " _
		& "LEFT JOIN " & cor_dbpre & "topics AS T4 ON T1.Topic_ID = T4.tid ) " _
		& "LEFT JOIN " & cor_dbpre & "members AS T5 ON T4.tmemberid = T5.MemberID ) "_
		& "WHERE T1.Headline_ID ={0}"
		cor.dal.open arrGH, ssql, array(iID)

		if cor.butil.eof(arrGH) Then
			Read = false
			exit function
		else
			ID				= arrGH(0,0)
			AuthorID		= arrGH(1,0)
			Author			= arrGH(24,0)
			Article			= arrGH(2,0)
			Title			= arrGH(3,0)
			Status			= arrGH(4,0)
			Date_Added		= cor.butil.datetime(cor.butil.cvLcidTime(arrGH(5,0)),vbShortDate)
			ArticleDate		= cor.butil.datetime(cor.butil.cvLcidTime(arrGH(6,0)),vbShortDate)
			Source			= arrGH(7,0)
			SourceURL		= arrGH(8,0)
			Image			= arrGH(9,0)
			GroupAccess		= arrGH(10,0)
			Link			= arrGH(11,0)
			LinkURL			= arrGH(12,0)
			Priority		= (arrGH(13,0))
			Expires			= cor.butil.datetime(cor.butil.cvLcidTime(arrGH(14,0)),vbShortDate)
			CategoryID		= arrGH(15,0)
			Category		= arrGH(23,0)
			if cor.filter.checkInt(arrGH(16,0)) > 0 Then MainNews = true else mainnews = false
			Views			= arrGH(17,0)
			Topic_ID		= arrGH(18,0)
			if cor.filter.checkInt(arrGH(19,0)) > 0 Then LinkTopic = true else LinkTopic = false
			if cor.filter.checkInt(arrGH(20,0)) > 0 Then AlertSent = 1 else AlertSent = 0
'			HeadlineColor	= arrGH(21,0)
			RelatedLinks	= arrGH(21,0)
			Alias			= arrGH(24,0)
			ForumAuthor		= arrGH(25,0)
			ForumAuthorID	= arrGH(26,0)
			erase arrGH

'			if isNull(HeadlineColor) then HeadlineColor = ""
			if GroupAccess <> "" then GroupAccess= replace(GroupAccess," ","",1,-1,1)
			Read			= true
		end if

	end function

	
	public function hasAccess(sGroupAccess)
		hasAccess = true
		if gh_Settings.UseGroupAccess then
			if sGroupAccess <> "" then 
				'if instr("," & GroupAccess & ",", "," & trim(cstr(iGroupID)) & ",") = 0 then
				Select Case instr("," & sGroupAccess & ",", "," & trim(cstr(cor_iGroupID)) & ",")
					Case 0
						hasAccess = False
					Case Else
						hasAccess = True
				End Select
			end if
		end if
	end function

'	public function hasAccess(iGroupID)
'		hasAccess = true
'		if gh_Settings.UseGroupAccess then
'			if NOT len(gh_Headline.GroupAccess) > 0 then
'				hasAccess = True
'				exit function
'			else
'				Select Case instr(gh_Headline.GroupAccess,trim(cstr(iGroupID & ",")))
'					Case Null
'						hasAccess = True
'					Case "start"
'						hasAccess = True
'					Case 0
'						if gh_Headline.GroupAccess = "" then hasAccess = True
'					Case Else
'					hasAccess = True
'				End Select

'			if len(gh_Headline.GroupAccess) > 0 then
'				if NOT instr(gh_Headline.GroupAccess &",",trim(cstr(iGroupID &","))) = Null OR instr(gh_Headline.GroupAccess &",",trim(cstr(iGroupID &","))) = 0 then
'					hasAccess = false
'					exit function
'				else
'					hasAccess = true
'				end if
'			else
'				hasAccess = true
'			end if
'		end if
'	end function

'	public sub getForumInfo(iID)
'		dim ssql
'		dim arrForum
'		ssql = "SELECT T1.tmemberid FROM " & cor_dbpre & "topics AS T1 WHERE T1.tid = {0}"
'		cor.dal.open arrForum, ssql, array(iID)
'		if cor.butil.eof(arrForum) Then
'			ForumAuthorID = 0 : ForumAuthor = ""
'		else
'			ForumAuthorID = arrForum(0,0)
'			ForumAuthor = cor.util.getUserNamebyID(ForumAuthorID)
'		end if
'	end sub

end class 
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
'
'
'------------------------------------------------------------------------------------------------------------------------------------------
class MOD_ClsRSS
	private url_
	private RSSChannel

	private sub class_initialize()
		set RSSChannel = nothing
	end sub

	public property get Url
		Url = url_
	end property

	public property let Url(v)
		url_ = v

'		dim domXml: set domXml = server.createObject("Msxml2.DOMDocument.4.0")
		Dim domXml: Set domXml = Server.CreateObject("Microsoft.XMLDOM")
		domXml.Setproperty "ServerHTTPRequest", true
		domXml.Async = false
		domXml.ResolveExternals = false
		domXml.ValidateOnParse = false
		domXml.load(url_)

		if (domXml.parseError.errorCode = 0) Then
			dim rootNode: set rootNode = domXml.documentElement
			if (NOT isObject(rootNode)) Then
				err.raise vbObjectError+3, "Xml Data", "No Root element found", "", 0
				exit Property
			end if

			dim channelNode: set channelNode = rootNode.selectSingleNode("channel")
			if (NOT isObject(channelNode)) Then
				err.raise vbObjectError+4, "Xml Data", "No 'channel' element found", "", 0
				exit Property
			end if

			' read channel info
			set RSSChannel = New MOD_ClsRSSChannel
			On Error resume next
			RSSChannel.Title			= channelNode.selectSingleNode("title").Text
			RSSChannel.Description		= channelNode.selectSingleNode("description").Text
			RSSChannel.Link				= channelNode.selectSingleNode("link").Text
			RSSChannel.lastBuildDate	= channelNode.selectSingleNode("lastBuildDate").Text
			RSSChannel.ttl				= channelNode.selectSingleNode("ttl").Text
			RSSChannel.category			= channelNode.selectSingleNode("category").Text
			On Error goto 0

			'Check for Image Tag
			dim channelImageNode
			set channelImageNode		= rootNode.getElementsByTagName("image")
'				response.write channelImageNode.selectSingleNode("url").Text

			if (NOT isObject(channelImageNode)) Then
				err.raise vbObjectError+4, "Xml Data", "No 'channel' element found", "", 0
				exit Property
			else

				dim objImageChild
				for each objImageChild in channelImageNode
					On Error resume next
					RSSChannel.ImageURL	= objImageChild.selectSingleNode("url").text
					RSSChannel.ImageTitle	= objImageChild.selectSingleNode("title").text
					RSSChannel.ImageLink	= objImageChild.selectSingleNode("link").text
					If NOT IsEmpty(rootNode.getElementsByTagName("width")) Then
						RSSChannel.ImageWidth	= objImageChild.selectSingleNode("width").text
					End If
					If NOT IsEmpty(rootNode.getElementsByTagName("height")) Then
						RSSChannel.ImageHeight	= objImageChild.selectSingleNode("height").text
					End If
					On Error goto 0
				next

			end if

			' read items within channel
			dim objLinks: set objLinks = rootNode.getElementsByTagName("item")
			if (isObject(objLinks)) Then
				dim objChild
				for Each objChild in objLinks
					On Error resume next
					dim RSSItem: set RSSItem = New MOD_ClsRSSItem
					RSSItem.Title		= objChild.selectSingleNode("title").Text
					RSSItem.Description	= objChild.selectSingleNode("description").Text
					RSSItem.Link		= objChild.selectSingleNode("link").Text
					RSSItem.pubDate		= objChild.selectSingleNode("pubDate").Text
					RSSItem.category	= objChild.selectSingleNode("category").Text
					RSSChannel.AddItem(RSSItem)
					On Error goto 0
				Next
			end if

			' release used resources
			set rootNode	= nothing
			set channelNode	= nothing
			set objLinks	= nothing
		else
			err.raise vbObjectError+2, "Xml Data", _
				"Unable to parse Xml: " & _
				domXml.parseError.reason, _
				"", 0
		end if
		set domXml = nothing
	end property

	public property get Channel
		set Channel = RSSChannel
	end property
end class 
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
'
'
'------------------------------------------------------------------------------------------------------------------------------------------	
class MOD_ClsRSSChannel
	private items_
	public Title
	public Description
	public Category
	public Link
	public Image
	public lastBuildDate
	public TTL
	public ImageTitle
	public ImageURL
	public ImageWidth
	public ImageHeight
	public ImageLink
		
	private sub class_initialize()
		set items_ = server.createObject("Scripting.Dictionary")
	end sub
	
	private sub class_terminate()
		set items_ = nothing
	end sub
	
	public sub AddItem(v)
		items_.Add items_.Count, v
	end sub
	
	public property get Items
		Items = items_.items
	end property
		
	public property let Items(v)
		set items_ = v
	end property
end class 
'	
'------------------------------------------------------------------------------------------------------------------------------------------
'
'
'
'------------------------------------------------------------------------------------------------------------------------------------------	
class MOD_ClsRSSItem
	public Title
	public Description
	public Link
	public pubDate
	public Category
end class 
'	
'------------------------------------------------------------------------------------------------------------------------------------------
'
'
'
'------------------------------------------------------------------------------------------------------------------------------------------
class MOD_clsRSSFeed
	public ID
	public Title
	public URL
	public Description
	public lastBuildDate
	public TTL
	public TTR
	public LastUpdate
	public CategoryFilters
	public TitleFilters
	public MainPage
	public Sequence
	public ImageURL
	public ImageTitle
	public ImageLink
	public ImageWidth
	public ImageHeight

	private sub class_initialize()
		ImageURL	= ""
		ImageTitle	= ""
		ImageLink	= ""
		ImageWidth	= "0"
		ImageHeight	= "0"
		Sequence	= "0"
	end sub

	public function Read(iID)
		dim rsGH
		dim adoRec
		dim adoRows
		dim arrFeeds
		dim ssql

		if NOT isNumeric(iID) then Read = false : exit function
		if iID = 0 Then
			Read = false
			exit function
		end if
		'-------------------0------------1---------2--------3--------------4-------5--------------6-----------------7------------8------------9------------10-------------11------------12-------------13-------
		ssql = "SELECT T1.RSSfeed_id, T1.title, T1.URL, T1.description, T1.TTL, T1.lastupdate, T1.lastbuilddate, T1.mainpage, T1.sequence, T1.imageurl, T1.imagetitle, T1.imagelink, T1.imagewidth, T1.imageheight " _
			& "FROM " & cor_dbpre & "gh_rssfeed AS T1 WHERE T1.RSSFeed_ID={0}"
		cor.dal.open arrFeeds, ssql, array(iID)
		if cor.butil.eof(arrFeeds) Then
			Read = false
			exit function
		else
			ID				= arrFeeds(0,0)
			Title			= arrFeeds(1,0)
			URL				= arrFeeds(2,0)
			Description		= arrFeeds(3,0)
			TTL				= arrFeeds(4,0)
			LastUpdate		= arrFeeds(5,0)
			LastBuildDate	= cor.butil.cvLcidTime(arrFeeds(6,0))
			MainPage		= arrFeeds(7,0)
'			TTR				= dateDiff("n",cDate(cor.butil.datetime(now(),vbGeneralDate)),DateAdd("n",TTL,cor.butil.cvLcidTime(LastUpdate)))
			TTR				= datediff("s",cDate(cor.butil.datetime(now(),vbGeneralDate)),DateAdd("s",(TTL*60),cor.butil.cvLcidTime(LastUpdate)))
			Sequence		= arrFeeds(8,0)
			ImageURL		= arrFeeds(9,0)
			ImageTitle		= arrFeeds(10,0)
			ImageLink		= arrFeeds(11,0)
			ImageWidth		= arrFeeds(12,0)
			ImageHeight		= arrFeeds(13,0)
		end if
		erase arrFeeds
		'
		cor.dal.open adoRows, "SELECT T1.Filter FROM " & cor_dbpre & "gh_rssfilter AS T1 WHERE T1.RSSFeed_ID={0} AND T1.FilterType='C'OR T1.FilterType='T'", array(iID)
		if Not cor.butil.eof(adoRows) then CategoryFilters = adoRows
		'
		'cor.dal.open adoRows, "SELECT T1.Filter FROM " & cor_dbpre & "gh_rssfilter AS T1 WHERE T1.RSSFeed_ID={0} AND T1.FilterType='T'", array(iID)
		'if Not cor.butil.eof(adoRows) Then TitleFilters = adoRows
		erase adoRows
		'
		Read = true
	end function
end class
'
'------------------------------------------------------------------------------------------------------------------------------------------
'
'
'
'------------------------------------------------------------------------------------------------------------------------------------------
class MOD_gh_Categories
	public ID
	public Category_Name
	public Sequence
	public FrontPage
	public ExtFeedID
	public Flags
	public AllowExt
	public ShowInAllNews
	public AllowSubscription
	public ImageURL
	public ImageTitle
	public ImageLink
	public ImageWidth
	public ImageHeight

	public function Read(iID)
		dim rsGH
		dim adoRec
		dim arrCats
		dim ssql

		if NOT isNumeric(iID) then
			Read = false
			exit function
		end if
		
		if iID = 0 then
			Read = false
			exit function
		end if
'-------------------------0----------1-----------------2------------3-------------4-------------5---------6------------7-----------------8---------------------9-----------10-------------11------------12-------------13---------
		ssql = "SELECT T1.cat_id, T1.category_name, T1.sequence, T1.frontpage, T1.extfeedid, T1.flags, T1.allowext, T1.showinallnews, T1.allowsubscription, T1.imageurl, T1.imagetitle, T1.imagelink, T1.imagewidth, T1.imageheight FROM " & cor_dbpre & "gh_category AS T1 WHERE T1.Cat_ID = {0}"
		cor.dal.open arrCats, ssql, array(iID)

		if cor.butil.eof(arrCats) then
			Read = false
			exit function
		else
			ID					= clng(arrCats(0,0))
			Category_Name		= cor.filter.validhtml(arrCats(1,0))
			Sequence			= arrCats(2,0)
			FrontPage			= arrCats(3,0)
			ExtFeedID			= arrCats(4,0)
			Flags				= arrCats(5,0)
			If cor.filter.checkInt(arrCats(6,0)) = 0 Then AllowExt			= false Else AllowExt			= true
			If cor.filter.checkInt(arrCats(7,0)) = 0 Then ShowInAllNews		= false Else ShowInAllNews		= true
			If cor.filter.checkInt(arrCats(8,0)) = 0 Then AllowSubscription	= false Else AllowSubscription	= true
			ImageURL			= arrCats(9,0)
			ImageTitle			= arrCats(10,0)
			ImageLink			= arrCats(11,0)
			ImageWidth			= arrCats(12,0)
			ImageHeight			= arrCats(13,0)
		end if
		erase arrCats
		Read = true
	end function
end class
'	
'------------------------------------------------------------------------------------------------------------------------------------------
'
'
'
'------------------------------------------------------------------------------------------------------------------------------------------	
'Permission Class
class MOD_GH_Permissions
	public ID
	public Author_ID
	public Author
	public Group_ID
	public Group
	public isGroupPermission
	public isAdmin
	public isModerator
	public Flags
	public NOPERMISSION
	
	private sub class_initialize()
		ID					= 0
		Author_ID			= ""
		Author				= ""
		Group_ID			= ""
		Group				= ""
		isGroupPermission	= 0
		isAdmin				= 0
		isModerator			= 0
		Flags				= ""
		NOPERMISSION		= true
	end sub

	public function Read(iID)
		dim arrGH
		dim ssql
		if iID = 0 Then
			NOPERMISSION = true
			exit function
		end if
		' Check for Complete Group Access ( Cat_ID=0 + Group_ID + Moderator or Admin
		'-----------------------0------------1-------------2------------3---------4-------------5---------6---------7----
		ssql = "SELECT T1.permissions_id, T1.author_id, T1.group_id, T1.admin, T1.moderator, T1.flags, T2.muser, T3.gname "_
			& "FROM (((" & cor_dbpre & "gh_permissions AS T1) " _
			& "LEFT JOIN " & cor_dbpre & "members AS T2 ON T1.author_id=T2.memberid ) " _
			& "LEFT JOIN " & cor_dbpre & "groups AS T3 ON T1.group_id=T3.gid ) " _
			& "WHERE T1.Permissions_ID={0}"
		cor.dal.Open arrGH, ssql, array(iID)
		if NOT cor.butil.eof(arrGH) Then
			ID					= arrGH(0,0)
			Author_ID			= arrGH(1,0)
			Group_ID			= arrGH(2,0)
			if cor.filter.checkInt(arrGH(3,0)) = 1 Then isAdmin = 1 else isAdmin = 0
			if cor.filter.checkInt(arrGH(4,0)) = 1 Then isModerator = 1 else isModerator = 0
			Flags				= arrGH(5,0)
			NOPERMISSION		= false
			Author				= arrGH(6,0)'cor.util.getUserNamebyID(Author_ID)
			Group				= arrGH(7,0)'cor.dal.getValue("SELECT T1.gname FROM " & cor_dbpre & "groups AS T1 WHERE T1.gid={0}", array(Group_ID))
		end if
		erase arrGH
	end function
end class

%>	
