﻿<%
'---------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'---------------------------------------------------------------------------------------
'
' Soop Portal Phoenix Installer v1.0a
' Author: Steve Podmore aka ph4nt0m, Brian aka Hooded, Charles aka Cadius
' Based on original idea from Brian aka Hooded
' Much code pilfered from the excellent GeckoInstaller By Dan Bodenstein
'---------------------------------------------------------------------------------------
sub DoStep1
	'db conn, site url
	dim prot	:	prot = split(request.servervariables("SERVER_PROTOCOL"),"/")
	dim url		:	url = lcase(prot(0)) & "://" & request.servervariables("SERVER_NAME")
	dim fp		:	fp = replace(request.servervariables("PATH_INFO"), "soopsetup.asp", "")
	url = url & fp

%>
	<div class="module" id="phstep1"><!-- <module> -->
	<div class="rbt"><div><div> </div></div></div>
	<div class="rbl"><!-- <rbl> -->
	<div class="rbr"><!-- <rbr> -->
	<div class="titleBar"><!-- <titleBar> -->
	<div class="title" id="phstep1title">Soop Portal Installation <% If cor.io.q("sec") <> "" Then Response.Write "Step " & cor.io.q("sec") & "" %></div>
	<div class="icons" style="display: none;"><!-- <icons> -->
	</div><!-- </icons> -->		</div><!-- </titleBar> -->
		<div class="modular text">
		<div class="modular text" style="padding:25px;">
		Please enter your database details and then click the "Test Database Connection" button to ensure your database details are correct.
		</div>
		<form id="soopdbsetup" name="soopdbsetup" class="soop" action="soopsetup.asp" method="post">
		<input type="hidden" name="setupp" id="setupp" value="1" />
		<fieldset>
			<legend><%= lngStpLgndDbType %></legend>
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label"><strong>Website Address</strong><br />This is your full domain name </li>
					<li class="input"><input type="text" id="webaddress" name="webaddress" size="60" maxlength="200" value="<%= url %>" />
						<div class="sample right">eg: http://www.mysite.com or http://localhost</div></li>
				</ul>
				</li>
			</ul>
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label"><label for=""><%= lngStpLblDbType %></label></li>
					<li class="input">
		<%
		Set oCombo = New class_comboBuilder
		oCombo.ElementID = "databasetype"
		oCombo.SelectedValue = ""
		oCombo.AddOption "access","Microsoft Access"
		oCombo.AddOption "mssql2000","Microsoft SQL Server 2000 7.0"
		oCombo.AddOption "mssql2005","Microsoft SQL Server 2005"
		oCombo.AddOption "mssql2008","Microsoft SQL Server 2008"
		oCombo.AddOption "mysql351","MySQL ODBC 3.51 Driver"
		oCombo.AddOption "mysql51","MySQL ODBC 5.1 Driver"
		oCombo.CreateCombo()
		Set oCombo = Nothing
		%>
					</li>
				</ul>
				</li>
			</ul>
			<div id="access" style="display:none;">
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label"><%= lngStpLblDbReqDbPathAndName %></li>
					<li class="input">
					<input value="<%= replace(Request.ServerVariables("PATH_TRANSLATED"),"soopsetup.asp","db\Phoenix.mdb",1,-1,1) %>" type="text" id="sqlpathname" name="sqlpathname" size="60" maxlength="100" />
					<div class="sample">eg:<%= replace(Request.ServerVariables("PATH_TRANSLATED"),"soopsetup.asp","db\phoenix.mdb",1,-1,1) %></div></li>
				</ul>
				</li>
			</ul>
			</div>
			<div id="sql" style="display:none;">
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label"><%= lngStpLblDbReq %></li>
					<li class="input"><input type="text" id="sqlsvrname" name="sqlsvrname" size="60" maxlength="200" /></li>
				</ul>
				</li>
			</ul>
			<div id="myport" style="display:none;">
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label"><%= lngStpDBPort %></li>
					<li class="input"><input type="text" id="mysqlport" name="mysqlport" size="12" maxlength="12" value="3306" /></li>
				</ul>
				</li>
			</ul>
			</div>
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label"><%= lngStpLblDbReqSQLDBName %></li>
					<li class="input"><input type="text" id="sqldbname" name="sqldbname" size="30" maxlength="200" /></li>
				</ul>
				</li>
			</ul>
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label"><%= lngStpLblDbReqUserName %></li>
					<li class="input"><input type="text" id="sqldbuser" name="sqldbuser" size="20" maxlength="100" /></li>
				</ul>
				</li>
			</ul>
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label"><%= lngStpLblDbReqUserPass %></li>
					<li class="input"><input type="text" id="sqldbpass" name="sqldbpass" size="20" maxlength="100" /></li>
				</ul>
				</li>
			</ul>
			</div>
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label"><%= lngStpLblDbReqdbpre %></li>
					<li class="input"><input type="text" id="dbprefix" name="dbprefix" size="6" maxlength="10" value="<%= cor_pre %>" /></li>
				</ul>
				</li>
			</ul>
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label"><%= lngStpLblDbReqCustomProvider %></li>
					<li class="input"><input type="text" id="sqlsvrcustom" name="sqlsvrcustom" size="60" maxlength="200" /></li>
				</ul>
				</li>
			</ul>
			<ul class="row">
				<li>
				<ul class="col">
					<li class="label">Install to perform</li>
					<li class="input">
				<%
				'Dim arrayInstalls, intLoop, strIniFile
				Call getInstallList()
				Response.Write ("<select name=""sFile"" id=""sFile"">")
					For intLoop = 1 to ubound(arrayInstalls,2)
					Response.write ("<option value=""" & arrayInstalls(4,intLoop) & "\" & arrayInstalls(0,intLoop) & """>")
					strIniFile = OpenINIFile(arrayInstalls(4,intLoop) & "\" & arrayInstalls(0,intLoop))
					Response.write (getxmlString("declare","name","Not Found",arrayInstalls(4,intLoop) & "\" & arrayInstalls(0,intLoop)))
					Response.Write ("</option>") & VbCrLf
					Next
				Response.Write ("</select>") & VbCrLf
				%>
					</li>
				</ul>
				</li>
			</ul>

		</fieldset>
		<fieldset id="testdb" style="display:none;">
			<legend>Test Database Connection</legend>
			<div id="tctest">
			<input type="button" name="td" id="td" value="Test Database Connection" class="frmButton">
			</div>
			<div id="testconreturn" style="padding:10px;">
			</div>
		</fieldset>
		<div class="center">
		<input type="submit" name="sec1" id="sec1" value="Continue" class="frmButton" disabled />
		</div>
		</form>
		<form id="testcon" name="testcon" method="post" action="soopsetup.asp">
		<input type="hidden" id="setupp" name="setupp" value="tc" />
		</form>
		<br />
		</div>
		</div><!-- </rbr> -->
		</div><!-- </rbl> -->
		<div class="rbb"><div><div> </div></div></div>
		</div>
<%
end sub
sub DoStep1b
%>
	<div class="module" id="phstep1b"><!-- <module> -->
		<div class="rbt"><div><div> </div></div></div>
		<div class="rbl"><!-- <rbl> -->
			<div class="rbr"><!-- <rbr> -->
				<div class="titleBar"><!-- <titleBar> -->
					<div class="title" id="phstep1title">Soop Portal Installation <% If cor.io.q("sec") <> "" Then Response.Write "Step " & cor.io.q("sec") & "" %></div>
					<div class="icons" style="display: none;"> 	</div><!-- </icons> -->
				</div><!-- </titleBar> -->
				<div class="modular text">
					<div class="modular text" style="padding:25px;">
						<span class="tiHeading">Please Note !!</span><br /><br />
						This part of the installer will install all the needed database table structure and data, this process can sometimes be a lenghly one so please do not navigate away from or refresh this page until you either see the "Database Install Complete" message or any error message.<br /><br />
					</div>
					<% Call ShowInstall(session("sFile")) %>
					<div id="frmButtons" class="modular text center">
						<input type="submit" name="sec1b" id="sec1b" value="Continue" class="frmButton" disabled="disabled" />
						<input type="submit" name="sec1br" id="sec1br" value="Back" class="frmButton" disabled="disabled" />
						<br /><br />
					</div>
				</div>
			</div><!-- </rbr> -->
		</div><!-- </rbl> -->
		<div class="rbb"><div><div> </div></div></div>
	</div>
<%
end sub
%>