﻿<%
'---------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'---------------------------------------------------------------------------------------
'
' Soop Portal Phoenix Installer v1.0a
' Author: Steve Podmore aka ph4nt0m, Brian aka Hooded, Charles aka Cadius
' Based on original idea from Brian aka Hooded
' Much code pilfered from the excellent GeckoInstaller By Dan Bodenstein
'---------------------------------------------------------------------------------------
sub DoStep3
	'step 3, update the admin user; site timezone/language defaults; update email system parameters.
%>
		<div class="module" id="phstep3"><!-- <module> -->
		<div class="rbt"><div><div>&nbsp; </div></div></div>
		<div class="rbl"><!-- <rbl> -->
		<div class="rbr"><!-- <rbr> -->
		<div class="titleBar"><!-- <titleBar> -->
		<div class="title" id="phstep3title">Soop Portal Installation <% If cor.io.q("sec") <> "" Then Response.Write "Step " & cor.io.q("sec") & "" %></div>
		<div class="icons" style="display: none;"><!-- <icons> -->
		</div><!-- </icons> -->
		</div><!-- </titleBar> -->
		<div class="modular text">
		<form id="basedbfrm" method="post" action="" class="soop">
		<input type="hidden" name="setupp" value="sd" />
	<fieldset>
	<legend>Administrator Settings</legend>
<ul class="row">
	<li>
	<ul class="col">
		<li class="label"><label for="adminname">Admin Username</label></li>
		<li class="input"><input type="text" id="adminname" name="adminname" size="30" maxlength="50" /></li>
	</ul>
	</li>
</ul>
<ul class="row">
	<li>
	<ul class="col">
		<li class="label"><label for="adminmail">Admin Email</label></li>
		<li class="input"><input type="text" id="adminmail" name="adminmail" size="30" maxlength="250" /></li>
	</ul>
	</li>
</ul>
<ul class="row">
	<li>
	<ul class="col">
		<li class="label"><label for="adminpass">Admin Password</label></li>
		<li class="input"><input type="password" id="adminpass" name="adminpass" size="30" maxlength="50" /></li>
	</ul>
	</li>
</ul>
<ul class="row">
	<li>
	<ul class="col">
		<li class="label"><label for="adminpass2">Confirm Admin Password</label></li>
		<li class="input"><input type="password" id="adminpass2" name="adminpass2" size="30" maxlength="50" /></li>
	</ul>
	</li>
</ul>
	</fieldset>
	<fieldset>
	<legend>Website Details</legend>
<ul class="row">
	<li>
	<ul class="col">
		<li class="label"><label for="sitename">Website Name</label></li>
		<li class="input"><input type="text" id="sitename" name="sitename" size="30" maxlength="50" /></li>
	</ul>
	</li>
</ul>
<ul class="row">
	<li>
	<ul class="col">
		<li class="label"><label for="language">Website Default Language</label></li>
		<li class="input">
		<%
		Set oCombo = New class_comboBuilder
		oCombo.ElementID = "language"
		oCombo.BuildComboFromFolder "./core/languages/",".xml"
		oCombo.CreateCombo()
		Set oCombo = Nothing
		%>
		</li>
	</ul>
	</li>
</ul>
<ul class="row">
	<li>
	<ul class="col">
		<li class="label"><label for="country">Website Default Location</label></li>
		<li class="input">
		<%
		Dim arCountry, arCID
		Set oCombo = New class_comboBuilder
		oCombo.ElementID = "country"
		arCountry = split(arrCountries,",")
		For i= 0 To Ubound(arCountry)
			arCID = split(arCountry(i),"|")
			If IsArray(arCID) Then
			oCombo.AddOption arCID(0),arCID(1)
			End If
		Next
		oCombo.CreateCombo()
		Set oCombo = Nothing
		%>
		</li>
	</ul>
	</li>
</ul>
<ul class="row">
	<li>
	<ul class="col">
		<li class="label"><label for="usertimezone">Default User Timezone</label></li>
		<li class="input">
		<%
		Set oCombo = New class_comboBuilder
		oCombo.ElementID = "usertimezone"
		oCombo.ClassName = "timezone"
		oCombo.BuildComboFromFile cor.butil.getWebRoot() & "core\classes\timezones.txt"
		oCombo.CreateCombo()
		Set oCombo = Nothing
		%>
		</li>
	</ul>
	</li>
</ul>
<ul class="row">
	<li>
	<ul class="col">
		<li class="label"><label for="servertimezone">Website's Server Timezone</label></li>
		<li class="input">
		<%
		Set oCombo = New class_comboBuilder
		oCombo.ElementID = "servertimezone"
		oCombo.ClassName = "timezone"
		oCombo.BuildComboFromFile cor.butil.getWebRoot() & "core\classes\timezones.txt"
		oCombo.CreateCombo()
		Set oCombo = Nothing
		%>
		</li>
	</ul>
	</li>
</ul>
	</fieldset>
	<fieldset>
	<legend>Email Settings</legend>
	<div class="holder2" style="margin:0 220px 0 0;">
		<ul class="row">
			<li>
			<ul class="col">
				<li class="label"><label for="emcomp">Email Component</label></li>
				<li class="input">
				<select size="" id="emcomp" name="emcomp" class="">
					<option selected="selected" value=""> - Please Select - </option>
					<option value="cdonts">CDONTS Windows 2000 or earlier</option>
					<option value="cdosys">CDOSYS Windows 2000 - 2008</option>
					<option value="cdosys_local">CDOSYS Local</option>
					<option value="cdosys_pickup">CDOSYS Pickup</option>
					<option value="cdosys_remote">CDOSYS Remote</option>
					<option value="aspemail">Persits AspEmail Premium - UTF-8</option>
					<option value="aspemailfree">Persits AspEmail Free</option>
					<option value="w3jmail">w3JMail Dimac - UTF-8 </option>
				</select>
				</li>
			</ul>
			</li>
		</ul>
		<ul class="row" id="ecfg-emusrname">
			<li>
			<ul class="col">
				<li class="label"><label for="emusrname">Email Username</label></li>
				<li class="input"><input type="text" id="emusrname" name="emusrname" size="30" maxlength="50" /></li>
			</ul>
			</li>
		</ul>
		<ul class="row" id="ecfg-empass">
			<li>
			<ul class="col">
				<li class="label"><label for="empass">Email Password</label></li>
				<li class="input"><input type="text" id="empass" name="empass" size="30" maxlength="50" /></li>
			</ul>
			</li>
		</ul>
		<ul class="row" id="ecfg-emreplyaddress">
			<li>
			<ul class="col">
				<li class="label"><label for="emreplyaddress">Reply Address</label></li>
				<li class="input"><input type="text" id="emreplyaddress" name="emreplyaddress" size="30" maxlength="250" /></li>
			</ul>
			</li>
		</ul>
		<ul class="row" id="ecfg-emsendername">
			<li>
			<ul class="col">
				<li class="label"><label for="emsendername">Senders Name</label></li>
				<li class="input"><input type="text" id="emsendername" name="emsendername" size="30" maxlength="250" /></li>
			</ul>
			</li>
		</ul>
		<ul class="row" id="ecfg-emserveradd">
			<li>
			<ul class="col">
				<li class="label"><label for="emserveradd">SMTP Server Address</label></li>
				<li class="input"><input type="text" id="emserveradd" name="emserveradd" size="30" maxlength="250" /></li>
			</ul>
			</li>
		</ul>
		<ul class="row" id="ecfg-empickupdir">
			<li>
			<ul class="col">
				<li class="label"><label for="empickupdir">SMTP Server Pickup Directory</label></li>
				<li class="input"><input type="text" id="empickupdir" name="empickupdir" size="30" maxlength="250" /></li>
			</ul>
			</li>
		</ul>
		<ul class="row" id="ecfg-emport">
			<li>
			<ul class="col">
				<li class="label"><label for="emport">SMTP Server Port</label></li>
				<li class="input"><input type="text" id="emport" name="emport" size="30" maxlength="50" /></li>
			</ul>
			</li>
		</ul>
		</div>
		<div class="holder3" style="width:200px;">
		<h3>Installed Email Components</h3>

<% 'Supported Email Components Checking
cor.str.wri chkEmObj(arrEmailComponents,iCnt)
If iCnt = 0 Then
		Response.Write "<p style=""font-size:1em;""><b>There are NO supported  Email Components Installed on this Server</b></p>"
End If
%>

		</div>
	</fieldset>
		<div class="center">
		<input type="submit" action="submit" name="sec4" id="sec4" value="Next" class="frmButton">
		</div>
		</form>
		</div><!-- </rbr> -->
		</div><!-- </rbl> -->
		<div class="rbb"><div><div></div></div></div>
		</div>
		<%
end sub
%>