﻿<%
'---------------------------------------------------------------------------------------
' SOOP 2.0 - Phoenix (TNG)
'
' Revision 2.00 - initial 15/02/2008
'
' SOOPPortal All Rights Reserved - Other copyrights as mentioned in sources or joined licences
'---------------------------------------------------------------------------------------
'
' Soop Portal Phoenix Installer v1.0a
' Author: Steve Podmore aka ph4nt0m, Brian aka Hooded, Charles aka Cadius
' Based on original idea from Brian aka Hooded
' Much code pilfered from the excellent GeckoInstaller By Dan Bodenstein
'---------------------------------------------------------------------------------------
'
' This rewrites the soop_setup_status file, which lets the soopSetup system know setup is complete. 
' it also shows the "next steps" text to the user, so they will know what needs to be done next.
sub doStep4

	cor.str.add "<" & "%"
	cor.str.add "'******************************************************************************************************'"
	cor.str.add "'*          __  __   __   __      o  __    __ _|_   __  |   |    ___   __                             *'"
	cor.str.add "'*        __)  (__) (__) |__)     | |  ) __)   |_, (__( |_, |_, (__/_ |  '                            *'"
	cor.str.add "'*                       |                                                                            *'"
	cor.str.add "'******************************************************************************************************'"
	cor.str.add "'*                                                                                                    *'"
	cor.str.add "'*        File Created with Soop Portal Phoenix Installer V1.0a                                       *'"
	cor.str.add "'*         Authors: Steve Podmore aka ph4nt0m , Brian aka Hooded, Charles aka Cadius                  *'"
	cor.str.add "'*         Based on Soop Setings file Creator by Hooded                                               *'"
	cor.str.add "'*                                                                                                    *'"
	cor.str.add "'******************************************************************************************************'"
	cor.str.add "'--- Configuration file written " & now 
	cor.str.add "'--- This file is only used by the soopsetup system."
	cor.str.add "'--- Let's not let someone run the setup script a second time on a completed install!"
	cor.str.add "'--- If this variable is set to true then the script assumes setup is complete."
	cor.str.add "const cor_sSetupComplete = True"
	call WriteSoopSettings(cor.str.build,"_soop_setup_status.asp", strPath)
%>
	<div class="module" style="display: block;"><!-- <module> -->
		<div class="rbt"><div><div> </div></div></div>
		<div class="rbl"><!-- <rbl> -->
			<div class="rbr"><!-- <rbr> -->
				<div class="titleBar"><!-- <titleBar> -->
					<div class="title">Soop Portal Phoenix Installation</div>
					<div class="icons" style="display: none;"><!-- <icons> --></div><!-- </icons> -->
				</div><!-- </titleBar> -->
				<div class="modular text">
					<div class="tiHeading"><h2>Finished!</h2><br /><br /></div>
					<p>You have now completed the base install of your new Phoenix Portal! <br /><br /></p>
					<p>Take a moment to <a href="default.asp" target="_blank">look around</a> your new SooP Site!
					  <br /><br /></p>
					<div class="tiHeading"><h2>Next Steps:</h2><br /><br /></div>
					<p>If everything seems to be working correctly, then you still need to do a few things to wrap up your site's configuration:</p>
					<ol class="uroman">
					<li>It is <em>strongly recommended</em> that you remove the
						following from your website immediately to prevent someone highjacking your site<br />
						<em>(as always, keep a backup, just in case!)</em>:
						<ul class="disc">
							<li> The SoopSetup.asp file in your SooP site's root folder</li>
							<li> The Setup folder and all of it's contents</li>
						</ul>
					</li>
					<li><b>Be Sure</b> to edit the <b>robots.txt</b> and the <b>sitemap.xml</b> in the root of your folder to reflect your sites information.</li>
					<li>You also need to go to the <u><em>core/languages/</em></u> folder and edit each &lt;Language&gt;.xml file:<br />
						&nbsp;&nbsp; The <u><em>lngWebSiteTitle</em></u> variable should be set to your site's name, as translated for each language.</li>
					<li>You need to log into your site and update your profile with the correct email address, avatar, and so forth.</li>
					<li>Register your site with <a href="http://www.soopportal.org" target="_blank">SoopPortal.Org</a> </li>
					<li>Start adding Banners, FAQs, Forums, Headlines and other site content!</li>
					<li>Go through the Management Sections area and set each section's meta tags (title and keywords especially).</li>
					<li>Edit the sitemap.xml and robots.txt file in the root of your site!  Make sure the domain name and other specifics are correct for you.</li>
<%	if lcase(Session("databasetype")) = "mssql" or lcase(Session("databasetype")) = "mysql" then	%>
					<li> <a href="/mgmt_db_create_full-text.asp">Set up Full Text Search</a> to enable site search functionality for MS SQL and MySQL only</li>
<%	End If 	%>
					</ol><br /><br />
					<p><em>	Remember,</em> your Db, RSSFeeds, and Uploads folders must keep Write permissions for full site functionality. <br /><br /></p>
					<p>If you have questions, comments, or problems, please go to
					<a href="http://www.soopportal.org" target="_blank">SoopPortal.Org</a>
					for help.<br /><br /></p>
					<p> Thank you for using our portal! We hope you like it!<br /><br /></p>
					<p>-SoopPortal.Org Development Team<br /><br /></p>
				</div><!-- modular txt -->
			</div><!-- </rbr> -->
		</div><!-- </rbl> -->
		<div class="rbb"><div><div> </div></div></div>
	</div><!-- module -->
<%
end sub
%>